CREATE TABLE dok_zag (
 proda VARCHAR(5)   NOT NULL, 
 vrsDo VARCHAR(2)   NOT NULL,
 proIn VARCHAR(6)   NOT NULL,  
 zapis VARCHAR(2)   NOT NULL,
 broDo INT          NOT NULL,
 verzi VARCHAR(3)   NOT NULL,
  kodPartnera         VARCHAR(13) NOT NULL,
  DVO                 DATETIME    NOT NULL,
  valuta              DATETIME    NOT NULL, 
   daniOdgodePl       INT DEFAULT 0,
   nacinPlacanja     CHAR(1) DEFAULT " ", 
  datumZakljucavanja DATETIME    DEFAULT NULL,
  datumRacuna        DATETIME    DEFAULT NULL,  
  datumNarudzbe      DATETIME    DEFAULT NULL,
  brojNarudzbe       VARCHAR(30) DEFAULT NULL,
  PDVstatus          CHAR(1) DEFAULT " ",
  casasSconto        DECIMAL(11,3)  NOT NULL,
   absCasasSconto    CHAR(1) DEFAULT " ",
   daniZaCasaSconto  INT DEFAULT 0,
  refProd            VARCHAR(13) NOT NULL,
  komercijalista     VARCHAR(13) NOT NULL,
  komentar  TEXT     DEFAULT NULL, 
  datumOtvaranja     DATETIME NOT NULL,
  datumIzmjene       DATETIME DEFAULT 0,
  tkoJeIzmjenio      VARCHAR(40) DEFAULT " ", 
  PRIMARY KEY (proda, vrsDo, proIn, zapis, broDo, verzi), 
  INDEX kodPartnera (kodPartnera)
);

CREATE TABLE dok_stavke (
 proda VARCHAR(5)   NOT NULL, 
 vrsDo VARCHAR(2)   NOT NULL,
 proIn VARCHAR(6)   NOT NULL,  
 zapis VARCHAR(2)   NOT NULL,
 broDo INT          NOT NULL,
 verzi VARCHAR(3)   NOT NULL,
 brojStavke INT     NOT NULL, 
  kodRobe           VARCHAR(13)    NOT NULL,
  vrstaProdaje      CHAR(1) DEFAULT "0",
  cijena            DECIMAL(11,3)  NOT NULL,
  cijenaZaIntFak    DECIMAL(11,3)  NOT NULL,
  kolicina          DECIMAL(11,3)  NOT NULL,
  rabatPpopust         DECIMAL(11,3)  NOT NULL,
   absRabatPopust      CHAR(1) DEFAULT " ",
  rabatPopustNaKol     DECIMAL(11,3)  NOT NULL,
   absRabatPopustNaKol CHAR(1) DEFAULT " ",
  PDVkod            VARCHAR(2) DEFAULT "A" NOT NULL,
  PDV               DECIMAL(6,3)  NOT NULL,
  ukalkuliarniPDV  DECIMAL(6,3)  NOT NULL,
  povratnaNaknada  DECIMAL(4,2) DEFAULT 0,
  nabavnaCijena    DECIMAL(11,3)  NOT NULL, 
  marza             DECIMAL(11,3)  NOT NULL,
   absMarza         VARCHAR(1) DEFAULT " ",
  zavisniTroskovi  DECIMAL(11,3)  NOT NULL,
   absZavTr        VARCHAR(1) DEFAULT " ",
  DVO              DATETIME NOT NULL, 
  tekst            VARCHAR(100) DEFAULT NULL,
  datumOtvaranja   DATETIME NOT NULL,
  datumIzmjene     DATETIME DEFAULT 0,
  tkoJeIzmjenio     VARCHAR(40) DEFAULT " ", 
  PRIMARY KEY (proda, vrsdo, proin, zapis, brodo, verzi, brojStavke), 
  INDEX kartica (proda, kodRobe, DVO)
);