CREATE TABLE IF NOT EXISTS kons_stanja (
  kodPartnera       CHAR(13)       NOT NULL,
  kodRobe           CHAR(16)      NOT NULL,    
  vrstaProdaje      CHAR(1)       NOT NULL,
  cijena            DECIMAL(11,3)  NOT NULL, 
  stanje            DECIMAL(11,3)  NOT NULL,   
  datumInventure    DATETIME DEFAULT 0,
  kolicinaInventure DECIMAL(11,3)  DEFAULT 0,   
  brojInvStavke     INT DEFAULT 0,
  datumOtvaranja    DATETIME NOT NULL,
  datumIzmjene      DATETIME DEFAULT 0,
  tkoJeIzmjenio     VARCHAR(40) DEFAULT " ",   
  PRIMARY KEY (kodPartnera, kodRobe, vrstaProdaje, cijena), 
  INDEX konsPoRobi (kodRobe, kodPartnera, vrstaProdaje) 
  );
-- tabela služi za memoriranje početnih stanja konsignacijske robe po poslovnim partnerima
-- po inventuri ili po donosu
-- vrstaProdaje može biti 1 (tuđa roba na našem skladištu) ili 2(naša roba kod drugih)
-- Stanje konsignacijske robe na određeni dan po pojedinom ili svim partnerima
-- izvodi se tako da se na početno stanje (kolicinaInventure) sumiraju količine
-- iz zapisnika K1 ili K2. 
-- polje stanje dodano je radi kompatibilnosti sa tabelom stanja a eventulano
-- može poslužiti kao trenutno stanje.
