CREATE TABLE kontni_moduli (
  kontniModul CHAR(3) NOT NULL,
  brojStavke INT NOT NULL,
  nazivModula VARCHAR(40) DEFAULT NULL,
  stoSeKnjizi INT NOT NULL,
  kontoDugovni CHAR(12) DEFAULT NULL,
  kakoSeKnjiziDugovni CHAR(1) DEFAULT 'P',
  predznakDugovni INT DEFAULT 1, 
  kontoPotrazni  CHAR(12) DEFAULT NULL,
  kakoSeKnjiziPotrazni CHAR(1) DEFAULT 'P',
  predznakPotrazni INT DEFAULT 1, 
  datumOtvaranja    DATETIME NOT NULL,
  datumIzmjene      DATETIME DEFAULT 0,
  tkoJeIzmjenio     VARCHAR(40) DEFAULT " ",
  PRIMARY KEY (kontniModul,brojStavke) 
) DEFAULT CHARSET=utf8; 
/*
   kontniModul
*****************************************
*      MODULI:                          *
*      -------                          *
*      10  - ulaz veleprodaja           *
*      101 - ulaz maloprodaja           *  
*      102 - ulaz repromaterijal        *
*      12  - ulaz uvoz-izvoz            *
*      20  - izlaz veleprodaja          *
*      201 - izlaz maloprodaja          *
*      204 - izlaz got.proizvodi  *     *
*      203 - servis usluge 
*      206 - IZVOZ pdvstatus 1 
*      650 - izlazna if veleprodaja     *
*      651 - izlazna if maloprodaja     *
*      652 - izlazna if got.proizvodi   *
*      655 - ulazna if got.proizvodi  
*      35 - rekapitlari paragonaca
*      26 - kartice po rekapitularima i dostavnicama
*      85 - nivelacije
*****************************************
   stoSeKnjizi
**      ulazi*  
*         - 1  Zaliha bez poreza  ,
*         - 10 ukalkulirani porez   
*         - 12 zavisni ukalkulirani tro{kovi 
*         - 14 transportni tro{kovi direktni ulaz
*         - 15 nabavan vrijednost 13 + 12
*         - 13 iznos za platiti dobavlja~u
*         - 8 rc
*         - 9 nefakturirana roba 
*         - 6 MPU 
*         - 20 Pretporez na kalkulaciji      
*         - 23 povratna naknada 0.5
*         - 24 carina(pona{a se kao ukal.tr.12)
*              (mo`e na salda konti)
*      izlazi
*         - 1  zaliha bez poreza
*         - 2  realizacija 
*         - 3  rabati +casas sconto
*         - 4 tro{kovi   ?
*         - 5 porez
*         - 6 MPU
*         - 7 iznos za platiti kupac 
*         - 16 stvarna RC  po izlazima
*         - 17 tro{ak nabave  1-16 
*         - 18 Transportni tro{k. direkt. bez poreza
*         - 19 Porez na tran.tro{kove 10 %
*        - 21 Zaokruzenja
*         - 22 usluga na paragoncima (bez poreza i umanjena za popust)
*         - 23 povratna naknada 0.5*KOL
   kakoSeKnjizi   P - pojedinačne stavke, K - kumluativno
   predznak       1 ili -1 
   
*/
