CREATE TABLE veze (
  konto CHAR(12) NOT NULL,
  kodPartnera CHAR(13) NOT NULL,
  vrsDo CHAR(2) NOT NULL,
  broDo CHAR(25) NOT NULL,
  vKonto CHAR(12) NOT NULL,
  vKodPartnera CHAR(13) NOT NULL,
  vVrsDo CHAR(2) NOT NULL,
  vBroDo CHAR(25) NOT NULL, 
  iznosVeze  DECIMAL(11,2)  NOT NULL,
  datumOtvaranja    DATETIME NOT NULL,
  datumIzmjene      DATETIME DEFAULT 0,
  tkoJeIzmjenio     VARCHAR(40) DEFAULT " ",
  PRIMARY KEY (konto,kodPartnera,vrsDo,broDo,vKonto,vKodPartnera,vVrsDo,vBroDo), 
    KEY vveze (vkonto,vkodPartnera,vvrsDo,vbroDo,konto,kodPartnera,vrsDo,broDo)
) DEFAULT CHARSET=utf8;
/* 
    veze - sto je s cime zatvoreno
      *       u GLAVNI dio ključa puni se kljuc dokumenta kojim se vrsi
      *       zatvaranje(polazni dokument) drugog dokumenta(npr virman) , a pod VEZNI dio ključa
      *       puni se kljuc dokumenta koji se zatvara(npr racun).
      *
      *       startom po glavnom kljucu npr. dobiju se svi racuni koji
      *       su zatvoreni tim virmanom, a startom po veznom (alternativni)
      *       dobiju se svi virmani koji zatvaraju doticni racun
glavni i vezni dokument su ravnopravni a za analizu zatvorenosti(veza) nekog dokumenta,
starta se po glavnom i po veznom ključu.
npr. Kupac(567) plaća virmanom 80kn račun koji glasi ma 100kn. konto 1200 i zatvaranje se vrši kod knjiženja virmana
1.     1200  567  40 141126-15PB  1200 567 20 2302-56      (ostalo je 20kn otvoreno)
2.     3.12.2014  knjiži proknjižen je virman od 20 kn ali bez povezivanja.
3.      5.12.2014 knjigovođa gleda kartice i vidi da je virman nepovezan.
        ide povezivat otvorene stavke ali tako da je kao polazni(glavni) dokument uzet račun sa dugom od 20 kn a vezni taj virman
       1200  567  20 2302-56    1200 567 40 141203-7ZB  račun i virmani su zatvoreni
Dakle prvi dio ključa(glavni) je polazni dokument kod zatvaranja, a vezni je drugi ili sljedeći.

Slučajevi 
Virman = 100kn  račun = 100kn  idealno
Virman =70kn račun = 100kn ključ 1200 5893 40 140508-2PB   1200 5893 20 2302-145    iznosVeze=70 dug po računu 30        iznosOtvoreni = 30 na računu
Virman = 120 račun 100           1200 5893 40 140508-5     1200 5893 20 2302-150              120 pretplata po računu 20 iznosOtvoreni = -20 na računu 
Virman = 130 dva računa plaća    1200 5893 40 140508-5-ZB  1200 5893 20 2302-145              30                         iznosOtvoreni = 0
                                 1200 5893 40 140508-5-ZB  1200 5893 20 2370-153              100                        iznosOtvoreni = 0
Temeljnicom se zatvara račun     1200 5893 48 2316-18OTPIS 1200 5893 20 2316-18               100                        iznosOtvoreni = 0

Kompenzacija: Izlaznim računom na 1200 2302-27 sa iznosom 100 zatvaraju se ulazni računi(kalkulacije) 2370-14  80kn i 2302-77 na 60kn.
                                 1200 5893 48 K3-2370-14   1200 5893 20 2302-27               80                    
                                 1200 5893 48 K3-2302-77   1200 5893 20 2302-27               20
                                 2200 5893 48 K3-2302-27   2200 5893 10 2370-14               80
                                 2200 5893 48 K3-2302-27   2200 5893 10 2302-77               20                     ostaje 40 kuna otvoreno na 2302-77
*/                         