<?php
function get_vrste_dokumenata() {
    global $db;
    $query = 'SELECT * FROM vrste_dokumenata';
    $statement = $db->prepare($query);
    $statement->execute();
    $vrsteDokumenata = $statement->fetchAll();
    $statement->closeCursor();
    return $vrsteDokumenata;
}
function get_vrsta_dokumenta($vrsDo) {
    global $db;
    $query = 'SELECT * FROM vrste_dokumenata
        WHERE vrsDo = :vrsDo';
    $statement = $db->prepare($query);
   	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->execute();
    $vrstaDokumenta = $statement->fetch();
    $statement->closeCursor();
    return $vrstaDokumenta;
}

function add_vrsta_dokumenta($vrsDo, $nazivDokumenta, $tipDokumenta, $azurStanja) {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = 'INSERT INTO vrste_dokumenata
                 (vrsDo, nazivDokumenta, tipDokumenta, azurStanja, datumOtvaranja, tkoJeIzmjenio)
              VALUES
                 (:vrsDo, :nazivDokumenta, :tipDokumenta, :azurStanja, NOW(), :email_user )';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':nazivDokumenta', $nazivDokumenta);
        $statement->bindValue(':tipDokumenta', $tipDokumenta);
        $statement->bindValue(':azurStanja', $azurStanja);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();

        return true;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
        return false;
    }
}

function update_vrsta_dokumenta($vrsDo, $nazivDokumenta, $tipDokumenta, $azurStanja) {
    global $db;
	$email_user = $_SESSION['admin']['email'];
    $query = '
        UPDATE vrste_dokumenata
        SET nazivDokumenta = :nazivDokumenta,
            tipDokumenta = :tipDokumenta,
            azurStanja = :azurStanja,
            datumIzmjene = NOW(),
            tkoJeIzmjenio = :email_user
        WHERE vrsDo = :vrsDo';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':nazivDokumenta', $nazivDokumenta);
        $statement->bindValue(':tipDokumenta', $tipDokumenta);
        $statement->bindValue(':azurStanja', $azurStanja);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function delete_vrstu_dokumenta($vrsDo) {
    global $db;
    $query = 'DELETE FROM vrste_dokumenata WHERE vrsDo = :vrsDo';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}    
?>