<?php
$maxDatum='2038-01-01 23:59:59';
$minDatum='1900-01-01 00:00:00';
function get_gk() {
    global $db;
    $query = 'SELECT * FROM gk_stavke'; 
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_gk_stavku($brojTemeljnice,$brojStavke) {
    global $db;
    $query = '
        SELECT *
        FROM gk_stavke
        WHERE brojTemeljnice = :brojTemeljnice
        AND brojStavke=:brojStavke';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_gk_po_temeljnicama($parametri) {
    global $db;
    if(trim($parametri['brojDokPr']!='') && $parametri['zaDioDokumenta'] )
        $brojDokPr='%'.trim($parametri['brojDokPr']).'%';
    else 
        $brojDokPr=$parametri['brojDokPr'];
    
    $query = "
select 
gk.brojTemeljnice, gk.vrsDo, vd.nazivDokumenta, vd.oznakaDokumenta, gk.brojIzvoda, 
sum(iznosDug) as duguje, sum(iznosPot) as potrazuje, count(brojStavke) as stavaka
from gk_stavke as gk
left outer join vrste_dokumenata as vd on vd.vrsDo=gk.vrsDo 
where (gk.konto=:konto or trim(:konto)='')
and (gk.kodPartnera=:kodPartnera or trim(:kodPartnera)='')
and (gk.vrsDo=:vrsDo or trim(:vrsDo)='')
and (gk.DVO>=:DVOod or trim(:DVOod)='')
and (gk.DVO<=:DVOdo or trim(:DVOdo)='')
and (gk.valuta>=:valutaod or trim(:valutaod)='')
and (gk.valuta<=:valutado or trim(:valutado)='')
and (gk.datumOtvaranja>=:datumOtvaranjaod or trim(:datumOtvaranjaod)='')
and (gk.datumOtvaranja<=:datumOtvaranjado or trim(:datumOtvaranjado)='')
and (:prikazuje='' or (:prikazuje='F' and trim(gk.kodPartnera)='') or (:prikazuje='S' and trim(gk.kodPartnera)<>''))

and (:kojiIznos='' or :kojiIznos='O' or (:kojiIznos='D' and iznosDug<>0) or (:kojiIznos='P' and iznosPot<>0))
and (trim(:iznosOd)='' or (iznosDug>=:iznosOd or iznosDug=0) and  (iznosPot>=:iznosOd or iznosPot=0))
and (trim(:iznosDo)='' or (iznosDug<=:iznosDo or iznosDug=0) and  (iznosPot<=:iznosDo or iznosPot=0))  
and gk.brojTemeljnice between :temeljnicaOd and :temeljnicaDo
AND (broDo LIKE :broDo OR trim(:broDo)='') 
group by `brojTemeljnice`, vrsDo, `brojIzvoda` 
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $parametri['vrsDo']);
        $statement->bindValue(':konto', $parametri['konto']);
        $statement->bindValue(':kodPartnera', $parametri['kodPartnera']);

        $datumi=gk_datumski_parametri($parametri);
        $statement->bindValue(':DVOod', $datumi['DVOod']);
        $statement->bindValue(':DVOdo', $datumi['DVOdo']);
        $statement->bindValue(':valutaod', $datumi['valutaod']);
        $statement->bindValue(':valutado', $datumi['valutado']);
        $statement->bindValue(':datumOtvaranjaod', $datumi['datumOtvaranjaod']);
        $statement->bindValue(':datumOtvaranjado', $datumi['datumOtvaranjado']);

        $statement->bindValue(':prikazuje', $parametri['prikazuje']);
        $statement->bindValue(':kojiIznos', $parametri['kojiIznos']);
        $statement->bindValue(':iznosOd', str_replace(',', '.', $parametri['iznosOd']));
        $statement->bindValue(':iznosDo', str_replace(',', '.', $parametri['iznosDo']));
        $statement->bindValue(':broDo', $brojDokPr);
        $statement->bindValue(':temeljnicaOd', $parametri['temeljnicaOd']);
        $statement->bindValue(':temeljnicaDo', $parametri['temeljnicaDo']);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_gk_lista_konto_partner($parametri) {
    global $db;
	global $maxDatum, $minDatum;
    if(trim($parametri['brojDokPr']!='') && $parametri['zaDioDokumenta'] )
        $brojDokPr='%'.trim($parametri['brojDokPr']).'%';
    else 
        $brojDokPr=$parametri['brojDokPr'];
    $query = "
select g.*, p.nazivPartnera
from
(
select gk.konto, k.nazivKonta, k.vrstaKonta, ifnull(gk.kodPartnera,'') as kodPartnera,  
-- p.nazivPartnera, 
sum(iznosDug) as duguje, sum(iznosPot) as potrazuje,
if(vrstaKonta='S' and :forma='uzmi_otvorene_stavke', sum(if(if(trim(gk.kodPartnera)<>'' and trim(:DVOdo)<>'$maxDatum', 
    fnIznosOtvoreno(gk.konto, gk.vrsDo, gk.broDo, gk.DVO, gk.kodPartnera, :DVOdo,(iznosDug+iznosPot)), gk.iznosOtv)<>0,1,0)),0) as brOtvoreno,
sum(if(iznosDug<>0,gk.iznosOtv,0)) as otvorenoDug,
sum(if(iznosPot<>0,gk.iznosOtv,0)) as otvorenoPot

from gk_stavke as gk
join konta as k on k.konto=gk.konto
-- left outer join partner as p on p.kodPartnera=gk.kodPartnera
left outer join ".get_admin_db().".administrators as a on a.email=gk.tkoJeIzmjenio
where (:forma='uzmi_fin_kartica' or vrstaKonta='S')
and (gk.konto like :konto or trim(:konto)='')
and (gk.kodPartnera=:kodPartnera or trim(:kodPartnera)='')
and (gk.vrsDo=:vrsDo or trim(:vrsDo)='')
and (gk.DVo>=:DVOod or trim(:DVOod)='')
and (gk.DVO<=:DVOdo or trim(:DVOdo)='')
and (gk.valuta>=:valutaod or trim(:valutaod)='')
and (gk.valuta<=:valutado or trim(:valutado)='')
and (gk.datumOtvaranja>=:datumOtvaranjaod or trim(:datumOtvaranjaod)='')
and (gk.datumOtvaranja<=:datumOtvaranjado or trim(:datumOtvaranjado)='')
and (:prikazuje='' or (:prikazuje='F' and trim(gk.kodPartnera)='') or (:prikazuje='S' and trim(gk.kodPartnera)<>''))

and (:kojiIznos='' or :kojiIznos='O' or (:kojiIznos='D' and iznosDug<>0) or (:kojiIznos='P' and iznosPot<>0))
and (trim(:iznosOd)='' or (iznosDug>=:iznosOd or iznosDug=0) and  (iznosPot>=:iznosOd or iznosPot=0))
and (trim(:iznosDo)='' or (iznosDug<=:iznosDo or iznosDug=0) and  (iznosPot<=:iznosDo or iznosPot=0))  

and (broDo like :broDo or trim(:broDo)='')
and (a.OIB=:knjizio or trim(:knjizio)='')
-- group by gk.konto, nazivPartnera, gk.kodPartnera, nazivKonta 
group by gk.konto,  ifnull(gk.kodPartnera,'')
) as g
left outer join partner as p on p.kodPartnera=g.kodPartnera
-- join konta as k on k.konto=g.konto
where (:forma='uzmi_fin_kartica' or brOtvoreno<>0)
and (:kojiIznos<>'O' 
    or ((trim(:iznosOd)='' or brOtvoreno>=:iznosOd) and (trim(:iznosDo)='' or brOtvoreno<=:iznosDo)))
order by konto, ifnull(nazivPartnera,'')    
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $parametri['vrsDo']);
        $statement->bindValue(':konto', trim($parametri['konto']).'%');
        $statement->bindValue(':kodPartnera', $parametri['kodPartnera']);
  
        $datumi=gk_datumski_parametri($parametri);
        $statement->bindValue(':DVOod', $datumi['DVOod']);
        $statement->bindValue(':DVOdo', $datumi['DVOdo']);
        $statement->bindValue(':valutaod', $datumi['valutaod']);
        $statement->bindValue(':valutado', $datumi['valutado']);
        $statement->bindValue(':datumOtvaranjaod', $datumi['datumOtvaranjaod']);
        $statement->bindValue(':datumOtvaranjado', $datumi['datumOtvaranjado']);
    //      echo $datumi['DVOod'] . $datumi['DVOdo'] . $datumi['valutaod'] . $datumi['valutado'] . $datumi['datumOtvaranjaod'] . $datumi['datumOtvaranjado'];
        $statement->bindValue(':prikazuje', $parametri['prikazuje']);
        $statement->bindValue(':forma', $parametri['forma']);
        $statement->bindValue(':kojiIznos', $parametri['kojiIznos']);
        $statement->bindValue(':iznosOd', str_replace(',', '.', $parametri['iznosOd']));
        $statement->bindValue(':iznosDo', str_replace(',', '.', $parametri['iznosDo']));
        $statement->bindValue(':broDo', $brojDokPr);
        $statement->bindValue(':knjizio', $parametri['proknjizio']);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}


function get_kartica_za_konto_partner($parametri,$konto,$kodPartnera='') {
    global $db;
	global $maxDatum, $minDatum;

    if(trim($parametri['brojDokPr']!='') && $parametri['zaDioDokumenta'] )
        $brojDokPr='%'.trim($parametri['brojDokPr']).'%';
    else 
        $brojDokPr=$parametri['brojDokPr'];
    $query = "
select g.*
from
(
select gk.*, vd.nazivDokumenta, vd.oznakaDokumenta
, if((trim(gk.kodPartnera)<>'' and trim(:DVOdo)<>'$maxDatum') or :racunajOtv='Da',
   fnIznosOtvoreno(gk.konto, gk.vrsDo, gk.broDo, gk.DVO, gk.kodPartnera, :DVOdo, (iznosDug+iznosPot)), iznosOtv) as otvoreno,

if(:kojiDatum='dospijece', gk.valuta, gk.DVO) as datumOrder
from gk_stavke as gk
left outer join vrste_dokumenata as vd on vd.vrsDo=gk.vrsDo 
where (gk.konto=:konto or trim(:konto)='')
and (gk.kodPartnera=:kodPartnera or trim(:kodPartnera)='')
and (gk.vrsDo=:vrsDo or trim(:vrsDo)='')
-- /*
and (gk.DVO>=:DVOod or trim(:DVOod)='')
and (gk.DVO<=:DVOdo or trim(:DVOdo)='')
and (gk.valuta>=:valutaod or trim(:valutaod)='')
and (gk.valuta<=:valutado or trim(:valutado)='')
and (gk.datumOtvaranja>=:datumOtvaranjaod or trim(:datumOtvaranjaod)='')
and (gk.datumOtvaranja<=:datumOtvaranjado or trim(:datumOtvaranjado)='')
-- */
and (:prikazuje='' or (:prikazuje='F' and trim(gk.kodPartnera)='') or (:prikazuje='S' and trim(gk.kodPartnera)<>''))

and (:kojiIznos='' or :kojiIznos='O' or (:kojiIznos='D' and iznosDug<>0) or (:kojiIznos='P' and iznosPot<>0))
and (trim(:iznosOd)='' or (iznosDug>=:iznosOd or iznosDug=0) and  (iznosPot>=:iznosOd or iznosPot=0))
and (trim(:iznosDo)='' or (iznosDug<=:iznosDo or iznosDug=0) and  (iznosPot<=:iznosDo or iznosPot=0))
  
and (broDo like :broDo or trim(:broDo)='')
order by gk.konto, ifnull(gk.kodPartnera,''), datumOrder
) as g
left outer join ".get_admin_db().".administrators as a on a.email=g.tkoJeIzmjenio
where (:forma='uzmi_fin_kartica' or otvoreno<>0)
and (:kojiIznos<>'O' 
    or ((trim(:iznosOd)='' or otvoreno>=:iznosOd) and (trim(:iznosDo)='' or otvoreno<=:iznosDo)))
and (a.OIB=:knjizio or trim(:knjizio)='')
order by konto, ifnull(g.kodPartnera,''), datumOrder     
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $parametri['vrsDo']);
        $statement->bindValue(':konto', $konto);
        $statement->bindValue(':kodPartnera', $kodPartnera);

        $datumi=gk_datumski_parametri($parametri);
        $statement->bindValue(':DVOod', $datumi['DVOod']);
        $statement->bindValue(':DVOdo', $datumi['DVOdo']);
        $statement->bindValue(':valutaod', $datumi['valutaod']);
        $statement->bindValue(':valutado', $datumi['valutado']);
        $statement->bindValue(':datumOtvaranjaod', $datumi['datumOtvaranjaod']);
        $statement->bindValue(':datumOtvaranjado', $datumi['datumOtvaranjado']);

        $statement->bindValue(':prikazuje', $parametri['prikazuje']);
        $statement->bindValue(':forma', $parametri['forma']);
        $statement->bindValue(':kojiIznos', $parametri['kojiIznos']);
        $statement->bindValue(':iznosOd', str_replace(',', '.', $parametri['iznosOd']));
        $statement->bindValue(':iznosDo', str_replace(',', '.', $parametri['iznosDo']));
        $statement->bindValue(':broDo', $brojDokPr);
        $statement->bindValue(':kojiDatum', $parametri['kojiDatum']);
        $statement->bindValue(':knjizio', $parametri['proknjizio']);
        if(isset($parametri['racunajOtv']))
            $racunajOtv=$parametri['racunajOtv'];
        else {
            $racunajOtv='';
       }
        $statement->bindValue(':racunajOtv', $racunajOtv);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_kartica_za_konto_partner2($parametri,$konto,$kodPartnera='') {
    global $db;
    if(trim($parametri['brojDokPr']!='') && $parametri['zaDioDokumenta'] )
        $brojDokPr='%'.trim($parametri['brojDokPr']).'%';
    else 
        $brojDokPr=$parametri['brojDokPr'];
    $query = "
select g.*
from
(
select gk.*, vd.nazivDokumenta, vd.oznakaDokumenta
, fnIznosOtvoreno(gk.konto, gk.vrsDo, gk.broDo, gk.DVO, gk.kodPartnera, :valutado, (iznosDug+iznosPot)) as otvoreno,

if(:kojiDatum='dospijece', gk.valuta, gk.DVO) as datumOrder
from gk_stavke as gk
left outer join vrste_dokumenata as vd on vd.vrsDo=gk.vrsDo 
where (gk.konto=:konto or trim(:konto)='')
and (gk.kodPartnera=:kodPartnera or trim(:kodPartnera)='')
and (gk.vrsDo=:vrsDo or trim(:vrsDo)='')
and (gk.DVO>=:DVOod or trim(:DVOod)='')
and (gk.DVO<=:DVOdo or trim(:DVOdo)='')
and (gk.valuta>=:valutaod or trim(:valutaod)='')
and (gk.valuta<=:valutado or trim(:valutado)='')
and (gk.datumOtvaranja>=:datumOtvaranjaod or trim(:datumOtvaranjaod)='')
and (gk.datumOtvaranja<=:datumOtvaranjado or trim(:datumOtvaranjado)='')
and (:prikazuje='' or (:prikazuje='F' and trim(gk.kodPartnera)='') or (:prikazuje='S' and trim(gk.kodPartnera)<>''))
and  (
    ((:kojiIznos='D' or :kojiIznos='') and 
     ((trim(:iznosOd)='' or IznosDug>=:iznosOd) and (trim(:iznosDo)='' or iznosDug<=:iznosDo)))

 or ((:kojiIznos='P' or :kojiIznos='') and  
     ((trim(:iznosOd)='' or IznosPot>=:iznosOd) and (trim(:iznosDo)='' or iznosPot<=:iznosDo)))
 or :kojiIznos='O'               
)
and (broDo like :broDo or trim(:broDo)='')
order by gk.konto, ifnull(gk.kodPartnera,''), datumOrder
) as g
where (:forma='uzmi_fin_kartica' or otvoreno<>0)
and (:kojiIznos<>'O' 
    or ((trim(:iznosOd)='' or otvoreno>=:iznosOd) and (trim(:iznosDo)='' or otvoreno<=:iznosDo)))
order by konto, ifnull(kodPartnera,''), datumOrder    
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $parametri['vrsDo']);
        $statement->bindValue(':konto', $konto);
        $statement->bindValue(':kodPartnera', $kodPartnera);

        $datumi=gk_datumski_parametri($parametri);
        $statement->bindValue(':DVOod', $datumi['DVOod']);
        $statement->bindValue(':DVOdo', $datumi['DVOdo']);
        $statement->bindValue(':valutaod', $datumi['valutaod']);
        $statement->bindValue(':valutado', $datumi['valutado']);
        $statement->bindValue(':datumOtvaranjaod', $datumi['datumOtvaranjaod']);
        $statement->bindValue(':datumOtvaranjado', $datumi['datumOtvaranjado']);

        $statement->bindValue(':prikazuje', $parametri['prikazuje']);
        $statement->bindValue(':forma', $parametri['forma']);
        $statement->bindValue(':kojiIznos', $parametri['kojiIznos']);
        $statement->bindValue(':iznosOd', str_replace(',', '.', $parametri['iznosOd']));
        $statement->bindValue(':iznosDo', str_replace(',', '.', $parametri['iznosDo']));
        $statement->bindValue(':broDo', $brojDokPr);
        $statement->bindValue(':kojiDatum', $parametri['kojiDatum']);
        if(isset($parametri['racunajOtv']))
            $racunajOtv=$parametri['racunajOtv'];
        else {
            $racunajOtv='';
       }
        $statement->bindValue(':racunajOtv', $racunajOtv);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_gk_pdv($brojTemeljnice,$brojStavke,$uldb=null) {
    if($uldb==null)
        global $db;
    else 
        $db=$uldb;
    $query = '
        SELECT *
        FROM gk_pdv
        WHERE brojTemeljnice = :brojTemeljnice
        AND brojStavke=:brojStavke';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_gk_dupli_dokument($slog) {
    global $db;
    $query = " 
        SELECT * 
        FROM gk_stavke
        WHERE konto=:konto AND vrsDo=:vrsDo AND broDo=:broDo AND year(DVO)=year(:DVO)
        AND (brojTemeljnice<>:brojTemeljnice OR (brojTemeljnice=:brojTemeljnice AND brojIzvoda=:brojIzvoda AND brojStavke<>:brojStavke))
        -- AND kodPartnera<>:kodPartnera
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $slog['brojTemeljnice']);
        $statement->bindValue(':brojIzvoda', $slog['brojIzvoda']);
        $statement->bindValue(':brojStavke', $slog['brojStavke']);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->bindValue(':kodPartnera', $slog['kodPartnera']);
        $DVO = new DateTime($slog['DVO']);
        
        $statement->bindValue(':DVO', $DVO->format("Y-m-d H:i:s"));
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function getGkDupliDokument($slog) {
//kontrola na dupli obično za salda-konto konta(bez obzira na iznos)    
    global $db;
    $query = " 
        SELECT * 
        FROM gk_stavke
        WHERE konto=:konto AND vrsDo=:vrsDo AND broDo=:broDo";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function getGk1SaldaKontoDokument($konto,$kodPartnera,$vrsDo,$broDo) {
// uzimanje podataka o salda-konto dokumentu koji u gk_stavke ima uniq ključ prema parametrima , trim(kodPartnera) <> ''
    global $db;
    $query = " 
        SELECT * 
        FROM gk_stavke
        WHERE konto=:konto AND kodPartnera = :kodPartnera AND vrsDo=:vrsDo AND broDo=:broDo AND trim(kodPartnera) <> '' ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':konto', $konto);
        $statement->bindValue(':kodPartnera', $kodPartnera);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':broDo', $broDo);   
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}


function getGkDupliDokumentF($slog) {
//kontrola na dupli za financijska konta kontroliraju se i iznosi    
    global $db;
    $query = " 
        SELECT * 
        FROM gk_stavke
        WHERE konto=:konto AND vrsDo=:vrsDo AND broDo=:broDo AND iznosDug=:iznosDug AND iznosPot=:iznosPot";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->bindValue(':iznosDug', $slog['iznosDug']);
        $statement->bindValue(':iznosPot', $slog['iznosPot']);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_gk_temeljnicu($brojTemeljnice,$vrsDo,$brojIzvoda,$prikazujePo,$brojDokPr,$zaDioDokumenta,$iznosOd,$iznosDo,$kojiIznos,$nazivBaze='') {
    global $db;
    if(trim($brojDokPr)!='' && $zaDioDokumenta)
        $brojDokPr='%'.trim($brojDokPr).'%';
    $tablica='gk_stavke';
    if($nazivBaze!='')
        $tablica=$nazivBaze.'.gk_stavke';
    if($prikazujePo=='') $prikazujePo='brojStavke';
    $query = " 
        SELECT gk.*, k.vrstaKonta
        FROM $tablica as gk
        JOIN konta as k on k.konto=gk.konto     
        WHERE brojTemeljnice = :brojTemeljnice
        AND (vrsDo=:vrsDo OR :vrsDo='0' OR :vrsDo='')
        AND (brojIzvoda=:brojIzvoda OR :brojIzvoda='0' OR :brojIzvoda='')
        AND (broDo LIKE :broDo OR trim(:broDo)='') 
        and  (
            ((:kojiIznos='D' or :kojiIznos='') and 
             ((trim(:iznosOd)='' or IznosDug>=:iznosOd) and (trim(:iznosDo)='' or iznosDug<=:iznosDo)))

         or ((:kojiIznos='P' or :kojiIznos='') and  
             ((trim(:iznosOd)='' or IznosPot>=:iznosOd) and (trim(:iznosDo)='' or iznosPot<=:iznosDo)))
         or :kojiIznos='O'               
        )
        ORDER BY $prikazujePo
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':brojIzvoda', $brojIzvoda);
        $statement->bindValue(':kojiIznos', $kojiIznos);
        $statement->bindValue(':iznosOd', str_replace(',', '.', $iznosOd));
        $statement->bindValue(':iznosDo', str_replace(',', '.', $iznosDo));
        $statement->bindValue(':broDo', $brojDokPr);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function add_gk_stavku($slog, $uldb=null,$transakcija=false) {
    $konto = get_konto($slog['konto']);
    if (empty($konto)) {
        $vrstaDokumenta = get_vrsta_dokumenta($slog['vrsDo']);
        echo 'Konto ' . $slog['konto'] . ' ne postoji u kontnom planu ! za vrstu dokumenta:' . $vrstaDokumenta['nazivDokumenta'] . '  i broj dokumenta; ' . $slog['broDo'];
    }    
    if (!isset($slog['pozivNaBroj'])) $slog['pozivNaBroj']='';
    if($uldb==null)
        global $db;
    else 
        $db=$uldb;
    if(!isset($slog['donosDug'])) {
        $slog['donosDug']=0;
        $slog['donosPot']=0;
    }
    $email_user = $_SESSION['admin']['email'];
    $query = "
        INSERT INTO gk_stavke
        (
            brojTemeljnice, 
            brojStavke,
            konto,
            kodPartnera,
            pozivNaBroj,
            vrsDo,
            broDo,
            brojIzvoda,
            DVO,
            valuta, 
            iznosDug,
            iznosPot,
            iznosOtv,
            donosDug,
            donosPot,
            brojDobRacuna,
            vrstaRacuna,
            PDVstatus,
            opisKnjizenja,
            datumOtvaranja,
            tkoJeIzmjenio
        )
        VALUES
        (
            :brojTemeljnice, 
            :brojStavke,
            :konto,
            :kodPartnera,
            :pozivNaBroj,
            :vrsDo,
            :broDo,
            :brojIzvoda,
            :DVO,
            :valuta, 
            :iznosDug,
            :iznosPot,
            :iznosOtv,
            :donosDug,
            :donosPot,
            :brojDobRacuna,
            :vrstaRacuna,
            :PDVstatus,
            :opisKnjizenja,
            NOW(), 
            :email_user 
        )";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $slog['brojTemeljnice']);
        $statement->bindValue(':brojStavke', $slog['brojStavke']);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->bindValue(':kodPartnera', $slog['kodPartnera']);
        $statement->bindValue(':pozivNaBroj', $slog['pozivNaBroj']);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);
        $statement->bindValue(':brojIzvoda', $slog['brojIzvoda']);

        $d1=new DateTime($slog['DVO']);
        $datum = $d1->format('Y-m-d H:i:s');
        $statement->bindValue(':DVO', $datum);
        
        if(trim($slog['valuta'])=='')
            $statement->bindValue(':valuta', null, PDO::PARAM_NULL);   
        else 
        {
            $d1=new DateTime($slog['valuta']);
            $datum = $d1->format('Y-m-d H:i:s');
            $statement->bindValue(':valuta', $datum);
        }
        $statement->bindValue(':iznosDug', str_replace(',', '.',$slog['iznosDug']));
        $statement->bindValue(':iznosPot', str_replace(',', '.', $slog['iznosPot']));
        $statement->bindValue(':iznosOtv', str_replace(',', '.', $slog['iznosDug']) + str_replace(',', '.',$slog['iznosPot']));
        $statement->bindValue(':donosDug', str_replace(',', '.',$slog['donosDug']));
        $statement->bindValue(':donosPot', str_replace(',', '.', $slog['donosPot']));
        $statement->bindValue(':brojDobRacuna', $slog['brojDobRacuna']);
        //$statement->bindValue(':iznosPdv', $slog['iznosPdv']);
        $statement->bindValue(':vrstaRacuna', $slog['vrstaRacuna']);
        $statement->bindValue(':PDVstatus', $slog['PDVstatus']);
        //$statement->bindValue(':neoporezivIznos', $slog['neoporezivIznos']);
        $statement->bindValue(':opisKnjizenja', $slog['opisKnjizenja']);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
        //return $poreznaGrupa;
    } catch (PDOException $e) {
        if($transakcija) {
            $db->rollBack();
        }
        $error_message = $e->getMessage();
        display_db_error($error_message);
        return;
    }
    if(isset($slog['gk_pdv']))
        add_pdv_stavku($slog, $db);
}    

function add_pdv_stavku($slog,$uldb=null,$transakcija=false) {
    if($uldb==null)
        global $db;
    else 
        $db=$uldb;
    $email_user = $_SESSION['admin']['email'];
    if(isset($slog['gk_pdv'])) {
        $query = "
        INSERT INTO gk_pdv
        (
            brojTemeljnice, 
            brojStavke,
            poreznaGrupa,
            PDV,
            osnovica,
            iznosPDV,
            neMozeSeOdbiti,
            datumOtvaranja,
            tkoJeIzmjenio
        )
        VALUES
        (
            :brojTemeljnice, 
            :brojStavke,
            :poreznaGrupa,
            :PDV,
            :osnovica,
            :iznosPDV,
            :neMozeSeOdbiti,
            NOW(), 
            :email_user 
        )";
        try {
            $statement = $db->prepare($query);
            $statement->bindValue(':brojTemeljnice', $slog['brojTemeljnice']);
            $statement->bindValue(':brojStavke', $slog['brojStavke']);
            foreach ($slog['gk_pdv'] as $gk_pdv) {
                if((float)str_replace(',', '.', $gk_pdv['osnovica'])==0)
                    continue;
                $statement->bindValue(':poreznaGrupa', $gk_pdv['poreznaGrupa']);
                $statement->bindValue(':PDV', $gk_pdv['PDV']);
                $statement->bindValue(':osnovica', str_replace(',', '.', $gk_pdv['osnovica']));
                $statement->bindValue(':iznosPDV', str_replace(',', '.', $gk_pdv['iznosPDV']));
                $statement->bindValue(':neMozeSeOdbiti', str_replace(',', '.', $gk_pdv['neMozeSeOdbiti']));
                $statement->bindValue(':email_user', $email_user);
                $statement->execute();
                $statement->closeCursor();
            }
        } catch (PDOException $e) {
            if($transakcija) {
                $db->rollBack();
            }
            $error_message = 'Tablica: gk_pdv <br>'.$e->getMessage();
            display_db_error($error_message);
        }
    }
}

function update_gk_stavku($slog,$transakcija=false) {
     if (!isset($slog['pozivNaBroj'])) $slog['pozivNaBroj']='';
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = "
        UPDATE gk_stavke
        SET
            konto=:konto,
            kodPartnera=:kodPartnera,
            pozivNaBroj=:pozivNaBroj,
            vrsDo=:vrsDo,
            broDo=:broDo,
            brojIzvoda=:brojIzvoda,
            DVO=:DVO,
            valuta=:valuta, 
            iznosDug=:iznosDug,
            iznosPot=:iznosPot,
            iznosOtv=:iznosOtv,
            brojDobRacuna=:brojDobRacuna,
            vrstaRacuna=:vrstaRacuna,
            PDVstatus=:PDVstatus,
            opisKnjizenja=:opisKnjizenja,
            datumIzmjene=NOW(),
            tkoJeIzmjenio=:email_user
        WHERE 
            brojTemeljnice=:brojTemeljnice 
            AND brojStavke=:brojStavke
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $slog['brojTemeljnice']);
        $statement->bindValue(':brojStavke', $slog['brojStavke']);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->bindValue(':kodPartnera', $slog['kodPartnera']);
        $statement->bindValue(':pozivNaBroj', $slog['pozivNaBroj']);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);
        $statement->bindValue(':brojIzvoda', $slog['brojIzvoda']);

        $d1=new DateTime($slog['DVO']);
        $datum = $d1->format('Y-m-d H:i:s');
        $statement->bindValue(':DVO', $datum);
        
        if(trim($slog['valuta'])=='')
            $statement->bindValue(':valuta', null, PDO::PARAM_NULL);   
        else 
        {
            $d1=new DateTime($slog['valuta']);
            $datum = $d1->format('Y-m-d H:i:s');
            $statement->bindValue(':valuta', $datum);
        }
        $statement->bindValue(':iznosDug', str_replace(',', '.',$slog['iznosDug']));
        $statement->bindValue(':iznosPot', str_replace(',', '.', $slog['iznosPot']));
        $statement->bindValue(':iznosOtv', str_replace(',', '.', $slog['iznosDug']+$slog['iznosPot']));
        $statement->bindValue(':brojDobRacuna', $slog['brojDobRacuna']);
        //$statement->bindValue(':iznosPdv', $slog['iznosPdv']);
        $statement->bindValue(':vrstaRacuna', $slog['vrstaRacuna']);
        $statement->bindValue(':PDVstatus', $slog['PDVstatus']);
        //$statement->bindValue(':neoporezivIznos', $slog['neoporezivIznos']);
        $statement->bindValue(':opisKnjizenja', $slog['opisKnjizenja']);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        if($transakcija) {
            $db->rollBack();
        }
        $error_message = $e->getMessage();
        display_db_error($error_message);
        return;
    }
    delete_gk_pdv_stavku($slog["brojTemeljnice"], $slog["brojStavke"]);
    add_pdv_stavku($slog);
}    

function update_gk_iznosOtv($vrsDo, $broDo, $DVO, $konto, $kodPartnera, $iznosOtv) {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = "
        UPDATE gk_stavke
        SET
            iznosOtv=:iznosOtv,
            datumIzmjene=NOW(),
            tkoJeIzmjenio=:email_user
        WHERE 
            konto=:konto AND kodPartnera=:kodPartnera AND vrsDo=:vrsDo AND broDo=:broDo AND DVO=:DVO
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':konto', $konto);
        $statement->bindValue(':kodPartnera', $kodPartnera);
        $statement->bindValue(':iznosOtv', $iznosOtv);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
        return;
    }
}    

function update_gk_izvod($brojTemeljnice, $brojIzvoda, $DVO) {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = "
        UPDATE gk_stavke
        SET
            DVO=:DVO,
            valuta=:DVO,
            datumIzmjene=NOW(),
            tkoJeIzmjenio=:email_user
        WHERE 
            brojTemeljnice=:brojTemeljnice AND brojIzvoda=:brojIzvoda
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojIzvoda', $brojIzvoda);
        $d1=new DateTime($DVO);
        $datum = $d1->format('Y-m-d H:i:s');
        $statement->bindValue(':DVO', $datum);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
        return;
    }
}    

function  knjizi_temeljnicu(&$temeljnica) {
    //brisi_temeljnicu($temeljnica[0]['brojTemeljnice']);
    $i=0;
    foreach ($temeljnica as $slog) {
        if($slog['izmjenjeno']) {
            $stavka=get_gk_stavku($slog["brojTemeljnice"], $slog["brojStavke"]);
            if(is_array($stavka))
                update_gk_stavku($slog);
            else
                add_gk_stavku($slog);
            if(isset($slog['noveVeze'])) {
                zatvaranjeStavaka($slog['noveVeze']['lijeviDok'], $slog['noveVeze']['vezniDok'], $slog['noveVeze']['iznosVeza']);
                unset($slog['noveVeze']);
            }
            $temeljnica[$slog['brojStavke']-1]['izmjenjeno']=false;
        }
        $i++;
    }
}

function brisi_temeljnicu($brojTemeljnice,$brojIzvoda='',$kakoBrise='') {
    global $db;
    if($kakoBrise=='otvorene')
        $dioSQL="AND (trim(ifnull(kodPartnera,''))='' OR iznosOtv=iznosDug+iznosPot)";
    else
        $dioSQL='';
    $query = "
        DELETE
        FROM gk_stavke
        WHERE brojTemeljnice = :brojTemeljnice
        AND (brojIzvoda=:brojIzvoda or trim(:brojIzvoda)='')
        $dioSQL
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojIzvoda', $brojIzvoda);
        $statement->execute();
    } catch (PDOException $e) {
        $error_message = 'Tablica: gk_stavke <br>'.$e->getMessage();
        display_db_error($error_message);
        return;
    }
    if($brojIzvoda=='') {
       // ako brišemo jedan broj izvoda, brišemo virmane. Virmani nemaju razradu po pdv-u         
        $query = " 
            DELETE
            FROM gk_pdv
            WHERE brojTemeljnice = :brojTemeljnice
            ";
        try {
            $statement = $db->prepare($query);
            $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
            $statement->execute();
        }
        catch (PDOException $e) {
            $error_message = 'Tablica: gk_pdv <br>'.$e->getMessage();
            display_db_error($error_message);
        }
    }    
}

function delete_gk_pdv_stavku($brojTemeljnice, $brojStavke, $transakcija=false) {
    global $db;
    $query = '
        DELETE
        FROM gk_pdv
        WHERE brojTemeljnice = :brojTemeljnice
        AND brojStavke = :brojStavke';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->execute();
    } catch (PDOException $e) {
        if($transakcija) {
            $db->rollBack();
        }
        $error_message = 'Tablica: gk_pdv <br>'.$e->getMessage();
        display_db_error($error_message);
        return;
    }
}    

function delete_gk_stavku($brojTemeljnice, $brojStavke,$transakcija=false) {
    global $db;
    delete_gk_pdv_stavku($brojTemeljnice, $brojStavke);
    $query = '
        DELETE
        FROM gk_stavke
        WHERE brojTemeljnice = :brojTemeljnice
        AND brojStavke = :brojStavke';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->execute();
    } catch (PDOException $e) {
        if($transakcija) {
            $db->rollBack();
        }
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    
}

function get_URA_knj($proda, $DVOod, $DVOdo, $poSkladistima='N',$kodPartnera='',$PDVstatus='S') {
    global $db;
    
    $query = "
select 
if(:poSkladistima='D',
if(locate('-',broDo)>0,SUBSTRING_INDEX(broDo,'-',1),'zz'),'') as proda,
s.`brojTemeljnice`,
s.`brojStavke`,
s.broDo,
s.`DVO`,
s.`kodPartnera`,
if(s.`iznosPot`<>0,s.`iznosPot`, s.`iznosDug`) as iznosSPDVom,
pp.nazivPartnera,
pp.ulicaBroj,
pp.mjestoSjedista,
pp.OIB
from gk_stavke as s
left outer join partner as pp on pp.kodPartnera=s.kodPartnera
where vrsDo in ('10','11','12')
and trim(s.kodPartnera)<>''
and s.DVO between :DVOOd and :DVODo
and (s.kodPartnera=:kodPartnera or trim(:kodPartnera)='')
and (PDVStatus=:PDVStatus or :PDVStatus ='S') 
and (s.broDo like :proda or trim(:proda)='' or trim(:proda)='0')
order by
proda,
DVO,
broDo
          ";

    $DVO_o = new DateTime($DVOod);
    $DVO_o2 = new DateTime($DVOdo);

    $statement = $db->prepare($query);
    // /*
    if($proda!='0')
        $proda=trim($proda).'%';
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':poSkladistima', $poSkladistima);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->bindValue(':PDVStatus', $PDVstatus);
    
     // */
    $statement->execute();
    $knjiga= $statement->fetchAll();
    $statement->closeCursor();
    return $knjiga;
    
}

function get_URA_stopa($brojTemeljnice, $brojStavke, $stopa) {
    global $db;
    
    $query = "
        select s.*, p.`PDV` 
        from gk_pdv as s
        inner join porezi as p on p.`poreznaGrupa`=s.`poreznaGrupa`
        where brojTemeljnice=:brojTemeljnice 
        and brojStavke=:brojStavke
        and p.PDV=:PDV
          ";

    $statement = $db->prepare($query);
    // /*
    $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
    $statement->bindValue(':brojStavke', $brojStavke);
    $statement->bindValue(':PDV', $stopa);
     // */
    $statement->execute();
    $knjiga= $statement->fetch();
    $statement->closeCursor();
    return $knjiga;
    
}

function get_gk_max_brojStavke($brojTemeljnice, $uldb=null) {
    if($uldb==null)
        global $db;
    else 
        $db=$uldb;
    $query = "
        select ifnull(max(brojStavke),0) maxBrojStavke 
        from gk_stavke
        where brojTemeljnice=:brojTemeljnice
    ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result['maxBrojStavke'];
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_gk_za_zatvaranje($konto, $kodPartnera, $brojTemeljnice,$brojStavke) {
    global $db;
    $query = "
        select gk.*,
        vd.oznakaDokumenta,
        if(gk.`iznosDug`<>0, gk.`iznosOtv`,0) as iznosOtvDug,
        if(gk.`iznosPot`<>0, gk.`iznosOtv`,0) as iznosOtvPot
        from gk_stavke as gk
        left outer join vrste_dokumenata as vd on vd.vrsDo=gk.vrsDo
        where konto=:konto
        and kodPartnera=:kodPartnera
        and not (gk.brojTemeljnice=:brojTemeljnice and gk.brojStavke=:brojStavke)
        and gk.iznosOtv<>0
        order by gk.valuta, gk.broDo        
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':konto', $konto);
        $statement->bindValue(':kodPartnera', $kodPartnera);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function kreiraj_gk_pdv_iz_gk_stavki() {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = "
        SELECT brojTemeljnice,brojStavke,iznosPdv,neoporezivIznos
        FROM gk_stavke
        WHERE vrsDo = '11' ";
    try {
        $statement = $db->prepare($query);        
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();       
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    $brojac = 0;
    foreach ($result as $p ) {
       $query = "
        INSERT INTO gk_pdv
        (
            brojTemeljnice, 
            brojStavke,
            poreznaGrupa,
            PDV,
            osnovica,
            iznosPDV,
            datumOtvaranja,
            tkoJeIzmjenio
        )
        VALUES
        (
            :brojTemeljnice, 
            :brojStavke,
            :poreznaGrupa,
            :PDV,
            :osnovica,
            :iznosPDV,
            NOW(), 
            :email_user 
        )";
        try {
            $statement = $db->prepare($query);          
            $statement->bindValue(':brojTemeljnice', $p['brojTemeljnice']);
            $statement->bindValue(':brojStavke', $p['brojStavke']); 
            $PDV = 25; $poreznaGrupa = 'A'; $osnovica = round(($p['iznosPdv'] * 100 / 25),2); 
            $statement->bindValue(':poreznaGrupa', $poreznaGrupa);
            $statement->bindValue(':PDV', $PDV);
            $statement->bindValue(':osnovica', $osnovica);
            $statement->bindValue(':iznosPDV', $p['iznosPdv']);
            $statement->bindValue(':email_user', $email_user);
            $statement->execute();
            $statement->closeCursor();    
            $brojac = $brojac + 1;
        } catch (PDOException $e) {
            $error_message = 'Tablica: gk_pdv <br>'.$e->getMessage();
            display_db_error($error_message);
        }
        
        if ($p['neoporezivIznos'] != 0) {
 //upis drugog sloga jer na starom je to bio jedan slog(oporeziv dio i neoporeziv dio)        
            try {
                $statement = $db->prepare($query);          
                $statement->bindValue(':brojTemeljnice', $p['brojTemeljnice']);
                $statement->bindValue(':brojStavke', $p['brojStavke']); 
                $PDV = 0; $poreznaGrupa = 'N'; $osnovica = $p['neoporezivIznos']; $iznosPDV = 0;
                $statement->bindValue(':poreznaGrupa', $poreznaGrupa);
                $statement->bindValue(':PDV', $PDV);
                $statement->bindValue(':osnovica', $osnovica);
                $statement->bindValue(':iznosPDV', $iznosPDV);
                $statement->bindValue(':email_user', $email_user);
                $statement->execute();
                $statement->closeCursor();
                echo 'Ima neoporeziv dio UFO Broj temeljnice;'  . $p['brojTemeljnice'] . ' broj stavke: ' . $p['brojStavke'] . '</br>';  
            $brojac = $brojac + 1;
           } catch (PDOException $e) {
            $error_message = 'Tablica:  2 gk_pdv <br>'.$e->getMessage();
            display_db_error($error_message);
           }            
        }
    }
    echo 'Upisano stavki u gk_pdv:' . $brojac;
}

function veza_na_robno($slog) {
    if(trim($_SESSION['godina_b'])!='')
        // ako je arhiva
        $godina=$_SESSION['godina_b'];
    else {    
        $danas= new DateTime();
        // tekuća godina
        $godina=$danas->format("Y");
    }
    $DVO=new DateTime($slog['DVO']);
    $DVOGodina=$DVO->format("Y");
    if($godina!=$DVOGodina ) {
        // DVO nije u tekućoj godina pa u robnom nemna tog dokumenta
        $baza=$_SESSION['odabranaBaza'];
        if(trim($_SESSION['godina_b'])!='')
            $baza=str_replace('_'.substr($_SESSION['godina_b'], 2, 2), '', $baza);
        $baza= $_SESSION['odabranaBaza'].'_'.substr($DVOGodina, 2, 2);
        if(!postoji_baza($baza))
        return false;
    }
    $pomArray=explode('-', $slog['broDo']);
    if(count($pomArray)<2)
        // nije u formatu broja dokumenta
        return false;
    
    // u prvom dijelu broDo mora biti poslovnica. ako nije, dokument se ne nalazi u robnom
    $poslovnica=get_poslovnica($pomArray[0]);
  
    if(is_array($poslovnica)) {
        if(count($poslovnica)<1)
            return false;
    }
    if(!isset($poslovnica['kodPoslovnice']))
        return false;
    
    // gleda dali ima verziju
    $broDo=  explode('/', $pomArray[1]);
    
    // dali u broju imamo i godinu
    $n=count($broDo);
    if($n>1 && ($broDo[$n-1]==$DVOGodina || $broDo[$n-1]==substr($DVOGodina, 2, 2))) {
        $broDo[$n-1]='';
    }
    
    $robniDokument['proda']=$poslovnica['kodPoslovnice'];
    if($slog['vrsDo']=='10')
        $robniDokument['vrsDo']='1 ';
    else if($slog['vrsDo']=='20')
        $robniDokument['vrsDo']='5 ';
    else if($slog['vrsDo']=='24')
        $robniDokument['vrsDo']='5U';
    else 
        return false;

    $robniDokument['proIn']='';
    $robniDokument['zapis']='';
    $robniDokument['broDo']=$broDo[0];
    $robniDokument['verzi']=count($broDo)>1?$broDo[1]:'';
    return $robniDokument;
}

function pretvoriBrojRobnoGk(&$proda='',&$vrsDo='',&$proIn='',&$zapis='',&$broDo=0,&$verzi='',&$broDoGk='',&$vrsDoGk='') {
/*pretvara iz robnog u broj za gk_stavke (ako su popunjene proda...
   i kontra ako su popunjeni brodoGk i vrsdoGk
 */    

$broDoGkOrg = $broDoGk;    
   
if (trim($proda) !='') {
      
   if (trim($zapis)=='') $broDoGk = $proda . '-' . $broDo; /* obični broj  2302-58 */
   else $broDoGk = $proda . '-' . trim($zapis) . $broDo;   /* ima zapisnik  2302-KN58 */  
   
   if (trim($proIn) != '' ) $broDoGk = $proda . '-'  . $proIn . '-' . $broDo; /* samo za ulazne interne fakture ovo postoji 2316-2302-58  */
  
   if (trim($verzi) !='') $broDoGk .= '/' . trim($verzi);  /* ima verzija 2302-58/PO  2302-KN58/ISP  2316-2302-58/DOP */
   
   if (trim($vrsDo)=='5') $vrsDoGk='20'; if (trim($vrsDo)=='6') $vrsDoGk='65'; if (trim($vrsDo)=='2') $vrsDoGk='66';
   if (trim($vrsDo) =='5U') $vrsDoGk='24'; if (trim($vrsDo) =='K') $vrsDoGk='10'; 
   if (trim($vrsDo) =='8') $vrsDoGk='35'; if ( trim($vrsDo) =='3' && ($zapis=='KN' || $zapis=='NC'  || $zapis=='PC' || $zapis=='SC') ) $vrsDoGk='85';
 
} 

if (trim($broDoGkOrg) !='') {
/* pretvorba iz gk u robni oblik broja dokumenta */    
    
}
return; 
}

function saldaBrutoBilanca($DVOod,$DVOdo,$kontoOd='0',$kontoDo='999999') {
    global $db;
    
$query = "select
    konto, 
    sum(donosD) as donosD, 
    sum(donosP) as donosP, 
    sum(prometD) as prometD, 
    sum(prometP) as prometP    
    from 
    (
        select  
          konto,           
          if(brojTemeljnice=1,iznosDug,0) as donosD,
          if(brojTemeljnice=1,iznosPot,0) as donosP,
          if(brojTemeljnice<>1,iznosDug,0) as prometD,
          if(brojTemeljnice<>1,iznosPot,0) as prometP
        from gk_stavke 
        where DVO between :DVOOd and :DVODo
        and konto between :kontoOd and :kontoDo
    ) as t
    group by
    konto;  
    ";  
    $DVO_o = new DateTime($DVOod);
    $DVO_o2 = new DateTime($DVOdo);
    $statement = $db->prepare($query);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':kontoOd', $kontoOd);   
    $statement->bindValue(':kontoDo', $kontoDo);
    $statement->execute();
    $rezultat= $statement->fetchAll();
    $statement->closeCursor();
    return $rezultat; 
} 

function gk_datumski_parametri($parametri) {
	global $maxDatum, $minDatum;
    if(trim($parametri['DVOod'])=='') $parametri['DVOod']=$minDatum;
    // maksimum DateTime (ne može više zbod Y2K38 errora)
    if(trim($parametri['DVOdo'])=='') $parametri['DVOdo']=$maxDatum;
    $datumi['DVOod']=$datumi['valutaod']=$datumi['datumOtvaranjaod']=$minDatum;
    $datumi['DVOdo']=$datumi['valutado']=$datumi['datumOtvaranjado']=$maxDatum;

    if(trim($parametri['DVOod'])=='')
        $od='';
    else {
        $d1=new DateTime($parametri['DVOod']);
        $od = $d1->format('Y-m-d H:i:s');
    }
    if(trim($parametri['DVOdo'])=='')
        $do='';
    else {
        $d1=new DateTime($parametri['DVOdo']);
        //$do = $d1->format('Y-m-d H:i:s');
        $do = $d1->format('Y-m-d 23:59:59');
    }
    switch ($parametri['kojiDatum']) {
    case 'DVO':
        $datumi['DVOod']=$od;
        $datumi['DVOdo']=$do;
        break;
    case 'dospijece':
        $datumi['valutaod']=$od;
        $datumi['valutado']=$do;
        break;
    case 'unosa':
        $datumi['datumOtvaranjaod']=$od;
        $datumi['datumOtvaranjado']=$do;
        break;
    }
    if(isset($parametri['valutaod']) || isset($parametri['valutado'])) {
        $od=$do='';
        if(isset($parametri['valutaod']))
            if(trim($parametri['valutaod'])!='') {
                $d1=new DateTime($parametri['valutaod']);
                $od = $d1->format('Y-m-d H:i:s');                
            }
        if(isset($parametri['valutado']))
            if(trim($parametri['valutado'])!='') {
                $d1=new DateTime($parametri['valutado']);
                $do = $d1->format('Y-m-d H:i:s');                
            }

        $datumi['valutaod']=$od;
        $datumi['valutado']=$do;
    }    
    return $datumi;
}

function gk_datumski_parametri_tj($parametri) {
    $datumi['DVOod']=$datumi['DVOdo']=$datumi['valutaod']=$datumi['valutado']=$datumi['datumOtvaranjaod']=$datumi['datumOtvaranjado']='';
    
        $danas = new DateTime();
        $danas = $danas->format('Y-m-d 23:59:59');
        $davno = '1900-01-01 00:00:00';
        
        $buducaValuta = new DateTime();
        $today = getdate();
        $year = $today['year'] + 3;
        $buducaValuta->setDate($year, 1, 1);       
        $buducaValuta = $buducaValuta->format('Y-m-d 23:59:59');
        
        $datumi['DVOod']=$datumi['valutaod']=$datumi['datumOtvaranjaod']=$davno;
        $datumi['DVOdo']=$datumi['datumOtvaranjado']=$danas;
        $datumi['valutado']=$buducaValuta;
        
    if(trim($parametri['DVOod'])=='') {
        $od='';
          $od=$davno;
    } else {
        $d1=new DateTime($parametri['DVOod']);
        $od = $d1->format('Y-m-d H:i:s');
    }
    if(trim($parametri['DVOdo'])=='') {
        $do=''; // kod stare baze
          $do = $danas; // kod nove baze
     if ($parametri['kojiDatum'] == 'dospijece' ) {
              $do = $buducaValuta;
          }
  
    } else {
        $d1=new DateTime($parametri['DVOdo']);
        //$do = $d1->format('Y-m-d H:i:s');
        $do = $d1->format('Y-m-d 23:59:59');
    }
    switch ($parametri['kojiDatum']) {
    case 'DVO':
        $datumi['DVOod']=$od;
        $datumi['DVOdo']=$do;
        break;
    case 'dospijece':
        $datumi['valutaod']=$od;
        $datumi['valutado']=$do;
        break;
    case 'unosa':
        $datumi['datumOtvaranjaod']=$od;
        $datumi['datumOtvaranjado']=$do;
        break;
    }
    if(isset($parametri['valutaod']) || isset($parametri['valutado'])) {
        $od=$do='';
        if(isset($parametri['valutaod']))
            if(trim($parametri['valutaod'])!='') {
                $d1=new DateTime($parametri['valutaod']);
                $od = $d1->format('Y-m-d H:i:s');                
            }
        if(isset($parametri['valutado']))
            if(trim($parametri['valutado'])!='') {
                $d1=new DateTime($parametri['valutado']);
                $do = $d1->format('Y-m-d H:i:s');                
            }

        $datumi['valutaod']=$od;
        $datumi['valutado']=$do;
    }    
    return $datumi;
}

function prijenos_u_novu_godinu($godina, $prenosiSe, $minSaldo) {
    ini_set('max_execution_time', 3000);     
    
    require_once('./model/konta_db.php');
    
    global $db;
    $b=explode('_', $_SESSION['odabranaBaza']);
    unset($b[count($b)-1]);
    $baza=implode('_', $b);
    
    $finStavaka=$skStavaka=0;
    // brisanje starih podataka
    $query = "
        DELETE FROM $baza.gk_stavke
        WHERE brojTemeljnice=1
        AND (:prenosiSe=''
         OR (:prenosiSe='f' AND trim(kodPartnera)='') 
         OR (:prenosiSe='s' AND trim(kodPartnera)<>'')) 
    ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':prenosiSe', $prenosiSe);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    
    if($prenosiSe=='' || $prenosiSe=='s') {
        $query = "
            DELETE FROM $baza.gk_pdv
            WHERE brojTemeljnice=1
        ";
        try {
            $statement = $db->prepare($query);
            $statement->execute();
            $statement->closeCursor();
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        }        
    }
    
    // prijenos financijskih konta
    if($prenosiSe=='' || $prenosiSe=='f') {
        $DVO=(string)($godina+1).'-01-01 00:00:00';
        $query = "
        INSERT INTO $baza.gk_stavke
        (
        brojTemeljnice, brojStavke, vrsDo, broDo, brojIzvoda, konto, kodPartnera, DVO, valuta, 
        brojDobRacuna,
        opisKnjizenja,
        iznosPdv,
        vrstaRacuna, 
        neoporezivIznos,
        iznosDug, iznosPot, iznosOtv,
        donosDug, donosPot ,
        datumOtvaranja, tkoJeIzmjenio
        )
        SELECT 
        1 as brojTemeljnice, @b:=@b+1 as brojStavke, '48' as vrsDo, 1 as broDo, 0 as brojIzvoda, 
        f.konto, '' as kodPartnera, :DVO as DVO, :DVO as valuta,
        '' as brojDobRacuna,
        '' as opisKnjizenja,
        0 as iznosPdv,
        '' as vrstaRacuna, 
        0 as neoporezivIznos, 
        if(saldo>0, saldo,0) as iznosDug,
        if(saldo<0, -saldo,0) as iznosPot,        
        0 as iznosOtv,
        duguje as donosDug,
        potrazuje as domosPot, 
        NOW() as datumOtvaranja, 
        'DONOS' as tkoJeIzmjenio
        FROM 
        ( 
        SELECT 
        gk.konto, sum(iznosDug) as duguje, sum(iznosPot) as potrazuje,
        sum(iznosDug-iznosPot) as saldo
        FROM gk_stavke as gk
        INNER JOIN konta as k ON k.konto=gk.konto
        WHERE k.`vrstaKonta`='F'
        GROUP BY gk.konto
        -- HAVING abs(sum(iznosDug-iznosPot))>=@mimSaldo
        ) AS f,
        (SELECT @b:=ifnull(max(brojStavke),0) FROM $baza.gk_stavke WHERE brojTemeljnice=1) as n
        ";
        try {
            $statement = $db->prepare($query);
            $statement->bindValue(':DVO', $DVO);
            $statement->execute();
            $finStavaka = $statement->rowCount();
            $statement->closeCursor();
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        }        
    }

    if($prenosiSe=='' || $prenosiSe=='s') {
        $query = "
        SELECT
        gk.*, iznosOtv as otvoreno
        FROM gk_stavke as gk
        INNER JOIN konta as k ON k.konto=gk.konto
        WHERE k.`vrstaKonta`='S'
        AND ABS(iznosOtv)>:mimSaldo
        ";
        try {
            $statement = $db->prepare($query);
            $statement->bindValue(':mimSaldo', $minSaldo);
            $statement->execute();
            $sk = $statement->fetchAll();
            $statement->closeCursor();
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        }
        $skStavaka=count($sk);
        $password = 'a83bmi';
        $novaDB=konekcijaNaBazu($_SESSION['username'], $password, $baza);

        $brStavke=  get_gk_max_brojStavke(1, $novaDB);
        foreach ($sk as $slog) {
            if($slog['vrsDo']=='11') {
                $pdv=get_gk_pdv($slog['brojTemeljnice'], $slog['brojStavke']);
                if(count($pdv))
                    $slog['gk_pdv']=$pdv;
            }
            $slog['brojTemeljnice']=1;
            $slog['brojStavke']=++$brStavke;
            $pomGodina=substr($slog['DVO'], 0, 4);
            $slog['donosDug']=$slog['iznosDug'];
            $slog['donosPot']=$slog['iznosPot'];
            if($slog['iznosDug']<>0)
                $slog['iznosDug']=$slog['iznosOtv'];
            else
                $slog['iznosPot']=$slog['iznosOtv'];
            if((string)$godina==$pomGodina) {
                $slog['broDo'].='/'.substr($pomGodina,-2);
            }
            add_gk_stavku($slog, $novaDB);
        }
    }
  /*   $query = "
            UPDATE $baza.gk_stavke 
            set iznosDug = 0, iznosPot = 0
            where (konto like '7%' or konto like '4%' or konto like '8%')
            and brojTemeljnice = 1
            ";
   */
       $query = "
            DELETE FROM $baza.gk_stavke            
            where (konto like '7%' or konto like '4%' or konto like '8%')
            and brojTemeljnice = 1
            ";
  
        try {
            $statement = $db->prepare($query);
            $statement->execute();
            $statement->closeCursor();
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        }            
   $poruka='Preneseno je ';
   if($finStavaka>0)
       $poruka.=$finStavaka. ' financijskih ';
   if($skStavaka>0) {
       if($finStavaka>0)
           $poruka.='i ';
       $poruka.=$skStavaka.' salda-konto ';
   }
   return $poruka.'stavaka.';
}
function  citajDokZag($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi) {
    global $db;
    /* ne čita u prošlim godinama ! */
$query = "select * from dok_zag 
   where :proda = proda and :vrsDo = vrsDo and :proIn = proIn and :zapis = zapis and broDo = :broDo and verzi = :verzi
    ";     
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);   
    $statement->execute();
    $rezultat= $statement->fetch();
    $statement->closeCursor();
    return $rezultat; 
} 

?>