
function get_kamatneStope() {
    global $db;
    $query = 'SELECT * FROM kamatneStope'; 
	try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_kamatneStopePoVrsti($vrstaKamStope) {
    global $db;
    $query = "SELECT * FROM kamatneStope WHERE vrstaKamStope=:vrstaKamStope"; 
	try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrstaKamStope', $vrstaKamStope);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function get_konto($konto) {
    global $db;
    $query = '
        SELECT *
        FROM kamatneStope
        WHERE konto = :konto';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':konto', $konto);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function add_kamatneStope($slog) {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = "
        INSERT INTO kamatneStope
        (
            vrstaKamStope,
            datumOd,
            datumDo,
            nazivKamate,
            kamatnaStopa,
            datumOtvaranja,
            tkoJeIzmjenio
        )
        VALUES
        (
            :vrstaKamStope,
            :datumOd,
            :datumDo,
            :nazivKamate,
            :kamatnaStopa,
            NOW(), 
            :email_user 
        )";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrstaKamStope', $slog['vrstaKamStope']);
        $statement->bindValue(':datumOd', $slog['datumOd']);
        $statement->bindValue(':nazivKamate', $slog['nazivKamate']);
        $statement->bindValue(':kamatnaStopa', $slog['kamatnaStopa']);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
        //return $poreznaGrupa;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function update_kamatneStope($slog) {
    global $db;
	$email_user = $_SESSION['admin']['email'];
    $query = '
        UPDATE kamatneStope
        SET 
            vrstaKamStope = :vrstaKamStope,
            datumOd = :datumOd,
            datumDo = :datumDo,
            nazivKamate = :nazivKamate,
            kamatnaStopa = :kamatnaStopa,
            datumIzmjene = NOW(),
            tkoJeIzmjenio = :email_user
        WHERE vrstaKamStope = :vrstaKamStope and datumOd = :datumOd';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrstaKamStope', $slog['vrstaKamStope']);
        $statement->bindValue(':datumOd', $slog['datumOd']);
        $statement->bindValue(':datumDo', $slog['datumDo']);
        $statement->bindValue(':nazivKamate', $slog['nazivKamate']);
        $statement->bindValue(':kamatnaStopa', $slog['kamatnaStopa']);        
        $statement->bindValue(':email_user', $email_user); 
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function delete_kamatneStope($konto) {
    global $db;
    $query = 'DELETE FROM kamatneStope WHERE konto = :konto';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':konto', $konto);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

