<?php

function add_veze($brojTemeljnice, $brojStavke, $vBrojTemeljnice, $vBrojStavke, $iznosVeze) {
    global $db;
    $dokument=get_gk_stavku($brojTemeljnice, $brojStavke);
    $vezniDokument=get_gk_stavku($vBrojTemeljnice, $vBrojStavke);
    //iznos veze se upisuje s predznakom lijevog dokumenta
    $predznakVeze=round($iznosVeze/abs($iznosVeze),0);  //round radim ako slučajno rezultat nije 1 npr. 1.00000003 ili 0.99999998
    $predznakDokumenta=round($dokument['iznosOtv']/abs($dokument['iznosOtv']),0);
    $iznosiNaIstojStrani=($dokument['iznosDug']==0 && $vezniDokument['iznosDug']==0) || ($dokument['iznosPot']==0 && $vezniDokument['iznosPot']==0);
    if($predznakVeze!=$predznakDokumenta && $iznosiNaIstojStrani) {
        $iznosVeze=-$iznosVeze;
    }    
    $email_user = $_SESSION['admin']['email'];
    $query = "
        INSERT INTO veze
        (
            konto,
            kodPartnera,
            vrsDo,
            broDo,
            DVO,
            vKonto,
            vKodPartnera,
            vVrsDo,
            vBroDo, 
            vDVO,
            iznosVeze,
            datumOtvaranja,
            tkoJeIzmjenio
        )
        VALUES
        (
            :konto,
            :kodPartnera,
            :vrsDo,
            :broDo,
            :DVO,
            :vKonto,
            :vKodPartnera,
            :vVrsDo,
            :vBroDo, 
            :vDVO,
            :iznosVeze,                                                                   
            NOW(), 
            :email_user 
        )";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':konto', $dokument['konto']);
        $statement->bindValue(':kodPartnera', $dokument['kodPartnera']);
        $statement->bindValue(':vrsDo', $dokument['vrsDo']);
        $statement->bindValue(':broDo', $dokument['broDo']);
        $statement->bindValue(':DVO', $dokument['DVO']);
        $statement->bindValue(':vKonto', $vezniDokument['konto']);
        $statement->bindValue(':vKodPartnera', $vezniDokument['kodPartnera']);
        $statement->bindValue(':vVrsDo', $vezniDokument['vrsDo']);
        $statement->bindValue(':vDVO', $vezniDokument['DVO']);
        
        $statement->bindValue(':vBroDo', $vezniDokument['broDo']);
        $statement->bindValue(':iznosVeze', $iznosVeze);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    //
    
    update_gk_iznosOtv($dokument['vrsDo'], $dokument['broDo'], $dokument['DVO'],$dokument['konto'], $dokument['kodPartnera'], $dokument['iznosOtv']-$iznosVeze);
    
    /*
    Kod veznog dokumenta: 
    uspoređuju se da li su Dugovno/Potrazno  isti za GLAVNI
    i VEZNI. Ako su isti, iznos veze mijenja predznak 
    jer se kod povezivanja uzima uvijek predznak polaznog dokumenta,
    a u vezama nije navedeno polje Dugovno/Potrazno, tako da se
    kod sumiranja po vezama o ovome mora voditi racuna.
     */
    $istiDugujePotrazuje=$dokument['iznosDug']==0 && $vezniDokument['iznosDug']==0 
                      || $dokument['iznosPot']==0 && $vezniDokument['iznosPot']==0;
    if($istiDugujePotrazuje)
        $iznosVeze=-$iznosVeze;
    update_gk_iznosOtv($vezniDokument['vrsDo'], $vezniDokument['broDo'], $vezniDokument['DVO'], $vezniDokument['konto'], $vezniDokument['kodPartnera'], $vezniDokument['iznosOtv']-$iznosVeze);
}
function delete_veze($slogVeze) {
    global $db; 
  
/* iz view_fin_kartica poziva se funkcija otvaranjeStavke($stavka)  ($stavka je komplet slog gk_stavke)
  function otvaranjeStavke($stavka) je u knjigovodstvo/model/cart_gk) i unutar sebe prvo poziva  $veze=get_veze_po_dokumentu($stavka);
 * get_veze_po_dokumentu($stavka) odabere sve veze PO JEDNOM DOKUMENTU bilo kao glavni ili vezni 
  Funkcija otvaranjeStavke($stavka) preko foreacha poziva(vrti) jedan po jedan slog iz veza po dokumentu koji se otpaja,
 *   foreach  
 *           delete_veze($slogVeze) (briše se 1 slog u veze koji sadrži 2 dokumenta: glavni(polazni kod spajanja) i vezni).          
             (jedan slog za veze po tom jednom dokumentu (glavni ili vezni) se briše
             a otvoreni iznos se updata za oba dokumentata 2 puta se poziva
             funkcija update_gk_iznosOtv(...,$iznosOtv) koja je u gk_db (po glavnom i po veznom)*           
 *   endforeach      
*/
    $query = "
        delete from veze
        where konto=:konto and kodPartnera=:kodPartnera and vrsDo=:vrsDo and broDo=:broDo and DVO=:DVO
        and vKonto=:vKonto and vKodPartnera=:vKodPartnera and vVrsDo=:vVrsDo and vBroDo=:vBroDo and vDVO=:vDVO
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':konto', $slogVeze['konto']);
        $statement->bindValue(':kodPartnera', $slogVeze['kodPartnera']);
        $statement->bindValue(':vrsDo', $slogVeze['vrsDo']);
        $statement->bindValue(':broDo', $slogVeze['broDo']);
        $statement->bindValue(':DVO', $slogVeze['DVO']);
        $statement->bindValue(':vKonto', $slogVeze['vKonto']);
        $statement->bindValue(':vKodPartnera', $slogVeze['vKodPartnera']);
        $statement->bindValue(':vVrsDo', $slogVeze['vVrsDo']);
        $statement->bindValue(':vBroDo', $slogVeze['vBroDo']);
        $statement->bindValue(':vDVO', $slogVeze['vDVO']);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    
    
    /* primjer: virmanom V1 300 kuna plaćeni računi R1 200 kuna i R2 70
     * otpajanje 1 prolaz
     1. 1200 40 V1 150419   1200 20 R1 150419    200                                    brisanje 0ve veze i update iznosOtvoreni na V1 i R1
     * 
     * otpajanje drugi prolaz
     2. 1200 20 R1 150419   1200 40 V1 150419     70    na virmanu ostalo otvoreno 30   brisanje 0ve veze i update iznosOtvoreni na R1 i V1
     * 
     * storno
     * R3   500
     * R3/A  -500
     3. zbroj veza po glavnom i veznom za V1 = 270
     4. zbroj veza po glavnom i veznom za R1 = 200
     5. zbroj veza po glavnom i veznom za R2 = 70
     * 
     * 
     */   
    
 //    var_dump($sumaVezaPoDok);
   $sumaVeza=zbroj_veza_po_dok($slogVeze['vrsDo'], $slogVeze['broDo'], $slogVeze['DVO'], $slogVeze['konto'], $slogVeze['kodPartnera']);
    /* novi iznosi otvoreni nakon brisanje veznog sloga: stari iznosOtvoreni(prije brisanje veze) + iznos veze */
 //   $noviOtvoreniIznos = noviOtvoreniIznos($slogVeze['vrsDo'], $slogVeze['broDo'], $slogVeze['DVO'], $slogVeze['konto'], $slogVeze['kodPartnera'],$slogVeze['iznosVeze']); 
    update_gk_iznosOtv($slogVeze['vrsDo'], $slogVeze['broDo'], $slogVeze['DVO'], $slogVeze['konto'], $slogVeze['kodPartnera'], $sumaVeza['otvoreno']);
    
  $sumaVeza=zbroj_veza_po_dok($slogVeze['vVrsDo'], $slogVeze['vBroDo'], $slogVeze['vDVO'], $slogVeze['vKonto'], $slogVeze['vKodPartnera']);
    //$slogVeze2[]=array('vrsDo' => $slogVeze['vVrsDo'], 'broDo' => $slogVeze['vBroDo'], 'konto' => $slogVeze['vKonto'], 'kodPartnera' => $slogVeze['vKodPartnera']);
    update_gk_iznosOtv($slogVeze['vVrsDo'], $slogVeze['vBroDo'], $slogVeze['vDVO'], $slogVeze['vKonto'], $slogVeze['vKodPartnera'], $sumaVeza['otvoreno']);
   
}    
    
function get_veze_po_dokumentu($slog, $DVOdo='') {
    global $db;
    $query = " 
select 'glavni' as vrstaVeze, v.konto, v.vrsDo, v.broDo, v.DVO, v.kodPartnera, 
vkonto as kontoVeze, vvrsDo as vrsDoVeze, vd.oznakaDokumenta as oznakaDokumentaVeze, vbroDo as broDoVeze, nazivDokumenta,
v.vDVO as DVOVeze, vkodPartnera as kodPartneraVeze, iznosVeze,
gk.brojTemeljnice, gk.brojStavke, gk.DVO as DVO_gk, gk.valuta, gk.iznosDug, gk.iznosPot, gk.iznosOtv, gk.brojIzvoda, gk.opisKnjizenja, gk.brojDobRacuna 
from veze as v
left outer join vrste_dokumenata as vd on vd.vrsDo=v.vvrsDo
left outer join gk_stavke as gk on gk.konto=v.vkonto and gk.kodPartnera=v.vkodPartnera and gk.vrsDo=v.vVrsdo and gk.DVO=v.vDVO and gk.broDo=v.vbroDo
where v.konto=:konto and v.kodPartnera=:kodPartnera and v.vrsDo=:vrsDo and v.broDo=:broDo and v.DVO=:DVO
and (gk.DVO<=:DVOdo or trim(:DVOdo)='')
union all
select 'vezni' as vrstaVeze, vkonto, vvrsDo, vbroDo, vDVO, vkodPartnera,  
v.konto, v.vrsDo, vd.oznakaDokumenta as oznakaDokumentaVeze, v.broDo, nazivDokumenta, 
v.DVO, v.kodPartnera, iznosVeze ,
gk.brojTemeljnice, gk.brojStavke, gk.DVO as DVO_gk, gk.valuta, gk.iznosDug, gk.iznosPot, gk.iznosOtv, gk.brojIzvoda, gk.opisKnjizenja, gk.brojDobRacuna 
from veze as v
left outer join vrste_dokumenata as vd on vd.vrsDo=v.vrsDo
left outer join gk_stavke as gk on gk.konto=v.konto and gk.kodPartnera=v.kodPartnera and gk.vrsDo=v.vrsDo and gk.broDo=v.broDo and gk.DVO=v.DVO
where vkonto=:konto and vkodPartnera=:kodPartnera and vvrsDo=:vrsDo and vbroDo=:broDo and vDVO=:DVO
and (gk.DVO<=:DVOdo or trim(:DVOdo)='')
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);

            $d1=new DateTime($slog['DVO']);
            $DVO = $d1->format('Y-m-d H:i:s');
        
        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->bindValue(':kodPartnera', $slog['kodPartnera']);
        if(trim($DVOdo)!='') {
            $d1=new DateTime($DVOdo);
            $DVOdo = $d1->format('Y-m-d H:i:s');
        } else {
            $d1=new DateTime();        
            $DVOdo = $d1->format('Y-m-d 23:59:59');
        }
        $statement->bindValue(':DVOdo', $DVOdo);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
}

function get_veze_po_dokumentu2($slog) {
    global $db;
    $query = " 
select v.*
from veze as v
where v.konto=:konto and v.kodPartnera=:kodPartnera and v.vrsDo=:vrsDo and v.broDo=:broDo and v.DVO=:DVO
union all
select v.* 
from veze as v
where vkonto=:konto and vkodPartnera=:kodPartnera and vvrsDo=:vrsDo and vbroDo=:broDo and vDVO=:DVO

        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $slog['vrsDo']);
        $statement->bindValue(':broDo', $slog['broDo']);

        $d1 = new DateTime($slog['DVO']);
        $DVO = $d1->format('Y-m-d H:i:s');

        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':konto', $slog['konto']);
        $statement->bindValue(':kodPartnera', $slog['kodPartnera']);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_veze_po_temeljnici($brojTemeljnice, $brojIzvoda='') {
    global $db;
    $query = " 
select 'glavni' as vrstaVeze, v.*
from veze as v
left outer join vrste_dokumenata as vd on vd.vrsDo=v.vvrsDo
left outer join gk_stavke as gk on gk.konto=v.vkonto and gk.kodPartnera=v.vkodPartnera and gk.vrsDo=v.vVrsDo and gk.broDo=v.vbroDo
where gk.brojTemeljnice=:brojTemeljnice and (brojIzvoda=:brojIzvoda or trim(:brojIzvoda)='')
union all
select 'vezni' as vrstaVeze, v.*
from veze as v
left outer join vrste_dokumenata as vd on vd.vrsDo=v.vrsDo
left outer join gk_stavke as gk on gk.konto=v.konto and gk.kodPartnera=v.kodPartnera and gk.vrsDo=v.vrsDo and gk.broDo=v.broDo
where gk.brojTemeljnice=:brojTemeljnice and (brojIzvoda=:brojIzvoda or trim(:brojIzvoda)='')
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':brojTemeljnice', $brojTemeljnice);
        $statement->bindValue(':brojIzvoda', $brojIzvoda);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
}

function noviOtvoreniIznos( $vrsDo, $broDo, $DVO, $konto, $kodPartnera, $iznosVeze ) {
   global $db;
   $query = "
       select IznosDug, iznosPot from gk_stavke
       where
       where konto=:konto and kodPartnera=:kodPartnera and vrsDo=:vrsDo and broDo=:broDo and DVO=:DVO    
    ";
} 
function zbroj_veza_po_dok($vrsDo, $broDo, $DVO, $konto, $kodPartnera, $DVOdo='') {
    global $db;
    $query = " 
/*
kratak opis upita:
sign(v.iznosVeze) - predznak iznosa na stavki veze,
sign(gk.iznosDug+gk.iznosPot) - predznak dug/pot stavke u gk za koju vršimo izračun 
ako ta dva predznaka nisu jednaka radi se o vezi sa storno stavkom i u sumi mora promjeniti predznak
*/
select 
ifnull(sum(sign(v.iznosVeze) * sign(gk.iznosDug+gk.iznosPot)*v.iznosVeze),0) as sumaVeza, 
ifnull((gk.iznosDug+gk.iznosPot) - ifnull(sum(sign(v.iznosVeze) * sign(gk.iznosDug+gk.iznosPot)*v.iznosVeze),0),0) otvoreno,
gk.iznosDug+gk.iznosPot as iznosUgk 
from gk_stavke as gk
left outer join 
(
    select v.*
    from veze as v 
    -- povezujemo se s gk da bismo vidjelistanje na dan 
    left outer join gk_stavke as gk_veze 
    on ((gk_veze.konto=v.konto and gk_veze.kodPartnera=v.kodPartnera and gk_veze.vrsDo=v.vrsDo and gk_veze.broDo=v.broDo and gk_veze.DVO=v.DVO)
    or (gk_veze.konto=v.vKonto and gk_veze.kodPartnera=v.vKodPartnera and gk_veze.vrsDo=v.vVrsDo and gk_veze.broDo=v.vBroDo and gk_veze.DVO=v.vDVO))
    where ((v.konto=:konto and v.kodPartnera=:kodPartnera and v.vrsDo=:vrsDo and v.broDo=:broDo and v.DVO=:DVO)
    or (vKonto=:konto and vKodPartnera=:kodPartnera and vVrsDo=:vrsDo and vBroDo=:broDo and vDVO=:DVO))
    and not (gk_veze.vrsDo=:vrsDo and gk_veze.broDo=:broDo) 
    and (gk_veze.DVO<=:DVOdo or trim(:DVOdo)='')
) as v on
((v.konto=gk.konto and v.kodPartnera=gk.kodPartnera and v.vrsDo=gk.vrsDo and v.broDo=gk.broDo)
or (vKonto=gk.konto and vKodPartnera=gk.kodPartnera and vVrsDo=gk.vrsDo and vBroDo=gk.broDo))
where gk.konto=:konto and gk.kodPartnera=:kodPartnera and gk.vrsDo=:vrsDo and gk.broDo=:broDo and gk.DVO=:DVO
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':konto', $konto);
        $statement->bindValue(':kodPartnera', $kodPartnera);
        if(trim($DVOdo)=='')
            $datum=$DVOdo;   
        else 
        {
            $d1=new DateTime($DVOdo);
            $datum = $d1->format('Y-m-d H:i:s');
        }
        $statement->bindValue(':DVOdo', $datum);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
    
}

function get_otvoreno_s_krivim_predznakom() {
    global $db;
    $query = " 
        select 	brojTemeljnice, brojStavke, vrsDo, broDo, DVO, konto, kodPartnera, iznosDug, iznosPot, iznosDug - iznosPot as saldo,
        if(iznosPot=0,`iznosOtv`,0) otvorenoDug, if(iznosDug=0,`iznosOtv`,0) otvorenoPot, 
        if(iznosPot=0,`iznosOtv`,0) - if(iznosDug=0,`iznosOtv`,0) otvorenoSaldo
        from gk_stavke
        where trim(kodPartnera)<>'' and `iznosOtv`<>0
        and sign(iznosDug - iznosPot) <> sign(if(iznosPot=0,`iznosOtv`,0) - if(iznosDug=0,`iznosOtv`,0))
        ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
    
}

function get_pogresne_veze() {
    global $db;
    $query = " 
    select 
     v.*
    from veze as v 
    inner join gk_stavke as glavni 
    on glavni.konto=v.konto and glavni.kodPartnera=v.kodPartnera and glavni.vrsDo=v.vrsDo and glavni.broDo=v.broDo and glavni.DVO=v.DVO
    inner join gk_stavke as vezni 
    on vezni.konto=v.vKonto and vezni.kodPartnera=v.vKodPartnera and vezni.vrsDo=v.vVrsDo and vezni.broDo=v.vBroDo and vezni.DVO=v.vDVO
    where sign(glavni.`iznosDug` - glavni.`iznosPot`) = sign(vezni.`iznosDug` - vezni.`iznosPot`)
    and ((glavni.iznosDug=0 and vezni.iznosDug=0) or (glavni.iznosPot=0 and vezni.iznosPot=0))
        ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
    
}

function get_veze_bez_dokumenta() {
    global $db;
    $query = " 
    select 
    case
        when gk_veze.konto is null and gk_vveze.konto is null then 'oba' 
        when gk_veze.konto is null then 'glavni' 
        when gk_vveze.konto is null then 'vezni' 
    end
    as nedostaje,
     v.*
    from veze as v 
    left outer join gk_stavke as gk_veze 
    on (gk_veze.konto=v.konto and gk_veze.kodPartnera=v.kodPartnera and gk_veze.vrsDo=v.vrsDo and gk_veze.broDo=v.broDo and gk_veze.DVO=v.DVO)
    left outer join gk_stavke as gk_vveze 
    on (gk_vveze.konto=v.vKonto and gk_vveze.kodPartnera=v.vKodPartnera and gk_vveze.vrsDo=v.vVrsDo and gk_vveze.broDo=v.vBroDo and gk_vveze.DVO=v.vDVO)
    where gk_veze.konto is null or gk_vveze.konto is null
        ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
    
}

function get_pogresni_otvoreni_iznosi() {
    global $db;
    $query = " 
        select *
        from 
        ( 
        select 
        gk.`brojTemeljnice`, gk.`brojStavke`, gk.`vrsDo`, gk.`brojIzvoda`, gk.konto, gk.`kodPartnera`, gk.broDo, gk.DVO, gk.`iznosOtv`, 
        gk.tkoJeIzmjenio ,
        (gk.iznosDug+gk.iznosPot) - ifnull(sum( 
            if((gk.iznosDug=0 and vezni.iznosDug=0) or (gk.iznosPot=0 and vezni.iznosPot=0), -- iznosi na istoj strani 
                 sign(v.iznosVeze) * sign(gk.iznosDug+gk.iznosPot),1)
                    *v.iznosVeze),0) as poVezama 
        from gk_stavke as gk
        join konta as k on k.konto=gk.konto
        join 
        (
            select 'glavni' as vrstaVeze, v.konto, v.vrsDo, v.broDo, v.DVO, v.kodPartnera, 
            vKonto, vVrsDo, vBroDo,
            v.vDVO, vkodPartnera, iznosVeze
            from veze as v
            union all
            select 'vezni' as vrstaVeze, vkonto, vvrsDo, vbroDo, vDVO, vkodPartnera,  
            v.konto, v.vrsDo, v.broDo, 
            v.DVO, v.kodPartnera, iznosVeze 
            from veze as v
        ) as v on 
        (v.konto=gk.konto and v.kodPartnera=gk.kodPartnera and v.vrsDo=gk.vrsDo and v.broDo=gk.broDo and v.DVO=gk.DVO)
        inner join gk_stavke as vezni 
        on vezni.konto=v.vKonto and vezni.kodPartnera=v.vKodPartnera and vezni.vrsDo=v.vVrsDo and vezni.broDo=v.vBroDo and vezni.DVO=v.vDVO
        where `vrstaKonta`='S'
        group by
        gk.`brojTemeljnice`, gk.`brojStavke`
        ) as gk
        where iznosOtv<>poVezama
        ";
/*
    $query = " 
        select *
        from 
        ( 
        select 
        gk.`brojTemeljnice`, gk.`brojStavke`, gk.`vrsDo`, gk.`brojIzvoda`, gk.konto, gk.`kodPartnera`, gk.broDo, gk.DVO, gk.`iznosOtv`, 
        gk.tkoJeIzmjenio,
        -- (gk.iznosDug+gk.iznosPot) - ifnull(sum(sign(v.iznosVeze) * sign(gk.iznosDug+gk.iznosPot)*v.iznosVeze),0) as poVezama 
       (gk.iznosDug+gk.iznosPot) - ifnull(sum( 
            if((gk.iznosDug=0 and vezni.iznosDug=0) or (gk.iznosPot=0 and vezni.iznosPot=0), -- iznosi na istoj strani  
                 sign(v.iznosVeze) * sign(gk.iznosDug+gk.iznosPot),1)
                    *v.iznosVeze),0) as poVezama 
        from gk_stavke as gk
        join veze as v on 
        ((v.konto=gk.konto and v.kodPartnera=gk.kodPartnera and v.vrsDo=gk.vrsDo and v.broDo=gk.broDo and v.DVO=gk.DVO)
        or (vKonto=gk.konto and vKodPartnera=gk.kodPartnera and vVrsDo=gk.vrsDo and vBroDo=gk.broDo and vDVO=gk.DVO))
        join konta as k on k.konto=gk.konto
        inner join gk_stavke as vezni 
        on vezni.konto=v.vKonto and vezni.kodPartnera=v.vKodPartnera and vezni.vrsDo=v.vVrsDo and vezni.broDo=v.vBroDo and vezni.DVO=v.vDVO
        where `vrstaKonta`='S'
        group by
        gk.`brojTemeljnice`, gk.`brojStavke`, gk.`vrsDo`, gk.`brojIzvoda`, gk.konto, gk.`kodPartnera`, gk.broDo, gk.DVO, gk.`iznosOtv`, 
        gk.tkoJeIzmjenio
        ) as gk
        where iznosOtv<>poVezama
        ";
    */
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
    
}

function get_pogresni_otvoreni_iznosi2() {
    global $db;
    $query = " 
        select gk.*,
        gk.iznosDug+gk.iznosPot as poVezama 
        from gk_stavke as gk
        join konta as k on k.konto=gk.konto
        left outer join veze as v 
        on (v.konto=gk.konto and v.kodPartnera=gk.kodPartnera and v.vrsDo=gk.vrsDo and v.broDo=gk.broDo and v.DVO=gk.DVO)
        left outer join veze as v2 
        on (v2.vkonto=gk.konto and v2.vkodPartnera=gk.kodPartnera and v2.vvrsDo=gk.vrsDo and v2.vbroDo=gk.broDo and v2.vDVO=gk.DVO)
        where vrstaKonta='S' and iznosDug+iznosPot<>iznosOtv
        and v.konto is null and v2.konto is null
        ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }    
    
}

function brisanje_nepostojecih_veza($veze) {
    foreach ($veze as $veza) {
        delete_veze($veza);

        switch($veza['nedostaje']) {
        case 'glavni' :
            $iznosVeze=  zbroj_veza_po_dok($veza['vrsDo'], $veza['broDo'], $veza['DVO'], $veza['konto'], $veza['kodPartnera']);
            update_gk_iznosOtv($veza['vrsDo'], $veza['broDo'], $veza['DVO'], $veza['konto'], $veza['kodPartnera'], $iznosVeze['otvoreno']);
        case 'vezni' :
            $iznosVeze=  zbroj_veza_po_dok($veza['vVrsDo'], $veza['vBroDo'], $veza['vDVO'], $veza['vKonto'], $veza['vKodPartnera']);
            update_gk_iznosOtv($veza['vVrsDo'], $veza['vBroDo'], $veza['vDVO'], $veza['vKonto'], $veza['vKodPartnera'], $iznosVeze['otvoreno']);
        }    
        
    }
    return "Obrisano veza:".count($veze);
}

function brisanje_pogresnih_veza($veze) {
    foreach ($veze as $veza) {
        delete_veze($veza);

        $iznosVeze=  zbroj_veza_po_dok($veza['vrsDo'], $veza['broDo'], $veza['DVO'], $veza['konto'], $veza['kodPartnera']);
        update_gk_iznosOtv($veza['vrsDo'], $veza['broDo'], $veza['DVO'], $veza['konto'], $veza['kodPartnera'], $iznosVeze['otvoreno']);

        $iznosVeze=  zbroj_veza_po_dok($veza['vVrsDo'], $veza['vBroDo'], $veza['vDVO'], $veza['vKonto'], $veza['vKodPartnera']);
        update_gk_iznosOtv($veza['vVrsDo'], $veza['vBroDo'], $veza['vDVO'], $veza['vKonto'], $veza['vKodPartnera'], $iznosVeze['otvoreno']);    
        
    }
    return "Obrisano veza:".count($veze);
}
function korekcija_otvorenih_iznosa($stavke) {
    foreach ($stavke as $slog) {
        if(isset($slog['poVezama']))
            update_gk_iznosOtv($slog['vrsDo'], $slog['broDo'], $slog['DVO'], $slog['konto'], $slog['kodPartnera'], $slog['poVezama']);
        else {
            $iznosVeze=  zbroj_veza_po_dok($slog['vrsDo'], $slog['broDo'], $slog['DVO'], $slog['konto'], $slog['kodPartnera']);
            update_gk_iznosOtv($slog['vrsDo'], $slog['broDo'], $slog['DVO'], $slog['konto'], $slog['kodPartnera'], $iznosVeze['otvoreno']);
        }
        
    }
    return "korigirano stavaka:".count($stavke);
}

function reset_otvorenih_iznosa($stavke) {
    foreach ($stavke as $slog) {
        update_gk_iznosOtv($slog['vrsDo'], $slog['broDo'], $slog['DVO'], $slog['konto'], $slog['kodPartnera'], $slog['iznosDug']+$slog['iznosPot']);
        
    }
    return "korigirano stavaka:".count($stavke);
}


function korekcija_otvorenih_s_krvim_predznakom($stavke) {
    foreach ($stavke as $slog) {
        $veze = get_veze_po_dokumentu2($slog);
        brisanje_pogresnih_veza($veze);
    }
    return "korigirano stavaka:" . count($stavke);
}

?> 