<?php
/* 
 * Funkcije: add_blagdani_praznici, update_blagdani_praznici, delete_blagdani_praznici nisu potrebne
 * jer koristi add_slog_tablice, update_slog_tablice, delete_slog_tablice iz tablica_db.php
 */

function get_blagdani_praznici($godina='') {
    global $db;
    $query ="  
        select * 
        from blagdani_praznici
        where year(datum)=:godina or :godina=''
        order by year(datum) desc, datum
        "; 
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':godina', $godina);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function kopiraj_blagdane_u_godinu($godina) {
    $blagdani=get_blagdani_praznici($godina);
    if(count($blagdani)>0) {
        return "U $godina. godini već postoje blagdani!";
    }

    $blagdani=get_blagdani_praznici();
    if(count($blagdani)<1) {
        return "Ne postoji niti jedan blagdan! Nemam što kopirati!";
    }
    
    $d=new DateTime($blagdani[0]['datum']);
    $godinaKopiranja=$d->format('Y');
    $brojSlogova=0;
    foreach ($blagdani as $slog) {
        $d=new DateTime($slog['datum']);
        $pomGodina=$d->format('Y');
        if($pomGodina!=$godinaKopiranja)
            return "U $godina. godinu je kopirano $brojSlogova blagdana.";
        $slogZaUnos['datum']=substr_replace($slog['datum'], $godina, 0 , 4);
        $slogZaUnos['nazivBlagdana']=$slog['nazivBlagdana'];
        add_slog_tablice('blagdani_praznici', $slogZaUnos);
        ++$brojSlogova;
    }
    return "U $godina. godinu je kopirano $brojSlogova blagdana.";
}

function  kojiJeBlagdan($datum) {
    global $db;
    $datum_o = new DateTime($datum);
    $datumB = $datum_o->format("Y-m-d");
    $query = 'SELECT nazivBlagdana       
            FROM blagdani_praznici        
            WHERE datum = :datumB';      
       $statement = $db->prepare($query);       
       $statement->bindValue(':datumB', $datumB);
       $statement->execute();
       $nazivBlagdana = $statement->fetch();
       $statement->closeCursor(); 
       return $nazivBlagdana; 
}  

?>
