<?php
function kontrola_stavaka($proda, $vrsDo, $proIn, $zapis, $verzi, $DVOod,$DVOdo, $refProd) {
    global $db;
    $query = "
select s.* 
from dok_stavke as s
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.zapis=s.zapis  and z.verzi=s.verzi and z.proIn=s.proIn
where z.proda is null 
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo    
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        //$statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        //$statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function kontrola_zag($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select z.* 
from dok_zag as z
left outer join dok_stavke as s on s.proda=z.proda and s.vrsDo=z.vrsDo 
    and s.broDo=z.broDo and s.zapis=z.zapis  and s.verzi=z.verzi and s.proIn=z.proIn
where s.proda is null 
and (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or z.vrsDo=:vrsDo)
and (z.zapis=:zapis or trim(:zapis)='')
and z.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_robe_u_maticnoj($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select s.proda, s.`vrsDo`, s.`proIn`, s.zapis, s.`broDo`, s.verzi, s.`brojStavke`, 
s.`kodRobe`, s.`vrstaProdaje` as VP, s.kolicina, s.cijena, s.`DVO`
from dok_stavke as s
left outer join maticna_robe as m on m.`kodRobe`=s.`kodRobe`
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.zapis=s.zapis  and z.verzi=s.verzi and z.proIn=s.proIn
where m.`kodRobe` is null and s.kodRobe<> '#'
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo 
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_partnera_u_maticnoj($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select z.proda, z.`vrsDo`, z.`proIn`, z.zapis, z.`broDo`, z.verzi,  
z.`kodPartnera`, z.`DVO`
from dok_zag as z
left outer join partner as p on p.`kodPartnera`=z.`kodPartnera`
where p.`kodPartnera` is null and trim(z.`kodPartnera`)<>''
and (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or z.vrsDo=:vrsDo)
and (z.zapis=:zapis or trim(:zapis)='')
and z.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_2_u_prometnoj($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select z.proda, z.`vrsDo`, z.`proIn`, z.zapis, z.`broDo`, z.verzi,  
z.`DVO`, z.`kodPartnera`
from dok_zag as z
left outer join dok_zag as i
on i.proda=z.`kodPartnera` and i.`vrsDo`='2' and i.`proIn`=z.`proda` and i.zapis=z.zapis and i.`broDo`=z.`broDo` and i.verzi=z.verzi
where z.vrsDo='6' and i.proda is null
and (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or z.vrsDo=:vrsDo)
and (z.zapis=:zapis or trim(:zapis)='')
and z.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_6_u_prometnoj($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select z.proda, z.`vrsDo`, z.`proIn`, z.zapis, z.`broDo`, z.verzi,  
z.`DVO`, z.`kodPartnera`
from dok_zag as z
left outer join dok_zag as i
on i.proda=z.proIn and i.`vrsDo`='6' and i.`proIn`='' and i.zapis=z.zapis and i.`broDo`=z.`broDo` and i.verzi=z.verzi and i.kodPartnera=z.proda
where z.vrsDo='2' and i.proda is null
and (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or z.vrsDo=:vrsDo)
and (z.zapis=:zapis or trim(:zapis)='')
and z.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_st_int_fakt($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
-- nema ulaznih stavaka internih faktura
select 'ul. int. f. za:' as 'nedostaje_stavka', 
s.proda, s.`vrsDo`, s.`proIn`, s.zapis, s.`broDo`, s.verzi, s.`brojStavke`, s.`kodRobe`, 
s.`vrstaProdaje` as VP, s.cijena, s.`cijenaZaIntFak`, s.kolicina, s.`DVO`
from dok_stavke as s
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.zapis=s.zapis  and z.verzi=s.verzi and z.proIn=s.proIn
left outer join dok_stavke as i
on i.proda=z.`kodPartnera` and i.`vrsDo`='2' and i.`proIn`=s.`proda` and i.zapis=s.zapis 
and i.`broDo`=s.`broDo` and i.verzi=s.verzi and i.`brojStavke`=s.`brojStavke`
where s.vrsDo='6' and i.`brojStavke` is null
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 

union all
-- nema  stavaka  na izlaznoj internoj fakturi
select 'izl. int. f. za:' as 'nedostaje_stavka', 
s.proda, s.`vrsDo`, s.`proIn`, s.zapis, s.`broDo`, s.verzi, s.`brojStavke`, s.`kodRobe`, 
s.`vrstaProdaje` as VP, s.cijena, s.`cijenaZaIntFak`, s.kolicina, s.`DVO`
from dok_stavke as s
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.zapis=s.zapis  and z.verzi=s.verzi and z.proIn=s.proIn
left outer join dok_stavke as i
on i.proda=s.proIn and i.`vrsDo`='6' and i.`proIn`='' and i.zapis=s.zapis and i.`broDo`=s.`broDo` and i.verzi=s.verzi
and s.`brojStavke`=i.`brojStavke`
where s.vrsDo='2' and i.proda is null
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function razlicite_st_interne($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
-- Stavke koje se ne podudaraju u izl. int. f sa stavkama u ul int. f.
select 
s.proda, s.`vrsDo`, s.`proIn`, s.zapis, s.`broDo`, s.`brojStavke`,s.verzi, 
concat('Izlazna:', '<br>', 'Ulazna:') as 'Opis', 
concat(s.`kodRobe`, '<br>', i.`kodRobe`) as kodRobe, 
concat(s.vrstaProdaje, '<br>', i.`vrstaProdaje`) as VP, 
concat(s.cijena, '<br>', i.cijena)as cijena,
concat(s.kolicina, '<br>', i.`kolicina`) as kolicina, 
concat(s.DVO, '<br>', i.`DVO`) as DVO
from dok_stavke as s
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.zapis=s.zapis  and z.verzi=s.verzi and z.proIn=s.proIn
inner join dok_stavke as i
on i.proda=z.`kodPartnera` and i.`vrsDo`='2' and i.`proIn`=s.`proda` and i.zapis=s.zapis 
and i.`broDo`=s.`broDo` and i.verzi=s.verzi and i.`brojStavke`=s.`brojStavke`
where s.vrsDo='6' 
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo
and (s.cijena<>i.cijena or s.kolicina<>i.kolicina or s.`kodRobe`<>i.`kodRobe` or s.`vrstaProdaje`<>i.`vrstaProdaje`)
and (z.refProd=:refProd or trim(:refProd)='') 
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function kontrola_pocBrSt($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
-- kontrola početnog broja stavke
select s.proda, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, min(s.`brojStavke`) as pocetniBtojStavke 
from dok_stavke as s
where (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo
group by s.proda, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi 
having min(s.`brojStavke`)<>1
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
    $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function primke_bez_kalkulacija($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
SELECT z.*
FROM dok_zag as z
LEFT OUTER JOIN 
( 
SELECT proda, brodo, verzi 
FROM 
kalkulacije
UNION ALL
SELECT proda, brodo, verzi 
FROM 
ostale_primke_po_kalkulaciji
) as k on k.proda=z.proda and k.broDo=z.broDo and k.verzi=z.verzi
WHERE z.vrsDo='1' 
 AND k.proda is null
and (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and z.DVO between :DVOOd and :DVODo
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
//        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
//        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
    $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function rupe_u_brSt($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    
/* SPORA VERZIJA   
    $query = "
-- dokumenti koji imaju rupe u brojaču stavaka
select s.proda, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, s.`brojStavke`, min(i.`brojStavke`) as sljedeciBrojStavke 
from dok_stavke as s
inner join dok_stavke as i
on i.proda=s.proda and i.`vrsDo`=s.vrsDo and i.`proIn`=s.proIn and i.zapis=s.zapis 
and i.`broDo`=s.`broDo` and i.verzi=s.verzi and i.`brojStavke`>s.`brojStavke` 
where (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo
group by s.proda, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi,s.`brojStavke`
having min(i.brojStavke)-s.brojStavke >1
";
*/    
    $query = "
select proda, vrsDo, proIn, zapis, broDo, verzi, prethodni_broj, sljedeci_broj, sljedeci_broj - (prethodni_broj+1) as slobodnih_brojeva
from
(
select proda, vrsDo, proIn, zapis, broDo, verzi, 
-- kod promjene vrste dijela ključa resetira na 0
if(@prodaSt=proda and @vrsDoSt=vrsDo and @proInSt=proIn and @zapisSt=zapis and @broDoSt=broDo and @verziSt=verzi, @stariBroj,@stariBroj:=0) as prethodni_broj, 
@stariBroj:=brojStavke as sljedeci_broj 
, @prodaSt:=proda, @vrsDoSt:=vrsDo, @proInSt:=proIn, @zapisSt:=zapis, @broDoSt:=broDo, @verziSt:=verzi
from dok_stavke , 
(select @stariBroj:=0, @prodaSt:='', @vrsDoSt:='', @proInSt:='', @zapisSt:='', @broDoSt:=0, @verziSt:='') as i
/*
where (proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or vrsDo=:vrsDo)
and (zapis=:zapis or trim(:zapis)='')
and DVO between :DVOOd and :DVODo
*/
order by  proda, vrsDo, proIn, zapis, `broDo`, verzi, brojStavke
) as s
where sljedeci_broj > prethodni_broj+1
";
    
    try {
        $statement = $db->prepare($query);
        // /*
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
         // */
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function kontrola_zapisnika($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
-- kontrola uparenosti zapisnika NC,KN,PC,SC
select 
s.proda, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, s.kodRobe, s.`vrstaProdaje` as VP, abs(s.kolicina) as kolicina,
sum(if(s.kolicina>0,1,0)) as pozitivnih_stavaka, sum(if(s.kolicina<0,1,0)) as negativnih_stavaka
from dok_stavke as s
where s.zapis in ('NC','KN','PC','SC') 
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or s.vrsDo=:vrsDo)
and (s.zapis=:zapis or trim(:zapis)='')
and s.DVO between :DVOOd and :DVODo
group by 
s.proda, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, s.kodRobe, s.`vrstaProdaje`, abs(s.kolicina) 
having sum(if(s.kolicina>0,1,0)) <> sum(if(s.kolicina<0,1,0))
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function rupe_u_broDo($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo,$refProd) {
    global $db;
    $query = "
select proda, vrsDo, proIn, zapis, prethodni_broj, sljedeci_broj, sljedeci_broj - (prethodni_broj+1) as slobodnih_brojeva
from
(
select proda, vrsDo, proIn, zapis, 
-- kod promjene vrste dijela ključa resetira na 0
if(@prodaS=proda and @vrsDoS=vrsDo and @proInS=proIn and @zapisS=zapis, @stariBroj,@stariBroj:=0) as prethodni_broj, 
@stariBroj:=brodo as sljedeci_broj 
, @prodaS:=proda, @vrsDoS:=vrsDo, @proInS:=proIn, @zapisS:=zapis
from dok_zag as z, 
(select @stariBroj:=0, @prodaS:='', @vrsDoS:='', @proInS:='', @zapisS:='') as i
where (proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or vrsDo=:vrsDo)
and (zapis=:zapis or trim(:zapis)='')
and DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
order by  proda, vrsDo, proIn, zapis, `broDo`
) as zz
where sljedeci_broj > prethodni_broj+1
";
    try {
        $statement = $db->prepare($query);
        // /*
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);

         // */
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function rupe_u_partner() {
    global $db;
    $query = "
select round(prethodni_broj) as prethodni_broj, sljedeci_broj, round(sljedeci_broj - (prethodni_broj+1)) as slobodnih_brojeva
from
(
select 
-- kod promjene vrste dijela ključa resetira na 0
@stariBroj as prethodni_broj, 
@stariBroj:=convert(kodPartnera, DECIMAL) as sljedeci_broj 
from partner as z, 
(select @stariBroj:=0) as i
order by  convert(kodPartnera, DECIMAL)
) as zz
 where sljedeci_broj > prethodni_broj+1        
";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function dokumenti_po_satima($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd='') {
    global $db;
/*
    $query = "
select z.proda as Poslovnica, z.vrsDo, z.zapis as Zapisnik, 
sum(if(time(z.dvo) between '00:00:00' and '00:59:59',1,0)) as `00:00-00:59`,
sum(if(time(z.dvo) between '01:00:00' and '01:59:59',1,0)) as `01:00-01:59`,
sum(if(time(z.dvo) between '02:00:00' and '02:59:59',1,0)) as `02:00-02:59`,
sum(if(time(z.dvo) between '03:00:00' and '03:59:59',1,0)) as `03:00-03:59`,
sum(if(time(z.dvo) between '04:00:00' and '04:59:59',1,0)) as `04:00-04:59`,
sum(if(time(z.dvo) between '05:00:00' and '05:59:59',1,0)) as `05:00-05:59`,
sum(if(time(z.dvo) between '06:00:00' and '06:59:59',1,0)) as `06:00-06:59`,
sum(if(time(z.dvo) between '07:00:00' and '07:59:59',1,0)) as `07:00-07:59`,
sum(if(time(z.dvo) between '08:00:00' and '08:59:59',1,0)) as `08:00-08:59`,
sum(if(time(z.dvo) between '09:00:00' and '09:59:59',1,0)) as `09:00-09:59`,
sum(if(time(z.dvo) between '10:00:00' and '10:59:59',1,0)) as `10:00-10:59`,
sum(if(time(z.dvo) between '11:00:00' and '11:59:59',1,0)) as `11:00-11:59`,
sum(if(time(z.dvo) between '12:00:00' and '12:59:59',1,0)) as `12:00-12:59`,
sum(if(time(z.dvo) between '13:00:00' and '13:59:59',1,0)) as `13:00-13:59`,
sum(if(time(z.dvo) between '14:00:00' and '14:59:59',1,0)) as `14:00-14:59`,
sum(if(time(z.dvo) between '15:00:00' and '15:59:59',1,0)) as `15:00-15:59`,
sum(if(time(z.dvo) between '16:00:00' and '16:59:59',1,0)) as `16:00-16:59`,
sum(if(time(z.dvo) between '17:00:00' and '17:59:59',1,0)) as `17:00-17:59`,
sum(if(time(z.dvo) between '18:00:00' and '18:59:59',1,0)) as `18:00-18:59`,
sum(if(time(z.dvo) between '19:00:00' and '19:59:59',1,0)) as `19:00-19:59`,
sum(if(time(z.dvo) between '20:00:00' and '20:59:59',1,0)) as `20:00-20:59`,
sum(if(time(z.dvo) between '21:00:00' and '21:59:59',1,0)) as `21:00-21:59`,
sum(if(time(z.dvo) between '22:00:00' and '22:59:59',1,0)) as `22:00-22:59`,
sum(if(time(z.dvo) between '23:00:00' and '23:59:59',1,0)) as `23:00-23:59`,
count(z.brodo) as Ukupno,

sum(if(time(z.dvo) between '00:00:00' and '00:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `00:00-00:59 iznos`,
sum(if(time(z.dvo) between '01:00:00' and '01:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `01:00-01:59 iznos`,
sum(if(time(z.dvo) between '02:00:00' and '02:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `02:00-02:59 iznos`,
sum(if(time(z.dvo) between '03:00:00' and '03:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `03:00-03:59 iznos`,
sum(if(time(z.dvo) between '04:00:00' and '04:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `04:00-04:59 iznos`,
sum(if(time(z.dvo) between '05:00:00' and '05:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `05:00-05:59 iznos`,
sum(if(time(z.dvo) between '06:00:00' and '06:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `06:00-06:59 iznos`,
sum(if(time(z.dvo) between '07:00:00' and '07:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `07:00-07:59 iznos`,
sum(if(time(z.dvo) between '08:00:00' and '08:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `08:00-08:59 iznos`,
sum(if(time(z.dvo) between '09:00:00' and '09:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `09:00-09:59 iznos`,
sum(if(time(z.dvo) between '10:00:00' and '10:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `10:00-10:59 iznos`,
sum(if(time(z.dvo) between '11:00:00' and '11:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `11:00-11:59 iznos`,
sum(if(time(z.dvo) between '12:00:00' and '12:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `12:00-12:59 iznos`,
sum(if(time(z.dvo) between '13:00:00' and '13:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `13:00-13:59 iznos`,
sum(if(time(z.dvo) between '14:00:00' and '14:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `14:00-14:59 iznos`,
sum(if(time(z.dvo) between '15:00:00' and '15:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `15:00-15:59 iznos`,
sum(if(time(z.dvo) between '16:00:00' and '16:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `16:00-16:59 iznos`,
sum(if(time(z.dvo) between '17:00:00' and '17:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `17:00-17:59 iznos`,
sum(if(time(z.dvo) between '18:00:00' and '18:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `18:00-18:59 iznos`,
sum(if(time(z.dvo) between '19:00:00' and '19:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `19:00-19:59 iznos`,
sum(if(time(z.dvo) between '20:00:00' and '20:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `20:00-20:59 iznos`,
sum(if(time(z.dvo) between '21:00:00' and '21:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `21:00-21:59 iznos`,
sum(if(time(z.dvo) between '22:00:00' and '22:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `22:00-22:59 iznos`,
sum(if(time(z.dvo) between '23:00:00' and '23:59:59',round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as `23:00-23:59 iznos`,

sum(round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2)) as UkupnoIznos

from dok_zag as z
join dok_stavke as s on s.proda=z.proda and s.vrsDo=z.vrsDo 
    and s.broDo=z.broDo and s.zapis=z.zapis  and s.verzi=z.verzi and s.proIn=z.proIn
join poslovnice as  p on p.kodPoslovnice=z.proda
where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and z.DVO between :DVOOd and :DVODo
and (FIND_IN_SET(trim(z.vrsDo),  :vrsDo) or trim(:vrsDo)='')
and (z.zapis=:zapis or trim(:zapis)='')
and (z.refProd=:refProd or trim(:refProd)='') 
group by z.proda, z.vrsDo, z.zapis
";
*/
    $query = "
select z.proda as Poslovnica, z.vrsDo, z.zapis as Zapisnik, 
sum(if(time(z.dvo) between '00:00:00' and '00:59:59',1,0)) as `00:00-00:59`,
sum(if(time(z.dvo) between '01:00:00' and '01:59:59',1,0)) as `01:00-01:59`,
sum(if(time(z.dvo) between '02:00:00' and '02:59:59',1,0)) as `02:00-02:59`,
sum(if(time(z.dvo) between '03:00:00' and '03:59:59',1,0)) as `03:00-03:59`,
sum(if(time(z.dvo) between '04:00:00' and '04:59:59',1,0)) as `04:00-04:59`,
sum(if(time(z.dvo) between '05:00:00' and '05:59:59',1,0)) as `05:00-05:59`,
sum(if(time(z.dvo) between '06:00:00' and '06:59:59',1,0)) as `06:00-06:59`,
sum(if(time(z.dvo) between '07:00:00' and '07:59:59',1,0)) as `07:00-07:59`,
sum(if(time(z.dvo) between '08:00:00' and '08:59:59',1,0)) as `08:00-08:59`,
sum(if(time(z.dvo) between '09:00:00' and '09:59:59',1,0)) as `09:00-09:59`,
sum(if(time(z.dvo) between '10:00:00' and '10:59:59',1,0)) as `10:00-10:59`,
sum(if(time(z.dvo) between '11:00:00' and '11:59:59',1,0)) as `11:00-11:59`,
sum(if(time(z.dvo) between '12:00:00' and '12:59:59',1,0)) as `12:00-12:59`,
sum(if(time(z.dvo) between '13:00:00' and '13:59:59',1,0)) as `13:00-13:59`,
sum(if(time(z.dvo) between '14:00:00' and '14:59:59',1,0)) as `14:00-14:59`,
sum(if(time(z.dvo) between '15:00:00' and '15:59:59',1,0)) as `15:00-15:59`,
sum(if(time(z.dvo) between '16:00:00' and '16:59:59',1,0)) as `16:00-16:59`,
sum(if(time(z.dvo) between '17:00:00' and '17:59:59',1,0)) as `17:00-17:59`,
sum(if(time(z.dvo) between '18:00:00' and '18:59:59',1,0)) as `18:00-18:59`,
sum(if(time(z.dvo) between '19:00:00' and '19:59:59',1,0)) as `19:00-19:59`,
sum(if(time(z.dvo) between '20:00:00' and '20:59:59',1,0)) as `20:00-20:59`,
sum(if(time(z.dvo) between '21:00:00' and '21:59:59',1,0)) as `21:00-21:59`,
sum(if(time(z.dvo) between '22:00:00' and '22:59:59',1,0)) as `22:00-22:59`,
sum(if(time(z.dvo) between '23:00:00' and '23:59:59',1,0)) as `23:00-23:59`,
count(z.brodo) as Ukupno ,

-- /*oIznos
sum(if(time(z.dvo) between '00:00:00' and '00:59:59',s.UkupnoIznos,0)) as `00:00-00:59 iznos`,
sum(if(time(z.dvo) between '01:00:00' and '01:59:59',s.UkupnoIznos,0)) as `01:00-01:59 iznos`,
sum(if(time(z.dvo) between '02:00:00' and '02:59:59',s.UkupnoIznos,0)) as `02:00-02:59 iznos`,
sum(if(time(z.dvo) between '03:00:00' and '03:59:59',s.UkupnoIznos,0)) as `03:00-03:59 iznos`,
sum(if(time(z.dvo) between '04:00:00' and '04:59:59',s.UkupnoIznos,0)) as `04:00-04:59 iznos`,
sum(if(time(z.dvo) between '05:00:00' and '05:59:59',s.UkupnoIznos,0)) as `05:00-05:59 iznos`,
sum(if(time(z.dvo) between '06:00:00' and '06:59:59',s.UkupnoIznos,0)) as `06:00-06:59 iznos`,
sum(if(time(z.dvo) between '07:00:00' and '07:59:59',s.UkupnoIznos,0)) as `07:00-07:59 iznos`,
sum(if(time(z.dvo) between '08:00:00' and '08:59:59',s.UkupnoIznos,0)) as `08:00-08:59 iznos`,
sum(if(time(z.dvo) between '09:00:00' and '09:59:59',s.UkupnoIznos,0)) as `09:00-09:59 iznos`,
sum(if(time(z.dvo) between '10:00:00' and '10:59:59',s.UkupnoIznos,0)) as `10:00-10:59 iznos`,
sum(if(time(z.dvo) between '11:00:00' and '11:59:59',s.UkupnoIznos,0)) as `11:00-11:59 iznos`,
sum(if(time(z.dvo) between '12:00:00' and '12:59:59',s.UkupnoIznos,0)) as `12:00-12:59 iznos`,
sum(if(time(z.dvo) between '13:00:00' and '13:59:59',s.UkupnoIznos,0)) as `13:00-13:59 iznos`,
sum(if(time(z.dvo) between '14:00:00' and '14:59:59',s.UkupnoIznos,0)) as `14:00-14:59 iznos`,
sum(if(time(z.dvo) between '15:00:00' and '15:59:59',s.UkupnoIznos,0)) as `15:00-15:59 iznos`,
sum(if(time(z.dvo) between '16:00:00' and '16:59:59',s.UkupnoIznos,0)) as `16:00-16:59 iznos`,
sum(if(time(z.dvo) between '17:00:00' and '17:59:59',s.UkupnoIznos,0)) as `17:00-17:59 iznos`,
sum(if(time(z.dvo) between '18:00:00' and '18:59:59',s.UkupnoIznos,0)) as `18:00-18:59 iznos`,
sum(if(time(z.dvo) between '19:00:00' and '19:59:59',s.UkupnoIznos,0)) as `19:00-19:59 iznos`,
sum(if(time(z.dvo) between '20:00:00' and '20:59:59',s.UkupnoIznos,0)) as `20:00-20:59 iznos`,
sum(if(time(z.dvo) between '21:00:00' and '21:59:59',s.UkupnoIznos,0)) as `21:00-21:59 iznos`,
sum(if(time(z.dvo) between '22:00:00' and '22:59:59',s.UkupnoIznos,0)) as `22:00-22:59 iznos`,
sum(if(time(z.dvo) between '23:00:00' and '23:59:59',s.UkupnoIznos,0)) as `23:00-23:59 iznos`,
-- */

sum(s.UkupnoIznos) as UkupnoIznos
from dok_zag as z
join 
(
    SELECT s.proda, s.`vrsDo`, s.zapis, s.broDo, s.verzi, s.proIn,
    sum(round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2)) as UkupnoIznos
    FROM dok_stavke as s 
    join poslovnice as  p on p.kodPoslovnice=s.proda
    -- /*
    where (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
    and s.DVO between :DVOOd and :DVODo
    and (FIND_IN_SET(trim(s.vrsDo),  :vrsDo) or trim(:vrsDo)='')
    and (s.zapis=:zapis or trim(:zapis)='')
    -- */
    GROUP BY s.proda, s.`vrsDo`, s.zapis, s.broDo, s.verzi,s.proIn

) as s on s.proda=z.proda and s.vrsDo=z.vrsDo 
    and s.broDo=z.broDo and s.zapis=z.zapis  and s.verzi=z.verzi and s.proIn=z.proIn
-- /*
where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and z.DVO between :DVOOd and :DVODo
and (FIND_IN_SET(trim(z.vrsDo),  :vrsDo) or trim(:vrsDo)='')
and (z.zapis=:zapis or trim(:zapis)='')
and (z.refProd=:refProd or trim(:refProd)='') 
-- */
group by z.proda, z.vrsDo, z.zapis
";
    try {
        $statement = $db->prepare($query);
        // /*
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);

         // */
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function kolicina_po_vrsti_dok($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd='') {
    global $db;
    $query = "
select s.proda, s.vrsDo, vd.nazivDokumenta, s.zapis, z.dokumenata,  count(*) as stavaka
from dok_stavke as s
 join
(
    select proda, vrsDo, zapis, 
    count(brodo) as dokumenata
    from dok_zag as z
    where (proda=:proda or trim(:proda)='' or trim(:proda)='0')
    and DVO between :DVOOd and :DVODo
    and (FIND_IN_SET(trim(vrsDo),  :vrsDo) or trim(:vrsDo)='')
    and (zapis=:zapis or trim(:zapis)='')
    and (z.refProd=:refProd or trim(:refProd)='') 
    group by proda, vrsDo, zapis
) as z
on z.proda=s.proda and z.vrsDo=s.`vrsDo` and z.zapis=s.zapis
left outer join vrste_dokumenata as vd on vd.`vrsDo`=z.vrsDo 
where s.DVO between :DVOOd and :DVODo
group by s.proda, s.vrsDo, s.zapis, dokumenata
";
    try {
        $statement = $db->prepare($query);
        // /*
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);

         // */
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
    return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function kontrola_konsignacija_K2($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select k2.proda, k2.`vrsDo`, k2.`proIn`, k2.zapis, k2.`broDo`, k2.verzi, k2.`brojStavke`, 
k2.`kodRobe`, k2.`vrstaProdaje` as VP, k2.kolicina, k2.cijena, 'Nedostaje stavka u K2 zapisniku verzije 1' as greska
from dok_stavke as k2
left outer join dok_stavke as s 
on s.proda=k2.proda and s.vrsDo=k2.vrsDo and s.proIn=k2.proIn and s.zapis=k2.zapis and s.broDo=k2.broDo and s.verzi='1' and s.brojStavke=k2.brojStavke
where k2.zapis='K2' and k2.verzi=''
and s.proda is null
and (k2.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and k2.DVO between :DVOOd and :DVODo
UNION ALL
select k2.proda, k2.`vrsDo`, k2.`proIn`, k2.zapis, k2.`broDo`, k2.verzi, k2.`brojStavke`, 
k2.`kodRobe`, k2.`vrstaProdaje` as VP, k2.kolicina, k2.cijena, 'Nedostaje stavka u orginalnom K2 zapisniku (bez verzije)' as greska
from dok_stavke as k2
left outer join dok_stavke as s 
on s.proda=k2.proda and s.vrsDo=k2.vrsDo and s.proIn=k2.proIn and s.zapis=k2.zapis and s.broDo=k2.broDo and s.verzi='' and s.brojStavke=k2.brojStavke
where k2.zapis='K2' and k2.verzi='1'
and s.proda is null
and (k2.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and k2.DVO between :DVOOd and :DVODo
UNION ALL
select k2.proda, k2.`vrsDo`, k2.`proIn`, k2.zapis, k2.`broDo`, k2.verzi, k2.`brojStavke`, 
k2.`kodRobe`, k2.`vrstaProdaje` as VP, k2.kolicina, k2.cijena, concat('Stavka u K2 zapisniku verzije 1: količina=', s.kolicina) as greska
from dok_stavke as k2
join dok_stavke as s 
on s.proda=k2.proda and s.vrsDo=k2.vrsDo and s.proIn=k2.proIn and s.zapis=k2.zapis and s.broDo=k2.broDo and s.verzi='1' and s.brojStavke=k2.brojStavke
where k2.zapis='K2' and k2.verzi=''
and s.kolicina<>-1*k2.kolicina
and (k2.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and k2.DVO between :DVOOd and :DVODo
UNION ALL
select k2.proda, k2.`vrsDo`, k2.`proIn`, k2.zapis, k2.`broDo`, k2.verzi, k2.`brojStavke`, 
k2.`kodRobe`, k2.`vrstaProdaje` as VP, k2.kolicina, k2.cijena, concat('Pogrešna vrsta prodaje: u verziji=\"\" VP=', k2.`vrstaProdaje`, ', u veziji=1 VP=', z.`vrstaProdaje`) as greska
from dok_stavke as k2
left outer join dok_stavke as z
on z.proda=k2.proda and z.vrsDo=k2.`vrsDo` and z.`proIn`=k2.`proIn`
and z.zapis=k2.zapis and z.`broDo`=k2.`broDo` and z.verzi<>k2.verzi and z.`brojStavke`=k2.`brojStavke`
where k2.zapis='K2' and k2.verzi='' and z.verzi='1'
and (k2.`vrstaProdaje`=z.`vrstaProdaje` or k2.`vrstaProdaje` not in ('0','2')  or z.`vrstaProdaje` not in ('0','2')) 
and (k2.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and k2.DVO between :DVOOd and :DVODo
UNION ALL
select k2.proda, k2.`vrsDo`, k2.`proIn`, k2.zapis, k2.`broDo`, k2.verzi, '', 
'', '' as VP, '', '', concat('Različiti partneri: verzija=\"\" partner=', trim(k2.kodPartnera), ', verzija=1 partner=', trim(s.kodPartnera)) as greska
from dok_zag as k2
join dok_zag as s 
on s.proda=k2.proda and s.vrsDo=k2.vrsDo and s.proIn=k2.proIn and s.zapis=k2.zapis and s.broDo=k2.broDo and s.verzi='1' 
where k2.zapis='K2' and k2.verzi=''
and s.kodPartnera<>k2.kodPartnera
and (k2.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and k2.DVO between :DVOOd and :DVODo
UNION ALL
select k2.proda, k2.`vrsDo`, k2.`proIn`, k2.zapis, k2.`broDo`, k2.verzi, '', 
'', '' as VP, '', '', concat('Različiti DVO: nerija=\"\" DVO=', trim(k2.DVO), ', verzija=1 DVO=', trim(s.DVO)) as greska
from dok_zag as k2
join dok_zag as s 
on s.proda=k2.proda and s.vrsDo=k2.vrsDo and s.proIn=k2.proIn and s.zapis=k2.zapis and s.broDo=k2.broDo and s.verzi='1' 
where k2.zapis='K2' and k2.verzi=''
-- and s.DVO<>k2.DVO
and replace(s.DVO, substring(s.DVO, instr(s.DVO, ':')+1),'')<>replace(k2.DVO, substring(k2.DVO, instr(k2.DVO, ':')+1),'') 
and (k2.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and k2.DVO between :DVOOd and :DVODo


";
    try {
        $statement = $db->prepare($query);
        // /*
        $statement->bindValue(':proda', $proda);
    //    $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
    //    $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));

         // */
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_robe_iz_stanja($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select s.proda, s.`kodRobe`, s.cijena ,s.stanje, s.`datumInventure`, s.`kolicinaInventure` ,s.`brojInvStavke`
from stanja as s
left outer join maticna_robe as m on m.`kodRobe`=s.`kodRobe`
where m.kodRobe is null and trim(s.kodRobe)<>'#'
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        //$statement->bindValue(':vrsDo', $vrsDo);

        //$DVO_o = new DateTime($DVOod);
        //$DVO_o2 = new DateTime($DVOdo);
        //$statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        //$statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_robe_iz_inv_stanja($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo,$refProd) {
    global $db;
    $query = "
select s.proda, s.`kodRobe`, s.cijena ,s.stanje, s.`datumInventure`, s.`kolicinaInventure` ,s.`brojInvStavke`
from inv_stanja as s
left outer join maticna_robe as m on m.`kodRobe`=s.`kodRobe`
where m.`kodRobe` is null 
and (s.proda=:proda or trim(:proda)='' or trim(:proda)='0')
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        //$statement->bindValue(':vrsDo', $vrsDo);

        //$DVO_o = new DateTime($DVOod);
        //$DVO_o2 = new DateTime($DVOdo);
        //$statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        //$statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function nema_robe_iz_kons_stanja($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select s.kodPartnera, s.`kodRobe`, s.cijena ,s.stanje, s.`datumInventure`, s.`kolicinaInventure` ,s.`brojInvStavke`
from kons_stanja as s
left outer join maticna_robe as m on m.`kodRobe`=s.`kodRobe`
where m.`kodRobe` is null 
";
    try {
        $statement = $db->prepare($query);
        //$statement->bindValue(':proda', $proda);
        //$statement->bindValue(':vrsDo', $vrsDo);

        //$DVO_o = new DateTime($DVOod);
        //$DVO_o2 = new DateTime($DVOdo);
        //$statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        //$statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function dokumenti_po_refProd($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select z.proda, z.vrsDo, z.proIn, z.zapis, z.broDo, z.verzi, z.kodPartnera, z.DVO, z.refProd, 
 a.skracenica, 
z.`tkoJeIzmjenio` as email
from dok_zag as z
left outer join ".get_admin_db().".administrators as a on a.email=z.`tkoJeIzmjenio`
where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or z.vrsDo=:vrsDo)
and (z.zapis=:zapis or trim(:zapis)='')
and z.DVO between :DVOOd and :DVODo
and (a.OIB=:refProd or trim(:refProd)='') 
order by a.skracenica, z.proda, z.vrsDo, z.proIn, z.zapis, z.broDo, z.verzi
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function kontrola_konsignacije_po_kodu_robe($DVOdo) {
    global $db;
    $query = "
select
kodRobe, vrstaProdaje, sum(kolicina) as po_dokumentima, sum(stanje) u_tablici_stanja
from
(  
    select
    kodRobe, vrstaProdaje, kolicinaInventure as kolicina, stanje
    from stanja
    where vrstaProdaje in ('1','2')

    union all

    select
    kodRobe, vrstaProdaje, kolicina, 0 as stanje
    from dok_stavke
    where vrstaProdaje in ('1','2')
    and DVO<=:DVODo
) as p
group by kodRobe, vrstaProdaje
having sum(kolicina)<>sum(stanje)
    ";
    try {
        $statement = $db->prepare($query);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function roba_s_nepostojecom_grupom() {
    global $db;
    $query = "
select r.* 
from maticna_robe as r
left outer join robne_grupe as rg on rg.`kodGrupe`= r.`kodGrupe`
where rg.`kodGrupe` is null
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function roba_s_nepostojecom_grupom2() {
    global $db;
    $query = "
select r.* 
from maticna_robe as r
left outer join robne_grupe as rg on rg.`kodGrupe`= r.`kodGrupe2`
where rg.`kodGrupe` is null and ifnull(`kodGrupe2`,'')<>''
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function roba_s_nadgrupama() {
    global $db;
    $query = "
select r.*
from maticna_robe as r
join 
( 
select g.kodGrupe, count(pg.kodGrupe) as brojGrana
from robne_grupe as g
left outer join robne_grupe as pg on pg.kodGrupe like  concat(trim(g.kodGrupe), '%') and pg.kodGrupe<>g.kodGrupe
group by g.kodGrupe
having  count(pg.kodGrupe)>0
) as gr on gr.`kodGrupe`=r.`kodGrupe`
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function roba_s_mat_cijenom_0() {
    global $db;
    $query = "
select 
distinct st.`kodRobe`, r.`nazivRobe`
-- st.*
from stanja as st
join maticna_robe as r on r.`kodRobe`=st.`kodRobe`
where r.cijena=0
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);       
    }
}
function aktivan_0_aImaStanjePromet() {
    global $db;
    $query = "
select distinct r.kodRobe, substr(nazivRobe,1,50), r.cijena, kodGrupe 
from maticna_robe  as r 
join dok_stavke st on st.kodRobe = r.`kodRobe`
where r.aktivan = 0 

union 

select distinct 
r.kodRobe, substr(nazivRobe,1,50), r.cijena, kodGrupe 
-- , stanje, kolicinaInventure,
from maticna_robe  as r 
join stanja as s on s.kodRobe=r.kodRobe
where r.aktivan = 0 
and (stanje <> 0 or kolicinaInventure <> 0)

    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);       
    }
}

function dokumenti_s_pogresnimPDVom($proda, $vrsDo, $proIn, $zapis, $verzi,$DVOod, $DVOdo, $refProd) {
    global $db;
    $query = "
select z.proda, z.vrsDo, z.proIn, z.zapis, z.broDo, z.verzi, z.PDVstatus, z.DVO
from dok_zag as z
join vrste_dokumenata as vd on vd.vrsDo=z.vrsDo
join dok_stavke as s on s.proda=z.proda and s.vrsDo=z.vrsDo and s.proIn=z.proIn and s.zapis=z.zapis and s.broDo=z.broDo and s.verzi=z.verzi
where (vd.fiskalizacija='Da' or z.vrsDo='6') and (trim(ifnull(z.PDVstatus,''))='' and s.PDV=0 or trim(ifnull(z.PDVstatus,''))<>'' and s.PDV<>0)

and (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (trim(:vrsDo)='' or z.vrsDo=:vrsDo)
and (z.zapis=:zapis or trim(:zapis)='')
and z.DVO between :DVOOd and :DVODo
and (z.refProd=:refProd or trim(:refProd)='') 
group by z.proda, z.vrsDo, z.proIn, z.zapis, z.broDo, z.verzi, z.PDVstatus
";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
    //    $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
    //    $statement->bindValue(':verzi', $verzi);

        $DVO_o = new DateTime($DVOod);
        $DVO_o2 = new DateTime($DVOdo);
        $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
        $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function partnerove_zemlje_nema_u_zemlje() {
    global $db;
    $query = "
SELECT p.kodPartnera, p.nazivPartnera,p.`ulicaBroj`, p.`mjestoSjedista`, p.zemlja, 
p.datumOtvaranja, p.datumIzmjene, p.tkoJeIzmjenio
FROM partner as p
LEFT OUTER JOIN zemlje as z ON z.zemlja=p.zemlja
WHERE trim(p.zemlja)<>'' AND z.zemlja is null
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);       
    }
}

function zemlje_porijekla_nema_u_zemlje() {
    global $db;
    $query = "
SELECT m.*
FROM maticna_robe as m
LEFT OUTER JOIN zemlje as z ON z.zemlja=m.zemljaPorijekla
WHERE trim(m.zemljaPorijekla)<>'' AND z.zemlja is null
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);       
    }
}

function razlike_primke_kalkulacije() {
    global $db;
    $query = "
    select *, iznosPoKalkulaciji - iznosPoPrimki as razlika 
    from ( 
    select k.proda, k.broDo,k.verzi, p.vrstaPoslovnice,
    -- prodajniIznosSpdv, prodajniIznosBezPDV,
    if(`vrstaPoslovnice`=1, prodajniIznosSpdv, prodajniIznosBezPDV) as iznosPoKalkulaciji,
    round(sum(if(p.vrstaPoslovnice=1,
        round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,if(trim(s.zapis)='' and trim(s.vrsDo)<>'1',s.PDV,s.ukalkuliraniPDV),0,0,0,0,'zaplatit'),2),
        -- else za: p.vrstaPoslovnice=1
        round(kolicina*s.cijena,4)
    )), 2) as iznosPoPrimki 
    from kalkulacije as k
    join poslovnice as  p on p.kodPoslovnice=k.proda
    join
    (
        -- skupa stavlja sve primke po kalkulacijama
        SELECT 
        proda, vrsDo, proIn, zapis, broDo, verzi,
        proda as os_proda, '1 ' as os_vrsDo, proIn os_proIn, zapis as os_zapis, brodo as os_broDo, verzi as os_verzi
        FROM kalkulacije 
        UNION 
        SELECT 
        proda, vrsDo, proIn, zapis, broDo, verzi,
        os_proda, os_vrsDo, os_proIn, os_zapis, os_broDo, os_verzi
        FROM ostale_primke_po_kalkulaciji as o
    ) as ppk on ppk.proda=k.proda and ppk.vrsDo=k.vrsDo and ppk.proIn=k.proIn and ppk.zapis=k.zapis and ppk.broDo=k.broDo and ppk.verzi=k.verzi

    join dok_stavke as s on s.proda=ppk.os_proda and s.vrsDo='1' and s.proIn=ppk.os_proIn and s.zapis=ppk.os_zapis and s.broDo=ppk.os_broDo and s.verzi=ppk.os_verzi
    group by
    k.proda,
    k.zapis,
    k.proIn,
    k.broDo,
    k.verzi,
    k.vrsDo,
    k.broDo,
    p.vrstaPoslovnice
    ) as x
    where iznosPoPrimki<>iznosPoKalkulaciji
    ";
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $dokument = $statement->fetchAll();
        $statement->closeCursor();
        return $dokument;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);       
    }
}

?>
