<?php
// funkcije za rad s parametrima
function add_parametri($nazivParametra, $vrijednostParametra, $opisParametra) {
    //global $db;
    $db=get_konekcija_mur('parametri');
    $email_user = $_SESSION['admin']['email'];
    $query = "INSERT INTO ".get_admin_db().".parametri
             (
             nazivParametra, vrijednostParametra, opisParametra, datumOtvaranja,tkoJeIzmjenio
             )
             VALUES
             (
             :nazivParametra, :vrijednostParametra, :opisParametra,  NOW(), :email_user 
             )";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':nazivParametra', $nazivParametra);
        $statement->bindValue(':vrijednostParametra', $vrijednostParametra);
        $statement->bindValue(':opisParametra', $opisParametra);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
        return;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function azuriraj_parametar($nazivParametra, $vrijednostParametra, $opisParametra) {
    //global $db;
    $db=get_konekcija_mur('parametri');
    $email_user = $_SESSION['admin']['email'];
    $query = 
            "INSERT INTO ".get_admin_db().".parametri
             ( nazivParametra, vrijednostParametra, opisParametra, datumOtvaranja,tkoJeIzmjenio )
             VALUES
             ( :nazivParametra, :vrijednostParametra, :opisParametra,  NOW(), :email_user )
             ON DUPLICATE KEY UPDATE
             vrijednostParametra=:vrijednostParametra, 
             opisParametra=:opisParametra, 
             datumIzmjene=NOW(),
             tkoJeIzmjenio=:email_user
             ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':nazivParametra', $nazivParametra);
        $statement->bindValue(':vrijednostParametra', $vrijednostParametra);
        $statement->bindValue(':opisParametra', $opisParametra);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
        return;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function update_parametri($nazivParametra, $vrijednostParametra, $opisParametra) {
    //global $db;
    $db=get_konekcija_mur('parametri');
    $email_user = $_SESSION['admin']['email'];
    $query = "UPDATE ".get_admin_db().".parametri
             SET 
             vrijednostParametra=:vrijednostParametra, 
             opisParametra=:opisParametra, 
             datumIzmjene=NOW(),
             tkoJeIzmjenio=:email_user
             WHERE nazivParametra=:nazivParametra
            ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':nazivParametra', $nazivParametra);
        $statement->bindValue(':vrijednostParametra', $vrijednostParametra);
        $statement->bindValue(':opisParametra', $opisParametra);
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
        return;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function delete_parametri($nazivParametra) {
    //global $db;
    $db=get_konekcija_mur('parametri');
    $query = "DELETE FROM ".get_admin_db().".parametri WHERE nazivParametra = :nazivParametra";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':nazivParametra', $nazivParametra);
        $statement->execute();        
        return;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_parametar ($nazivParametra) {
    //global $db;
    $db=get_konekcija_mur('parametri');
    $query = 'SELECT * FROM '.get_admin_db().'.parametri WHERE nazivParametra = :nazivParametra';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':nazivParametra', $nazivParametra);
        $statement->execute();
        $parametar = $statement->fetch();
        $statement->closeCursor();
        return $parametar;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_parametri() {
    //global $db;
    $db=get_konekcija_mur('parametri');
    $query = 'SELECT * FROM '.get_admin_db().'.parametri order by nazivParametra';
    try {
        $statement = $db->prepare($query);
        $statement->execute();
        $parametri = $statement->fetchAll();
        $statement->closeCursor();
        return $parametri;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
?>