<?php
function is_valid_partneri_email($email) {
    global $db;
    $query = '
        SELECT kodPartnera FROM partneri
        WHERE email = :email';
    $statement = $db->prepare($query);
    $statement->bindValue(':email', $email);
    $statement->execute();
    $valid = ($statement->rowCount() == 1);
    $statement->closeCursor();
    return $valid;
}

function is_valid_partneri_login($email, $password) {
    global $db;
    $password = sha1($email . $password);
    $query = '
        SELECT * FROM partneri
        WHERE email = :email AND password = :password';
    $statement = $db->prepare($query);
    $statement->bindValue(':email', $email);
    $statement->bindValue(':password', $password);
    $statement->execute();
    $valid = ($statement->rowCount() == 1);
    $statement->closeCursor();
    return $valid;
}

function get_partneri($kod_partnera) {
    global $db;
    $query = 'SELECT * FROM partneri WHERE kodPartnera = :kod_partnera';
    $statement = $db->prepare($query);
    $statement->bindValue(':kod_partnera', $kod_partnera);
    $statement->execute();
    $partneri = $statement->fetch();
    $statement->closeCursor();
    return $partneri;
}

function get_partneri_by_email($email) {
    global $db;
    $query = 'SELECT * FROM partneri WHERE email = :email';
    $statement = $db->prepare($query);
    $statement->bindValue(':email', $email);
    $statement->execute();
    $partneri = $statement->fetch();
    $statement->closeCursor();
    return $partneri;
}

function partneri_change_shipping_id($kodPartnera, $address_id) {
    global $db;
    $query = 'UPDATE partneri SET shipAddressID = :address_id
              WHERE kodPartnera = :kodPartnera';
    $statement = $db->prepare($query);
    $statement->bindValue(':address_id', $address_id);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->execute();
    $statement->closeCursor();
}

function partneri_change_billing_id($kodPartnera, $address_id) {
    global $db;
    $query = 'UPDATE partneri SET billingAddressID = :address_id
              WHERE kodPartnera = :kodPartnera';
    $statement = $db->prepare($query);
    $statement->bindValue(':address_id', $address_id);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->execute();
    $statement->closeCursor();
}

function add_partneri($kod_partnera, $naziv_partnera, $mjesto_sjedista, $ulica_broj, $pos_pretinac, $mjesto_poste, $broj_poste, 
                      $zemlja, $oib, $telefoni, $email, $password_1, $password_2) {
    global $db;
    $password = sha1($email . $password_1);
    $query = '
        INSERT INTO partneri (kodPartnera, nazivPartnera, mjestoSjedista, ulicaBroj, posPretinac, mjestoPoste, brojPoste, zemlja, OIB, telefoni, email, password)
	VALUES (:kod_partnera, :naziv_partnera, :mjesto_sjedista, :ulica_broj, :pos_pretinac, :mjesto_poste, :broj_poste, :zemlja, :oib, :telefoni, :email, :password)';
    $statement = $db->prepare($query);
	$statement->bindValue(':kod_partnera', $kod_partnera);
    $statement->bindValue(':naziv_partnera', $naziv_partnera);
    $statement->bindValue(':mjesto_sjedista', $mjesto_sjedista);
    $statement->bindValue(':ulica_broj', $ulica_broj);
    $statement->bindValue(':pos_pretinac', $pos_pretinac);
	$statement->bindValue(':mjesto_poste', $mjesto_poste);
    $statement->bindValue(':broj_poste', $broj_poste);
    $statement->bindValue(':zemlja', $zemlja);
    $statement->bindValue(':oib', $oib);
    $statement->bindValue(':telefoni', $telefoni);
	$statement->bindValue(':email', $email);
	$statement->bindValue(':password', $password);
    $statement->execute();
    $ID_partnera = $db->lastInsertId();
    $statement->closeCursor();
    return $kod_partnera;
}

function update_partneri($kod_partnera, $naziv_partnera, $mjesto_sjedista, $ulica_broj, $pos_pretinac, $mjesto_poste, $broj_poste, 
                      $zemlja, $oib, $telefoni, $email, $password_1, $password_2) {
    global $db;
    $query = '
        UPDATE partneri
      		SET nazivPartnera = :naziv_partnera,
		    mjestoSjedista = :mjesto_sjedista,
		    ulicaBroj = :ulica_broj,
			posPretinac = :pos_pretinac,
			mjestoPoste = :mjesto_poste,
			brojPoste = :broj_poste,
			zemlja = :zemlja,
			OIB = :oib,
			telefoni = :telefoni,
			email = :email
        WHERE kodPartnera = :kod_partnera';
		
    $statement = $db->prepare($query);
	$statement->bindValue(':kod_partnera', $kod_partnera);
	$statement->bindValue(':naziv_partnera', $naziv_partnera);
    $statement->bindValue(':mjesto_sjedista', $mjesto_sjedista);
    $statement->bindValue(':ulica_broj', $ulica_broj);
    $statement->bindValue(':pos_pretinac', $pos_pretinac);
	$statement->bindValue(':mjesto_poste', $mjesto_poste);
    $statement->bindValue(':broj_poste', $broj_poste);
    $statement->bindValue(':zemlja', $zemlja);
    $statement->bindValue(':oib', $oib);
    $statement->bindValue(':telefoni', $telefoni);
	$statement->bindValue(':email', $email);
    $statement->execute();
    $statement->closeCursor();

    if (!empty($password_1) && !empty($password_2)) {
        $password = sha1($email . $password_1);
        $query = '
            UPDATE partneri
            SET password = :password
            WHERE kodPartnera = :kod_partnera';
        $statement = $db->prepare($query);
        $statement->bindValue(':password', $password);
        $statement->bindValue(':kodPartnera', $kodPartnera);
        $statement->execute();
        $statement->closeCursor();
    }
}
?>