<?php
function stanja_po_grupi($kodPoslovnice, $vrstaProdaje, $kodGrupe, $kojaStanja, &$iznosPoGrupiSpdv, &$stanjePoGrupi) {
    global $db;
    $query = '
        SELECT *
        FROM maticna_robe m
           INNER JOIN robne_grupe g
           ON m.kodGrupe = g.kodGrupe
        WHERE m.kodGrupe = :kodGrupe
		ORDER BY m.nazivRobe';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodGrupe', $kodGrupe);
        $statement->execute();
        $result1 = $statement->fetchAll();
        $statement->closeCursor();
     //   return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    //echo 'count result1=' . count($result1);
    // koja Stanja:  stanja razlicita od nule, sva stanja, negativna stanja, nula stanja
    $result_konacni = array(); 

    foreach($result1 as $stavkaGrupe) {
        $kodRobe = $stavkaGrupe['kodRobe']; 

        switch ($kojaStanja) {
        case 'samoNul':
                 $query = '
                   SELECT SUM(stanje) AS suma_po_sifri
                   FROM stanja
                   WHERE kodPoslovnice = :kodPoslovnice AND kodRobe = :kodRobe 
                   HAVING suma_po_sifri = 0';
        case 'neNul':
                 $query = '
                   SELECT SUM(stanje) AS suma_po_sifri
                   FROM stanja
                   WHERE kodPoslovnice = :kodPoslovnice AND kodRobe = :kodRobe 
                   HAVING suma_po_sifri != 0';
        case 'samoNegativna':
                 $query = '
                   SELECT SUM(stanje) AS suma_po_sifri
                   FROM stanja
                   WHERE kodPoslovnice = :kodPoslovnice AND kodRobe = :kodRobe 
                   HAVING suma_po_sifri < 0';
               break; 
        default:
                //sva stanja svaStanja
                //echo 'prolazim u default'; 
                $query = '
                   SELECT SUM(stanje) AS suma_po_sifri
                   FROM stanja
                   WHERE kodPoslovnice = :kodPoslovnice AND kodRobe = :kodRobe';
                   break;			   
    }
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodPoslovnice', $kodPoslovnice);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->execute();
        $result2 = $statement->fetch();
         //  echo 'count($result2)=' . count($result2);
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    } 
    //za sve iz result2   treba iz result1 uzeti naziv robe,cijenu 
    if ( count($result2) != 0 ) {	
            //$result_konacni['$kodRobe'] = $kodRobe;
            $result_konacni[$kodRobe]['nazivRobe'] = $stavkaGrupe['nazivRobe'];  
            $result_konacni[$kodRobe]['cijena'] = $stavkaGrupe['cijena'];
            $result_konacni[$kodRobe]['stanje'] = $result2['suma_po_sifri'];
            $iznosPoGrupiSpdv = $iznosPoGrupiSpdv + ($stavkaGrupe['cijena'] * $result2['suma_po_sifri']);
            $stanjePoGrupi = $stanjePoGrupi + $result2['suma_po_sifri']; 
      } 	
    }
    return $result_konacni;
	
}
// function zalihe($proda, $vrstaProdaje, $kodGrupe, $kojaStanja, $invDonos, &$iznosPoGrupiSpdv, &$stanjePoGrupi) {
function zalihe($proda, $vrstaProdaje, $kodGrupe, $kodRobe, $kojaStanja, $invDonos, $finKol, $daniOd, $daniDo, $kojeCijene, $grupeArray,
                $zemljaPorijekla='', $vrstaArtikla='', $tarifniBroj='', $poTarifnimBrojevima='Ne',$ispodMinZaliha='') {
  // pretvorba grupeArray u string sa zarezima
    $stringGrupe = '';
    foreach($grupeArray as $jednaGrupa) {
      $stringGrupe .= $jednaGrupa . ',';  
    }
    
    global $db;    
    
    if($finKol == 'fin')  {     //samo financijski 
       $query = "SELECT COUNT(*) FROM robne_grupe";
       try {
        $statement = $db->prepare($query);        
        $statement->execute();
        $ukupnoSvihGrupa = $statement->fetch();
        $statement->closeCursor();
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        }  
        //ako nisu odabrane sve grupe na listi ispisuje odabrane
        if (count($grupeArray) != $ukupnoSvihGrupa[0] and trim($stringGrupe)!='') echo 'Odabrane grupe ' . $stringGrupe;
            
       $query = "
             SELECT if(:poTarifnimBrojevima='Da', tarifniBroj, proda) as grupa, 
             SUM(if((:kojaStanja='neNul' and stanje<>0) 
                    or (:kojaStanja='samoNegativna' and stanje<0) 
                    or (:kojaStanja='samoNul' and stanje=0) or :kojaStanja='svaStanja',
                stanje * if(:kojeCijene='cijenePoDok',s.cijena,m.cijena),0)) AS iznosZaliheBezPdv, 
             SUM(if((:kojaStanja='neNul' and stanje<>0) 
                    or (:kojaStanja='samoNegativna' and stanje<0) 
                    or (:kojaStanja='samoNul' and stanje=0) or :kojaStanja='svaStanja',
                stanje * round(if(:kojeCijene='cijenePoDok',s.cijena,m.cijena) *(1+PDV/100),2),0)) AS iznosZaliheSpdv,
             SUM(if((:kojaStanja='neNul' and kolicinaInventure<>0) 
                    or (:kojaStanja='samoNegativna' and kolicinaInventure<0) 
                    or (:kojaStanja='samoNul' and kolicinaInventure=0) or :kojaStanja='svaStanja',
                kolicinaInventure * (if(:kojeCijene='cijenePoDok',s.cijena,m.cijena)),0)) AS inventuraBezPdv, 
             SUM(if((:kojaStanja='neNul' and kolicinaInventure<>0) 
                    or (:kojaStanja='samoNegativna' and kolicinaInventure<0) 
                    or (:kojaStanja='samoNul' and kolicinaInventure=0) or :kojaStanja='svaStanja',
                kolicinaInventure * round((if(:kojeCijene='cijenePoDok',s.cijena,m.cijena))*(1+PDV/100),2),0)) AS inventuraSpdv
             FROM stanja as s
             left outer join maticna_robe as m on s.kodRobe= m.kodRobe 
             left outer join porezi as p on m.poreznaGrupa= p.poreznaGrupa
             WHERE (proda = :proda or :proda = '0') 
             and (:vrstaProdaje = '' or vrstaProdaje = :vrstaProdaje)   
             -- and :kojaStanja = 'neNul'  
             and ((:kojaStanja='neNul' and stanje<>0) or (:kojaStanja='samoNegativna' and stanje<0) or (:kojaStanja='samoNul' and stanje=0) 
              or (:kojaStanja='neNul' and kolicinaInventure<>0) or (:kojaStanja='samoNegativna' and kolicinaInventure<0) or (:kojaStanja='samoNul' and kolicinaInventure=0)
              or :kojaStanja='svaStanja')
             and (:kodRobe = '' or s.kodRobe = :kodRobe)
             and (:kodGrupe = '' or kodGrupe = :kodGrupe)
            -- and (locate(concat(trim(m.kodGrupe),','),:stringGrupe) > 0  or trim(:stringGrupe)='')
            and (FIND_IN_SET(trim(m.kodGrupe), :stringGrupe) or trim(:stringGrupe)='')
            and (FIND_IN_SET(trim(tarifniBroj), :tarifniBroj) or trim(:tarifniBroj)='')
            and (FIND_IN_SET(trim(vrstaArtikla), :vrstaArtikla) or trim(:vrstaArtikla)='')
            and (FIND_IN_SET(trim(zemljaPorijekla), :zemljaPorijekla) or trim(:zemljaPorijekla)='')
             and( (:daniOd='' or :daniDo='') or ( (datediff(NOW(), datumPi)) > :daniOd  and (datediff(NOW(), datumPi)) < :daniDo ) ) 
             and m.robaUsluga = 'R'
             GROUP BY grupa ";
    } else {
        //količinski i s nazivima $finKol = 'kol'
          //dva slučaja 1. cijene po dokumentima (iz tabele stanja) za jedan kod robe i vrstu prodaje može postojati više cijena
          //            2. cijene iz cjenika(maticna_robe) sumira po kodu robe i vrsti prodaje ima samo jedna stavka za isti kodRobe i vrstuProdaje a cijena je iz maticna_robe
      if ($kojeCijene == 'cijenePoDok' ) { 
        $query = "
        select s.kodRobe, vrstaProdaje, nazivRobe, jedinicaMjere, EANkod,
        if(:poTarifnimBrojevima='Da', tarifniBroj, m.kodGrupe) as grupa, s.cijena as cijena,
        if(:invDonos,kolicinaInventure,stanje) as stanjeRobe,
        round(s.cijena*(1+PDV/100),2) as cijenaSpdv, PDV, (datediff(NOW(), datumPi)) as daniBp
        from stanja as s
        left outer join maticna_robe as m on s.kodRobe= m.kodRobe 
        left outer join porezi as p on m.poreznaGrupa= p.poreznaGrupa
        left outer join robne_grupe as r on m.kodGrupe=r.kodGrupe
        where
        proda=:proda
        and (((if(:invDonos,kolicinaInventure,stanje)) <> 0 and :kojaStanja='neNul') or ((if(:invDonos,kolicinaInventure,stanje)) < 0 and :kojaStanja='samoNegativna')
           or ((if(:invDonos,kolicinaInventure,stanje))=0 and :kojaStanja='samoNul')  or :kojaStanja='svaStanja')
        and (:kodGrupe=''  or m.kodGrupe=:kodGrupe)
        -- and (locate(concat(trim(m.kodGrupe),','),:stringGrupe) > 0 or trim(:stringGrupe)='')  
        and (FIND_IN_SET(trim(m.kodGrupe), :stringGrupe) or trim(:stringGrupe)='')
        and m.robaUsluga = 'R'
        and (:kodRobe='' or s.kodRobe=:kodRobe)
        and (:vrstaProdaje='' or vrstaProdaje=:vrstaProdaje)
        and (FIND_IN_SET(trim(tarifniBroj), :tarifniBroj) or trim(:tarifniBroj)='')
        and (FIND_IN_SET(trim(vrstaArtikla), :vrstaArtikla) or trim(:vrstaArtikla)='')
        and (FIND_IN_SET(trim(zemljaPorijekla), :zemljaPorijekla) or trim(:zemljaPorijekla)='')
        and( (:daniOd='' or :daniDo='') or ( (datediff(NOW(), datumPi)) > :daniOd  and (datediff(NOW(), datumPi)) < :daniDo ) 
           or ( (datediff(NOW(), datumPu)) > :daniOd  and (datediff(NOW(), datumPu)) < :daniDo )        
        )
        order by grupa, s.kodRobe"; 
      } else  {
        $vrstaProdajeVeazanoUzMinZalihe = " and (:vrstaProdaje='' or vrstaProdaje=:vrstaProdaje) ";  
        $groupByVezanoUzMinZalihe = " GROUP BY s.kodRobe, vrstaProdaje ";
        $uzMinZalihe = "  and (:ispodMinZaliha='samo' and stanjeRobe<mz.minZaliha or :ispodMinZaliha<>'samo') ";
        if ( $ispodMinZaliha == 'zbrojenoVP10D' ) {
           $vrstaProdajeVeazanoUzMinZalihe = " and (vrstaProdaje = '0' or vrstaProdaje = '1' or vrstaProdaje = 'D') "; 
           $groupByVezanoUzMinZalihe = " GROUP BY s.kodRobe ";
           $uzMinZalihe = " and stanjeRobe<mz.minZaliha ";
        }
        // cijenePoCjeniku  sumira stanje po kodu robe i vrsti prodaje tako da postoji samo jedna stavka za kod robe i vrstu prodaje
        $query = "
        select s.kodRobe, vrstaProdaje, nazivRobe, jedinicaMjere, EANkod,
        if(:poTarifnimBrojevima='Da', tarifniBroj, m.kodGrupe) as grupa, 
        m.cijena as cijena,
        SUM(if(:invDonos,kolicinaInventure,stanje)) as stanjeRobe,
        round(m.cijena*(1+PDV/100),2) as cijenaSpdv, 
        PDV, (datediff(NOW(), datumPi)) as daniBp,
        mz.minZaliha
        from stanja as s
        left outer join maticna_robe as m on s.kodRobe= m.kodRobe 
        left outer join porezi as p on m.poreznaGrupa= p.poreznaGrupa
        left outer join robne_grupe as r on m.kodGrupe=r.kodGrupe
        left outer join minimalne_zalihe as mz on mz.kodRobe=s.kodRobe and mz.kodPoslovnice=s.proda

        where
        proda=:proda        
        and m.robaUsluga = 'R'
        and (:kodGrupe=''  or m.kodGrupe=:kodGrupe) 
        -- and (locate(concat(trim(m.kodGrupe),','),:stringGrupe) > 0  or trim(:stringGrupe)='')
        and (FIND_IN_SET(trim(m.kodGrupe), :stringGrupe) or trim(:stringGrupe)='')
        and (:kodRobe='' or s.kodRobe=:kodRobe)
  --      and (:vrstaProdaje='' or vrstaProdaje=:vrstaProdaje)
        $vrstaProdajeVeazanoUzMinZalihe
  --      and (vrstaProdaje='0' or vrstaProdaje='D')
        and (FIND_IN_SET(trim(tarifniBroj), :tarifniBroj) or trim(:tarifniBroj)='')
        and (FIND_IN_SET(trim(vrstaArtikla), :vrstaArtikla) or trim(:vrstaArtikla)='')
        and (FIND_IN_SET(trim(zemljaPorijekla), :zemljaPorijekla) or trim(:zemljaPorijekla)='')
        and( (:daniOd='' or :daniDo='') or ( (datediff(NOW(), datumPi)) > :daniOd  and (datediff(NOW(), datumPi)) < :daniDo ) )       
     --   GROUP BY s.kodRobe, vrstaProdaje
        $groupByVezanoUzMinZalihe
     --    GROUP BY s.kodRobe

        having ((stanjeRobe <> 0  and :kojaStanja='neNul')  or (stanjeRobe < 0  and :kojaStanja='samoNegativna')
         or (stanjeRobe = 0  and :kojaStanja='samoNul')  or :kojaStanja='svaStanja')
    --    and (:ispodMinZaliha='samo' and stanjeRobe<mz.minZaliha or :ispodMinZaliha<>'samo') 
        $uzMinZalihe
         order by grupa, nazivRobe
         ";   
        
      }         
    }   
    // zajedničko za sve querija
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':kodGrupe', $kodGrupe);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->bindValue(':kojaStanja', $kojaStanja);
        $statement->bindValue(':invDonos', $invDonos);
        $statement->bindValue(':daniOd', $daniOd);
        $statement->bindValue(':daniDo', $daniDo);
        $statement->bindValue(':kojeCijene', $kojeCijene); 
        $statement->bindValue(':stringGrupe', trim($stringGrupe));
        $statement->bindValue(':zemljaPorijekla', $zemljaPorijekla);
        $statement->bindValue(':vrstaArtikla', $vrstaArtikla);
        $statement->bindValue(':tarifniBroj', $tarifniBroj);
        $statement->bindValue(':poTarifnimBrojevima', $poTarifnimBrojevima);
        if($kojeCijene=='cijenePoCjeniku')
            $statement->bindValue(':ispodMinZaliha', $ispodMinZaliha);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    } 
    return $result;   
}

function stanje_po_kodu_robe_1p($kodPoslovnice, $kodRobe, $vrstaProdaje,$db=null) {
    if($db==null)
        global $db;
    $query = '
        SELECT SUM(stanje) AS suma_po_kodu_robe
        FROM stanja
        WHERE proda = :kodPoslovnice AND kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodPoslovnice', $kodPoslovnice);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function stanje_po_kodu_robe_sve_ili_neke_p($kodPoslovnice, $kodRobe, $vrstaProdaje='0',$db=null) {
    if($db==null)
        global $db;
    $query = "
        SELECT SUM(s.stanje) AS sumaPoKoduRobe, minZaliha
        FROM stanja s
        LEFT OUTER JOIN minimalne_zalihe m
        ON s.proda = m.kodPoslovnice and s.kodRobe = m.kodRobe
        WHERE (proda = :kodPoslovnice OR trim(:kodPoslovnice) = '' OR trim(:kodPoslovnice) = '0') AND s.kodRobe = :kodRobe
        AND vrstaProdaje = :vrstaProdaje";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodPoslovnice', $kodPoslovnice);
        $statement->bindValue(':kodRobe', $kodRobe);   
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje); 
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function stanje_po_kodu_robe_1p_sveVP($kodPoslovnice, $kodRobe) {
    global $db;
    $query = " 
        SELECT SUM(stanje) AS suma_po_kodu_robe
        FROM stanja
        WHERE proda = :kodPoslovnice AND kodRobe = :kodRobe AND (vrstaProdaje='0' OR vrstaProdaje='1')";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodPoslovnice', $kodPoslovnice);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function stanjePoKoduRobeSveP($kodRobe, $vrstaProdaje='0') {
    //zbrojeno po svim poslovnicama
	//vp  ???? TREBA RAZRADITI
    global $db;
	if ($vrstaProdaje == 'vpSve') {
	$query = '
        SELECT SUM(stanje) AS sumaPoKoduRobe
        FROM stanja
        WHERE kodRobe = :kodRobe';
    } else {
    $query = '
        SELECT SUM(stanje) AS sumaPoKoduRobe
        FROM stanja
        WHERE kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje';
    }	
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
function stanje_po_kodu_robe_svep_p($kodRobe, $vrstaProdaje='0') {
    global $db;
    //po poslovnicama-prodavaonama ???? SELECT kodPoslovnice ?
    $query = '
        SELECT kodPoslovnice SUM(stanje) AS suma_po_kodu_robe_1p
		FROM stanja
		WHERE kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje
		GROUP BY kodPoslovnice';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_stanje($proda,$kodRobe, $vrstaProdaje, $cijena) {
    global $db;
    
    $query = '
       SELECT *
       FROM stanja
       WHERE proda = :proda AND kodRobe = :kodRobe 
       AND vrstaProdaje = :vrstaProdaje AND cijena = :cijena';
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodRobe', $kodRobe);
	$statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->execute();
        $slog = $statement->fetch();
        $statement->closeCursor();
        return $slog;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function zamjena_robe_na_inventuri($proda,$stariKodRobe, $staraVrstaProdaje, $noviKodRobe, $novaVrstaProdaje, $cijena) {
    global $db;

    $staro_stanje = get_stanje($proda, $stariKodRobe, $staraVrstaProdaje, $cijena);
    if(empty($staro_stanje)) return;
    
    $kolicina = $staro_stanje['kolicinaInventure'];
    $datumInveture = $staro_stanje['datumInventure'];
    if($kolicina==0) return;
    
    $email_user = $_SESSION['admin']['email'];
    $query = " 
        UPDATE stanja 
        SET 
           stanje = stanje - :kolicina,
           datumInventure = null,
           kolicinaInventure = 0,
           datumIzmjene = NOW(),
           tkoJeIzmjenio = :email_user 
        WHERE proda = :proda AND kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje
           AND cijena = :cijena
    ";
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodRobe', $stariKodRobe);
	$statement->bindValue(':vrstaProdaje', $staraVrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->bindValue(':kolicina', $kolicina);
        $statement->bindValue(':email_user', $email_user);      
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }

    $slog = get_stanje($proda, $noviKodRobe, $novaVrstaProdaje, $cijena);
    if(empty($slog)) {
     $query = " 
        INSERT INTO stanja 
        (
        proda,kodRobe,vrstaProdaje,cijena,stanje,datumInventure,kolicinaInventure,
        datumOtvaranja,tkoJeIzmjenio
        )
        VALUES 
        (
        :proda,:kodRobe,:vrstaProdaje,:cijena,:kolicina,:datumInventure,:kolicina,
        NOW(),:email_user
        )
        ";        
    }
    else {
        $query = " 
            UPDATE stanja 
            SET 
               stanje = stanje + :kolicina,
               datumInventure = :datumInventure,
               kolicinaInventure = :kolicina,
               datumIzmjene = NOW(),
               tkoJeIzmjenio = :email_user 
            WHERE proda = :proda AND kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje
               AND cijena = :cijena
        ";
    }
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodRobe', $noviKodRobe);
	$statement->bindValue(':vrstaProdaje', $novaVrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->bindValue(':datumInventure', $datumInveture);
        $statement->bindValue(':kolicina', $kolicina);
        $statement->bindValue(':email_user', $email_user);      
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
        
    
}

function azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$kodRobe,$vrstaProdaje,$cijena,$kolicina,$rabatPopust,$absRabatPopust,
    $nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu) {
    if(trim($kodRobe)=='#') return;
    
    if (trim($zavisniTroskoviPu) == '') $zavisniTroskoviPu = 0;
    if (trim($marzaPu) == '') $marzaPu = 0;
           
    include_once 'model/vrste_dokumenata_db.php';
    $slogVrsDo=  get_vrsta_dokumenta($vrsDo);
    if($slogVrsDo['azurStanja']==0)
       return 0;

    $nivelacija=trim($vrsDo)=='3' && ($zapis=='SC' || $zapis=='PC' || $zapis== 'NC' ||  $zapis=='KN');
    $kolicina = round($kolicina * $slogVrsDo['azurStanja'],3);    
    global $db;
    
    if (trim($rabatPopust)=='') $rabatPopust = 0;
    
    // 1. dali slog postoji u stanja
    // 2. ako postoji ide se na update, a ako ne ide se na insert     
    //    $proda = $_SESSION['odabranaPoslovnica'];
    $cijena = round($cijena,4);
    //   echo 'iz stanjadb vrstaProdaje= '. $vrstaProdaje;
    $query = '
        SELECT stanje
        FROM stanja
       WHERE proda = :proda AND kodRobe = :kodRobe 
       AND vrstaProdaje = :vrstaProdaje AND cijena = :cijena';
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodRobe', $kodRobe);
	$statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->execute();
        $postoji_slog = $statement->fetch();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
//    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
//    $proIn = $_SESSION['dok_zag']['proIn'];
//    $zapis = $_SESSION['dok_zag']['zapis']; 
//    $broDo = $_SESSION['dok_zag']['broDo'];
//    $verzi = $_SESSION['dok_zag']['verzi']; 
//    $kodPartneraPu = $_SESSION['dok_zag']['kodPartnera'];
    
    
   //Ponekad dođe krivo okrenuti datum u DVO, za svaki slučaj ga treba okrenuti, Makar  3.4.2014.
   $DVO_o = new DateTime($DVO);
   $DVO = $DVO_o->format("Y-m-d H:i:s");
    
    //if ($vrsDo == '5 ' || $vrsDo == '6 ' || $vrsDo == '7 ' || $vrsDo == '8 ' || $vrsDo == 'PR' || $vrsDo == 'NS')
               //$kolicina = round($kolicina * (-1),3);
    
    if (!empty($postoji_slog)) $novoStanje = $postoji_slog['stanje'] + $kolicina;
    
    $stanje = $kolicina;
    $vrsDoPu = ''; $proInPu = ''; $zapisPu = ''; $broDoPu = ''; $verziPu = ''; $datumPu = '';
    $rabatPu = 0; $absRabatPu = '';
    $vrsDoPi = ''; $proInPi = ''; $zapisPi = ''; $broDoPi = ''; $verziPi = ''; $datumPi = '';
    $rabatPopustPi =0; $absRabatPopustPi = '';
    if ($vrsDo == '1 ' || $vrsDo == '2 ' || $vrsDo == '3 ' || $vrsDo == '4 ') {
        $vrsDoPu = $vrsDo;  $proInPu = $proIn; $zapisPu = $zapis; $broDoPu = $broDo; $verziPu = $verzi;
        $datumPu = $DVO; $rabatPu = $rabatPopust; $absRabatPu = $absRabatPopust;  
    } else { 
        $vrsDoPi = $vrsDo;  $proInPi = $proIn; $zapisPi = $zapis; $broDoPi = $broDo; $verziPi = $verzi;
        $datumPi = $DVO; $rabatPopustPi = $rabatPopust; $absRabatPopustPi = $absRabatPopust;  
    }
    $email_user = $_SESSION['admin']['email'];
if (empty($postoji_slog)) {
     $query = 
        'INSERT INTO stanja (proda,kodRobe,vrstaProdaje,cijena,stanje,vrsDoPu,proInPu,zapisPu,broDoPu,verziPu,
        datumPu,rabatPu,absRabatPu,marzaPu,absMarzaPu,zavisniTroskoviPu,absZavisniTroskoviPu,nabavnaCijenaPu,
        kodPartneraPu,vrsDoPi,proInPi,zapisPi,broDoPi,verziPi,datumPi,rabatPopustPi,
        absRabatPopustPi,datumOtvaranja,tkoJeIzmjenio)
        VALUES (:proda,:kodRobe,:vrstaProdaje,:cijena,:stanje,:vrsDoPu,:proInPu,:zapisPu,:broDoPu,:verziPu,
        :datumPu,:rabatPu,:absRabatPu,:marzaPu,:absMarzaPu,:zavisniTroskoviPu,:absZavisniTroskoviPu,:nabavnaCijenaPu,
        :kodPartneraPu,:vrsDoPi,:proInPi,:zapisPi,:broDoPi,:verziPi,:datumPi,:rabatPopustPi,
        :absRabatPopustPi,NOW(),:email_user)';
     
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->bindValue(':stanje', $stanje);
        $statement->bindValue(':vrsDoPu', $vrsDoPu);
        $statement->bindValue(':proInPu', $proInPu);
        $statement->bindValue(':zapisPu', $zapisPu);
        if($broDoPu=='')
            $statement->bindValue(':broDoPu', null, PDO::PARAM_NULL);
        else
            $statement->bindValue(':broDoPu', $broDoPu);
        $statement->bindValue(':verziPu', $verziPu);
        if($datumPu=='')
            $statement->bindValue(':datumPu', null, PDO::PARAM_NULL);
        else
            $statement->bindValue(':datumPu', $datumPu);
        $statement->bindValue(':rabatPu', $rabatPu);
        $statement->bindValue(':absRabatPu', $absRabatPu);
        $statement->bindValue(':marzaPu', $marzaPu);
        $statement->bindValue(':absMarzaPu', $absMarzaPu);
        $statement->bindValue(':zavisniTroskoviPu', $zavisniTroskoviPu);
        $statement->bindValue(':absZavisniTroskoviPu', $absZavisniTroskoviPu);
        $statement->bindValue(':nabavnaCijenaPu', $nabavnaCijenaPu);
        $statement->bindValue(':kodPartneraPu', $kodPartneraPu);
        $statement->bindValue(':vrsDoPi', $vrsDoPi);
        $statement->bindValue(':proInPi', $proInPi);
        $statement->bindValue(':zapisPi', $zapisPi);
        if($broDoPi=='')
            $statement->bindValue(':broDoPi', null, PDO::PARAM_NULL);
        else
            $statement->bindValue(':broDoPi', $broDoPi);
        $statement->bindValue(':verziPi', $verziPi);
        if($datumPi=='')
            $statement->bindValue(':datumPi', null, PDO::PARAM_NULL);
        else
            $statement->bindValue(':datumPi', $datumPi);
        $statement->bindValue(':rabatPopustPi', $rabatPopustPi);
        $statement->bindValue(':absRabatPopustPi', $absRabatPopustPi);
        $statement->bindValue(':email_user', $email_user);      
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    return $rowCount;
 } else {
     if($nivelacija)
        $query = '
        UPDATE stanja 
        SET stanje = :novoStanje, 
           datumIzmjene = NOW(),
           tkoJeIzmjenio	 = :email_user 
        WHERE proda = :proda AND kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje
           AND cijena = :cijena';
     else    
        $query = '
        UPDATE stanja 
        SET stanje = :novoStanje, 
           vrsDoPu = :vrsDoPu,
           proInPu = :proInPu,
           zapisPu = :zapisPu,
           broDoPu = :broDoPu,
           verziPu = :verziPu,
           datumPu = :datumPu,
           rabatPu = :rabatPu,
           absRabatPu = :absRabatPu,
           marzaPu = :marzaPu,
           absMarzaPu = :absMarzaPu,
           zavisniTroskoviPu = :zavisniTroskoviPu,
           absZavisniTroskoviPu = :absZavisniTroskoviPu,
           nabavnaCijenaPu = :nabavnaCijenaPu,
           kodPartneraPu = :kodPartneraPu,
           vrsDoPi = :vrsDoPi,
           proInPi = :proInPi,
           zapisPi = :zapisPi,
           broDoPi = :broDoPi,
           verziPi = :verziPi,
           datumPi = :datumPi,
           rabatPopustPi = :rabatPopustPi,
           absRabatPopustPi = :absRabatPopustPi,
           datumIzmjene = NOW(),
           tkoJeIzmjenio	 = :email_user 
        WHERE proda = :proda AND kodRobe = :kodRobe AND vrstaProdaje = :vrstaProdaje
           AND cijena = :cijena';
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
	$statement->bindValue(':kodRobe', $kodRobe);
	$statement->bindValue(':vrstaProdaje', $vrstaProdaje);
	$statement->bindValue(':cijena', $cijena);            
        $statement->bindValue(':novoStanje', $novoStanje);
        if(!$nivelacija) {
            $statement->bindValue(':vrsDoPu', $vrsDoPu);
            $statement->bindValue(':proInPu', $proInPu);
            $statement->bindValue(':zapisPu', $zapisPu);
            if($broDoPu=='')
                $statement->bindValue(':broDoPu', null, PDO::PARAM_NULL);
            else
                $statement->bindValue(':broDoPu', $broDoPu);
            $statement->bindValue(':verziPu', $verziPu);
            if($datumPu=='')
                $statement->bindValue(':datumPu', null, PDO::PARAM_NULL);
            else
                $statement->bindValue(':datumPu', $datumPu);
            $statement->bindValue(':rabatPu', $rabatPu);
            $statement->bindValue(':absRabatPu', $absRabatPu);
            $statement->bindValue(':marzaPu', $marzaPu);
            $statement->bindValue(':absMarzaPu', $absMarzaPu);
            $statement->bindValue(':zavisniTroskoviPu', $zavisniTroskoviPu);
            $statement->bindValue(':absZavisniTroskoviPu', $absZavisniTroskoviPu);
            $statement->bindValue(':nabavnaCijenaPu', $nabavnaCijenaPu);
            $statement->bindValue(':kodPartneraPu', $kodPartneraPu);
            $statement->bindValue(':vrsDoPi', $vrsDoPi);
            $statement->bindValue(':proInPi', $proInPi);
            $statement->bindValue(':zapisPi', $zapisPi);
            if($broDoPi=='')
                $statement->bindValue(':broDoPi', null, PDO::PARAM_NULL);
            else
                $statement->bindValue(':broDoPi', $broDoPi);
            $statement->bindValue(':verziPi', $verziPi);
            if($datumPi=='')
                $statement->bindValue(':datumPi', null, PDO::PARAM_NULL);
            else
                $statement->bindValue(':datumPi', $datumPi);
            $statement->bindValue(':rabatPopustPi', $rabatPopustPi);
            $statement->bindValue(':absRabatPopustPi', $absRabatPopustPi);
        }
        $statement->bindValue(':email_user', $email_user);      
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    return $rowCount;
 }
 
}

function ispadi_stanja() {
    global $db;
    $query = " 
select 
    s.proda, 
    s.kodRobe, 
    s.vrstaProdaje, 
    -- s.cijena, 
    s.stanje  + ifnull(kolicinaInventure,0) as poKartici,
    st.stanje as uStanjima, 
    kolicinaInventure

from
(  
select 
    s.proda, 
    s.kodrobe, 
    s.vrstaProdaje, 
    -- s.cijena , 
    ifnull(sum(ifnull(s.kolicina * v.`azurStanja`,0)),0) as stanje
from dok_stavke as s
left outer join vrste_dokumenata as v on v.`vrsDo`=s.`vrsDo`
join poslovnice as p on p.kodPoslovnice=s.proda
where (s.`DVO`>= `datumInventure` and datumInventure>'0000-00-00 00:00:00' 
  or (p.datumInventure='0000-00-00 00:00:00' or datumInventure is null)) 
group by
    s.proda, 
    s.kodrobe, 
    s.vrstaProdaje 
    -- s.cijena 
) as s
-- /*
inner join
(
select proda, kodRobe, vrstaProdaje, sum(stanje) as stanje, sum(kolicinaInventure) as kolicinaInventure
from stanja
group  by proda, kodRobe, vrstaProdaje

) as st
 on st.proda=s.proda and st.`kodRobe`=s.`kodRobe` and st.vrstaProdaje=s.`vrstaProdaje` -- and st.cijena=s.cijena
-- */
where st.stanje<>s.stanje + ifnull(kolicinaInventure,0)
     ";
     try {
        $statement = $db->prepare($query);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function korekcija_stanja_Pu_donosa($parametri) {
    global $db;
    $query='SELECT @@collation_database';
    $statement = $db->prepare($query);
    $statement->execute();
    $pp= $statement->fetch();
    $statement->closeCursor();
    $collation=$pp[0];
    
    $b=explode('_', $_SESSION['odabranaBaza']);
    $arhBaza=$_SESSION['odabranaBaza'];
    if($_SESSION['godina_b']!='') {
        $n=count($b)-1;
        $arhBaza=  str_replace($b[$n], (int)$b[$n]-1, $arhBaza);
    }
    else {
        $g=(int)date('Y') - 2001;
        $arhBaza.='_'.$g;
    }
    
    $proda=implode(",", $parametri['odabranePoslovnice']);
    $query = " 
UPDATE stanja0101 as st
set
    st.`vrsDoPu`='',
    st.`proInPu`='',
    st.`zapisPu`='',
    st.`broDoPu`=null,
    st.`verziPu`='',
    st.`datumPu`=null,
    st.`rabatPu`=0,
    st.`absRabatPu`=0,
    st.`marzaPu`=0,
    st.`absMarzaPu`=0,
    st.zavisniTroskoviPu=0,
    st. absZavisniTroskoviPu=0, 
    st.nabavnaCijenaPu=0, 
    st.kodPartneraPu=0
WHERE (FIND_IN_SET(trim(st.proda), '$proda') or trim('$proda')='' or trim('$proda')='0')
    and (st.kodRobe=:kodRobe or trim(:kodRobe)='')
     ";
     try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $parametri['kodRobe']);
        $statement->execute();
        $brojSlogova=$statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }

    
    $query = " 
UPDATE stanja0101 as st
join
(  
-- SELECT s.proda , s.kodRobe, s.`vrstaProdaje`, s.cijena, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, 
-- s.`rabatPopust`,s.`absRabatPopust`, s.marza,s.`absMarza`,s.`zavisniTroskovi`,s.`absZavTr`, s.`nabavnaCijena`, z.kodPartnera, z.`DVO`  
SELECT s.proda COLLATE $collation as proda, s.kodRobe COLLATE $collation as kodRobe, 
s.`vrstaProdaje` COLLATE $collation as vrstaProdaje, s.cijena, s.vrsDo COLLATE $collation as vrsDo, 
s.proIn COLLATE $collation as proIn, s.zapis COLLATE $collation as zapis, s.broDo, s.verzi COLLATE $collation as verzi, 
s.`rabatPopust`,s.`absRabatPopust`, s.marza,s.`absMarza`,s.`zavisniTroskovi`,s.`absZavTr`, s.`nabavnaCijena`, z.kodPartnera, z.`DVO`  
FROM $arhBaza.dok_stavke as s
join
(
SELECT s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena,  
max(s.DVO) as datum 
FROM $arhBaza.dok_stavke as s
WHERE (vrsDo = '1' or vrsDo = '2' )
GROUP BY s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena
) as s2 on s2.proda=s.proda and s2.`kodRobe`=s.`kodRobe` and s2.cijena=s.cijena and s2.datum=s.DVO

join $arhBaza.dok_zag as z 
  on z.proda=s.proda and z.vrsDo=s.`vrsDo` and z.`proIn`=s.`proIn` 
  and z.zapis=s.zapis and z.`broDo`=s.`broDo` and z.verzi=s.verzi

WHERE (s.vrsDo = '1' or s.vrsDo = '2' ) 

) 
as s on s.proda=st.proda and s.kodRobe=st.kodRobe and s.vrstaProdaje=st.`vrstaProdaje` -- and s.cijena=st.cijena 
set
    st.`vrsDoPu`=s.vrsDo,
    st.`proInPu`=s.proIn,
    st.`zapisPu`=s.zapis,
    st.`broDoPu`=s.broDo,
    st.`verziPu`=s.verzi,
    st.`datumPu`=s.DVO,
    st.`rabatPu`=s.rabatPopust,
    st.`absRabatPu`=s.`absRabatPopust`, 
    st.`marzaPu`=s.marza,
    st.`absMarzaPu`=s.`absMarza`,
    st.zavisniTroskoviPu=s.zavisniTroskovi,
    st. absZavisniTroskoviPu=s.absZavTr, 
    st.nabavnaCijenaPu=s.`nabavnaCijena`, 
    st.kodPartneraPu=s.kodPartnera
where st.kolicinaInventure>0
and (FIND_IN_SET(trim(st.proda), '$proda') or trim('$proda')='' or trim('$proda')='0')
    and (st.kodRobe=:kodRobe or trim(:kodRobe)='')
     ";
     try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $parametri['kodRobe']);
        $statement->execute();
        $brojSlogova=$statement->rowCount();
        $statement->closeCursor();
        //return 'Obrađeno:'.$brojSlogova.' slogova.';
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    $query = " 
update stanja0101 as s
inner join 
(
select proda COLLATE $collation as proda, kodRobe COLLATE $collation as kodRobe, vrstaProdaje COLLATE $collation as vrstaProdaje, datumPu,
rabatPu, absRabatPu COLLATE $collation as absRabatPu, marzaPu, absMarzaPu COLLATE $collation as absMarzaPu, zavisniTroskoviPu, nabavnaCijenaPu
from $arhBaza.stanja0101
where `kolicinaInventure`>0
and trim(`vrsDoPu`)='1'
) as s2 on s2.proda=s.proda and s2.kodRobe=s.kodRobe and s2.vrstaProdaje=s.vrstaProdaje 
set
s.datumPu=s2.datumPu,
s.rabatPu=s2.rabatPu,
s.absRabatPu=s2.absRabatPu,
s.marzaPu=s2.marzaPu,
s.absMarzaPu=s2.absMarzaPu,
s.zavisniTroskoviPu=s2.zavisniTroskoviPu,
s.nabavnaCijenaPu=s2.nabavnaCijenaPu
where s.`kolicinaInventure`>0
and s.`nabavnaCijenaPu`=0
and (FIND_IN_SET(trim(s.proda), '$proda') or trim('$proda')='' or trim('$proda')='0')
    and (s.kodRobe=:kodRobe or trim(:kodRobe)='')
     ";
     try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $parametri['kodRobe']);
        $statement->execute();
        $brojSlogova=$statement->rowCount();
        $statement->closeCursor();
        return 'Obrađeno:'.$brojSlogova.' slogova.';
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_int_fakt_stanja0101($db, $parametri) {
    $proda=implode(",", $parametri['odabranePoslovnice']);
    $query = " 
    select * 
    from stanja0101 as st
    where st.`kolicinaInventure`>0 and st.vrsDoPu='2'
    and (FIND_IN_SET(trim(st.proda), '$proda') or trim('$proda')='' or trim('$proda')='0')
    and (st.kodRobe=:kodRobe or trim(:kodRobe)='')
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $parametri['kodRobe']);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function pojedinacna_korekcija_stanja_Pu_donosa($dokument, $proda, $cijena) {
    global $db;
    $query = " 
UPDATE stanja0101
set
    rabatPu=:rabatPu,
    absRabatPu=:absRabatPu, 
    marzaPu=:marzaPu,
    absMarzaPu=:absMarzaPu,
    zavisniTroskoviPu=:zavisniTroskoviPu,
    absZavisniTroskoviPu=:absZavisniTroskoviPu, 
    nabavnaCijenaPu=:nabavnaCijenaPu,
    datumPu=:datumPu
where 
    proda=:proda
    and kodRobe=:kodRobe
    and vrstaProdaje=:vrstaProdaje
    and cijena=:cijena
    and kolicinaInventure>0 and vrsDoPu='2'
    ";
     try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodRobe', $dokument['kodRobe']);
        $statement->bindValue(':vrstaProdaje', $dokument['vrstaProdaje']);
        $statement->bindValue(':cijena', $cijena);
        
        $statement->bindValue(':datumPu', $dokument['DVO']);
        $statement->bindValue(':rabatPu', $dokument['rabatPopust']);
        $statement->bindValue(':absRabatPu', $dokument['absRabatPopust']);
        $statement->bindValue(':marzaPu', $dokument['marza']);
        $statement->bindValue(':absMarzaPu', '%');
        $statement->bindValue(':zavisniTroskoviPu', $dokument['zavisniTroskovi']);
        $statement->bindValue(':absZavisniTroskoviPu', '%');
        $statement->bindValue(':nabavnaCijenaPu', $dokument['nabavnaCijena']);
        $statement->execute();
        $statement->closeCursor();
        return;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function stanja_po_grupi1($proda, $vrstaProdaje, $kodGrupe) {
    global $db;
    $query = '
        SELECT proda, s.kodRobe, s.cijena, vrstaProdaje, stanje as kolicina
        FROM stanja s
        JOIN maticna_robe m
        ON s.kodRobe = m.kodRobe
        WHERE s.proda = :proda and vrstaProdaje = :vrstaProdaje and kodGrupe = :kodGrupe and stanje <> 0';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':kodGrupe', $kodGrupe);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    //echo 'count result1=' . count($result1);
}
function stanja_po_grupi_za_excel($proda, $vrstaProdaje, $kodGrupe) {
    global $db;
    $query = "
        SELECT proda, s.kodRobe, vrstaProdaje, nazivRobe, EANkod, m.cijena, vrstaProdaje, sum(stanje) as stanje
        FROM stanja s
        JOIN maticna_robe m
        ON s.kodRobe = m.kodRobe
/*     WHERE s.proda = :proda and vrstaProdaje = :vrstaProdaje and kodGrupe = :kodGrupe and stanje <> 0       */
       WHERE s.proda = :proda and (vrstaProdaje = '0' or vrstaProdaje = 'D') and kodGrupe = :kodGrupe and stanje <> 0
        group by proda, s.kodRobe, vrstaProdaje";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
    //    $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':kodGrupe', $kodGrupe);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    //echo 'count result1=' . count($result1);
}
function prikazPseudoStanja($stanjeR,$vrstaProdaje,$kodGrupe,$odvojeniZnakVece=false) {
    //  prikaz pseudo stanja u jednom polju npr. >20 ili u dva odvojena polja  > (prvo polje) a drugo polje 20
    // odvojeni prikaz se korisri kod pretvorbe stanja u excel 
    $pseudoStanje = array();
    $pseudoStanje[0]=$stanjeR;
    $pseudoStanje[1]='';
    if ( (isset($_SESSION['admin']['kodPartneraORG']) and $_SESSION['admin']['kodPartneraORG'] == '701') or $_SESSION['admin']['kodPartnera'] == '701' ) {      
        $kodoviGrupaBicikli = '0501, 1081, 1082, 1083, 1085, 1086, 1088, 1089';  
        $pos = strpos($kodoviGrupaBicikli,$kodGrupe);
        if ($pos) {  // roba iz gornjih grupa            
            if ($stanjeR > 20) {
                $pseudoStanje[0] = '> 20';  
                if ($odvojeniZnakVece === true) {
                    $pseudoStanje[0] = '20';     
                    $pseudoStanje[1] = '>'; 
                }    
            } 
            return $pseudoStanje;
        }        
        if ($stanjeR > 100) {  // sva ostala roba izvan gornjih grupa
            $pseudoStanje[0] = '> 100';
            if ($odvojeniZnakVece === true) {
                    $pseudoStanje[0] = '100';
                    $pseudoStanje[1] = '>';                    
            }    
        };
        return $pseudoStanje;
    }   
//    *************************************************************** b2b koerisnici ostali
    
    if ($odvojeniZnakVece === true) $pseudoStanje[1] = '>';
    $pseudoStanje[0] = $stanjeR; 
    
    if ($stanjeR <= 0) {
        $pseudoStanje[0] = '0.00';
        $pseudoStanje[1] = '';
    }   
    if ($stanjeR > 0 && $stanjeR <= 5) {   
        if ($odvojeniZnakVece === false) $pseudoStanje[0] = '> 1'; else $pseudoStanje[0] = 1;                                     
    }           
    if ($stanjeR > 5 && $stanjeR <= 10) {
        if ($odvojeniZnakVece === false) $pseudoStanje[0] = '> 5'; else $pseudoStanje[0] = 5;                                    
    }           
    if ($stanjeR > 10 && $stanjeR <= 50) {
       if ($odvojeniZnakVece === false) $pseudoStanje[0] = '> 10'; else $pseudoStanje[0] = 10;                  
    }           
    if ($stanjeR > 50 && $stanjeR <= 100) {
        if ($odvojeniZnakVece === false) $pseudoStanje[0] = '> 50'; else $pseudoStanje[0] = 50; 
    }   
    if ($stanjeR > 100) {
        if ($odvojeniZnakVece === false) $pseudoStanje[0] = '> 100'; else $pseudoStanje[0] = 100; 
    }
     
    
    if ($vrstaProdaje == 'D' && $stanjeR  >= 1) {
        $pseudoStanje[0] = 'DOLAZI';    
        $pseudoStanje[1] = '';        
    }
    
    return $pseudoStanje;
}

function stanje_robe_chaky_din($prodaChaky, $prodaDinaic, $kodGrupe) {
    global $db;
    /*
    $query = "
        SELECT c_r.kodRobe, c_r.nazivRobe, c_r.kodGrupe, 
        c_r.cijena, round(c_r.cijena*(1+c_p.PDV/100),2) as cijenaSPDV, c_r.popust,
        SUM(if(c_st.proda='701',c_st.stanje,0)) as kolicina_701,
        d_r.kodGrupe as kodGrupe_din,
        d_r.cijena as cijena_din, round(d_r.cijena*(1+c_p.PDV/100),2) as cijenaSPDV_din, d_r.popust as popust_din,
        SUM(if(d_st.proda='201',d_st.stanje,0)) as kolicina_201,
        SUM(if(d_st.proda='202',d_st.stanje,0)) as kolicina_202,
        SUM(if(d_st.proda='204',d_st.stanje,0)) as kolicina_204,
        SUM(if(d_st.proda='205',d_st.stanje,0)) as kolicina_205,
        SUM(if(d_st.proda='208',d_st.stanje,0)) as kolicina_208,
        SUM(if(d_st.proda='209',d_st.stanje,0)) as kolicina_209,
        SUM(if(d_st.proda='210',d_st.stanje,0)) as kolicina_210

        FROM murskiga_robno_cha.maticna_robe as c_r
        LEFT OUTER JOIN murskiga_robno_cha.porezi as c_p ON c_p.poreznaGrupa=c_r.poreznaGrupa
        LEFT OUTER JOIN murskiga_robno_cha.stanja as c_st ON c_st.kodRobe=c_r.kodRobe
        LEFT OUTER JOIN murskiga_robno_din.maticna_robe as d_r ON d_r.kodRobe=c_r.kodRobe
        LEFT OUTER JOIN murskiga_robno_din.stanja as d_st ON d_st.kodRobe=c_r.kodRobe
        WHERE (FIND_IN_SET(trim(c_r.kodGrupe), :kodGrupe) or trim(:kodGrupe)='')
        AND (FIND_IN_SET(trim(c_st.proda), :prodaChaky) or trim(:prodaChaky)='')
        GROUP BY c_r.kodRobe
        ";
        */
    
    $p = explode(',', $prodaChaky);
    $sqlChaky = '';
    foreach ($p as $proda) {
        $sqlChaky .= "SUM(if(c_st.proda = '$proda', c_st.stanje, 0)) as kolicina_$proda,   
                            "; 
    }
    $p = explode(',', $prodaDinaic);
    $sqlDinamic = $subSqlDinamic = '';
    foreach ($p as $proda) {
        $sqlDinamic .= "ifnull(kolicina_$proda,0) as kolicina_$proda,   
                            "; 
        $subSqlDinamic .= "SUM(if(d_st.proda = '$proda', d_st.stanje, 0)) as kolicina_$proda,   
                            "; 
    }
    $query = "
        SELECT c_r.kodRobe, c_r.nazivRobe, c_r.kodGrupe, 
        c_r.cijena, round(c_r.cijena*(1+c_p.PDV/100),2) as cijenaSPDV, c_r.popust,
        $sqlChaky
        d_r.kodGrupe as kodGrupe_din,
        d_r.cijena as cijena_din, round(d_r.cijena*(1+c_p.PDV/100),2) as cijenaSPDV_din, d_r.popust as popust_din,
        $sqlDinamic
        'kraj' as kraj    

        FROM murskiga_robno_cha.maticna_robe as c_r
        LEFT OUTER JOIN murskiga_robno_cha.porezi as c_p ON c_p.poreznaGrupa=c_r.poreznaGrupa
        LEFT OUTER JOIN murskiga_robno_cha.stanja as c_st ON c_st.kodRobe=c_r.kodRobe
        LEFT OUTER JOIN murskiga_robno_din.maticna_robe as d_r ON d_r.kodRobe=c_r.kodRobe
        LEFT OUTER JOIN 
        (
            SELECT kodRobe,
            $subSqlDinamic
            'kraj' as kraj                
            FROM murskiga_robno_din.stanja as d_st
            GROUP BY kodRobe
        ) as d_st ON d_st.kodRobe=c_r.kodRobe
        WHERE (FIND_IN_SET(trim(c_r.kodGrupe), :kodGrupe) or trim(:kodGrupe)='')
        AND (FIND_IN_SET(trim(c_st.proda), :prodaChaky) or trim(:prodaChaky)='')
        GROUP BY c_r.kodRobe
        ";
    // echo nl2br($query);
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':prodaChaky', $prodaChaky);
    //    $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':kodGrupe', $kodGrupe);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    //echo 'count result1=' . count($result1);
}

function za_dimamic_web($proda, $kodGrupe) {
    global $db;

    $query = "
SELECT m.kodRobe, nazivRobe, jedinicaMjere, round(m.cijena * (1+p.PDV/100),4) as MPC, popust, 
ifnull(pom2.stanje,0) as stanje, ifnull(nalaziSeU,'') as gdjeSeNalazi,
 velicinaRame, velicinaKotaca, spol, kodGrupe, kodGrupe2, brand, aktivan, opis 
FROM maticna_robe as m
INNER JOIN porezi as p ON p.poreznaGrupa=m.poreznaGrupa
LEFT OUTER JOIN
(
       select kodRobe, proda, sum(stanje) as stanje, 
       GROUP_CONCAT(proda) as nalaziSeU 
        from
        (
            select kodRobe, proda, sum(stanje) as stanje
            from stanja
            where stanje<>0 
            and FIND_IN_SET(trim(proda), :proda)
            group by trim(kodRobe), trim(proda)
        ) as st
        where stanje<>0 
        group by kodRobe
) AS pom2 ON trim(pom2.kodRobe) = trim(m.kodRobe)
WHERE FIND_IN_SET(trim(kodGrupe), :kodGrupe)
   OR FIND_IN_SET(trim(kodGrupe2), :kodGrupe)
GROUP BY m.kodRobe
    ";
    // echo nl2br($query);
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':kodGrupe', $kodGrupe);
        $statement->execute();
        $result = $statement->fetchAll(PDO::FETCH_ASSOC); // FETCH_ASSOC - ne ukjučuje indeks kolone u array (0, 1,2,..) nema $result[0] itd
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
?>
