<?php
function add_krediti_obustave($slog) {
    global $db;
	$email_user = $_SESSION['admin']['email'];
    $query = " 
        INSERT INTO  krediti_obustave 
        (
            kodRadnika, kodBanke,
            kodKredita,
            nazivKreditaObustave,
            rataKredita,
            absRataKredita,
            brojRacunaZaIsplatuKredita,
            modelPrimatelja,
            pozivNaBrojPrimatelja,
            ukupniIznosKredita,
            pocetakObustave,
            iznosPrveRate,
            zavrsetakObustave,  
            virmanPojedinacniGrupni,
            brojRata,
            iznosZadnjeRate,
            modelPlatitelja,
            pozivNaBrojPlatitelja,
            aktivan,
            datumOtvaranja, tkoJeIzmjenio
        ) 
	VALUES 
        (
            :kodRadnika, :kodBanke,
            :kodKredita,
            :nazivKreditaObustave,
            :rataKredita,
            :absRataKredita,
            :brojRacunaZaIsplatuKredita,
            :modelPrimatelja,
            :pozivNaBrojPrimatelja,
            :ukupniIznosKredita,
            :pocetakObustave,
            :iznosPrveRate,
            :zavrsetakObustave, 
            :virmanPojedinacniGrupni,
            :brojRata,
            :iznosZadnjeRate,
            :modelPlatitelja,
            :pozivNaBrojPlatitelja,
            :aktivan,
            NOW(), :email_user
        )
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRadnika', $slog['kodRadnika']);
        $statement->bindValue(':kodBanke', $slog['kodBanke']);
        $statement->bindValue(':kodKredita', $slog['kodKredita']);
        $statement->bindValue(':nazivKreditaObustave', $slog['nazivKreditaObustave']);
        $statement->bindValue(':rataKredita', str_replace(',', '.', $slog['rataKredita']));
        $statement->bindValue(':absRataKredita', $slog['absRataKredita']);
        $statement->bindValue(':brojRacunaZaIsplatuKredita', $slog['brojRacunaZaIsplatuKredita']);
        $statement->bindValue(':modelPrimatelja', $slog['modelPrimatelja']);
        $statement->bindValue(':pozivNaBrojPrimatelja', $slog['pozivNaBrojPrimatelja']);
        $statement->bindValue(':ukupniIznosKredita', $slog['ukupniIznosKredita']);

        if($slog['pocetakObustave']!='') {
            $d = new DateTime($slog['pocetakObustave']);
            $pocetakObustave=$d->format("Y-m-d");
            $statement->bindValue(':pocetakObustave', $pocetakObustave);
        }
        else 
            $statement->bindValue(':pocetakObustave', null, PDO::PARAM_NULL);   
        if($slog['zavrsetakObustave']!='') {
            $d = new DateTime($slog['zavrsetakObustave']);
            $zavrsetakObustave=$d->format("Y-m-d");
            $statement->bindValue(':zavrsetakObustave', $d->format("Y-m-d"));
        }
        else 
            $statement->bindValue(':zavrsetakObustave', null, PDO::PARAM_NULL);   
        $statement->bindValue(':virmanPojedinacniGrupni', $slog['virmanPojedinacniGrupni']);
        $statement->bindValue(':iznosPrveRate', str_replace(',', '.', $slog['iznosPrveRate']));
        $statement->bindValue(':iznosZadnjeRate', str_replace(',', '.', $slog['iznosZadnjeRate']));
        $statement->bindValue(':brojRata', $slog['brojRata']);
        $statement->bindValue(':modelPlatitelja', $slog['modelPlatitelja']);
        $statement->bindValue(':pozivNaBrojPlatitelja', $slog['pozivNaBrojPlatitelja']);
        $statement->bindValue(':aktivan', $slog['aktivan']);
        $statement->bindValue(':email_user', $email_user); 
        $statement->execute();
        $statement->closeCursor();      
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function update_krediti_obustave($slog, $stariKljuc) {
    global $db;
	$email_user = $_SESSION['admin']['email'];
    $query = " 
        UPDATE krediti_obustave
        SET            
            kodBanke = :kodBanke,
            kodKredita = :kodKredita,
            nazivKreditaObustave = :nazivKreditaObustave,
            rataKredita = :rataKredita,
            absRataKredita = :absRataKredita,
            brojRacunaZaIsplatuKredita = :brojRacunaZaIsplatuKredita,
            modelPrimatelja = :modelPrimatelja,
            pozivNaBrojPrimatelja = :pozivNaBrojPrimatelja,
            ukupniIznosKredita = :ukupniIznosKredita,
            pocetakObustave = :pocetakObustave,
            iznosPrveRate = :iznosPrveRate,
            zavrsetakObustave = :zavrsetakObustave,  
            virmanPojedinacniGrupni = :virmanPojedinacniGrupni,
            brojRata = :brojRata,
            iznosZadnjeRate = :iznosZadnjeRate,
            modelPlatitelja = :modelPlatitelja,
            pozivNaBrojPlatitelja = :pozivNaBrojPlatitelja,
            aktivan=:aktivan,
            datumIzmjene = NOW(),
            tkoJeIzmjenio = :email_user
        WHERE kodRadnika = :kodRadnika_st AND kodBanke = :kodBanke_st AND kodKredita = :kodKredita_st
        ";
    try {
        $statement = $db->prepare($query);
        // $statement->bindValue(':kodRadnika', $slog['kodRadnika']);
        $statement->bindValue(':kodBanke', $slog['kodBanke']);
        $statement->bindValue(':kodKredita', $slog['kodKredita']);
        $statement->bindValue(':nazivKreditaObustave', $slog['nazivKreditaObustave']);
        $statement->bindValue(':rataKredita', str_replace(',', '.', $slog['rataKredita']));
        $statement->bindValue(':absRataKredita', $slog['absRataKredita']);
        $statement->bindValue(':brojRacunaZaIsplatuKredita', $slog['brojRacunaZaIsplatuKredita']);
        $statement->bindValue(':modelPrimatelja', $slog['modelPrimatelja']);
        $statement->bindValue(':pozivNaBrojPrimatelja', $slog['pozivNaBrojPrimatelja']);
        $statement->bindValue(':ukupniIznosKredita', $slog['ukupniIznosKredita']);

        if($slog['pocetakObustave']!='') {
            $d = new DateTime($slog['pocetakObustave']);
            $pocetakObustave=$d->format("Y-m-d");
            $statement->bindValue(':pocetakObustave', $pocetakObustave);
        }
        else 
            $statement->bindValue(':pocetakObustave', null, PDO::PARAM_NULL);   
        if($slog['zavrsetakObustave']!='') {
            $d = new DateTime($slog['zavrsetakObustave']);
            $zavrsetakObustave=$d->format("Y-m-d");
            $statement->bindValue(':zavrsetakObustave', $d->format("Y-m-d"));
        }
        else 
            $statement->bindValue(':zavrsetakObustave', null, PDO::PARAM_NULL);   
        $statement->bindValue(':virmanPojedinacniGrupni', $slog['virmanPojedinacniGrupni']);
        $statement->bindValue(':iznosPrveRate', str_replace(',', '.', $slog['iznosPrveRate']));
        $statement->bindValue(':iznosZadnjeRate', str_replace(',', '.', $slog['iznosZadnjeRate']));
        $statement->bindValue(':brojRata', $slog['brojRata']);
        $statement->bindValue(':modelPlatitelja', $slog['modelPlatitelja']);
        $statement->bindValue(':pozivNaBrojPlatitelja', $slog['pozivNaBrojPlatitelja']);
        $statement->bindValue(':aktivan', $slog['aktivan']);
        $statement->bindValue(':email_user', $email_user); 

        $statement->bindValue(':kodRadnika_st', $stariKljuc['kodRadnika']);
        $statement->bindValue(':kodBanke_st', $stariKljuc['kodBanke']);
        $statement->bindValue(':kodKredita_st', $stariKljuc['kodKredita']);

        $statement->execute();
        $statement->closeCursor();      
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function delete_krediti_obustave($slog) {
    global $db;
    $query = "DELETE FROM krediti_obustave WHERE kodRadnika = :kodRadnika AND kodBanke = :kodBanke AND kodKredita = :kodKredita";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRadnika', $slog['kodRadnika']);
        $statement->bindValue(':kodBanke', $slog['kodBanke']);
        $statement->bindValue(':kodKredita', $slog['kodKredita']);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_krediti_obustave($kodRadnika='', $aktivniKrediti='svi', $datumPregleda=null) {
    global $db;
    if(!isset($datumPregleda)) {
        $d = new DateTime();
        
        $datumPregleda = $d->format('Y-m-d');
    }
    $query = " 
        select k.*, r.imeIprezime, r.bodovi, p.nazivPartnera
        from krediti_obustave as k
        join maticna_radnika as r on r.kodRadnika=k.kodRadnika
        join partner as p on p.kodPartnera=k.kodBanke
        where (k.kodRadnika=:kodRadnika or :kodRadnika='')
        and (:aktivniKrediti='svi' 
            or (:aktivniKrediti='aktivni' 
                and :datumPregleda between ifnull(pocetakObustave,:datumPregleda) and ifnull(zavrsetakObustave,:datumPregleda) and aktivan='Da')
            or (:aktivniKrediti='neaktivni' 
                and not (:datumPregleda between ifnull(pocetakObustave,:datumPregleda) and ifnull(zavrsetakObustave,:datumPregleda) and aktivan='Da'))
        )
        order by imeIprezime, k.kodRadnika, kodBanke, kodKredita
    ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRadnika', $kodRadnika);
        $statement->bindValue(':aktivniKrediti', $aktivniKrediti);
        $statement->bindValue(':datumPregleda', $datumPregleda);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function get_kredit($slog) {
    global $db;
    $query = " 
            SELECT k.*, p.nazivPartnera
            FROM krediti_obustave as k
            JOIN partner as p ON p.kodPartnera=k.kodBanke
            WHERE kodRadnika = :kodRadnika 
            AND kodBanke = :kodBanke 
            AND kodKredita = :kodKredita
            ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRadnika', $slog['kodRadnika']);
        $statement->bindValue(':kodBanke', $slog['kodBanke']);
        $statement->bindValue(':kodKredita', $slog['kodKredita']);
        $statement->execute();
        $result = $statement->fetch();
        $statement->closeCursor();
        return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
?>