DROP TABLE IF EXISTS iisplate_na_banke_maticna_radnika;

CREATE TABLE iisplate_na_banke_maticna_radnika (
  kodRadnika  CHAR(11)      NOT NULL,
  kodBanke VARCHAR(13) NOT NULL,    /*  moguća isplata plaće na više banki po dijelovima */
  verzijaIsplate char(1) DEFAULT ' ',  /* npr. isplata u istoj banci na zaštićeni račun npr. verzija 0 ili A i isplata na redovni račun npr. verzija 1 ili B) */
  brojRacunaZaIsplatuPlace VARCHAR(60) DEFAULT ' ',
  postoIliIznosPlace DECIMAL(9,2)  DEFAULT 100, /* najčešća isplata 100% na jedan račun */
  postoIliIznos VARCHAR(7) DEFAULT '%', /* %, iznos, ostatak  */
  nacinIsplate VARCHAR(6) DEFAULT 'tekuci',   /* Isplata na tekući račun(tekuci) ili Isplata na žiro račun(ziro) */
  datumOtvaranja    DATETIME NOT NULL,
  datumIzmjene      DATETIME DEFAULT 0,
  tkoJeIzmjenio     VARCHAR(40) DEFAULT " ",
  PRIMARY KEY (kodRadnika,kodBanke,verzijaIsplate)
) DEFAULT CHARSET=utf8; 

INSERT INTO iisplate_na_banke_maticna_radnika
(
kodRadnika, kodBanke, verzijaIsplate, brojRacunaZaIsplatuPlace, postoIliIznosPlace, postoIliIznos, nacinIsplate, tkoJeIzmjenio, datumOtvaranja
)
SELECT kodRadnika, banka,'', brojBankRacuna, iznosBanka, postoIliIznosBanka, 'tekuči', 'prijepis', now()
FROM maticna_radnika
;
