CREATE TEMPORARY TABLE pomocna
AS
SELECT TABLE_NAME, COLUMN_NAME, IS_NULLABLE
FROM INFORMATION_SCHEMA.COLUMNS
WHERE  `TABLE_SCHEMA` = database()
 AND COLUMN_DEFAULT LIKE '%0000-00-00 00:00:00%'
ORDER BY TABLE_NAME
;

SELECT * FROM pomocna; 

drop procedure if exists date_default_null;
delimiter $$
CREATE PROCEDURE date_default_null()
BEGIN
declare s_tablica varchar(100) default '';
declare tablica varchar(100);
declare kolona varchar(50);
declare isnull char(3);
declare sve varchar(10000) default '';
DECLARE done INT DEFAULT FALSE;
DECLARE c CURSOR FOR
    SELECT TABLE_NAME, COLUMN_NAME, IS_NULLABLE
    FROM pomocna
    ORDER BY TABLE_NAME;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;
DECLARE EXIT HANDLER FOR SQLEXCEPTION ROLLBACK;
DECLARE EXIT HANDLER FOR SQLWARNING ROLLBACK;

SET @upit='';

START TRANSACTION;

open c;
read_loop: LOOP
    FETCH c INTO tablica, kolona, isnull;
    IF done THEN
        LEAVE read_loop;
    END IF;

    IF tablica<>s_tablica THEN
        IF @upit<>'' THEN
            SET @upit=concat(@upit, ' ;');
            set @st:=@upit;
            PREPARE stmt1 FROM @st;
            execute stmt1;
            SET sve:=concat(sve,' || ',  @upit);
        END IF;
        SET s_tablica=tablica;
        SET @upit=concat('ALTER TABLE ', tablica, ' ');
        SET @zarez=' ';
    ELSE
        SET @zarez=', ';
    END IF;

   IF isnull='YES' THEN
        SET @upit=CONCAT(@upit, @zarez, ' ALTER ' , kolona, ' SET DEFAULT NULL');
        SET @update=concat('UPDATE ', tablica, ' SET ', kolona, '=NULL ' ' where ', kolona, ' like ''%0000-00-00 00:00:00%'' ' );
        -- SELECT @update;
        set @st:=@update;
        PREPARE stmt1 FROM @st;
        execute stmt1;
        
    ELSE
        SET @upit=CONCAT(@upit, @zarez, ' CHANGE COLUMN ', kolona,' ', kolona, ' DATETIME NOT NULL ') ;
    END IF;

END LOOP;

IF @upit<>'' THEN
    SET @upit=concat(@upit, ' ;');
    set @st:=@upit;
    PREPARE stmt1 FROM @st;
    execute stmt1;
    SET sve:=concat(sve,' || ',  @upit);
END IF;

COMMIT;

select sve as 'izvrsene komande';
close c;
END $$
delimiter ;

call date_default_null();

drop procedure if exists date_default_null;

DROP TABLE pomocna; 
