set @negativnaStanjaNa0='Da', @datumInventure='2015-01-01 00:00:00';


delete from inv_stanja;

insert into inv_stanja
select * from inv_stanja_inventura
;

/*
Zbraja duple stavke i zbroj stavlja u stavku s cijenom 0
*/
update inv_stanja as i
join 
(
select proda, kodrobe, count(*) as ukStanje  /* select proda, kodrobe, count(*), SUM(kolicinaInventure) as ukStanje    14.01.2020  ??? */
from inv_stanja_inventura
group by proda, kodrobe, vrstaProdaje
having count(*)>1
) as p on p.proda=i.proda and p.kodrobe=i.kodrobe
set stanje=ukStanje,
    kolicinaInventure=ukStanje
where cijena=0
;

/*
Briše duple stavke kojima cijena nije 0
*/
delete i from inv_stanja as i
join 
(
select proda, kodrobe, count(*) as ukStanje   /*                                      */
from inv_stanja_inventura
group by proda, kodrobe, vrstaProdaje
having count(*)>1
) as p on p.proda=i.proda and p.kodrobe=i.kodrobe
where cijena<>0
;

/*
'oduzima' sve promete između datuma inventure i datuma unosa inventure (datumOtvaranja)
i tako svede stanja na datum inventure
*/
update inv_stanja as st
join
(
select i.proda, i.kodRobe, i.vrstaProdaje, i.stanje - sum(s.kolicina*vd.azurStanja) as novoStanje
from inv_stanja_inventura as i
join dok_stavke as s on s.proda=i.proda and s.kodrobe=i.kodrobe and s.vrstaprodaje=i.vrstaprodaje
join vrste_dokumenata as vd on vd.vrsDo=s.vrsDo
where i.datumOtvaranja>=s.DVO
group by i.proda, i.kodRobe, i.vrstaProdaje, i.stanje
)
as p on p.proda=st.proda and p.kodRobe=st.kodRobe and p.vrstaProdaje=st.vrstaProdaje 
set stanje=p.novoStanje,
    kolicinaInventure=p.novoStanje,
    datumizmjene=now(),
    tkoJeIzmjenio='Razlika po prometu'
;


/*
Upisuje stanja iz prometa iz 2014, kojih nema u inventuri.
*/
insert into inv_stanja
(
    proda, kodRobe, vrstaProdaje, cijena, stanje, kolicinaInventure, brojInvStavke, datumOtvaranja, tkoJeIzmjenio
)
select 
    s.proda, 
    s.kodRobe, 
    s.vrstaProdaje, 
    0 , -- s.cijena , 
    sum(s.stanje),
    sum(s.stanje),
    @b := @b + 1,
    now(),
    'Stanje iz 2014.' 
from murskiga_robno_akc_14.stanja as s
left outer join inv_stanja as i on i.proda=s.proda and i.kodRobe=s.kodRobe and i.vrstaProdaje=s.vrstaProdaje,
(select @b:=max(brojInvStavke) from inv_stanja) as b
where i.proda is null
 group by s.proda, s.kodrobe, s.`vrstaProdaje`
;

/*
updatira cijenu iz arhive od 15.01.2015.
*/
update inv_stanja as st
left outer join murskiga_robno_akc150115.maticna_robe as m on m.kodrobe=st.`kodRobe`
set st.cijena=m.cijena
-- where st.cijena=0
;

/*
Ako je @negativnaStanjaNa0='Da', postavlja negativna stanja na 0
*/
update inv_stanja
set stanje=0,
    kolicinaInventure=0,
    datumizmjene=now(),
    tkoJeIzmjenio='Negativno stanje na 0'
where stanje<0 and @negativnaStanjaNa0='Da'
;

/* postavlja datumInventure*/
update inv_stanja
set datumInventure=@datumInventure