/*
Skopirati inv_stanja u inv_stanja_pomo
Zbraja stanja višestrukih stavki na inventuri koje su unesene kao isti kod sa različitim cijenama i zbroj stavlja u stavku s cijenom 0
*/
update inv_stanja as i
join 
(
select proda, kodrobe, count(*), sum(stanje) as ukStanje
from inv_stanja_pomo
group by proda, kodrobe, vrstaProdaje
having count(*)>1
) as p on p.proda=i.proda and p.kodrobe=i.kodrobe
set stanje=ukStanje,
    kolicinaInventure=ukStanje
where cijena=0
;

/*
Briše duple stavke kojima cijena nije 0
*/
delete i from inv_stanja as i
join 
(
select proda, kodrobe, count(*)
from inv_stanja_pomo
group by proda, kodrobe, vrstaProdaje
having count(*)>1
) as p on p.proda=i.proda and p.kodrobe=i.kodrobe
where cijena<>0
;
