<?php 
/**
 * format za unos datuma pokriva na maskama :
 * 1.1.1000 - 31/12/9999 dd.mm.gggg
 * delimiter datuma je . 
 * dan, mjesec mogu biti s vodećim 0 ili bez njih
 * godina se unosi na 4  decimale
 * Vrijeme (nije obavezno):
 * 00:00:00 - 23:59:59  u formatu hh:MM:ss 
 */
$formatDatumaUnos='(([1-9]|[0-2]\d|[3][0-1]).([1-9]|[0]\d|[1][0-2]).[1-9][0-9]\d{2}(\s([1-9]|[0-1]\d|[2][0-3]):[0-5]\d(:[0-5]\d){0,1}){0,1})$';
$formatDatumaBaza='(([1-9][0-9]\d{2})\-([1-9]|[0]\d|[1][0-2])\-([1-9]|[0-2]\d|[3][0-1])(\s([1-9]|[0-1]\d|[2][0-3])\:[0-5]\d(\:[0-5]\d){0,1}){0,1})$';
$formatVrijeme='([0-1][1-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])$';
$patternDatum="[0-9]{1,2}.{0,1}[0-9]{1,2}.{0,1}[0-9]{4}";
$patternDatumVrijeme="[0-9]{1,2}.{0,1}[0-9]{1,2}.{0,1}[0-9]{4}( [0-9]{2}:[0-9]{2}:[0-9]{2}){0,1}( +){0,1}";

// numerički patterni
$pBroj3Decimale="^(\s*)?[-+]?[0-9]*[.,]?[0-9]{1,3}(\s*)?$";

//$pBroj2Decimale="[-+]?[0-9]*[.,]?[0-9]{1,2}";
/*
 * ^(\s*)?    - vodeći razmaci (? -ili bez njih)
 * [-+]?      - predznak (? - ili bez njega)
 * [0-9]*     - cijeli dio broja (* - više znamenki)
 * [.,]?      - decimalni  zarez ili točka (? -nije obavezno)
 * [0-9]{1,2} - jedna il dvije decimale iza zareza
 * (\s*)?$    - razmaci iza broja, niti jedan ili koliko god
 */
$pBroj2Decimale="^(\s*)?[-+]?[0-9]*[.,]?[0-9]{1,2}(\s*)?$";

$pCijena3Decimale="^(\s*)?[0-9]*[.,]?[0-9]{1,3}(\s*)?$";
$pCijena2Decimale="^(\s*)?[0-9]*[.,]?[0-9]{1,2}(\s*)?$";
$pCijena4Decimale="^(\s*)?[0-9]*[.,]?[0-9]{1,4}(\s*)?$";
?>
<?php
function is_present($value) {
    if (isset($value) && strlen($value) > 0) {
        return true;
    } else {
        return false;
    }
}

function is_valid_number($value, $min = NULL, $max = NULL, $required = true) {
    if ($required && !is_present($value)) return false;
    if (!is_numeric($value)) return false;
    if (isset($min) && $value < $min) {
        return false;
    }
    //if (isset($max) && $equal_max && $value > $max) {  OVO ?
    if (isset($max) && $value > $max) {
        return false;
    }
    return true;
}
function is_valid_datum(&$datum, $unutarArhive=false, $formatBezTocaka=true) {
    $datum=rtrim($datum);
    if($datum=='')
        return null;
    global $formatDatumaBaza;
    global $formatDatumaUnos;
    $greskaDatum = NULL;
    $brZnakova = strlen($datum);
        //prazan može biti onda uzima tekući datum i vrijeme
        //minimalni 1.1.2013
    //if ($brZnakova < 8 && $brZnakova > 0)
    if ($brZnakova < 6 && $brZnakova > 0) {
       $greskaDatum = ' Neispravan datum ! ' . $datum;
       return $greskaDatum;
    }  
    
    // ako datum nije u formatu bez točaka u sebi mora imati ',' -  datum iz unosa,ili '-' - datum iz baze 
    if(!$formatBezTocaka && strpos($datum, '.')===false && strpos($datum, '-')=== false) {
       $greskaDatum = ' Neispravan datum ! ' . $datum;
       return $greskaDatum;        
    }
    
    // u datum formata '190214' dodaje točka i pretvara ga u '19.02.2014
    if(($brZnakova==6 || $brZnakova==8 || $brZnakova==15 || $brZnakova==17) && $formatBezTocaka) {
        $stariDatum=$datum;
        if($brZnakova==6 || $brZnakova==15) 
            $datum=substr_replace($datum, '20', 4, 0);
            
        $datum=substr_replace($datum, '.', 4, 0);
        $datum=substr_replace($datum, '.', 2, 0);
    }
    
    //$p=date_parse($datum);
    $formatOk=true;
    if(trim($datum)!='')
        // preg_match na početku patterna mora imati '/^' kako bi uspewđivao cijeli datum a ne dijelove
        $formatOk= preg_match('/^'.$formatDatumaUnos.'/',$datum) || preg_match('/^'.$formatDatumaBaza.'/',$datum);
    if(!$formatOk)
        $greskaDatum = ' Neispravan datum ili vrijeme! ' . $datum;
    if (!isset($greskaDatum)) {	
        try {
            $datum_o = new DateTime("$datum"); 
        } catch (Exception $e) {
            $greskaDatum = ' Neispravan datum ili vrijeme ! ' . $datum;
        }

        // datumi poput '30.02.2015' i '31.04.2015' prolaze pa je potrebno pogledati u DateTime::getLastErrors() 
        // on u tom slučaju vrača warnings, odnosno $gr['warning_count']>0
        $gr=DateTime::getLastErrors();
        if( (isset($gr['warning_count']) && $gr['warning_count']>0) || (isset($gr['error_count']) && $gr['error_count'] >0) )
            $greskaDatum = ' Neispravan datum ili vrijeme ! ' . $datum;
        if(isset($datum_o))
            if(trim($_SESSION['godina_b'])!='' && trim($_SESSION['godina_b'])!=$datum_o->format('Y') && $unutarArhive) 
                $greskaDatum = ' Datum mora biti u godini arhive! ';
    }
        
    $buduciDatum=false;    
    if (!isset($greskaDatum)) {
       $now = new DateTime();
       if ($datum_o > $now) { 
           $greskaDatum .= ' Budući datum ! ' . $datum;
           $buduciDatum=true;
       }     
    }
    if($greskaDatum!=null && isset($stariDatum) && !$buduciDatum)
        $datum=$stariDatum;
    return $greskaDatum;
}
function is_valid_datum_(&$datum, $unutarArhive=false, $formatBezTocaka=true, $trebaBitiPopunjen=true, $buduciDatum = false) {
// OVA FUNKCIJA SE NE KORISTI 
    $datum=trim($datum); 
 //   if($datum=='')
 //      return null; 
    if ($datum == '' && $trebaBitiPopunjen === true) {
        $greskaDatum = 'Datum nije popunjen !';
        return $greskaDatum;
    }    
    global $formatDatumaBaza;
    global $formatDatumaUnos;
    $greskaDatum = NULL;
    $brZnakova = strlen($datum);
        //prazan može biti onda uzima tekući datum i vrijeme
        //minimalni 1.1.2013
    //if ($brZnakova < 8 && $brZnakova > 0)
    if ($brZnakova < 6 && $brZnakova > 0) {
       $greskaDatum = ' Neispravan datum ! ' . $datum;
       return $greskaDatum;
    }  
    // u datum formata '190214' dodaje točkr i pretvara ga u '19.02.2014
    if(($brZnakova==6 || $brZnakova==8 || $brZnakova==15 || $brZnakova==17) && $formatBezTocaka) {
        $stariDatum=$datum;
        if($brZnakova==6 || $brZnakova==15) 
            $datum=substr_replace($datum, '20', 4, 0);
            
        $datum=substr_replace($datum, '.', 4, 0);
        $datum=substr_replace($datum, '.', 2, 0);
    }
    //$p=date_parse($datum);
    $formatOk=true;
    if(trim($datum)!='')
        // preg_match na početku patterna mora imati '/^' kako bi uspewđivao cijeli datum a ne dijelove
        $formatOk= preg_match('/^'.$formatDatumaUnos.'/',$datum) || preg_match('/^'.$formatDatumaBaza.'/',$datum);
    if(!$formatOk)
        $greskaDatum = ' Neispravan datum ili vrijeme! ' . $datum;
    if (!isset($greskaDatum)) {	
        try {
            $datum_o = new DateTime("$datum"); 
        } catch (Exception $e) {
            $greskaDatum = ' Neispravan datum ili vrijeme ! ' . $datum;
        }

        // datumi poput '30.02.2015' i '31.04.2015' prolaze pa je potrebno pogledati u DateTime::getLastErrors() 
        // on u tom slučaju vrača warnings, odnosno $gr['warning_count']>0
        $gr=DateTime::getLastErrors();
        if($gr['warning_count']>0 || $gr['error_count']>0)
            $greskaDatum = ' Neispravan datum ili vrijeme ! ' . $datum;
        if(isset($datum_o)) {   
   //         echo 'sesio godina_b=' . $_SESSION['godina_b'] . 'datum_offormat Y=' . $datum_o->format('Y') . 'UNUTAR ARHIVE=' . $unutarArhive;       
            if( trim($_SESSION['godina_b'])!='' && trim($_SESSION['godina_b'])!=$datum_o->format('Y') && $unutarArhive ) {
            $greskaDatum = ' Datum mora biti u godini arhive! ';  
            }     
        }
    }
        
    $buduciDatum_=false;    
    if (!isset($greskaDatum)) {
       $now = new DateTime();
       if ($datum_o > $now && $buduciDatum === false) { 
           $greskaDatum .= ' Budući datum ! ' . $datum;
           $buduciDatum_=true;
       }     
    }
    if($greskaDatum!=null && isset($stariDatum) && !$buduciDatum_)
        $datum=$stariDatum;
    return $greskaDatum;
}

function is_valid_vrijeme($vrijeme) {
    $dio=explode(':', $vrijeme);
    if(count($dio)<2 || count($dio)>3)
        return 'Neispravan  format ! '.$vrijeme;
    try {
        $datum_o = new DateTime("$vrijeme"); 
    } catch (Exception $e) {
        return  ' Neispravno vrijeme ! ' . $vrijeme;
    }
    return NULL;
}

function is_valid_card_type($card_type) {
    if (!is_int($card_type)) return false;
    if ( $card_type < 1 || $card_type > 6 ) return false;
    return true;
}

function is_valid_card_number($card_number, $card_type) {
    switch ($card_type) {
        case 6:
            $pattern = '/^\d{15}$/';
            break;
        default:
            $pattern = '/^\d{16}$/';
            break;
    }
    return preg_match($pattern, $card_number);
}

function is_valid_card_cvv($card_cvv, $card_type) {
    switch ($card_type) {
        case 6:
            $pattern = '/^\d{4}$/';
            break;
        default:
            $pattern = '/^\d{3}$/';
            break;
    }
    return preg_match($pattern, $card_cvv);
}

function is_valid_card_expires($card_expires) {
    $pattern = '/^\d{1,2}\/\d{4}$/';
    if (!preg_match($pattern, $card_expires)) return false;
    $date_parts = explode('/', $card_expires);
    $now = new DateTime();
    $expires = new DateTime();
    $expires->setDate($date_parts[1], $date_parts[0], 1);
    $expires->add(new DateInterval("P1M"));
    $expires->sub(new DateInterval("P1D"));
    $expires->setTime(23,59,59);

    return ($now < $expires);
}

// f-ja pokušava "pogoditi' formate kolona arraya.
// pretpostavka: ako je u koloni max puta isti tip (npr. datum) ili prazno, onda je kolona toga tipa,
//               ako je kolona stalno prazna (empty()) tip je neodređen
//               u svim ostalim slučajevima polje je tipa 'string'
// tipovi polja: ''       - kolona je stalno prazna
//               'date'   - u koloni su max puta datumi ili prazno
//               'int'    - u koloni su max puta cijeli brojevi li prazno
//               'float'  - isto kao 'int' s tim da je bar jedan od brojeva float
//               'string' - sve ostalo
function postaviFormate($set, $naziviPolja, $max=20) {
    if(!is_array($set))
        return false;
    if(!is_array($set[0]))
        return false;

    $m=count($set);
    if($max>$m)
        $max=$m;
    $n=count($naziviPolja);
    $formati[]=array();
    
    for ($i = 0; $i < $max; $i++) {
        for ($j = 0; $j < $n; $j++) {
            if(empty($formati[$j])) $formati[$j]='';
            $polje=$set[$i][$naziviPolja[$j]];
            if(!empty($polje)) {
                if($formati[$j]==='' || $formati[$j]==='float' || $formati[$j]==='int') {
                    $polje=str_replace(',', '.', $polje);
                    if(preg_match("#^([\+\-]|)([0-9]*)(\.([0-9]*?)|)(0*)$#" , trim($polje))) {
                        $broj= (string)intval($polje);
                        if(trim($polje)==$broj && $formati[$j]!='float')
                            $formati[$j]='int';
                        else
                            $formati[$j]='float';
                    }
                    else {
                        if($formati[$j]!='') 
                            $formati[$j]='string';
                    }
                }

                if($formati[$j]==='' || $formati[$j]==='datum') {
                    $greskaDatum = is_valid_datum($polje,false,false);
                    if(empty($greskaDatum)) 
                        $formati[$j]='datum';
                    else
                        if($formati[$j]!='') 
                            $formati[$j]='string';
                }
                
            }
            // kraj nije prazno
        }
    }
    return $formati;
}

function usporedi_datume(&$datumOd,&$datumDo,$tekstOd, $tekstDo, $nacin, $buduciDatum, $dozvoljenaKorekcija=false,$datumUarhivi=true) {
    /*
     * Parametar $nacin 
     *    - 'obavezni', oba datuma moraju biti popunjena,
     *    - 'neobavezni', oba mogu biti prazna ili popunjen samo jedan ili oba popunjena
     *    - 'ovisni', oba mogu biti prazna, ako je jedam popunjen mora biti popunjen i drugi
     *   datumUarhivi ako se radi o arhivskoj godini datumOd mora biti u arhivskoj godini defaultno datumOd mora biti u arhivskoj godini
     */
    $greska='';
    if($nacin=='obavezni') {
        $pomGreska='';
        if(trim($datumOd)=='') {
             $greska.=" Unos polja '$tekstOd' je obavezan! ";
        }
        if(trim($datumDo)=='') {
             $greska.=" Unos polja '$tekstDo' je obavezan! ";
        }
        if($pomGreska!='')
            return $pomGreska;
    }
    else {
        if(trim($datumOd)=='' && trim($datumDo)=='') 
            return null;
        if($nacin=='ovisni') {
            if(trim($datumOd)=='' ) 
                 return " Unesite polje '$tekstOd'! ";
            
            if(trim($datumDo)=='' ) 
                 return " Unesite polje '$tekstDo'! ";  
        }
        
    }
        
    if(trim($datumOd)!='') {
            $greskaDatum = is_valid_datum($datumOd, $datumUarhivi);
            if (isset($greskaDatum)) {
                $buduciDatumP = stripos($greskaDatum, ' Budući datum ! ');
                if ($buduciDatumP=== 0 && $buduciDatum) 
                    $greskaDatum = ''; 
                else 
                    $greska .= $tekstOd.': '.$greskaDatum;  
            } 
    }        

    if(trim($datumDo)!='') {
        $greskaDatum = is_valid_datum($datumDo);
        if (isset($greskaDatum)) {
            $buduciDatumP = stripos($greskaDatum, ' Budući datum ! ');
            if ($buduciDatumP=== 0 && $buduciDatum) 
                $greskaDatum = ''; 
            else 
                $greska .= ' '.$tekstDo.': '.$greskaDatum;  
        } 
    }        
    if(trim($greska)!='')
        return $greska;

    if($dozvoljenaKorekcija) {
        $duljina=strlen(trim($datumOd));
        if($duljina==10) 
            $datumOd=trim($datumOd).' 00:00:00';
        $duljina=strlen(trim($datumDo));
        if($duljina==10) {
            $danas= new DateTime();
            $pom= new DateTime($datumDo);
            if($pom->format('d.m.y')==$danas->format('d.m.y'))
                // ako je današnji datum ne stavlja 23:59:59 jer je to budući datum 
                $datumDo=trim($datumDo).' '.$danas->format('H:i:s');
            else
                $datumDo=trim($datumDo).' 23:59:59';
        }
    }
    
    if($nacin=='neobavezni' && (trim($datumOd)=='' || trim($datumDo)=='')) {
        return null;
    }
    
    $dOd= new DateTime($datumOd);
    $dDo= new DateTime($datumDo);
    if($dOd>$dDo)
        return " Polje '$tekstOd' mora biti 'prije' polja '$tekstDo'! ";

    return null;
}

function is_modul_11($broj,$brojZnamenki){
    //da li su prosljeđeni brojevi i da li ima 11 znamenki
    if(is_numeric($broj) && strlen($broj)===$brojZnamenki){
        $a = 10;
        $i = 0;
        //ponavljaj korake za sve znamenke
        while ($i < 10){
            $a = $a + substr($broj, $i, 1); //pribroji znamenku
            $a = $a % 10; //podjeli cjelobrojno sa brojem 10
            $a = ($a == 0) ? 10 : $a; //ako je ostatak 0 zamjeni sa 10
            $a *= 2; //međuostatak pomnoži sa 2
            $a = $a % 11; //dobiveni umnožak podijeli sa 11
            $i++; //postavi na sljedeću znamenku
        }
        //kontrola
        $kontrola = 11 - $a;
        //ako je ostatak 10 kontrolna znamenka je 0
        $kontrola = ($kontrola == 10) ? 0 : $kontrola;
        //ako je $kontrola jednaka zadnjoj znamenki sve je ok
        return ($kontrola == substr($broj, 10, 1)) ? TRUE : FALSE;
    }else{
        return FALSE;
    }
}

function is_bez_navodnika($varijabla){
    return (strpos($varijabla,'"') === FALSE) && (strpos($varijabla,"'") === FALSE);
}
    
function brojDana($datumOd, $datumDo) {
    $interval=$datumDo->diff($datumOd);
    $brojdana=abs($interval->days);
    if($interval->h<>0 || $interval->i<>0 || $interval->s<>0)
        $brojdana++;
    return $brojdana;
}

/**
 * 
 * @param type $iban
 * @return boolean
 * napravljeno po specifikaciji iz: https://en.wikipedia.org/wiki/International_Bank_Account_Number#Validating_the_IBAN
 */
function is_valid_IBAN($iban)
{
    $iban = strtolower(str_replace(' ','',$iban));
    // duljina ibana po držvama
    $duljinaIBANa = array('al'=>28,'ad'=>24,'at'=>20,'az'=>28,'bh'=>22,'be'=>16,'ba'=>20,'br'=>29,'bg'=>22,'cr'=>21,'hr'=>21,'cy'=>28,'cz'=>24,
                    'dk'=>18,'do'=>28,'ee'=>20,'fo'=>18,'fi'=>18,'fr'=>27,'ge'=>22,'de'=>22,'gi'=>23,'gr'=>27,'gl'=>18,'gt'=>28,'hu'=>28,
                    'is'=>26,'ie'=>22,'il'=>23,'it'=>27,'jo'=>30,'kz'=>20,'kw'=>30,'lv'=>21,'lb'=>28,'li'=>21,'lt'=>20,'lu'=>20,'mk'=>19,
                    'mt'=>31,'mr'=>27,'mu'=>30,'mc'=>27,'md'=>24,'me'=>22,'nl'=>18,'no'=>15,'pk'=>24,'ps'=>29,'pl'=>28,'pt'=>25,'qa'=>29,
                    'ro'=>24,'sm'=>27,'sa'=>24,'rs'=>22,'sk'=>24,'si'=>19,'es'=>24,'se'=>24,'ch'=>21,'tn'=>24,'tr'=>26,'ae'=>23,'gb'=>22,'vg'=>24);
    $slova = array('a'=>10,'b'=>11,'c'=>12,'d'=>13,'e'=>14,'f'=>15,'g'=>16,'h'=>17,'i'=>18,'j'=>19,'k'=>20,'l'=>21,'m'=>22,
                   'n'=>23,'o'=>24,'p'=>25,'q'=>26,'r'=>27,'s'=>28,'t'=>29,'u'=>30,'v'=>31,'w'=>32,'x'=>33,'y'=>34,'z'=>35);

    $kodDrzave = substr($iban,0,2);
    if(!isset($duljinaIBANa[$kodDrzave]))
        return false;
    
    if(strlen($iban) == $duljinaIBANa[$kodDrzave]){
        //prva 4 znaka 'HRcc' stavlja na kraj
        $okrenuto = substr($iban, 4).substr($iban,0,4);
        $ibanUNizu = str_split($okrenuto);
        $zaProvjeru = "";

        foreach($ibanUNizu as $znak){
            if(!is_numeric($znak)){
                $znak = $slova[$znak];
            }
            $zaProvjeru .= $znak;
        }

        // broj je u stringu, da ne bi bio 'prevelik' i desio bi se owerfov, zato za izračun modula koristimo string funkciju bcmod.
        // da bi bcmod radio treba uključiti u php verziji na serveru modul bcmath
        if(bcmod($zaProvjeru, '97') == '1')
        {
            return true;
        }
    }
    return false;
}
?>