<?php
include_once  'dokumenti/unosiIKontrole.php';
function zadnji_broj($proda, $vrsDo, $zapis, $verzi='') {
//    echo 'verzi u zadnji broj=' . $verzi;
    // zadnji zauzeti broj
    /* 13.3.2020 
     * EV evidentne dostavnice imaju svoj redosljed brojeva od 1(Auto Akcija) npr. 391,392,861EV,862EV sljedeći je 863 + EV ako je broj dokumenta prazno a verzi EV (zadnji je 862 +EV)
     * UV uvozne primke imaju svoj broj redosljeda(Chaky)
     * PR privremene primke isto
     *      ************************************************
     * NZV privremeni nezavršeni dokumenti koji se fiskaliziraju uzimaju obično prvi sljedeći slobodni broj za verzi= ''
     * ili ako ima jedan ili više NZV uzima se kao verzija ='Sve' pr. postoji 345,346NZV onda uzima sljedeći 347NZV
     * $verzi == 'Sve' traži max broj neovisno o verziji (po svim verzijama)
     * ako je verzi npr. PO a broj dokumenta prazno, i imamo 456,457,458PO onda je sljedeći 459PO (zadnji je 458 + PO)
     * ako je nakon ovoga broj dokumenta i verzija prazno onda je sljedeći 459 (zadnji je 458)
    */    
    global $db;  
    if( trim($verzi)=='EV' || trim($verzi)=='UV' || trim($verzi)=='PR' ) {
        // 1. slučaj verzije koje imaju svoje vlastite redne brojeve dokumenta koji kreću od 1 na početku godine
      $dioVerzi=" AND trim(verzi) = :verzi";
    } else {
      $dioVerzi=" AND trim(verzi) NOT IN ('EV', 'UV', 'PR')"; 
      // 2. slučaj ako je verzi == 'Sve' ili ostale verzije koje nisu gore navedene, traži max broj neovisno o verziji (Sve verzije)
    }  
    
    if ( $_SESSION['dok_zag']['verzi'] == 'NZV' && trim($verzi) == '' ) $dioVerzi=" AND trim(verzi) NOT IN ('EV', 'UV', 'PR', 'NZV')"; 
      // 3. slučaj kada se verzija NZV pretvara u '', a traži se zadnji slobodni broj NOT IN ('EV', 'UV', 'PR', 'NZV')"  
      // pokrivaju se i fiskalizirane dostavnice, tipa 123PO, 124NZV, 125NZV što se kod npr. fiskalizacije 125NZV pretvara u čisti broj 124
    /* kod B2B prvo se radi narudžba N, iz nje se kreira narudžba NS sa istim broj kao N ali verzija B2B
     * zato se kod narudžbe N bira max broj od N i NS jer bi se inače moglo desiti da se nova narudžba N kod pretvorbe u NS sa istim brojem bio bi dupli broj
     * primjer kreirana narudžba N 513 koja se pretvara u narudžbu NS  sa brojem 513/B2B a N sa brojem 513 se briše
     * sada kada se ponovo radi nova narudžba N uzima ponovno broj 513 i kod pretvorbe u NS pokušava pretvoriti u 513/B2B što već postoji
     */
    $whereDio1 = " WHERE  proda = :proda AND vrsDo = :vrsDo AND zapis = :zapis ";   // defaultni
    if (trim($vrsDo) == 'N') $whereDio1 = " WHERE  proda = :proda AND (vrsDo = 'N' or vrsDo = 'NS') AND zapis = :zapis "; 
    $where = $whereDio1 . $dioVerzi; 
    $query = "
        SELECT IFNULL(MAX(broDo),0) AS zadnji_broj
        FROM dok_zag  
        $where
        ";  
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    if ( trim($vrsDo) != 'N' ) $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':zapis', $zapis);
    
    if( trim($verzi)=='EV' || trim($verzi)=='UV' || trim($verzi)=='PR' )
        $statement->bindValue(':verzi', trim($verzi) );
    
    $statement->execute();
    $zadnji_broj = $statement->fetch();
  //  echo 'zadnji_broj=' . $zadnji_broj['0']; exit;
    $statement->closeCursor();
    return $zadnji_broj;
 }

function zadnji_broj_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    global $db;
    $query = "
        SELECT IFNULL(MAX(brojStavke),0) AS zadnjiBroj
        FROM dok_stavke 
        WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
        ";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->execute();
    $zadnji_broj = $statement->fetch();
    $statement->closeCursor();
    return $zadnji_broj['zadnjiBroj'];
}

// Parametar $dok_zag se prenosi s '&' - po adresi, kako bi sve promjene bile zapamčene u $_SESSION['dok_zag']
function add_dok_zag(&$dok_zag)  {
    global $db;
    if(isset($_SESSION['odabranaPoslovnica']))
        $proda = $_SESSION['odabranaPoslovnica'];
    else
        $proda = $dok_zag['proda'];

  /* 
     if($_SESSION['admin']['prioritet']==9) { 
 echo  ' I N V E N T U R A <br>
Postovani, <br>
obavjestavamo Vas da u periodu od 10.12.2022 do 13.12.2022 necete moci narucivati robu putem B2B zbog godisnje inventure.
<p> Hvala na razumijevanju.</p>';
        exit;
     } 
  */    
     if($dok_zag['casasSconto']=='')
         $dok_zag['casasSconto']=0;
     if($dok_zag['daniZaCasasSconto']=='')
         $dok_zag['daniZaCasasSconto']=0;
    $vrsDo = $dok_zag['vrsDo'];
    $proIn = $dok_zag['proIn'];
    $zapis = $dok_zag['zapis']; 
    $broDo = $dok_zag['broDo'];
    $verzi = $dok_zag['verzi']; 
    $kodPartnera = $dok_zag['kodPartnera'];
    if ($broDo === 0) {
        echo 'Broj dokumenta === 0 !! add_dok_zag IZBACUJE PROGRAM!!!';
        exit;
    } 
    if($_SESSION['admin']['prioritet']==9 && trim($vrsDo)=='N') 
        $b2bPoslovnica=$dok_zag['b2bPoslovnica']=get_b2bPoslovnica();
    else if(isset($dok_zag['b2bPoslovnica']))
        $b2bPoslovnica=$dok_zag['b2bPoslovnica'];
    else
        $b2bPoslovnica=null;
    
    if (trim($vrsDo) == '8' || trim($vrsDo) == 'PB') 
        $dok_zag['DVO'] = '';
 //da kod prikaza paragonca ne ostane stari DVO ili datum računa
 //i predračuna i računa-dostavnica ne ostane stari DVO ili datum računa
 //DVO = datum knjiženja a ne onaj koji piše eventualno trgovac isto i datum računa      
    if (isset($dok_zag['fiskalizacijaDaNe'])) {
       if ($dok_zag['fiskalizacijaDaNe'] == 'Da') {
           $dok_zag['DVO'] = '';
           $dok_zag['datumRacuna'] = '';
       }
    }
         
    if (!empty($dok_zag['DVO'])) {
        $datum_o = new DateTime($dok_zag['DVO']);
        $DVO = $datum_o->format("Y-m-d H:i:s");    
    } else {	
        $datum_o = new DateTime;
        $DVO = $datum_o->format("Y-m-d H:i:s");
    }
        
    $dok_zag['DVOY-m-d H:i:s'] = $DVO;
        
    $vrsDoN_NS_P_O=array('N','NS','P','O');  if ( in_array_trim(trim($vrsDo),$vrsDoN_NS_P_O) ) $dok_zag['datumRacuna'] = $dok_zag['DVO'];
        
    $daniOdgodePl = $dok_zag['daniOdgodePl'];
    if (!empty($dok_zag['valuta'])) {
        $datum_o = new DateTime($dok_zag['valuta']);
        $valuta = $datum_o->format("Y-m-d H:i:s");
    } else {         
        $datum_o = new DateTime($dok_zag['DVO']);
        if (!empty($daniOdgodePl)) {
            $interval = new DateInterval('P'.$daniOdgodePl.'D'); 
        } else {
            $interval = new DateInterval('P15D');
        }
        $datum_o->add($interval);   
        $valuta = $datum_o->format("Y-m-d H:i:s");
        if (trim($daniOdgodePl) === '0') 
            $valuta = $DVO;
    }
	
    $nacinPlacanja = $dok_zag['nacinPlacanja'];
    //$datumRacuna = $dok_zag['datumRacuna'];
    if (!empty($dok_zag['datumRacuna'])) {
        $datum_o = new DateTime($dok_zag['datumRacuna']);
        $datumRacuna = $datum_o->format("Y-m-d H:i:s");    
    } else {
        $datum_o = new DateTime;
        $datumRacuna = $datum_o->format("Y-m-d H:i:s");  
        //$datumRacuna = NULL;
    }

    //$datumNarudzbe = $dok_zag['datumNarudzbe'];
    if (!empty($dok_zag['datumNarudzbe'])) {
        $datum_o = new DateTime($dok_zag['datumNarudzbe']);
        $datumNarudzbe = $datum_o->format("Y-m-d H:i:s");    
    } else {	
        $datumNarudzbe = NULL;
    }

    $brojNarudzbe = $dok_zag['brojNarudzbe'];       
    $PDVstatus = $dok_zag['PDVstatus'];
    $casasSconto = $dok_zag['casasSconto'];
    $absCasasSconto = $dok_zag['absCasasSconto'];
    $daniZaCasasSconto = $dok_zag['daniZaCasasSconto'];
    $refProd = $_SESSION['admin']['OIB'];
    $komercijalista = $dok_zag['komercijalista'];
    $komentar = $dok_zag['komentar'];
    $kasa = $dok_zag['kasa'];
    if (!isset($dok_zag['novac'])) $dok_zag['novac'] = NULL;
    $novac = $dok_zag['novac'];
    if (trim($novac == '')) $novac = 0;
    if (!isset($dok_zag['povrat'])) $dok_zag['povrat'] = NULL;
    $povrat = $dok_zag['povrat'];
    if (trim($povrat == '')) $povrat = 0;
    if (!isset($dok_zag['iznosKartice'])) $dok_zag['iznosKartice'] = NULL;
    $iznosKartice = $dok_zag['iznosKartice'];

    if (!isset($dok_zag['iznosTransRacun'])) $dok_zag['iznosTransRacun'] = NULL;
    $iznosTransRacun = $dok_zag['iznosTransRacun'];

    if (!isset($dok_zag['vrstaKartice'])) $dok_zag['vrstaKartice'] = NULL;
    $vrstaKartice = $dok_zag['vrstaKartice'];
    $kodPoslovniceMp = $dok_zag['kodPoslovniceMp'];
    if($vrsDo=='5 ' || $vrsDo=='5U') {
        if(!($PDVstatus=='C' || $PDVstatus=='D'|| $PDVstatus=='I')) {
            $dok_zag['stranaValuta']='';
            $dok_zag['iznosUstranojValuti']=0;
        }
    }
    $stranaValuta = $dok_zag['stranaValuta'];
    $iznosUstranojValuti = $dok_zag['iznosUstranojValuti'];
    $zasticeniDokument = $dok_zag['zasticeniDokument'];
    $privremeniDokument = $dok_zag['privremeniDokument'];
    if (!empty($dok_zag['datumZakljucavanja'])) {
        $datum_o = new DateTime($dok_zag['datumZakljucavanja']);
        $datumZakljucavanja = $datum_o->format("Y-m-d H:i:s");    
    } else {	
        $datumZakljucavanja = NULL;
    }
    
    if(!isset($dok_zag['prodaVezni'])) $dok_zag['prodaVezni']=NULL;
    if(!isset($dok_zag['vrsDoVezni'])) $dok_zag['vrsDoVezni']=NULL;
    if(!isset($dok_zag['proInVezni'])) $dok_zag['proInVezni']=NULL;
    if(!isset($dok_zag['zapisVezni'])) $dok_zag['zapisVezni']=NULL;
    if(!isset($dok_zag['broDoVezni'])) $dok_zag['broDoVezni']=0;
    if(!isset($dok_zag['verziVezni'])) $dok_zag['verziVezni']=NULL;
    if(!isset($dok_zag['predujam'])) $dok_zag['predujam']='Ne';
    if(!isset($dok_zag['brojRata'])) $dok_zag['brojRata']=0;

    $zavrsen = NULL;      // vrijedi za ako nije knjizenjeStavkeOdmah ili se radi o internima  
    
 /* 
     if ($_SESSION['knjizenjeStavkeOdmah']=='Da' && !($dok_zag['fiskalizacijaDaNe']=='Da' || trim($vrsDo)=='8' || trim($vrsDo)=='PB')) {
        if(!isset($dok_zag['zavrsen']))     
            $zavrsen = 'Ne';
        else
            $zavrsen = $dok_zag['zavrsen'];
    }  
 */

            if(!isset($dok_zag['zavrsen']))  {   
               $zavrsen = 'Ne';
            } else {
               $zavrsen = $dok_zag['zavrsen'];        
            }
    
// echo ' dolazim u add_dok_zag  ' . ' zavrsen = ' . $zavrsen . ' verzi=' . $verzi;
       
    $email_user = $_SESSION['admin']['email'];
    if(!isset($dok_zag['tkoJeKreirao']))
       $dok_zag['tkoJeKreirao']=$email_user;
    else if($dok_zag['tkoJeKreirao']=='')
       $dok_zag['tkoJeKreirao']=$email_user;
    $kolikoPuta = 1;
    if ($vrsDo == '6 ' ) 
        $kolikoPuta = 2;  //za interne fakture knjiži se dva puta vrsDo 6 i vrsDo 2
  
  for ($i = 1; $i <= $kolikoPuta; $i++)   {    
      if ($i == 2)  {
      //drugi prolaz knjiži se ulazna interna vrsDo 2
      //proIn se puni sa prodavaonom koja je izdala robu  -> proda
      //proda  se puni sa prodavaonom koja prima robu  -> kodPartnera
      //vrsDo = '2 '  
      //kodPartnera je prodavaona koja je izdala robu
      //  a sve ostalo je isto
         $proIn = $proda;
         $proda = $kodPartnera;
         $vrsDo = '2 ';
         $kodPartnera = str_pad($proIn,13); 
         $zavrsen = 'Da';
    }  
    kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi);

    if (trim($vrsDo)!='8' && trim($vrsDo)!='7' && trim($kodPartnera)=='') {
        $error_message = 'GREŠKA PREKID! Kod partnera nije popunjen! Na zaglavlju dokumenta nije odabran poslovni partner !' 
            . '</br>  Dokument: poslovnica;' 
            . $proda . ', vrsDo:' . $vrsDo . ', proIn:' . $proIn . ', zapisnik:' . $zapis . ', nroj:' . $broDo .', verzija:'. $verzi;;               
        error_log($error_message);
        $call_stack=  var_export(debug_backtrace(), TRUE);
        error_log($call_stack);
        display_error($error_message);
    }     

    $query = 
    'INSERT INTO dok_zag (proda,vrsDo,proIn,zapis,broDo,verzi,kodPartnera,DVO,valuta,
        daniOdgodePl,nacinPlacanja,datumRacuna,datumNarudzbe,brojNarudzbe,PDVstatus,casasSconto, 
        absCasasSconto,daniZaCasasSconto,refProd,komercijalista,komentar,kasa,novac,povrat,
        iznosKartice,iznosTransRacun,vrstaKartice,kodPoslovniceMp,stranaValuta,iznosUstranojValuti,zasticeniDokument,privremeniDokument,
        prodaVezni,vrsDovezni,proInVezni,zapisVezni,broDoVezni,verziVezni,datumZakljucavanja,zavrsen,predujam,b2bPoslovnica, brojRata,
        ispisCasasSconto, datumOtvaranja,tkoJeIzmjenio,tkoJeKreirao)
    VALUES (:proda,:vrsDo,:proIn,:zapis,:broDo,:verzi,:kodPartnera,:DVO,:valuta,
        :daniOdgodePl,:nacinPlacanja,:datumRacuna,:datumNarudzbe,:brojNarudzbe,:PDVstatus,:casasSconto, 
        :absCasasSconto,:daniZaCasasSconto,:refProd,:komercijalista,:komentar,:kasa,:novac,:povrat,
        :iznosKartice,:iznosTransRacun,:vrstaKartice,:kodPoslovniceMp,:stranaValuta,:iznosUstranojValuti,:zasticeniDokument,:privremeniDokument,
        :prodaVezni,:vrsDoVezni,:proInVezni,:zapisVezni,:broDoVezni,:verziVezni,:datumZakljucavanja,:zavrsen,:predujam,:b2bPoslovnica, :brojRata,
        :ispisCasasSconto, NOW(),:email_user,:tkoJeKreirao)';

    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->bindValue(':proIn', $proIn);
	$statement->bindValue(':zapis', $zapis);
	$statement->bindValue(':broDo', $broDo);
	$statement->bindValue(':verzi', $verzi);
	$statement->bindValue(':kodPartnera', trim($kodPartnera));
	$statement->bindValue(':DVO', $DVO);
	$statement->bindValue(':valuta', $valuta);
        if($daniOdgodePl=='')
            $statement->bindValue(':daniOdgodePl', null, PDO::PARAM_NULL);
        else
            $statement->bindValue(':daniOdgodePl', $daniOdgodePl);
	$statement->bindValue(':nacinPlacanja', $nacinPlacanja);
	$statement->bindValue(':datumRacuna', $datumRacuna);
	$statement->bindValue(':datumNarudzbe', $datumNarudzbe);
	$statement->bindValue(':brojNarudzbe', $brojNarudzbe);
	$statement->bindValue(':PDVstatus', $PDVstatus);
	$statement->bindValue(':casasSconto', $casasSconto);
	$statement->bindValue(':absCasasSconto', $absCasasSconto);
	$statement->bindValue(':daniZaCasasSconto', $daniZaCasasSconto);
	$statement->bindValue(':refProd', $refProd);
	$statement->bindValue(':komercijalista', $komercijalista);
	$statement->bindValue(':komentar', $komentar);
	$statement->bindValue(':kasa', $kasa);
        $statement->bindValue(':novac', $novac);
        $statement->bindValue(':povrat', $povrat);
        $statement->bindValue(':iznosKartice', $iznosKartice);
        $statement->bindValue(':iznosTransRacun', $iznosTransRacun);
        $statement->bindValue(':vrstaKartice', $vrstaKartice);
        $statement->bindValue(':kodPoslovniceMp', $kodPoslovniceMp);
        $statement->bindValue(':stranaValuta', $stranaValuta);
        $statement->bindValue(':iznosUstranojValuti', $iznosUstranojValuti);
        $statement->bindValue(':zasticeniDokument', $zasticeniDokument);
        $statement->bindValue(':privremeniDokument', $privremeniDokument);
        $statement->bindValue(':datumZakljucavanja', $datumZakljucavanja);    
        $statement->bindValue(':zavrsen', $zavrsen);
	$statement->bindValue(':prodaVezni', $dok_zag['prodaVezni']);
	$statement->bindValue(':vrsDoVezni', $dok_zag['vrsDoVezni']);
	$statement->bindValue(':proInVezni', $dok_zag['proInVezni']);
	$statement->bindValue(':zapisVezni', $dok_zag['zapisVezni']);
	$statement->bindValue(':broDoVezni', $dok_zag['broDoVezni']);
	$statement->bindValue(':verziVezni', $dok_zag['verziVezni']);
	$statement->bindValue(':predujam', $dok_zag['predujam']);
	$statement->bindValue(':brojRata', $dok_zag['brojRata']);
        $statement->bindValue(':ispisCasasSconto', $_SESSION['dok_zag']['ispisCasasSconto']);
        $statement->bindValue(':email_user', $email_user);      
	$statement->bindValue(':tkoJeKreirao', $dok_zag['tkoJeKreirao']);
        if($b2bPoslovnica===null)
            $statement->bindValue(':b2bPoslovnica', null, PDO::PARAM_NULL);
        else   
            $statement->bindValue(':b2bPoslovnica', $b2bPoslovnica);
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Dokument pod tim brojem već postoji!. <br>'.$e->getMessage();
        display_db_error($error_message);
    }
  //  return $rowCount;
  }  // za for
  return $rowCount;
}

function update_dok_zag()  {
    global $db;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi']; 
    $kodPartnera = $_SESSION['dok_zag']['kodPartnera'];
    
    if ($broDo === 0) {
        echo 'Broj dokumenta === 0 !! add_dok_zag IZBACUJE PROGRAM!!!';
        exit;
    }        
    if ($vrsDo == '8 ' || $vrsDo == 'PB') 
        $_SESSION['dok_zag']['DVO'] = '';
 //da kod prikaza paragonca ne ostane stari DVO ili datum računa
 //i predračuna i računa-dostavnica ne ostane stari DVO ili datum računa
 //DVO = datum knjiženja a ne onaj koji piše eventualno kupac isto i datum računa      
    if (isset($_SESSION['dok_zag']['fiskalizacijaDaNe'])) {
       if ($_SESSION['dok_zag']['fiskalizacijaDaNe'] == 'Da') {
           $_SESSION['dok_zag']['DVO'] = '';
           $_SESSION['dok_zag']['datumRacuna'] = '';
       }
    }
         
    if (!empty($_SESSION['dok_zag']['DVO'])) {
        $datum_o = new DateTime($_SESSION['dok_zag']['DVO']);
        $DVO = $datum_o->format("Y-m-d H:i:s");    
    } else {	
        $datum_o = new DateTime;
        $DVO = $datum_o->format("Y-m-d H:i:s");
    }
        
    $_SESSION['dok_zag']['DVOY-m-d H:i:s'] = $DVO;
    
    $vrsDoN_NS_P_O=array('N','NS','P','O');  if ( in_array_trim(trim($vrsDo),$vrsDoN_NS_P_O) ) $_SESSION['dok_zag']['datumRacuna'] = $_SESSION['dok_zag']['DVO'];
        
    $daniOdgodePl = $_SESSION['dok_zag']['daniOdgodePl'];
    if (!empty($_SESSION['dok_zag']['valuta'])) {
        $datum_o = new DateTime($_SESSION['dok_zag']['valuta']);
        $valuta = $datum_o->format("Y-m-d H:i:s");
    } else {         
        $datum_o = new DateTime($_SESSION['dok_zag']['DVO']);
        if (!empty($daniOdgodePl)) {
            $interval = new DateInterval('P'.$daniOdgodePl.'D'); 
        } else {
            $interval = new DateInterval('P15D');
        }
        $datum_o->add($interval);   
        $valuta = $datum_o->format("Y-m-d H:i:s");
        if (trim($daniOdgodePl) === '0') 
            $valuta = $DVO;
    }
	
    $nacinPlacanja = $_SESSION['dok_zag']['nacinPlacanja'];
    //$datumRacuna = $_SESSION['dok_zag']['datumRacuna'];
    if (!empty($_SESSION['dok_zag']['datumRacuna'])) {
        $datum_o = new DateTime($_SESSION['dok_zag']['datumRacuna']);
        $datumRacuna = $datum_o->format("Y-m-d H:i:s");    
    } else {
        $datum_o = new DateTime;
        $datumRacuna = $datum_o->format("Y-m-d H:i:s");  
        //$datumRacuna = NULL;
    }

    //$datumNarudzbe = $_SESSION['dok_zag']['datumNarudzbe'];
    if (!empty($_SESSION['dok_zag']['datumNarudzbe'])) {
        $datum_o = new DateTime($_SESSION['dok_zag']['datumNarudzbe']);
        $datumNarudzbe = $datum_o->format("Y-m-d H:i:s");    
    } else {	
        $datumNarudzbe = NULL;
    }

    $brojNarudzbe = $_SESSION['dok_zag']['brojNarudzbe'];       
    $PDVstatus = $_SESSION['dok_zag']['PDVstatus'];
    $casasSconto = $_SESSION['dok_zag']['casasSconto'];
    $absCasasSconto = $_SESSION['dok_zag']['absCasasSconto'];
    $daniZaCasasSconto = $_SESSION['dok_zag']['daniZaCasasSconto'];
    $refProd = $_SESSION['admin']['OIB'];
    $komercijalista = $_SESSION['dok_zag']['komercijalista'];
    $komentar = $_SESSION['dok_zag']['komentar'];
    $kasa = $_SESSION['dok_zag']['kasa'];
    $novac = $_SESSION['dok_zag']['novac'];
    $povrat = $_SESSION['dok_zag']['povrat'];
    $iznosKartice = $_SESSION['dok_zag']['iznosKartice'];
    $iznosTransRacun = $_SESSION['dok_zag']['iznosTransRacun'];
    $vrstaKartice = $_SESSION['dok_zag']['vrstaKartice'];
    $kodPoslovniceMp = $_SESSION['dok_zag']['kodPoslovniceMp'];
    if(trim($vrsDo)=='5' || $vrsDo=='5U') {
        if(!($PDVstatus=='C' || $PDVstatus=='D')) {
            $dok_zag['stranaValuta']='';
            $dok_zag['iznosUstranojValuti']=0;
        }
    }
    $stranaValuta = $_SESSION['dok_zag']['stranaValuta'];
    $iznosUstranojValuti = $_SESSION['dok_zag']['iznosUstranojValuti'];
    $zasticeniDokument = $_SESSION['dok_zag']['zasticeniDokument'];
    $privremeniDokument = $_SESSION['dok_zag']['privremeniDokument'];
    if (!empty($_SESSION['dok_zag']['datumZakljucavanja'])) {
        $datum_o = new DateTime($_SESSION['dok_zag']['datumZakljucavanja']);
        $datumZakljucavanja = $datum_o->format("Y-m-d H:i:s");    
    } else {	
        $datumZakljucavanja = NULL;
    }
    $email_user = $_SESSION['admin']['email'];
    
 // --------------------------------------------------------------------------------   
     if (trim($vrsDo) == '6') { // provjera da li se promjenio kodPartnera(prodavaona za ulaznu internu)
       $stariDokument = get_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
       if (is_array($stariDokument)) { 
           $stariKodPartnera = $stariDokument['kodPartnera'];
           if ($stariKodPartnera != $kodPartnera) {    //kodPartnera = prodavaona ulaza, mjenja se prodavaone ulaza ->iz dok_stavke je potrebno razdužiti robu sa stare prodavaone i zadužiti po novoj u stanja
              $stavkeInterne = get_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
              foreach ($stavkeInterne as $si) { 
                  /* kontraazuriranje stanja za staru ulaznu IF
                  azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$kodRobe,$vrstaProdaje,$cijena,$kolicina,$rabatPopust,$absRabatPopust,
    $nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu); */
                  azuriranje_stanja($stariKodPartnera,'2',$proIn,$zapis,$broDo,$verzi,$stariDokument['DVO'],$proda,$si['kodRobe'],$si['vrstaProdaje'],$si['cijena'],$si['kolicina']*(-1),$si['rabatPopust'],$si['absRabatPopust'],
    $si['cijena'],0,'',0,'');
                  
                  /* azuriranje stanja za novu ulaznu IF */
                  azuriranje_stanja($kodPartnera,'2',$proIn,$zapis,$broDo,$verzi,$DVO,$proda,$si['kodRobe'],$si['vrstaProdaje'],$si['cijena'],$si['kolicina'],$si['rabatPopust'],$si['absRabatPopust'],
    $si['cijena'],0,'',0,'');
              }        
           } 
       } else {
         echo 'Ne postoji stari dokument Interna faktura izlazna, koja se želi mjenjati !! update_dok_zag !'  . 'proda=' . $proda . ' vrsdo=' . $vrsDo
          . ' proIn=' . $proIn . ' zapis=' . $zapis . ' broDo=' . $broDo . ' verzi=' . $verzi;
         exit;
       }     
    }
// -----------------------------------------------------------------------------------    
    
    $kolikoPuta = 1;
    if ($vrsDo == '6 ' ) 
        $kolikoPuta = 2;  //za interne fakture knjiži se dva puta vrsDo 6 izlazna interna i vrsDo 2 ulazna interna
    $prodaStara=$proda;   
  for ($i = 1; $i <= $kolikoPuta; $i++)   {    
      if ($i == 2)  {
      //drugi prolaz knjiži se ulazna interna vrsDo 2
      //proIn se puni sa prodavaonom koja je izdala robu  -> proda
      //proda  se puni sa prodavaonom koja prima robu  -> kodPartnera
      //vrsDo = '2'  
      //kodPartnera je prodavaona koja je izdala robu
      //  a sve ostalo je isto
  /* kod promjene kodPartnera(prodavaona ulaza) na izlaznoj IF vrsDo = 6, updata se prodavaonna ulaza, te se u tom slučaju mora napraviti
   * update stanja sa minus(promjeniti predznak količinama) na staroj ulaznoj IF(proda=stariKodPartnera), i update stanja na proda=kodPartnera nova prodavaona)
   * u dok_stavke 
   */        
         $proIn = $proda;
         $proda = $kodPartnera;   
         $prodaStara=$stariKodPartnera; // ako se mjenja prodavaona ulaza na Izlaznoj internoj fakturi da staru prodavaonu updata na novu ovo treba
         $vrsDo = '2';
         $kodPartnera = str_pad($proIn,13); 
    }    

    if ( ( trim($vrsDo) !='8' && trim($vrsDo) !='7')  && trim($kodPartnera)=='') {
        $error_message = 'GREŠKA PREKID! Kod partnera nije popunjen!' 
            . '</br>  Dokument: poslovnica;' 
            . $proda . ', vrsDo:' . $vrsDo . ', proIn:' . $proIn . ', zapisnik:' . $zapis . ', broj:' . $broDo .', verzija:'. $verzi;;               
        error_log($error_message);
        $call_stack=  var_export(debug_backtrace(), TRUE);
        error_log($call_stack);
        display_error($error_message);
    }     

    $query = 
    "UPDATE dok_zag 
    SET 
          proda=:proda,
        kodPartnera=:kodPartnera,
        DVO=:DVO,
        valuta=:valuta,
        daniOdgodePl=:daniOdgodePl,
        nacinPlacanja=:nacinPlacanja,
        datumRacuna=:datumRacuna,
        datumNarudzbe=:datumNarudzbe,
        brojNarudzbe=:brojNarudzbe,
        PDVstatus=:PDVstatus,
        casasSconto=:casasSconto, 
        absCasasSconto=:absCasasSconto,
        daniZaCasasSconto=:daniZaCasasSconto,
         refProd=:refProd,
        komercijalista=:komercijalista,
        komentar=:komentar,
        kasa=:kasa,
        novac=:novac,
        povrat=:povrat,
        iznosKartice=:iznosKartice,
        iznosTransRacun=:iznosTransRacun,
        vrstaKartice=:vrstaKartice,
        kodPoslovniceMp=:kodPoslovniceMp,
        stranaValuta=:stranaValuta,
        iznosUstranojValuti=:iznosUstranojValuti,
        zasticeniDokument=:zasticeniDokument,
        privremeniDokument=:privremeniDokument,
        datumZakljucavanja=:datumZakljucavanja,
        predujam=:predujam,
        brojRata=:brojRata,
        ispisCasasSconto=:ispisCasasSconto,
        datumIzmjene=NOW(),
        tkoJeIzmjenio=:email_user
/*    WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn   */
        WHERE proda = :prodaStara AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
        ";   
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':prodaStara', $prodaStara);
	$statement->bindValue(':proda', $proda);
	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->bindValue(':proIn', $proIn);
	$statement->bindValue(':zapis', $zapis);
	$statement->bindValue(':broDo', $broDo);
	$statement->bindValue(':verzi', $verzi);
        //kodPartnera=:kodPartnera,       
	$statement->bindValue(':kodPartnera', trim($kodPartnera));
        //DVO=:DVO,
	$statement->bindValue(':DVO', $DVO);
        //valuta=:valuta,
	$statement->bindValue(':valuta', $valuta);
        //daniOdgodePl=:daniOdgodePl,
        if($daniOdgodePl=='')
            $statement->bindValue(':daniOdgodePl', null, PDO::PARAM_NULL);
        else
            $statement->bindValue(':daniOdgodePl', $daniOdgodePl);
        //nacinPlacanja=:nacinPlacanja,
	$statement->bindValue(':nacinPlacanja', $nacinPlacanja);
        //datumRacuna=:datumRacuna,
	$statement->bindValue(':datumRacuna', $datumRacuna);
        //datumNarudzbe=:datumNarudzbe,
	$statement->bindValue(':datumNarudzbe', $datumNarudzbe);
        //brojNarudzbe=:brojNarudzbe,
	$statement->bindValue(':brojNarudzbe', $brojNarudzbe);
        //PDVstatus=:PDVstatus,
	$statement->bindValue(':PDVstatus', $PDVstatus);
        //casasSconto=:casasSconto, 
	$statement->bindValue(':casasSconto', $casasSconto);
        //absCasasSconto=:absCasasSconto,
	$statement->bindValue(':absCasasSconto', $absCasasSconto);
        //daniZaCasasSconto=:daniZaCasasSconto,
	$statement->bindValue(':daniZaCasasSconto', $daniZaCasasSconto);
        //refProd=:refProd,
	$statement->bindValue(':refProd', $refProd);
        //komercijalista=:komercijalista,
	$statement->bindValue(':komercijalista', $komercijalista);
	$statement->bindValue(':komentar', $komentar);
	$statement->bindValue(':kasa', $kasa);
        $statement->bindValue(':novac', $novac);
        $statement->bindValue(':povrat', $povrat);
        $statement->bindValue(':iznosKartice', $iznosKartice);
        $statement->bindValue(':iznosTransRacun', $iznosTransRacun);
        $statement->bindValue(':vrstaKartice', $vrstaKartice);
        $statement->bindValue(':kodPoslovniceMp', $kodPoslovniceMp);
        $statement->bindValue(':stranaValuta', $stranaValuta);      
        $statement->bindValue(':iznosUstranojValuti', $iznosUstranojValuti);
        $statement->bindValue(':zasticeniDokument', $zasticeniDokument);
        $statement->bindValue(':privremeniDokument', $privremeniDokument);
        $statement->bindValue(':predujam', $_SESSION['dok_zag']['predujam']);
        $statement->bindValue(':brojRata', $_SESSION['dok_zag']['brojRata']);
        $statement->bindValue(':ispisCasasSconto', $_SESSION['dok_zag']['ispisCasasSconto']);
        $statement->bindValue(':datumZakljucavanja', $datumZakljucavanja);      
        $statement->bindValue(':email_user', $email_user);              
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Dokument pod tim brojem ne postoji!. <br>'.$e->getMessage();
        display_db_error($error_message);
    }

    
    $query = "  
    UPDATE dok_stavke
    SET 
          proda=:proda,
        DVO=:DVO
 /*   WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn */
       WHERE proda = :prodaStara AND vrsDo = :vrsDo AND proIn = :proIn 
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
        ";
    if(isset($_POST['stariPDVstatus'])) { 
        if(trim($PDVstatus)!=trim($_POST['stariPDVstatus'])) {
            if(trim($PDVstatus)=='') {
                $query = "  
                UPDATE dok_stavke as s
                INNER JOIN maticna_robe as r on r.kodRobe=s.kodRobe
                INNER JOIN porezi as p on p.poreznaGrupa=r.poreznaGrupa
                SET
                      proda=:proda,
                    s.poreznaGrupa=p.poreznaGrupa, 
                    s.PDV=p.PDV,
                    s.DVO=:DVO
            /*    WHERE s.proda = :proda AND s.vrsDo = :vrsDo AND s.proIn = :proIn  */
                WHERE s.proda = :prodaStara AND s.vrsDo = :vrsDo AND s.proIn = :proIn
                    AND s.zapis = :zapis AND s.broDo = :broDo AND s.verzi = :verzi
                    ";
            }
            else if(trim($_POST['stariPDVstatus'])=='') {
                $query = "  
                UPDATE dok_stavke
                SET 
                      proda=:proda,
                    PDV=0,
                    DVO=:DVO
           /*     WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn  */
                WHERE proda = :prodaStara AND vrsDo = :vrsDo AND proIn = :proIn
                    AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
                    ";
            }
        }
        
    }
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':prodaStara', $prodaStara);
	$statement->bindValue(':proda', $proda);  
	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->bindValue(':proIn', $proIn);
	$statement->bindValue(':zapis', $zapis);
	$statement->bindValue(':broDo', $broDo);
	$statement->bindValue(':verzi', $verzi);
	$statement->bindValue(':DVO', $DVO);

        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Promjena DVO na stavkama! <br>'.$e->getMessage();
        display_db_error($error_message);
    }
//  return $rowCount;
  }  // za for
  return $rowCount;
}

function add_dok_stavke($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$brojStavke,$kodRobe,$vrstaProdaje,$cijena,
        $cijenaZaIntFak,$kolicina,$rabatPopust,$absRabatPopust,$rabatPopustNaKol,$absRabatPopustNaKol,
	$poreznaGrupa,$PDV,$ukalkuliraniPDV,$povratnaNaknada,$nabavnaCijena,$marza,$absMarza,$zavisniTroskovi,
	$absZavTr,$tekst,$vezniDokument,$oznakaCjenika,$ulaznaInterna,$jedinicaMjere,$zeljenaKolicina,$DVO) {
    global $db;    
    if($vrstaProdaje=='2' && (trim($vrsDo)!='3' || !($zapis=='K2' || $zapis=='RT' || $zapis!='NC' || $zapis=='KN'))) {
        $error_message='Status robe (vrsta prodaje) 2-naša roba kod drugih, nije dozvoljen za ovu vrstu dokumenta! Stavka:'.$brojStavke.', roba:'.$kodRobe.'.';
        display_error($error_message);        
    }    

    if ( trim($vrsDo) == '5' || trim($vrsDo) == '5U' || trim($vrsDo) == 'PR' || trim($vrsDo) == 'P' || trim($vrsDo) == 'O' ) {
        if ( $PDV !=0 && trim($_SESSION['dok_zag']['PDVstatus']) != '' ) {
            error_log('Pdv NIJE NULA, za PDVstatus koji je OSLOBOĐEN PDV-a za dokument: ' .$proda.$vrsDo.$proIn.$zapis.$broDo.$verzi);
            $call_stack=  var_export(debug_backtrace(), TRUE);
            error_log($call_stack);
       //     delete_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
            $error_message = 'GREŠKA PREKID! Pdv nije nula, za PDVstatus koji je oslobođen PDV-a za dokument: ' . $proda.$vrsDo.$proIn.$zapis.$broDo.$verzi
                . '</br> brojStavke=' . $brojStavke . ' kodRobe=' . $kodRobe . ' vrstaProdaje=' . $vrstaProdaje . ' cijena=' . $cijena . ' kolicina=' . $kolicina 
. ' </br> ili neispravno promjenjena operacija iz Izmjena na Unos za nezavršen dokument ! Nezavršen dokument sa najmanje jednom stavkom mora se nakon povratka na zaglavlje dalje raditi pod ponuđenom operacijom Izmjena a ne Unos!'      
                    . '</br>Obavezno obavjestiti programera  na tel. 098627062 radi ispravka greške! ';            
            display_error($error_message);
        }   
        if ( $PDV ==0 && trim($_SESSION['dok_zag']['PDVstatus']) == '' ) {          
            error_log('Pdv je nula, za PDVstatus koji nije oslobođen PDV-a za dokument: ' .$proda.$vrsDo.$proIn.$zapis.$broDo.$verzi);
            $call_stack=var_export(debug_backtrace(), TRUE);
            error_log($call_stack);
    //         delete_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
            $error_message = 'GREŠKA PREKID! Pdv je nula, za PDVstatus koji NIJE oslobođen PDV-a za dokument: ' . $proda.$vrsDo.$proIn.$zapis.$broDo.$verzi . ' $_SESSION_dok_zag_PDVstatus=' . $_SESSION['dok_zag']['PDVstatus']
                    . '</br> brojStavke=' . $brojStavke . ' kodRobe=' . $kodRobe . ' vrstaProdaje=' . $vrstaProdaje . ' cijena=' . $cijena . ' kolicina=' . $kolicina 
. ' </br> ili neispravno promjenjena operacija iz Izmjena na Unos za nezavršen dokument ! Nezavršen dokument sa najmanje jednom stavkom mora se nakon povratka na zaglavlje dalje raditi pod ponuđenom operacijom Izmjena a ne Unos!'
                    . '</br>Kada se redom knjiže dokumenti sa različitim PDVstatusima,obavezno nakon knjiženja kliknuti na Čišćenje,<br> ili izaći iz Web preglednika i ponovno ući u program.';                   
            display_error($error_message);            
        }   
    }
   
    if (trim($rabatPopust) == '') $rabatPopust = 0;
    if (trim($povratnaNaknada) == '') $povratnaNaknada = 0;
    if (trim($marza) == '') $marza = 0;
    if (trim($rabatPopustNaKol) == '') $rabatPopustNaKol = 0;
    if (trim($kolicina) == '') $kolicina = 0;
    if (trim($zavisniTroskovi) == '') $zavisniTroskovi = 0;
 /*    if($_SESSION['admin']['prioritet']==9) { 
echo  ' I N V E N T U R A <br>
Postovani, <br>
obavjestavamo Vas da u periodu od 11.12.  - 18.12.2017. necete moci narucivati robu putem B2B zbog godisnje inventure.';
        exit;
     } */
    /*
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi'];
     */
    if ($ulaznaInterna == 'D') {
        $vrsDo = '2 ';
        $proIn = $proda;
        $proda = $_SESSION['dok_zag']['kodPartnera'];
    }

   $poslovnica = get_poslovnica($proda);
   if ($poslovnica['vrstaPoslovnice'] == '1') {
       $porez = get_porez($poreznaGrupa);   //maloprodaje 
       $ukalkuliraniPDV = $porez['PDV']; 
    } else {         
       $ukalkuliraniPDV = 0;
    }     
    /*    
    if (!isset($_SESSION['dok_zag']['DVOY-m-d H:i:s']))  {  
        $datum_o = new DateTime($_SESSION['dok_zag']['DVO']);
        $DVO = $datum_o->format("Y-m-d H:i:s");   
    }  else {
       $DVO = $_SESSION['dok_zag']['DVOY-m-d H:i:s']; 
    }  
    if (empty($DVO) || $DVO === NULL) {
        echo 'Nepopunjen DVO pred INSERT u dok_stavke!!! '
        . 'program se prekida!!!(dokumenti.db )';
        exit;
    } 
     */   
    $datum_o = new DateTime($DVO);
    $DVO = $datum_o->format("Y-m-d H:i:s");   
    $email_user = $_SESSION['admin']['email'];
    kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi);
    $query = '
        INSERT INTO dok_stavke
		(proda,vrsDo,proIn,zapis,broDo,verzi,brojStavke,kodRobe,vrstaProdaje,
		cijena,cijenaZaIntFak,kolicina,rabatPopust,absRabatPopust,rabatPopustNaKol,
		absRabatPopustNaKol,poreznaGrupa,PDV,ukalkuliraniPDV,povratnaNaknada,nabavnaCijena,
		marza,absMarza,zavisniTroskovi,absZavTr,DVO,tekst,vezniDokument,oznakaCjenika,jedinicaMjere,
                zeljenaKolicina,datumOtvaranja,tkoJeIzmjenio)
        VALUES
		(:proda,:vrsDo,:proIn,:zapis,:broDo,:verzi,:brojStavke,:kodRobe,:vrstaProdaje,
		:cijena,:cijenaZaIntFak,:kolicina,:rabatPopust,:absRabatPopust,:rabatPopustNaKol,
		:absRabatPopustNaKol,:poreznaGrupa,:PDV,:ukalkuliraniPDV,:povratnaNaknada,:nabavnaCijena,
		:marza,:absMarza,:zavisniTroskovi,:absZavTr,:DVO,:tekst,:vezniDokument,:oznakaCjenika,
                :jedinicaMjere,:zeljenaKolicina,NOW(),:email_user)';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->bindValue(':kodRobe', $kodRobe);
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->bindValue(':cijenaZaIntFak', $cijenaZaIntFak);
        $statement->bindValue(':kolicina', $kolicina);
        $statement->bindValue(':rabatPopust', $rabatPopust);
        $statement->bindValue(':absRabatPopust', $absRabatPopust);
        $statement->bindValue(':rabatPopustNaKol', $rabatPopustNaKol);
        $statement->bindValue(':absRabatPopustNaKol', $absRabatPopustNaKol);
        $statement->bindValue(':poreznaGrupa', $poreznaGrupa);
        $statement->bindValue(':PDV', $PDV);
        $statement->bindValue(':ukalkuliraniPDV', $ukalkuliraniPDV);
        $statement->bindValue(':povratnaNaknada', $povratnaNaknada);
        $statement->bindValue(':nabavnaCijena', $nabavnaCijena);
        $statement->bindValue(':marza', $marza);
        $statement->bindValue(':absMarza', $absMarza);
        $statement->bindValue(':zavisniTroskovi', $zavisniTroskovi);
        $statement->bindValue(':absZavTr', $absZavTr);
        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':tekst', $tekst);
        $statement->bindValue(':vezniDokument', $vezniDokument);
        //if(trim($oznakaCjenika)=='')
        if($oznakaCjenika===null)
            $statement->bindValue(':oznakaCjenika', null, PDO::PARAM_NULL);   
        else 
            $statement->bindValue(':oznakaCjenika', $oznakaCjenika);
        $statement->bindValue(':jedinicaMjere', $jedinicaMjere);
        $statement->bindValue(':zeljenaKolicina', $zeljenaKolicina);
        
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška prilikom upisa stavaka! <br>'.$e->getMessage();
        display_db_error($error_message);
    }
    
    if(isset($_SESSION['dok_zag']['opSaDok']))
        if($_SESSION['dok_zag']['opSaDok']=='Izmjena') {
            $query = " 
               UPDATE dok_zag
               SET  
                   datumIzmjene=NOW(),
                   tkoJeIzmjenio=:email_user

               WHERE proda=:proda AND vrsDo=:vrsDo AND proIn=:proIn AND zapis=:zapis AND broDo=:broDo AND verzi=:verzi 
               ";
           try {
               $statement = $db->prepare($query);
               $statement->bindValue(':proda', $proda);
               $statement->bindValue(':vrsDo', $vrsDo);
               $statement->bindValue(':proIn', $proIn);
               $statement->bindValue(':zapis', $zapis);
               $statement->bindValue(':broDo', $broDo);
               $statement->bindValue(':verzi', $verzi);

               $statement->bindValue(':email_user', $email_user);
               $statement->execute();
               $statement->closeCursor();
           } catch (PDOException $e) {
               $error_message = 'Pogreška prilikom upisa stavaka! <br>'.$e->getMessage().'<br>'.$query;
               display_db_error($error_message);
           }
           
        }
    
    $kodPartneraPu = $_SESSION['dok_zag']['kodPartnera']; 
    if (trim($vrsDo)=='2') 
        $kodPartneraPu = $proIn;
    
    $nabavnaCijenaPu = $nabavnaCijena; 
    $marzaPu = $marza; $absMarzaPu = $absMarza; $zavisniTroskoviPu = $zavisniTroskovi; $absZavisniTroskoviPu = $absZavTr;
    azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$kodRobe,$vrstaProdaje,$cijena, $kolicina,
                      $rabatPopust,$absRabatPopust,$nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);    

    include_once 'model/kuponi_db.php';
    if(is_kupon($kodRobe)) {
        $slogKupon = get_kupon($proda, $vrsDo, $proIn, $zapis,(int)$vezniDokument, '');
        if(!is_array($slogKupon)) {
            add_kuponi($proda, $vrsDo, $proIn, $zapis, (int)$vezniDokument, '');
        }
        update_kuponi($proda, $vrsDo, $proIn, $zapis, (int)$vezniDokument, '', $cijena);
    }
    
    return $rowCount;
}

function update_dok_stavke($brojStavke,$kodRobe,$vrstaProdaje,$cijena,$cijenaZaIntFak,$kolicina,
	$rabatPopust,$absRabatPopust,$rabatPopustNaKol,$absRabatPopustNaKol,
	$poreznaGrupa,$PDV,$ukalkuliraniPDV,$povratnaNaknada,$nabavnaCijena,$marza,
	$absMarza,$zavisniTroskovi,$absZavTr,$tekst,$vezniDokument,$oznakaCjenika, 
        $ulaznaInterna,$jedinicaMjere,$stariKodRobe,$staraKolicina,$staraCijena,$staraVP) {
    global $db;
    if (trim($rabatPopust) == '') $rabatPopust = 0;
    if (trim($rabatPopustNaKol) == '') $rabatPopustNaKol = 0;
    if (trim($kolicina) == '') $kolicina = 0;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi'];
    $slogStavka =  get_dok_1_stavka($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $brojStavke+1);
    if($vrstaProdaje=='2' && (trim($vrsDo)!='3' || !($zapis=='K2' || $zapis=='RT' || $zapis!='NC' || $zapis=='KN'))) {
        $error_message='Status robe (vrsta prodaje) 2-naša roba kod drugih, nije dozvoljen za ovu vrstu dokumenta! Stavka:'.$brojStavke.', roba:'.$kodRobe.'.';
        display_error($error_message);        
    }
    if(empty($slogStavka)) {
        $error_message = 'Pokušaj izmjene nepostojeće stavke(update_dok_stavke)! Prodavaona='.$proda .' Vrsta dokumenta='.$vrsDo. ' Broj dokumenta='.$broDo
             .' Zapisnik="'.$zapis.'" Verzija="' . $verzi .'" proIn="' . $proIn . '" Broj stavke=' . $brojStavke. ' Pogrešan postupak ili programska greška. Zvati programera';
        display_error($error_message);        
    } 
       
    if ($ulaznaInterna == 'D') {
        $vrsDo = '2 ';
        $proIn = $proda;
        $proda = $_SESSION['dok_zag']['kodPartnera'];
    }

   $poslovnica = get_poslovnica($proda);
   if ($poslovnica['vrstaPoslovnice'] == '1') {
       $porez = get_porez($poreznaGrupa);   //maloprodaje 
       $ukalkuliraniPDV = $porez['PDV']; 
    } else {         
       $ukalkuliraniPDV = 0;
    }         
    if (!isset($_SESSION['dok_zag']['DVOY-m-d H:i:s']))  {  
        $datum_o = new DateTime($_SESSION['dok_zag']['DVO']);
        $DVO = $datum_o->format("Y-m-d H:i:s");   
    }  else {
       $DVO = $_SESSION['dok_zag']['DVOY-m-d H:i:s']; 
    }  
    if (empty($DVO) || $DVO === NULL) {
        echo 'Nepopunjen DVO pred UPDATE u dok_stavke!!! '
        . 'program se prekida!!!(dokumenti.db )';
        exit;
    }
    $s=$_SESSION['cart'][$brojStavke];
    $kodPartneraPu = '';  
    $nabavnaCijenaPu = $s['nabavnaCijena']; 
    $marzaPu = $s['marza']; $absMarzaPu = $s['absMarza']; $zavisniTroskoviPu = $s['zavisniTroskovi']; $absZavisniTroskoviPu = $s['absZavTr'];
    
    azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$stariKodRobe,$staraVP,$staraCijena, round($staraKolicina  * -1, 3),
                      $rabatPopust,$absRabatPopust,$nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);    
    
    $email_user = $_SESSION['admin']['email'];
    $query = " 
        UPDATE dok_stavke
        SET kodRobe=:kodRobe, 
        
            vrstaProdaje=:vrstaProdaje,
            cijena=:cijena,
            cijenaZaIntFak=:cijenaZaIntFak,
            kolicina=:kolicina,
            rabatPopust=:rabatPopust,
            absRabatPopust=:absRabatPopust,
            rabatPopustNaKol=:rabatPopustNaKol,
            absRabatPopustNaKol=:absRabatPopustNaKol,
            poreznaGrupa=:poreznaGrupa,
            PDV=:PDV,
            ukalkuliraniPDV=:ukalkuliraniPDV,
            povratnaNaknada=:povratnaNaknada,
            nabavnaCijena=:nabavnaCijena,
            marza=:marza,
            absMarza=:absMarza,
            zavisniTroskovi=:zavisniTroskovi,
            absZavTr=:absZavTr,
            DVO=:DVO,
            tekst=:tekst,
            vezniDokument=:vezniDokument,
            oznakaCjenika=:oznakaCjenika,
            jedinicaMjere=:jedinicaMjere,
            
            datumIzmjene=NOW(),
            tkoJeIzmjenio=:email_user
        
        WHERE proda=:proda AND vrsDo=:vrsDo AND proIn=:proIn AND zapis=:zapis AND broDo=:broDo AND verzi=:verzi AND brojStavke=:brojStavke                ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->bindValue(':brojStavke', $brojStavke+1);
        $statement->bindValue(':kodRobe', $kodRobe);
        // /*
        $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
        $statement->bindValue(':cijena', $cijena);
        $statement->bindValue(':cijenaZaIntFak', $cijenaZaIntFak);
        $statement->bindValue(':kolicina', $kolicina);
        $statement->bindValue(':rabatPopust', $rabatPopust);
        $statement->bindValue(':absRabatPopust', $absRabatPopust);
        $statement->bindValue(':rabatPopustNaKol', $rabatPopustNaKol);
        $statement->bindValue(':absRabatPopustNaKol', $absRabatPopustNaKol);
        $statement->bindValue(':poreznaGrupa', $poreznaGrupa);
        $statement->bindValue(':PDV', $PDV);
        $statement->bindValue(':ukalkuliraniPDV', $ukalkuliraniPDV);
        $statement->bindValue(':povratnaNaknada', $povratnaNaknada);
        $statement->bindValue(':nabavnaCijena', $nabavnaCijena);
        $statement->bindValue(':marza', $marza);
        $statement->bindValue(':absMarza', $absMarza);
        $statement->bindValue(':zavisniTroskovi', $zavisniTroskovi);
        $statement->bindValue(':absZavTr', $absZavTr);
        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':tekst', $tekst);
        $statement->bindValue(':vezniDokument', $vezniDokument);
        //if(trim($oznakaCjenika)=='')
        if($oznakaCjenika===null)
            $statement->bindValue(':oznakaCjenika', null, PDO::PARAM_NULL);   
        else 
            $statement->bindValue(':oznakaCjenika', $oznakaCjenika);
        $statement->bindValue(':jedinicaMjere', $jedinicaMjere);
         // */
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška prilikom promjena stavaka! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }

    //
    $query = " 
        UPDATE dok_zag
        SET  
            datumIzmjene=NOW(),
            tkoJeIzmjenio=:email_user
        
        WHERE proda=:proda AND vrsDo=:vrsDo AND proIn=:proIn AND zapis=:zapis AND broDo=:broDo AND verzi=:verzi 
        ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška prilikom promjena stavaka! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }
    
    //

    azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$kodRobe,$vrstaProdaje,$cijena, $kolicina,
                      $rabatPopust,$absRabatPopust,$nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);    
    return $rowCount;
}

function update_dok_stavke_popust($brojStavke, $predznak, $staraCijena, $staraKolicina, $staraVrstaProdaje) {
    global $db;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi'];
    $DVO = $_SESSION['dok_zag']['DVO'];
    
    do {
    $email_user = $_SESSION['admin']['email'];
    $query = " 
        UPDATE dok_stavke
        SET kolicina=kolicina*:predznak,
            rabatPopust=:rabatPopust,
            rabatPopustNaKol=:rabatPopustNaKol,
            vrstaProdaje=:vrstaProdaje,
            zavisniTroskovi=:zavisniTroskovi,
            nabavnaCijena=:nabavnaCijena,
            marza=:marza,
            cijena=:cijena,
            
            datumIzmjene=NOW(),
            tkoJeIzmjenio=:email_user
        
        WHERE proda=:proda AND vrsDo=:vrsDo AND proIn=:proIn AND zapis=:zapis AND broDo=:broDo AND verzi=:verzi AND brojStavke=:brojStavke                ";
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->bindValue(':brojStavke', $brojStavke+1);

        $statement->bindValue(':predznak', $predznak);
        $statement->bindValue(':vrstaProdaje', $_SESSION['cart'][$brojStavke]['vrstaProdaje']);
        if (trim($_SESSION['cart'][$brojStavke]['rabatPopust']) == '')  $_SESSION['cart'][$brojStavke]['rabatPopust'] = 0;        
        $statement->bindValue(':rabatPopust', $_SESSION['cart'][$brojStavke]['rabatPopust']);
        if (trim($_SESSION['cart'][$brojStavke]['rabatPopustNaKol']) == '')  $_SESSION['cart'][$brojStavke]['rabatPopustNaKol'] = 0;  
        $statement->bindValue(':rabatPopustNaKol', $_SESSION['cart'][$brojStavke]['rabatPopustNaKol']);
        if (trim($_SESSION['cart'][$brojStavke]['nabavnaCijena']) == '')  $_SESSION['cart'][$brojStavke]['nabavnaCijena'] = 0;  
        $statement->bindValue(':nabavnaCijena', $_SESSION['cart'][$brojStavke]['nabavnaCijena']);
        if (trim($_SESSION['cart'][$brojStavke]['zavisniTroskovi']) == '')  $_SESSION['cart'][$brojStavke]['zavisniTroskovi'] = 0;  
        $statement->bindValue(':zavisniTroskovi', $_SESSION['cart'][$brojStavke]['zavisniTroskovi']);
        if (trim($_SESSION['cart'][$brojStavke]['marza']) == '')  $_SESSION['cart'][$brojStavke]['marza'] = 0; 
        $statement->bindValue(':marza', $_SESSION['cart'][$brojStavke]['marza']);
        $statement->bindValue(':cijena', $_SESSION['cart'][$brojStavke]['cijena']);
         // */
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška prilikom izmjene stavaka! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }

    $s=$_SESSION['cart'][$brojStavke];
    $kodPartneraPu = '';  
    if($staraKolicina!=$s['kolicina'] || $staraCijena!=$s['cijena'] || $staraVrstaProdaje != $s['vrstaProdaje']) {
        $nabavnaCijenaPu = $s['nabavnaCijena']; 
        $marzaPu = $s['marza']; $absMarzaPu = $s['absMarza']; $zavisniTroskoviPu = $s['zavisniTroskovi']; $absZavisniTroskoviPu = $s['absZavTr'];

        azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$s['kodRobe'],$staraVrstaProdaje,$staraCijena, round($staraKolicina  * -1, 3),
                          $s['rabatPopust'],$s['absRabatPopust'],$nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);    
        azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$s['kodRobe'],$s['vrstaProdaje'],$s['cijena'], $s['kolicina'],
                          $s['rabatPopust'],$s['absRabatPopust'],$nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);    
    }
    
        if (trim($vrsDo) == '6') {
            $vrsDo = '2 ';
            $proIn = $proda;
            $proda = $_SESSION['dok_zag']['kodPartnera'];
}
        else $vrsDo='';
    } while(trim($vrsDo)=='2');    
}

function get_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $baza=null) {
    global $db;
    if($_SESSION['admin']['prioritet']=='9' && trim($_SESSION['admin']['kodPartnera'])!='') {
        $kodPartnera=$_SESSION['admin']['kodPartnera'];
        if ($_SESSION['admin']['kodPartnera'] == '701') {
            $kodPartnera='';
        }        
    } else  {
        $kodPartnera='';
    }    
    if(isset($baza))
        $dok_zag = $baza.'.dok_zag';
    else
        $dok_zag = 'dok_zag';
    $query = "
        SELECT * 
        FROM $dok_zag 
        WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND BINARY rtrim(verzi) = rtrim(:verzi)
        AND (kodPartnera=:kodPartnera OR trim(:kodPartnera)='')
        ";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->bindValue(':proIn', $proIn);
	$statement->bindValue(':zapis', $zapis);
	$statement->bindValue(':broDo', $broDo);
	$statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->execute();
    $dok_zag = $statement->fetch();
    $statement->closeCursor();
    return $dok_zag;
}

function get_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $baza=null) {
    global $db;
    if(isset($baza))
        $dok_stavke = $baza.'.dok_stavke';
    else
        $dok_stavke = 'dok_stavke';
    $query = "SELECT * FROM $dok_stavke WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->execute();
    $dok_stavke = $statement->fetchAll();
    $statement->closeCursor();
    return $dok_stavke;
}

function get_dok_1_stavka($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $brojStavke) {
    global $db;
    $query = 'SELECT * FROM dok_stavke WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi AND brojStavke=:brojStavke';
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':brojStavke', $brojStavke);
    $statement->execute();
    $dok_stavke = $statement->fetch();
    $statement->closeCursor();
    return $dok_stavke;
}

function puni_dok_zag($dok_zag) {
    global $opSaDok;
    $_SESSION['dok_zag'] = $dok_zag;

    $_SESSION['dok_zag']['brojDokumenta'] = $_SESSION['dok_zag']['broDo'];
    $_SESSION['dok_zag']['opSaDok'] = $opSaDok;
//		    $_SESSION['dok_zag']['partner'] = ' ';
    $_SESSION['dok_zag']['partner'] = $_SESSION['dok_zag']['kodPartnera'];
    $_SESSION['dok_zag']['ispis_racun_dostavnica'] = '';
    if (isset($_POST['ispis_racun_dostavnica'])) $_SESSION['dok_zag']['ispis_racun_dostavnica'] = $_POST['ispis_racun_dostavnica'];
    $_SESSION['dok_zag']['ispis_otkupni_blok'] = 'zaStranku';
    if (isset($_POST['ispis_otkupni_blok'])) $_SESSION['dok_zag']['ispis_otkupni_blok'] = $_POST['ispis_otkupni_blok'];
    if (isset($_POST['fiskalizacijaDaNe'])) {
        $_SESSION['dok_zag']['fiskalizacijaDaNe'] = $_POST['fiskalizacijaDaNe'];
    } else {
        $_SESSION['dok_zag']['fiskalizacijaDaNe'] = 'Ne';
    }  
    if (isset($_POST['ispisEANkodaDaNe'])) {
        $_SESSION['dok_zag']['ispisEANkodaDaNe'] = $_POST['ispisEANkodaDaNe'];
    } else {
        $_SESSION['dok_zag']['ispisEANkodaDaNe'] = 'Ne';
    }  
    
     if (isset($_POST['IBANtelefon'])) {
        $_SESSION['dok_zag']['IBANtelefon'] = $_POST['IBANtelefon'];
    } else {
        $_SESSION['dok_zag']['IBANtelefon'] = 'Osnovni';
    }  

    if (isset($_POST['ispisCijenaSpdv'])) {
        $_SESSION['dok_zag']['ispisCijenaSpdv'] = $_POST['ispisCijenaSpdv'];
    } else {
        if ($_SESSION['skracenicaFirme'] !="cha")
           $_SESSION['dok_zag']['ispisCijenaSpdv'] = 'Ne'; 
        else
           $_SESSION['dok_zag']['ispisCijenaSpdv'] = 'Da';                       
    }

    if (isset($_POST['ispisDospijecaIdanaOdgode'])) {
        $_SESSION['dok_zag']['ispisDospijecaIdanaOdgode'] = $_POST['ispisDospijecaIdanaOdgode'];
    } else {
        $_SESSION['dok_zag']['ispisDospijecaIdanaOdgode'] = 'Da';
    }  
    if (($opSaDok) == 'Prikaz') {
       if ($_SESSION['dok_zag']['JIR'] != NULL) {
           $_SESSION['dok_zag']['fiskalizacijaDaNe'] = 'Da';
       } else {
           $_SESSION['dok_zag']['fiskalizacijaDaNe'] = 'Ne'; 
       } 
    } 
     //prazni datumi imnaju oblik NULL u tabelama a puni gggg-mm-dd hh:mm:ss
     //pa se formatiraju u oblik dd.mm.gggg hh:mm:ss

    $DVO_o = new DateTime($_SESSION['dok_zag']['DVO']);
    $_SESSION['dok_zag']['DVO'] = $DVO_o->format("d.m.Y H:i:s"); 
    $_SESSION['dok_zag']['DVOstari'] = $_SESSION['dok_zag']['DVO'];

    if ($_SESSION['dok_zag']['valuta'] != NULL) {
         $datum_o = new DateTime($_SESSION['dok_zag']['valuta']);					 
         $_SESSION['dok_zag']['valuta'] = $datum_o->format("d.m.Y H:i:s"); 
    }

    if ($_SESSION['dok_zag']['datumRacuna'] != NULL) {
        $datum_o = new DateTime($_SESSION['dok_zag']['datumRacuna']);
        $_SESSION['dok_zag']['datumRacuna'] = $datum_o->format("d.m.Y H:i:s");
    }

    if ($_SESSION['dok_zag']['datumNarudzbe'] != NULL) {
        $datum_o = new DateTime($_SESSION['dok_zag']['datumNarudzbe']);
        $_SESSION['dok_zag']['datumNarudzbe'] = $datum_o->format("d.m.Y H:i:s");
    }	

    if ($_SESSION['dok_zag']['datumZakljucavanja'] != NULL) {
        $datum_o = new DateTime($_SESSION['dok_zag']['datumZakljucavanja']);
        $_SESSION['dok_zag']['datumZakljucavanja'] = $datum_o->format("d.m.Y H:i:s");
    }	

}

function puni_cart_iz_dok_stavke() {
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo']; 
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis'];
    $broDo = $_SESSION['dok_zag']['broDo']; 
    $verzi = $_SESSION['dok_zag']['verzi'];	
    $dok_stavke = get_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
    $brojStavke = 0;
    $vidljivost=is_vidi_zasticena_polja($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
    if(isset($_SESSION['cart']))
        unset($_SESSION['cart']);
    foreach ($dok_stavke as $stavka) {
	$_SESSION['cart'][$brojStavke]['kolicina'] = $stavka['kolicina']; 
	$_SESSION['cart'][$brojStavke]['zeljenaKolicina'] = $stavka['zeljenaKolicina']; 
        $_SESSION['cart'][$brojStavke]['cijena'] = $stavka['cijena'];
	$_SESSION['cart'][$brojStavke]['kodRobe'] = $stavka['kodRobe'];
        $_SESSION['cart'][$brojStavke]['vrstaProdaje'] = $stavka['vrstaProdaje'];
	$_SESSION['cart'][$brojStavke]['cijenaZaIntFak'] = $stavka['cijenaZaIntFak'];
        if($vidljivost['rabat']) {
            $_SESSION['cart'][$brojStavke]['rabatPopust'] = $stavka['rabatPopust'];
            $_SESSION['cart'][$brojStavke]['absRabatPopust'] = $stavka['absRabatPopust'];
            $_SESSION['cart'][$brojStavke]['rabatPopustNaKol'] = $stavka['rabatPopustNaKol'];
            $_SESSION['cart'][$brojStavke]['absRabatPopustNaKol'] = $stavka['absRabatPopustNaKol'];
        }
        else {
            $_SESSION['cart'][$brojStavke]['rabatPopust'] = 0;
            $_SESSION['cart'][$brojStavke]['absRabatPopust'] = '';
            $_SESSION['cart'][$brojStavke]['rabatPopustNaKol'] = 0;
            $_SESSION['cart'][$brojStavke]['absRabatPopustNaKol'] = '';
        }
	$_SESSION['cart'][$brojStavke]['poreznaGrupa'] = $stavka['poreznaGrupa'];
	$_SESSION['cart'][$brojStavke]['PDV'] = $stavka['PDV'];
	$_SESSION['cart'][$brojStavke]['ukalkuliraniPDV'] = $stavka['ukalkuliraniPDV'];
	$_SESSION['cart'][$brojStavke]['povratnaNaknada'] = $stavka['povratnaNaknada'];
        if($vidljivost['nabavnaCijena']) 
            $_SESSION['cart'][$brojStavke]['nabavnaCijena'] = $stavka['nabavnaCijena'];
        else
            $_SESSION['cart'][$brojStavke]['nabavnaCijena'] = 0;
        if($vidljivost['rabat']) {
            $_SESSION['cart'][$brojStavke]['marza'] = $stavka['marza'];
            $_SESSION['cart'][$brojStavke]['absMarza'] = $stavka['absMarza'];
        }
        else {
            $_SESSION['cart'][$brojStavke]['marza'] = 0;
            $_SESSION['cart'][$brojStavke]['absMarza'] = '';            
        }
	$_SESSION['cart'][$brojStavke]['zavisniTroskovi'] = $stavka['zavisniTroskovi'];
        $_SESSION['cart'][$brojStavke]['absZavTr'] = $stavka['absZavTr'];
	$_SESSION['cart'][$brojStavke]['tekst'] = $stavka['tekst'];
	$_SESSION['cart'][$brojStavke]['vezniDokument'] = $stavka['vezniDokument'];
	$_SESSION['cart'][$brojStavke]['oznakaCjenika'] = $stavka['oznakaCjenika'];
	$_SESSION['cart'][$brojStavke]['jedinicaMjere'] = $stavka['jedinicaMjere'];
	$brojStavke++;
       // Set last category added to cart
	$kodRobe = $stavka['kodRobe'];          
        if (trim($kodRobe) != '#' ) {
    // 25.3.2020    $roba = get_product($_SESSION['odabranaPoslovnica'], $kodRobe);
            $roba = get_product_maticna_robe($kodRobe);        
            $_SESSION['last_category_id'] = $roba['kodGrupe'];
            $_SESSION['last_category_name'] = $roba['nazivGrupe'];
        }
    }
}

function is_vidi_zasticena_polja($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    $vidljivost['marza']=true;
    $vidljivost['nabavnaCijena']=true;
    $vidljivost['rabat']=true;
    if($_SESSION['admin']['prioritet']>4 && trim($vrsDo)=='1') {
        if(trim($_SESSION['admin']['vidljiviPodaciPrimke'])!='') {
            $nevidljivi=explode(',', $_SESSION['admin']['vidljiviPodaciPrimke']);
            if(is_array($nevidljivi)) {
                foreach ($nevidljivi as $p) {
                    if($p=='M')
                       $vidljivost['marza']=false; 
                    else if($p=='N')
                       $vidljivost['nabavnaCijena']=false; 
                    else if($p=='R')
                       $vidljivost['rabat']=false; 
                }
            }              
        }
        else {
            $dok=get_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
            if($dok['zasticeniDokument']=='Da') {
                $vidljivost['marza']=$vidljivost['nabavnaCijena']=$vidljivost['rabat']=false;
            }  
        }
    }
    return $vidljivost;
}

function get_dok_zag_po_partneru($kodPartnera) {
    global $db;
    $query = 'SELECT * FROM narudzbe WHERE kodPartnera = :kodPartnera
	ORDER BY DVO';
    $statement = $db->prepare($query);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->execute();
    $order = $statement->fetchAll();
    $statement->closeCursor();
    return $dok_zag_po_partneru;
}

function delete_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    global $db;
    global $action;
    //prvo provjeriti da li je dokument zaključan ili ima neku drugu zabranu brisanja 
    //za interne fakture treba obrisati vrsdo 6 i vrsdo 2    
    $dok_zag = get_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
    if (empty($dok_zag)) {
       echo 'Navedeni dokument za brisanje ne postoji !';
       exit;
    }
    if ($dok_zag['datumZakljucavanja'] != NULL) {
       echo 'Dokument je zaključan i ne može se brisati !';
       exit; 
    }
    if ($dok_zag['zastitniKod'] != NULL) {
       echo 'Dokument je fiskaliziran pa se ne može brisati !';
       exit; 
    }
    $kolikoPuta = 1;
    if ($vrsDo == '6 ' ) $kolikoPuta = 2;
    
  for ($i = 1; $i <= $kolikoPuta; $i++) {    
        if ($i == 2) {
            //drugi prolaz briše se ulazna interna vrsDo 2
            //proIn se puni sa prodavaonom koja je izdala robu  -> proda
            //proda  se puni sa prodavaonom koja prima robu  -> kodPartnera
            $vrsDo = '2 ';
            $proIn = $proda;
            $proda = $dok_zag['kodPartnera'];
            //$_SESSION['prodaUlInt'] = $proda; //da zapamti za brisanje stavki
        } 
        if(isset($action))
            if($action=='moze_brisati') {
                $stavke=  get_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
                if(!empty($stavke)) {
                    $error_message = 'Dokument nije moguće obrisati. Brisanje stavaka nije uspjelo!!';
                    display_db_error($error_message);
                }
            }
        $query = 'DELETE FROM dok_zag WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
            AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi';
        try {	
            $statement = $db->prepare($query);
            $statement->bindValue(':proda', $proda);
            $statement->bindValue(':vrsDo', $vrsDo);
            $statement->bindValue(':proIn', $proIn);
            $statement->bindValue(':zapis', $zapis);
            $statement->bindValue(':broDo', $broDo);
            $statement->bindValue(':verzi', $verzi);
            $statement->execute();
            $statement->closeCursor();
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        } 
    }     // za for petlju 
}

/*
function delete_dok_1_stavku($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $brojStavke) {
    global $db;
    $query = "DELETE FROM dok_stavke WHERE proda=:proda AND vrsDo=:vrsDo AND proIn=:proIn
        AND zapis=:zapis AND broDo=:broDo AND verzi=:verzi AND brojStavke=:brojStavke ";
    try {	
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->bindValue(':brojStavke', $brojStavke);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    } 
    
}
 */

function delete_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    global $db;
    $kolikoPuta = 1;
    if ($vrsDo == '6 ' ) {
        $kolikoPuta = 2;
        $dok_zag = get_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
        $_SESSION['prodaUlInt'] = $dok_zag['kodPartnera']; //da zapamti za brisanje stavki
    }
    
    for ($i = 1; $i <= $kolikoPuta; $i++) { 
        // echo 'Prolaz kroz for i=' . $i . 'koliko puta=' . $kolikoPuta;
        if ($i == 2) {
            //drugi prolaz briše se ulazna interna vrsDo 2
            //proIn se puni sa prodavaonom koja je izdala robu  -> proda
            //proda  se puni sa prodavaonom koja prima robu  -> kodPartnera
            $vrsDo = '2 ';
            $proIn = $proda;
            $proda = $_SESSION['prodaUlInt'];
            //   echo 'Drugi prolaz delete_dok_stavke $proda=' . $proda;
            unset($_SESSION['prodaUlInt']);
        }

        // --------------------------------------------------------------------------------  
        //prije deleta kontraažuriranje stanja za sve stavke
        if (trim($vrsDo)=='1' || trim($vrsDo)=='2' || trim($vrsDo)=='3' || trim($vrsDo)=='4' || trim($vrsDo)== '5' || $vrsDo == 'PR' || $vrsDo == 'NS'
                      || trim($vrsDo)=='6' || trim($vrsDo)=='7' || trim($vrsDo)=='8')   {

            $query = 'SELECT * FROM dok_stavke
             WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
                AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi  
            ';
            try {	
                $statement = $db->prepare($query);
                $statement->bindValue(':proda', $proda);
                $statement->bindValue(':vrsDo', $vrsDo);
                $statement->bindValue(':proIn', $proIn);
                $statement->bindValue(':zapis', $zapis);
                $statement->bindValue(':broDo', $broDo);
                $statement->bindValue(':verzi', $verzi);
                $statement->execute();
                $stavke = $statement->fetchAll();
                $statement->closeCursor();
            } catch (PDOException $e) {
                $error_message = $e->getMessage();
                display_db_error($error_message);
            }
            include_once 'model/kuponi_db.php';
            foreach($stavke as $s) {
                $kodPartneraPu = '';  
                $DVO = $s['DVO']; $kodRobe = $s['kodRobe']; $vrstaProdaje = $s['vrstaProdaje']; $cijena = $s['cijena']; $kolicina = round($s['kolicina'] * (-1), 3);
                $rabatPopust = $s['rabatPopust']; $absRabatPopust = $s['absRabatPopust']; $nabavnaCijenaPu = $s['nabavnaCijena']; 
                $marzaPu = $s['marza']; $absMarzaPu = $s['absMarza']; $zavisniTroskoviPu = $s['zavisniTroskovi']; $absZavisniTroskoviPu = $s['absZavTr'];

                azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$kodRobe,$vrstaProdaje,$cijena,$kolicina,$rabatPopust,$absRabatPopust,
                    $nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);    
                if(is_kupon($kodRobe)) {
                    update_kuponi($proda, $vrsDo, $proIn, $zapis, (int)$s['vezniDokument'], '', 0);
                }
            }

        }  
        // --------------------------------------------------------------------------------     

        //$query = 'DELETE FROM dok_stavke WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
        //    AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi';
        $query = 'DELETE FROM dok_stavke WHERE trim(proda) = trim(:proda) AND trim(vrsDo) = trim(:vrsDo) AND trim(proIn) = trim(:proIn)
           AND trim(zapis) = trim(:zapis) AND broDo = :broDo AND trim(verzi) = trim(:verzi)';
        try {	
            $statement = $db->prepare($query);
            $statement->bindValue(':proda', $proda);
            $statement->bindValue(':vrsDo', $vrsDo);
            $statement->bindValue(':proIn', $proIn);
            $statement->bindValue(':zapis', $zapis);
            $statement->bindValue(':broDo', $broDo);
            $statement->bindValue(':verzi', $verzi);
            $statement->execute();
            $rowCount = $statement->rowCount();
            $statement->closeCursor();
        //	return $rowCount;
        } catch (PDOException $e) {
            $error_message = $e->getMessage();
            display_db_error($error_message);
        }
    }     // za for petlju  
}

function update_dok_stavke_DVO() {
    global $db;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi']; 
    if (isset($_SESSION['dok_zag']['DVO'])) {
        //$DVO = $_SESSION['dok_zag']['DVO'];
        $DVO_o = new DateTime($_SESSION['dok_zag']['DVO']);
        $DVO = $DVO_o->format("Y-m-d H:i:s");    
    } else {	
        $datum_o = new DateTime();
        $DVO = $datum_o->format("Y-m-d H:i:s");
    }
    $email_user = $_SESSION['admin']['email'];
    $query = '
        UPDATE dok_stavke
        SET DVO = :DVO,
            datumIzmjene = NOW(),
		    tkoJeIzmjenio = :email_user
        WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi';
    try {
        $statement = $db->prepare($query);
		$statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
		$statement->bindValue(':DVO', $DVO);
		$statement->bindValue(':email_user', $email_user);
        $statement->execute();
		$rowCount = $statement->rowCount();
		$statement->closeCursor();
		return $rowCount;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

function update_dok_stavke_kodRobe($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $brojStavke, $noviKodRobe, $novaVrstaProdaje) {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    $query = " 
        UPDATE dok_stavke
        SET kodRobe = :noviKodRobe,
            vrstaProdaje = :novaVrstaProdaje,
            datumIzmjene = NOW(),
            tkoJeIzmjenio = :email_user
        WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi AND brojStavke = :brojStavke
        ";
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
	$statement->bindValue(':brojStavke', $brojStavke);
	$statement->bindValue(':noviKodRobe', $noviKodRobe);
	$statement->bindValue(':novaVrstaProdaje', $novaVrstaProdaje);
	$statement->bindValue(':email_user', $email_user);
        $statement->execute();
	$rowCount = $statement->rowCount();
	$statement->closeCursor();
	return $rowCount;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}

/*
 * POZOR!! 
 * f-ja round ima grešku, rijetku ali grešku.
 * npr.: round(141.075, 2) daje 141,07, round(4.725, 2) daje 4,72
 * To se vidi na paragoncu:
 * proda=2316, broDo=1663 DVO=21.08.2013 13:27:07
 * ukoliko bi se umjesto round pozvala f-ja mround ona bi korigirala tu grešku
 * Za sada sam ja f-ju racunajPDV slozio da računa s istom greškom
 * MAKAR, 19.1.20014.
 */
function zbroj_po_dok($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $cijeliDokIliRU='',$kreiraRaster=false) {
 /* ako je kreiraRaster == true(knjiženje u knjigovodstvo), onda računa i usluge unutar npr.robne fakture ili paragonca da bi se moglo skontirati
    iznos usluge (umanjen za popust rabat) i PDV na uslugu
    U slučaju postojanja usluge(prijevoza) na robnom dokumentu zbroj_po_dok daje ukupnu zalihu, PDV, ukalkulirani porez kao da usluge nema,
   a posebno daje
     $zbroj['samoRoba'] = round($samoRoba,2);
     $zbroj['samoRobaUkalkuliraniPDV'] = round($samoRobaUkalkuliraniPDV,2);
     $zbroj['samoUsluga'] = round($samoUsluga,2); 
     $zbroj['PDVsamoUsluga'] = round($PDVsamoUsluga,2); 
    prije poziva funkcije rasterFile() koja to koristi za knjiženje u knjigovodstvo, 
	mora se izračunati iz toga stvarnu robnu zalihu,PDV samo na robu, ukalkulirani porez(samo na robu) i rabat popust(samo na robu)
     to preračunavanje u slučaju casa sconta ovdje ne radi ??? ?   
 */   
    //   echo 'round(141,075)' . round(141.075, 2);
    global $db;
    $query = 'SELECT *
    FROM dok_stavke WHERE  proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
    AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi ';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
     // return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
//bitna razlika: maloprodajni način obračuna gdje je cijena s pdv-om zaokružena
//na dvije decimale ovo je DEFAULTNO
//i veleprodajni način gdje su cijene na 3 decimale bez pdv-a a pdv se na kraju računa
//na ukupni neto iznos bez poreza  
//varijable koje se odnose na veleprodaju imaju nastavak VPC(veleprodajna cijena)    
  $iznosBezPDVbruto = 0; //  cijena * kolicina   vpc cijena na 3 decimale(zajedničko za VPC i MPC)
  $iznosSpdvBruto = 0;  //cijena s PDV * kolicina
  $iznosRabatPopust = 0; //za primke i sve ostale dokumente
  $iznosRabatPopustVPC = 0; //uključuje i dodatni-količinski popust
  $iznosRabatPopustVPCobicni = 0; //samo rabat obični bez dodatnog količinskog rabata
  $ukPoreznaOsnovica = 0; //ukupna porezna osnovica po svim stopama 
  $ukPoreznaOsnovicaVPC = 0;
  $ukIznosPDV = 0;  //ukupni iznos PDVa po svim stopama
  $ukIznosPDVvpc = 0;
  $ukUkalkuliraniPDV = 0;
  $zaNaplatu = 0;
  $iznosNabavnaCijena = 0;
  $iznosMarza = 0;
  $iznosZavisniTroskovi = 0;
  $rabatPopustNaCijenu = 0;
  $samoRoba = 0;
  $samoRobaUkalkuliraniPDV = 0;
  $samoUsluga = 0;
  $PDVsamoUsluga = 0;
  $rabatPopustNaCijenuVPCobicni=0;
     $zbrojKolicina = 0;   
  $zbroj = array();  
  $poslovnica = get_poslovnica($proda);
 
  foreach($result as $stavkaZbroja) {
      
    $cijena = $stavkaZbroja['cijena'];
    $kolicina = $stavkaZbroja['kolicina'];
    $zbrojKolicina += $kolicina;
    $rabatPopust = $stavkaZbroja['rabatPopust'];
    
    if ($stavkaZbroja['cijena'] == 0 || $stavkaZbroja['kolicina'] == 0) continue; // # 
    
    if ($cijeliDokIliRU !='' || $kreiraRaster === true) {  // 10.11.2020 za knjiženje prijevoza i pdv prijevoza   
        $kodRobe = $stavkaZbroja['kodRobe'];
       //traže se stavke samo usluge ili samo roba R ili U
       // ili ako je cijeliDokIliRU == 'RU' i jedno i drugo ali odvojeno roba i usluga 
        $query = 'SELECT robaUsluga
                 FROM maticna_robe WHERE kodRobe = :kodRobe';
       try {
        $statement = $db->prepare($query);
        $statement->bindValue(':kodRobe', $kodRobe);        
        $statement->execute();
        $resultm = $statement->fetch();
        $statement->closeCursor();     
       } catch (PDOException $e) {
        $error_message = 'Nije pronađen kodRobe ' . $kodRobe . ' u zbroj_po_dok ' . $e->getMessage();
        display_db_error($error_message);
       }
       if (!empty($resultm)) {
            $robaUsluga = $resultm[0];      
            if ($cijeliDokIliRU == 'R' || $cijeliDokIliRU == 'U') {
                 if ($robaUsluga != $cijeliDokIliRU) continue;
                 //Obrađuju se samo stavke robe ili samo stavke usluge
            }  
       }    
    }
    
     
    $PDV = $stavkaZbroja['PDV'];
    $ukalkuliraniPDV = $stavkaZbroja['ukalkuliraniPDV'];
//  $rabatPopust = $stavkaZbroja['rabatPopust'];
    $absRabatPopust = $stavkaZbroja['absRabatPopust'];
    $rabatPopustNaKol = $stavkaZbroja['rabatPopustNaKol'];
    $absRabatPopustNaKol = $stavkaZbroja['absRabatPopustNaKol'];
    $nabavnaCijena = $stavkaZbroja['nabavnaCijena'];
    $marza = $stavkaZbroja['marza'];
    $absMarza = $stavkaZbroja['absMarza'];
    $zavisniTroskovi = $stavkaZbroja['zavisniTroskovi'];
    $absZavTr = $stavkaZbroja['absZavTr'];
    
    $bezPdvStavka = $cijena * $kolicina;	
    $iznosBezPDVbruto += $bezPdvStavka;
  //  $ukalkuliraniPDVstavka = $bezPdvStavka * ($ukalkuliraniPDV / 100);
  // $ukUkalkuliraniPDV += $ukalkuliraniPDVstavka;         
    $cijenaSpdv = round(($cijena * (1 + $PDV / 100)),2); 
    if ($PDV == 0 && $ukalkuliraniPDV !=0)
        $cijenaSpdv = round(($cijena * (1 + $ukalkuliraniPDV / 100)),2);    
    $sPdvStavkaBruto = $cijenaSpdv * $kolicina;
    $iznosSpdvBruto += $sPdvStavkaBruto;
    if ($rabatPopust != 0 || $rabatPopustNaKol !=0) {            
       if ($absRabatPopust == 'A') { 
          $rabatPopustNaCijenu = ($cijenaSpdv * $rabatPopustNaKol / 100) + $rabatPopust; 
          $rabatPopustNaCijenuVPC =  ($cijena * $rabatPopustNaKol / 100)  + $rabatPopust;
       //ako je absolutni onda je to popust S POREZOM!!!  kod maloprodaja  a kod veleprodaja bez PDV
       } else {
          $rabatPopustNaCijenu = $cijenaSpdv * ($rabatPopust + $rabatPopustNaKol) / 100; 
          $rabatPopustNaCijenuVPC = $cijena * ($rabatPopust + $rabatPopustNaKol) / 100; 
          $rabatPopustNaCijenuVPCobicni = $cijena * $rabatPopust / 100;
       } 
    }
    else {
            $rabatPopustNaCijenu = 0; 
            $rabatPopustNaCijenuVPC = 0;
            $rabatPopustNaCijenuVPCobicni = 0;
    }
 
    $netoCijenaSpdv = round(($cijenaSpdv - $rabatPopustNaCijenu),2);
    $netoCijenaVPC = $cijena - $rabatPopustNaCijenuVPC;
    $netoCijenaVPCobicna = $cijena - $rabatPopustNaCijenuVPCobicni;
    $zaNaplatuStavka = $netoCijenaSpdv * $kolicina;
    $zaNaplatu += $zaNaplatuStavka;
  //?zaokružena cijena na 2 dec  
    $pdvUstavki = ($netoCijenaSpdv - ($netoCijenaSpdv / ( 1 + $PDV / 100))) 
                  * $kolicina;
    $ukIznosPDV += $pdvUstavki;
    
    $ukalkuliraniPDVstavka = ($cijenaSpdv - ($cijenaSpdv / ( 1 + $ukalkuliraniPDV / 100))) 
                  * $kolicina;
    $ukUkalkuliraniPDV += $ukalkuliraniPDVstavka;
    
    $pdvUstavkiVPC = $netoCijenaVPC * $kolicina * $PDV / 100;
    $ukIznosPDVvpc += $pdvUstavkiVPC;   
        
    $poreznaOsnovicaUstavki = ($netoCijenaSpdv / ( 1 + $PDV / 100)) * $kolicina;
 //   if ($PDV == 0 && $ukalkuliraniPDV !=0)
 //   $poreznaOsnovicaUstavki = ($netoCijenaSpdv / ( 1 + $ukalkuliraniPDV / 100)) * $kolicina;    
    $ukPoreznaOsnovica += $poreznaOsnovicaUstavki;
    
    $poreznaOsnovicaUstavkiVPC = $netoCijenaVPC * $kolicina;
    $ukPoreznaOsnovicaVPC += $poreznaOsnovicaUstavkiVPC;
    
    $rabatPopustStavka = ($cijenaSpdv - $netoCijenaSpdv) * $kolicina;
    $rabatPopustStavkaVPC = ($cijena - $netoCijenaVPC) * $kolicina;
    $rabatPopustStavkaVPCobicni = ($cijena - $netoCijenaVPCobicna) * $kolicina;
    
    if (isset($robaUsluga)) {
        if ($cijeliDokIliRU == 'RU' || $kreiraRaster === true) {      // 10.11.2020
           if ($robaUsluga == 'R') {
              $samoRoba += $poreznaOsnovicaUstavki; 
              $samoRobaUkalkuliraniPDV += $ukalkuliraniPDVstavka;
           } else {
              $samoUsluga += $poreznaOsnovicaUstavki; 
              $PDVsamoUsluga += $pdvUstavki;
           }            
           //neto iznosi robe i usluga za sada SAMO ZA MALOPRODAJE
        }    
    }    
//dodaje se kasnije kod primke
       
    
//razrada po stopama PDV-a
    if (!isset($zbroj['PDVzbroj'])) {
       $zbroj['PDVzbroj'] = $PDV;
      // echo '$pdv1=' . $PDV;
       $zbroj[$PDV]['iznosPdv'] = $pdvUstavki;
       $zbroj[$PDV]['poreznaOsnovica'] = $poreznaOsnovicaUstavki;
    } else {
      //ako postoji više stopa jedna je aktivirana a druga ne npr.
       foreach ( $zbroj as $PDVzbroj  =>  $stavkaPDV ) {
          $nasaoPDV = 'NE';
          if ($PDVzbroj == $PDV) {
              $nasaoPDV = 'DA';
              $zbroj[$PDV]['iznosPdv'] += $pdvUstavki;
              $zbroj[$PDV]['poreznaOsnovica'] += $poreznaOsnovicaUstavki;
          }
       }
       if ($nasaoPDV == 'NE') {
              //neka druga PDV stopa jos nije otvorena
             $zbroj['PDVzbroj'] = $PDV;
             $zbroj[$PDV]['iznosPdv'] = $pdvUstavki;
             $zbroj[$PDV]['poreznaOsnovica'] = $poreznaOsnovicaUstavki; 
       }
    }
    
   /*
    //razrada po stopama ukalkulirani porez
    if (!isset($zbroj['ukalPDVzbroj'])) {
       $zbroj['ukalPDVzbroj'] = $ukalkuliraniPDV;
      // echo '$pdv1=' . $PDV;
       $zbroj[$ukalkuliraniPDV]['ukalIznosPdv'] = $ukalkuliraniPDVstavka;
       $zbroj[$ukalkuliraniPDV]['ukalPoreznaOsnovica'] = $bezPdvStavka;
    } else {
      //ako postoji više stopa jedna je aktivirana a druga ne npr.
       foreach ( $zbroj as $ukalPDVzbroj  =>  $stavkaUkalPDV ) {
          $nasaoUkalPDV = 'NE';
          if ($ukalPDVzbroj == $ukalkuliraniPDV) {
              $nasaoUkalPDV = 'DA';
              $zbroj[$ukalkuliraniPDV]['ukalIznosPdv'] += $ukalkuliraniPDVstavka;
              $zbroj[$ukalkuliraniPDV]['ukalPoreznaOsnovica'] += $bezPdvStavka;
          }
       }
       if ($nasaoUkalPDV == 'NE') {
              //neka druga PDV stopa jos nije otvorena
             $zbroj['ukalPDVzbroj'] = $ukalkuliraniPDV;
             $zbroj[$ukalkuliraniPDV]['ukalIznosPdv'] = $ukalkuliraniPDVstavka;
             $zbroj[$ukalkuliraniPDV]['ukalPoreznaOsnovica'] = $bezPdvStavka; 
       }
    }    
    */
 
    // za primku
    $nabavnaCijenaStavka = $nabavnaCijena * $kolicina;
    $iznosNabavnaCijena += $nabavnaCijenaStavka;
    
    $marzaStavka = $nabavnaCijena * ($marza / 100) * $kolicina;
    if ($absMarza == 'A') $marzaStavka = $marza * $kolicina;
    $iznosMarza += $marzaStavka;
     
    $zavisniTroskoviStavka = $nabavnaCijena * ($zavisniTroskovi / 100) * $kolicina;
    if ($absZavTr == 'A') $zavisniTroskoviStavka = $zavisniTroskovi * $kolicina;
    $iznosZavisniTroskovi += $zavisniTroskoviStavka;
    
    if (trim($vrsDo) == '1') {
       $rabatPopustStavka = $nabavnaCijena * ($rabatPopust / 100) * $kolicina; 
       if ($absRabatPopust == 'A' ) $rabatPopustStavka = $rabatPopust * $kolicina;
      }  
    //prije je za ostale dokumente izračunat rabat  
 $iznosRabatPopust += $rabatPopustStavka;
 $iznosRabatPopustVPC += $rabatPopustStavkaVPC;
 $iznosRabatPopustVPCobicni += $rabatPopustStavkaVPCobicni;
}  //kraj forecha
   $query = 'SELECT *
    FROM dok_zag WHERE  proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
    AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi ';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->execute();
        $result_dok_zag = $statement->fetch();
        $statement->closeCursor();
        // return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
  //  echo 'proda=' .$proda . 'vrsDo=' . $vrsDo . 'proIN=' . $proIn . 'zapis=' . $zapis . 'broDo=' . $broDo . 'verzi=' . $verzi;
 //       ECHO 'VARDUMPresult_dok_zag='. var_dump($result_dok_zag);
    $zbroj['iznosCasasSconto'] = 0;
    $iznosCasasSconto = 0; $iznosCasasScontoVPC = 0;
    $zbroj['casasSconto'] = $result_dok_zag['casasSconto'];
    $zbroj['absCasasSconto'] = $result_dok_zag['absCasasSconto'];
    $zbroj['daniZaCasasSconto'] = $result_dok_zag['daniZaCasasSconto'];
    
  if ($result_dok_zag['casasSconto'] != 0 ) {
      if ($result_dok_zag['absCasasSconto'] == 'A') {
         //absolutni casa sconto NA CIJELI DOKUMENT(nema veze s količinom)
         // i BEZ POREZA SE SMATRA 
         $casasScontoPosto = ($result_dok_zag['casasSconto'] / $ukPoreznaOsnovica) * 100; 
         $ukPoreznaOsnovica = $ukPoreznaOsnovica - $result_dok_zag['casasSconto'];
         $zbroj['iznosCasasSconto'] = $result_dok_zag['casasSconto'];
         $iznosCasasSconto = $result_dok_zag['casasSconto'];
      } else {
         $iznosCasasSconto = $ukPoreznaOsnovica * ($result_dok_zag['casasSconto'] / 100); 
      //   echo 'ukPoreznaOsnovicaVPC=' . $ukPoreznaOsnovicaVPC;
         $iznosCasasScontoVPC = $ukPoreznaOsnovicaVPC * ($result_dok_zag['casasSconto'] / 100);
      //   echo 'iznosCasasScontoVPC' . $iznosCasasScontoVPC;
         $ukPoreznaOsnovica = $ukPoreznaOsnovica - $iznosCasasSconto; 
         $ukPoreznaOsnovicaVPC = $ukPoreznaOsnovicaVPC - $iznosCasasScontoVPC; 
      //   echo 'ukPoreznaOsnovicaVPC2=' . $ukPoreznaOsnovicaVPC;
         $casasScontoPosto = $result_dok_zag['casasSconto'];
      }
//za % casas sconta se smanji i pdv  
     $smanjenjePDVa = ($casasScontoPosto / 100) * $ukIznosPDV; 
     $ukIznosPDV = $ukIznosPDV - $smanjenjePDVa;
     $zaNaplatu = $ukPoreznaOsnovica + $ukIznosPDV;
     
     $smanjenjePDVaVPC = ($casasScontoPosto / 100) * $ukIznosPDVvpc;
     $ukIznosPDVvpc = $ukIznosPDVvpc - $smanjenjePDVaVPC;
//?   
 }
 
  $zbroj['vrstaPoslovnice'] = $poslovnica['vrstaPoslovnice'];
  $zbroj['DVO'] = $result_dok_zag['DVO'];
  $zbroj['refProdOIB'] = $result_dok_zag['refProd'];
  $zbroj['kasa'] = $result_dok_zag['kasa'];
  $zbroj['PDVstatus'] = $result_dok_zag['PDVstatus'];
  $zbroj['fiskaliziraSe'] = false;
  // if ($result_dok_zag['novac'] !=0 || $result_dok_zag['iznosKartice'] !=0 )
  if ($result_dok_zag['novac'] !=0 || $result_dok_zag['iznosKartice'] !=0 || $result_dok_zag['iznosTransRacun'] !=0 )
      $zbroj['fiskaliziraSe'] = true;    
  
  $zbroj['iznosBezPDVbruto'] = round($iznosBezPDVbruto,2);
  $zbroj['iznosSpdvBruto'] = round($iznosSpdvBruto,2);
  $zbroj['iznosRabatPopust'] = round($iznosRabatPopust,2);
  $zbroj['iznosRabatPopustVPC'] = round($iznosRabatPopustVPC,2);  //zbrojen obični i količinski rabat
  $zbroj['iznosRabatPopustVPCnaKol'] = 0;
  if ( abs(round($iznosRabatPopustVPCobicni,2) - $zbroj['iznosRabatPopustVPC']) > 0.02 )
      $zbroj['iznosRabatPopustVPCnaKol'] =  $zbroj['iznosRabatPopustVPC'] - round($iznosRabatPopustVPCobicni,2);        
  
  $zbroj['iznosCasasSconto'] = round($iznosCasasSconto,2);
  $zbroj['iznosCasasScontoVPC'] = round($iznosCasasScontoVPC,2);
  $zbroj['ukPoreznaOsnovica'] = round($ukPoreznaOsnovica,2);
  $zbroj['ukPoreznaOsnovicaVPC'] = round($ukPoreznaOsnovicaVPC,2);
  
  $zbroj['samoRoba'] = round($samoRoba,2);
     $zbroj['samoRobaUkalkuliraniPDV'] = round($samoRobaUkalkuliraniPDV,2);
  $zbroj['samoUsluga'] = round($samoUsluga,2); 
  $zbroj['PDVsamoUsluga'] = round($PDVsamoUsluga,2);
  
  $zbroj['ukIznosPDV'] = round($ukIznosPDV,2); 
  $zbroj['ukIznosPDVvpc'] = round($ukIznosPDVvpc,2);
  $zbroj['zaNaplatuVPC'] = round(($zbroj['ukPoreznaOsnovicaVPC'] + $zbroj['ukIznosPDVvpc']),2);
  $zbroj['ukUkalkuliraniPDV'] = round($ukUkalkuliraniPDV,2);
  $zbroj['zaNaplatu'] = round($zaNaplatu,2);
  if (trim($vrsDo) != '1' && (trim($result_dok_zag['PDVstatus']) != '') ) {
      $zbroj['zaNaplatu'] = $zbroj['zaNaplatuVPC']; 
      $zbroj['ukPoreznaOsnovica'] = $zbroj['ukPoreznaOsnovicaVPC'];
      $zbroj['iznosRabatPopust'] = $zbroj['iznosRabatPopustVPC'];
  }
  $zbroj['iznosNabavnaCijena'] = round($iznosNabavnaCijena,2);
  $zbroj['iznosMarza'] = round($iznosMarza,2);
  $zbroj['iznosZavisniTroskovi'] = round($iznosZavisniTroskovi,2);
  if ($iznosZavisniTroskovi == 0 )
      $zbroj['iznosMarza'] = $iznosBezPDVbruto - $iznosNabavnaCijena;
  if ($zbroj['iznosNabavnaCijena'] == 0) $zbroj['iznosMarza'] = 0;
  
  $zbroj['pretporez'] = 0;
  $zbroj['zbrojKolicina'] = $zbrojKolicina;
  if (trim($vrsDo) == '1' ) {
     $kupovnaVrijednost =  $zbroj['iznosNabavnaCijena'] - $zbroj['iznosRabatPopust'] - $zbroj['iznosCasasSconto'];
     $zbroj['pretporez'] = round($kupovnaVrijednost * 0.25,2); 
     if (trim($result_dok_zag['PDVstatus'] != '')) $zbroj['pretporez'] = 0;
     $zbroj['zaNaplatu'] = $kupovnaVrijednost + $zbroj['pretporez'];
     if ($poslovnica['vrstaPoslovnice'] == '1') {
        $zbroj['ukUkalkuliraniPDV'] = $zbroj['iznosSpdvBruto'] - $zbroj['iznosBezPDVbruto'];  //za maloprodaje
     } else {
        $zbroj['ukUkalkuliraniPDV'] = 0;  //za veleprodaje,repromaterijal,gotove proizvode i usluge
        $zbroj['iznosSpdvBruto'] =  $zbroj['iznosBezPDVbruto'];  //za veleprodaje,repromaterijal,gotove priizvode i usluge
     }
  }   
  
/*  19.10.2020 ako je razlika  iznosBezPDVbruto - (rabat + casasconto) + PDV = Iznos s PDV-om 
    korekcija od 1 ili 2 lipe se stavlja na iznosBezPDVbruto jer se smatra da su rabat, casasconto, PDV i Iznos s PDV-om točni
    Ovo je bitno kod kontiranja u knjigovodstvo da saldo kontiranja bude 0, 
 *  Tu se pojavljuju razlike u zaokruženjima kod popusta i casasconta u rijetkim slučajevima
 *  Na MALOPRODAJI je iznos popusta(u postotku ili absolutni iskazan sa PDV-om, a casasSconto NIJE razrađen tako DA SE NE BI SMIO KORISTITI 
 */   
  if ( trim($vrsDo) != '1' || trim($vrsDo) != '2' || trim($vrsDo) != '6' || trim($vrsDo) != '7' ) {
      if ( $zbroj['vrstaPoslovnice'] == '0') {    
        $razlika = $zbroj['iznosBezPDVbruto'] - ( $zbroj['iznosRabatPopustVPC'] + $zbroj['iznosCasasScontoVPC'] ) 
                   +  $zbroj['ukIznosPDVvpc'] - $zbroj['zaNaplatuVPC'];
        $razlika = round($razlika,2);
        if ($razlika != 0) {
            if (abs($razlika) > 0.02 ) {
                echo 'Kontrolna razlika iznosa(iznosBezPDVbruto - (iznosRabatPopustVPC + iznosCasasScontoVPC) + ukIznosPDVvpc - zaNaplatuVPC)
                    na dokumentu je veća od 0,02 kn. Razlika je:' . number_format($razlika,2,',','')
                  . ' za dokument ' . $proda . ' ' . $vrsDo . ' ', $proIn . ' ' . $zapis . ' ' . $broDo . ' ' . $verzi . ' ' . '<br>';
            } else {
                // manje od 0,03
               $zbroj['iznosBezPDVbruto'] = $zbroj['iznosBezPDVbruto'] - $razlika;               
            }    
        }    
     }
  }
 // echo 'casascVPC=' . $zbroj['iznosCasasScontoVPC'] . '<br>';
 // echo 'casasc=' . $zbroj['iznosCasasSconto'] . '<br>';
  return  $zbroj;
}

function get_pregledi_dokumenata($kodPoslovnice,$vrsDo,$zapis,$verzi,$DVOod,$DVOdo,
    $valutaOd,$valutaDo,$partner,$nacinPlacanja,$PDVstatus,$brojNarudzbe,$vrstaOperatera,
    $refProd,$samoKartice=false,$cijeliDokIliRU='',$kreiraRaster=false,$knjigovodstvenoKnjizenje = '',
    $zakljucavanje = '',$poFiskalizaciji='',$zemljaPartnera='', $zavrseniDokumenti='Svi', $pokrajina) {
 
    global $db;
    $DVO_o = new DateTime($DVOod);
    $DVOod = $DVO_o->format("Y-m-d H:i:s");
    $DVO_o2 = new DateTime($DVOdo);
    $DVOdo = $DVO_o2->format("Y-m-d H:i:s");
    //echo 'DVOod=' . $DVOod . ' dvoDO=' . $DVOdo;
    /*
    if (trim($refProd)!='' ) {
        $operater = get_admin_by_skracenica ($refProd);       // skraćenica ne mora biti jedinstvena ? 
        $OIB = $operater['OIB'];
        $email=$operater['email'];
    } else {
        $OIB = '';
        $email='';
    }
    */
    
    $whereRefProf ='';
    if (trim($refProd)!='' && $_SESSION['admin']['prioritet']!=9) {
        $operater = get_admin_by_OIB($refProd);
        switch ($vrstaOperatera) {
        case 'refProd':
            $whereRefProf = "AND refProd = '$refProd'";
            break;
        case 'Komercijalista':
            $skracenica = $operater['skracenica'];
            $whereRefProf = "AND komercijalista = '$skracenica'";
            break;
        case 'kreirao':
           $email=$operater['email'];
           $whereRefProf = "AND tkoJeKreirao = '$email'";
       }
    }
    
    $sqlZaPartnera='';
    if(trim($zemljaPartnera)!='' || $pokrajina!='') {
        $sqlZaPartnera = "INNER JOIN partner as pa ON pa.kodPartnera=z.kodPartnera ";
        if(trim($zemljaPartnera)!='') 
            $sqlZaPartnera .= "and pa.zemlja='$zemljaPartnera'";
        if($pokrajina!='') 
            $sqlZaPartnera .= " and pa.pokrajina='$pokrajina'";
    }    

    /* ako je kreiraRaster true i vrsdo=3 (zapisnik) i zapisnik je prazan
     * obrađuju se NC KN PC i SC zapisnici iako su kao odabrani svi                         
     */
      
    $http_host = $_SERVER['HTTP_HOST'];
    if ($http_host === 'www.panex-agm.com' || $http_host === 'panex-agm.com' ) {    
       $admDbname = 'panex_robno_mur.administrators'; 
    } else {      
       $admDbname = 'murskiga_robno_mur.administrators'; 
    }
    
    if($_SESSION['admin']['prioritet']==9 && trim($_SESSION['admin']['punkt'])!= '') {
        $punkt=$_SESSION['admin']['punkt'];
         if (isset($_SESSION['admin']['kodPartneraORG']) and $_SESSION['admin']['kodPartneraORG'] = '701') {   
             $punkt='';  // da trgovački putnik vidi dokumente b2b korisnika
         } 
    }  else {
        $punkt='';
    }    

    if ($kreiraRaster ===true && trim($vrsDo) == '3' && trim($zapis) == '' ) {
        $query = "
        SELECT proda, vrsDo, proIn, zapis, broDo, verzi, DVO, valuta, iznosKartice, vrstaKartice, z.kodPartnera, brojNarudzbe, tkoJeKreirao,
        PDVstatus, zavrsen, ifnull(refProd,'') as refProd, z.tkoJeIzmjenio, prodaVezni, vrsDoVezni, proInVezni, zapisVezni, broDoVezni, verziVezni, 
        iznosUstranojValuti, stranaValuta, komercijalista,privremeniDokument 
        FROM dok_zag as z  
        WHERE (proda = :proda or :proda = '0')  AND vrsDo = :vrsDo
   
        AND (zapis = 'KN' or zapis = 'NC' or zapis = 'PC' or zapis = 'SC') AND (DVO >= :DVOod AND DVO <= :DVOdo)
        AND (z.kodPartnera = :kodPartnera or trim(:kodPartnera)='')
        AND (verzi = :verzi or upper(:verzi)='SVE')
        AND (z.zavrsen = :zavrseniDokumenti or :zavrseniDokumenti='Svi')
        AND (PDVstatus = :PDVstatus or :PDVstatus='S')
        AND (:samoKartice = false or iznosKartice <> 0)
        AND (:zakljucavanje = '' or :zakljucavanje = 'zakljucavanje' or :zakljucavanje = 'otkljucavanje'
             or (:zakljucavanje = 'nezakljucani' and datumZakljucavanja is NULL)  
             or (:zakljucavanje = 'zakljucani' and datumZakljucavanja is not NULL) ) 
        AND (brojNarudzbe = :brojNarudzbe or trim(:brojNarudzbe)='')  
        AND (:poFiskalizaciji is not NULL)  
        $whereRefProf
        ORDER BY proda, broDo";
    } else if($samoKartice) {    
        $query = "
        SELECT z.proda, z.vrsDo, z.proIn, z.zapis, z.broDo, z.verzi, DVO, z.valuta, brojNarudzbe,
            if(z.vrstaKartice like 'VI%E KARTICA', k.`vrstaRateKartice`, z. vrstaKartice) as vrstaKartice,
            if(z.vrstaKartice like 'VI%E KARTICA', k.`iznosRateKartice`, z. iznosKartice) as iznosKartice,
            z.kodPartnera, PDVstatus, zavrsen, ifnull(refProd,'') as refProd, tkoJeKreirao,
            z.tkoJeIzmjenio, prodaVezni, vrsDoVezni, proInVezni, zapisVezni, broDoVezni, verziVezni, iznosUstranojValuti, 
            stranaValuta, komercijalista, privremeniDokument
        FROM dok_zag as z
        left outer join rate_kartice as k 
        on k.proda=z.proda and k.vrsDo=z.`vrsDo` and k.`proIn`=z.`proIn` 
        and k.zapis=z.zapis and k.`broDo`=z.`broDo` and k.verzi=z.verzi
        $sqlZaPartnera
        WHERE (z.proda = :proda or :proda = '0')  AND z.vrsDo = :vrsDo
        AND (z.zapis = :zapis or trim(:zapis)='')  AND (DVO >= :DVOod AND DVO <= :DVOdo)
        AND (z.kodPartnera = :kodPartnera or trim(:kodPartnera)='')
        AND (z.verzi = :verzi or upper(:verzi)='SVE')
        AND (z.zavrsen = :zavrseniDokumenti or :zavrseniDokumenti='Svi')
        AND (PDVstatus = :PDVstatus or :PDVstatus='S')
        AND (@samoKartice = false or iznosKartice <> 0)
        AND (:zakljucavanje = '' or :zakljucavanje = 'zakljucavanje' or :zakljucavanje = 'otkljucavanje'
             or (:zakljucavanje = 'nezakljucani' and datumZakljucavanja is NULL)  
             or (:zakljucavanje = 'zakljucani' and datumZakljucavanja is not NULL) ) 
             
        AND (:poFiskalizaciji = '' 
             or (:poFiskalizaciji = 'neFisk' and zastitniKod is NULL)  
             or (:poFiskalizaciji = 'djeFisk' and (zastitniKod is not NULL and JIR is NULL) )
             or (:poFiskalizaciji = 'potFisk' and (zastitniKod is not NULL and JIR is not NULL) )
             or (:poFiskalizaciji = 'nakFisk' and (zastitniKod is not NULL and JIR is not NULL and TIMESTAMPDIFF(MINUTE,DVO,datumIvrijemeJIR) >= 10 ) )             
             or (:poFiskalizaciji = 'redFisk' and (zastitniKod is not NULL and JIR is not NULL and TIMESTAMPDIFF(MINUTE,DVO,datumIvrijemeJIR) < 10 ) ) )             
        AND (brojNarudzbe = :brojNarudzbe or trim(:brojNarudzbe)='')     
        $whereRefProf
        ORDER BY z.proda, z.broDo
        ";
    } else {    
        $query = " 
        SELECT proda, vrsDo, proIn, zapis, broDo, verzi, DVO, valuta, novac, povrat, iznosTransRacun, iznosKartice, vrstaKartice, z.kodPartnera, PDVstatus, zavrsen, ifnull(refProd,'') as refProd,
               z.tkoJeIzmjenio, prodaVezni, vrsDoVezni, proInVezni, zapisVezni, broDoVezni, verziVezni, iznosUstranojValuti, stranaValuta, brojNarudzbe, 
               tkoJeKreirao, komercijalista, privremeniDokument
        FROM dok_zag as z
        LEFT OUTER JOIN $admDbname as a ON a.email=z.`tkoJeKreirao`
        $sqlZaPartnera      
        WHERE (proda = :proda or :proda = '0')  AND vrsDo = :vrsDo
        AND (zapis = :zapis or trim(:zapis)='') AND (DVO >= :DVOod AND DVO <= :DVOdo)
        AND (z.kodPartnera = :kodPartnera or trim(:kodPartnera)='')
        AND (verzi = :verzi or upper(:verzi)='SVE')
        AND (z.zavrsen = :zavrseniDokumenti or :zavrseniDokumenti='Svi')
        AND (PDVstatus = :PDVstatus or :PDVstatus='S')
        AND (:samoKartice = false or iznosKartice <> 0)
        AND (:zakljucavanje = '' or :zakljucavanje = 'zakljucavanje' or :zakljucavanje = 'otkljucavanje'
             or (:zakljucavanje = 'nezakljucani' and datumZakljucavanja is NULL)  
             or (:zakljucavanje = 'zakljucani' and datumZakljucavanja is not NULL) ) 
             
        AND (:poFiskalizaciji = '' 
             or (:poFiskalizaciji = 'neFisk' and zastitniKod is NULL)  
             or (:poFiskalizaciji = 'djeFisk' and (zastitniKod is not NULL and JIR is NULL) )
             or (:poFiskalizaciji = 'potFisk' and (zastitniKod is not NULL and JIR is not NULL) )
             or (:poFiskalizaciji = 'nakFisk' and (zastitniKod is not NULL and JIR is not NULL and TIMESTAMPDIFF(MINUTE,DVO,datumIvrijemeJIR) >= 10 ) )             
             or (:poFiskalizaciji = 'redFisk' and (zastitniKod is not NULL and JIR is not NULL and TIMESTAMPDIFF(MINUTE,DVO,datumIvrijemeJIR) < 10 ) ) )             
        AND (brojNarudzbe = :brojNarudzbe or trim(:brojNarudzbe)='')     
   --     AND (a.punkt=:punkt OR trim(:punkt)='')  
        AND (ifnull(a.punkt,'')=:punkt OR trim(:punkt)='')
        $whereRefProf
        ORDER BY proda, broDo";
    }
 //   echo nl2br($query);
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $kodPoslovnice);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':zavrseniDokumenti', $zavrseniDokumenti);
    $statement->bindValue(':DVOod', $DVOod);
    $statement->bindValue(':DVOod', $DVOod);
    $statement->bindValue(':DVOdo', $DVOdo);
    $statement->bindValue(':kodPartnera', $partner);
    $statement->bindValue(':PDVstatus', $PDVstatus);
    $statement->bindValue(':samoKartice', $samoKartice);
    $statement->bindValue(':zakljucavanje', $zakljucavanje);
    $statement->bindValue(':brojNarudzbe', $brojNarudzbe);
    $statement->bindValue(':poFiskalizaciji', $poFiskalizaciji);
    $statement->bindValue(':punkt', $punkt);
    $statement->execute();
    $dok_zags = $statement->fetchAll();
    $statement->closeCursor();
    
 //   return $dok_zags;
    $dok_zbroj_konacni = array();
    foreach ($dok_zags as $dok_zag) {
        $proda = $dok_zag['proda']; 
        $vrsDo = $dok_zag['vrsDo'];
        $proIn = $dok_zag['proIn'];
        $zapis = $dok_zag['zapis'];
        $broDo = $dok_zag['broDo'];
        $verzi = $dok_zag['verzi'];
        
        
        switch ($vrstaOperatera) {
        case 'refProd':
            $operater = get_admin_by_OIB($dok_zag['refProd']);         
            $dok_zag['skracenicaOperatera'] = isset($operater['skracenica'])?$operater['skracenica']:'';
            break;
        case 'Komercijalista':
            $dok_zag['skracenicaOperatera'] = $dok_zag['komercijalista'];
            break;
        case 'kreirao':
            $operater = get_admin_by_email($dok_zag['tkoJeKreirao']);         
            $dok_zag['skracenicaOperatera'] = isset($operater['skracenica'])?$operater['skracenica']:'';
            break;
       default :
           $dok_zag['skracenicaOperatera'] = '';
       }
        
        if ($kreiraRaster===true && trim($vrsDo)=='5' && trim($verzi)=='EV')  continue; 
        
        if($_SESSION['admin']['prioritet']=='9' && trim($_SESSION['admin']['punkt'])!='') {
 /* primjer direktor ili neki glavni komercijalista može imati punkt prazno i može vidjeti-mjenjati sve naruđbe za korisnike sa kodPartnera NPR. 2
       trgovac iz nekog dućana može imati oznaku punkta                   npr. Nedelišće-207
       drugi trgovac također može imati oznaku punkta                        Nedelišće-207
       u ovom slučaju oba trgovca mogu vidjeti, mjenjati naruđbe koje su kreirali korisnici koji imaju isti punkt
       trgovac u  dućanu u Zagrebu ima    oznaku punkta                      Zagreb-206
       trgovci iz punkta Nedelišće-207 ne vide naruđbe trgovaca iz Zagreb-206 i obrnuto   
    Ako je vrsDo = '5' onda ispituje vezni dokument(provedene narudžbe) dali je naruđbu kreirao taj korisnik ili
        drugi korisnik koji ima isti punkt(dva trgovca sa različitim emailima(accountima) u istoj trgovini mogu gledati jedan drugome DOKUMENTE)
        vrsDo=5 je kreirao domicilni korisnik   */    
            
  /* *          $email = $dok_zag['tkoJeIzmjenio']; * */  /* email(račun) onoga tko je izradio dokument */
            $email = $dok_zag['tkoJeKreirao']; 
            if (trim($vrsDo)=='5') {              
               $dok_zagVezni=get_dok_zag($dok_zag['prodaVezni'], $dok_zag['vrsDoVezni'], $dok_zag['proInVezni'], $dok_zag['zapisVezni'], $dok_zag['broDoVezni'], $dok_zag['verziVezni']); 
               if (!empty($dok_zagVezni)) $email = $dok_zagVezni['tkoJeIzmjenio'];
            }                   
           $operaterZa9 = get_admin_by_email($email);           
        }
        
        $zbroj = zbroj_po_dok($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi, $cijeliDokIliRU, $kreiraRaster);
        
        if ($cijeliDokIliRU == 'RU' && $zbroj['samoRoba'] == $zbroj['ukPoreznaOsnovica']) continue; // prikazuju se paragonci koji imaju i robu i uslugu        
        if ($zbroj['zaNaplatu'] == 0 && $cijeliDokIliRU != '' ) continue; //kod robe i usluga uzima samo ako na dokumentu postoje roba ili usluga 
        
        if($dok_zag['privremeniDokument']!='Da') {
            if ($zakljucavanje == 'zakljucavanje') {
                $query = "
                update dok_zag
                    set datumZakljucavanja = NOW()
                    WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
                    AND zapis = :zapis AND broDo = :broDo AND (verzi = :verzi OR upper(:verzi)='SVE') 
                ";
             try {   
                $statement = $db->prepare($query);
                $statement->bindValue(':proda', $proda);
                $statement->bindValue(':vrsDo', $vrsDo);
                $statement->bindValue(':proIn', $proIn);              
                $statement->bindValue(':zapis', $zapis);
                $statement->bindValue(':broDo', $broDo);    
                $statement->bindValue(':verzi', $verzi);  
                $statement->execute();   
                $statement->closeCursor();
              } catch (PDOException $e) {            
                 $error_message = 'Greška kod zaključavanja dokumenta!. <br>'.$e->getMessage();
                 display_db_error($error_message);
              }       
            }
            if ($zakljucavanje == 'otkljucavanje') {
                $query = "
                update dok_zag
                    set datumZakljucavanja = NULL
                    WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
                    AND zapis = :zapis AND broDo = :broDo AND (verzi = :verzi OR upper(:verzi)='SVE') 
                ";
             try {   
                $statement = $db->prepare($query);
                $statement->bindValue(':proda', $proda);
                $statement->bindValue(':vrsDo', $vrsDo);
                $statement->bindValue(':proIn', $proIn);              
                $statement->bindValue(':zapis', $zapis);
                $statement->bindValue(':broDo', $broDo);    
                $statement->bindValue(':verzi', $verzi);  
                $statement->execute();   
                $statement->closeCursor();
              } catch (PDOException $e) {            
                 $error_message = 'Greška kod otključavanja dokumenta!. <br>'.$e->getMessage();
                 display_db_error($error_message);
              }
            }        
        }        
               
        $dok_zag['iznosRabatPopust'] = $zbroj['iznosRabatPopust'];
        $dok_zag['iznosRabatPopustVPC'] = $zbroj['iznosRabatPopustVPC'];
        $dok_zag['iznosCasasSconto'] = $zbroj['iznosCasasSconto'];
        $dok_zag['iznosCasasScontoVPC'] = $zbroj['iznosCasasScontoVPC'];
        $dok_zag['iznosBezPDVbruto'] = $zbroj['iznosBezPDVbruto'];
        $dok_zag['ukPoreznaOsnovica'] = $zbroj['ukPoreznaOsnovica'];
        $dok_zag['ukPoreznaOsnovicaVPC'] = $zbroj['ukPoreznaOsnovicaVPC'];
        $dok_zag['ukIznosPDV'] = $zbroj['ukIznosPDV'];
        $dok_zag['ukIznosPDVvpc'] = $zbroj['ukIznosPDVvpc'];
        $dok_zag['zaNaplatu'] = $zbroj['zaNaplatu'];
        $dok_zag['zaNaplatuVPC'] = $zbroj['zaNaplatuVPC'];
        $dok_zag['iznosNabavnaCijena'] = $zbroj['iznosNabavnaCijena'];
        $dok_zag['iznosMarza'] = $zbroj['iznosMarza'];
        $dok_zag['iznosZavisniTroskovi'] = $zbroj['iznosZavisniTroskovi'];
        $dok_zag['vrstaPoslovnice'] = $zbroj['vrstaPoslovnice'];
        $dok_zag['iznosSpdvBruto'] = $zbroj['iznosSpdvBruto'];
        $dok_zag['ukUkalkuliraniPDV'] = $zbroj['ukUkalkuliraniPDV'];
        $dok_zag['samoRoba'] = $zbroj['samoRoba'];
        $dok_zag['samoUsluga'] = $zbroj['samoUsluga'];    
        $dok_zag['PDVsamoUsluga'] = $zbroj['PDVsamoUsluga']; 
        $dok_zag['samoRobaUkalkuliraniPDV'] = $zbroj['samoRobaUkalkuliraniPDV'];
 /*       $OIB = $dok_zag['refProd'];
        $operater = get_admin_by_OIB($OIB);
        $skracenica = $operater['skracenica'];
        $dok_zag['skracenicaOperatera'] = $skracenica; */
                
  /* *      $email = $dok_zag['tkoJeIzmjenio']; * */  /* email(račun) onoga tko je izradio dokument */
        // $email = $dok_zag['tkoJeKreirao'];
        // $operater = get_admin_by_email ($email);         
        // $dok_zag['skracenicaOperatera'] = $operater['skracenica'];
        
        
        
        $dok_zbroj_konacni[] = $dok_zag;  //doda na kraj
    }
    return $dok_zbroj_konacni;
}

function update_dok_zag_JIR_ZKI($JIR,$ZKI, $komentar) {
    global $db;
    // echo 'zki=' . $ZKI . ' JIR=' . $JIR . '<BR/>';
	$proda = $_SESSION['odabranaPoslovnica'];
	$vrsDo = $_SESSION['dok_zag']['vrsDo'];
	$proIn = $_SESSION['dok_zag']['proIn'];
	$zapis = $_SESSION['dok_zag']['zapis']; 
	$broDo = $_SESSION['dok_zag']['broDo'];
	$verzi = $_SESSION['dok_zag']['verzi']; 
        if ($JIR === NULL) {
            $datumIvrijemeJIR = NULL;
        } else { 
	    $datum_o = new DateTime();
	    $datumIvrijemeJIR = $datum_o->format("Y-m-d H:i:s");
	}
    $query = '
        UPDATE dok_zag
        SET JIR = :JIR, 
            zastitniKod = :ZKI, 
            komentar = concat(komentar, :komentar),
            datumIvrijemeJIR = :datumIvrijemeJIR,
            valuta = DVO
        WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi';
    try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
	$statement->bindValue(':JIR', $JIR);
	$statement->bindValue(':ZKI', $ZKI);
	$statement->bindValue(':komentar', $komentar);
        $statement->bindValue(':datumIvrijemeJIR', $datumIvrijemeJIR);
        $statement->execute();
	$rowCount = $statement->rowCount();
	$statement->closeCursor();
	return $rowCount;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
}
/// makar
function razrada_po_stopi($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    global $db;
    $query = 
        "
        SELECT PDV, sum(kolicina) as kolicina, sum(s.cijena) as cijena, 
        sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2)) as zaplatit, 

        sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'pdv'),2)) as PDVIznos, 
        sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'osnovica'),2)) as osnovica, 
        sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabat'),2)) as rabat,
        sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabatnakol'),2)) as rabatNaKol

        FROM dok_zag as z

        left outer join dok_stavke as s on s.proda=z.proda and s.vrsDo=z.vrsDo and s.proIn=z.proIn 
            and s.zapis=z.zapis and s.broDo=z.broDo and s.verzi=z.verzi
        left outer join  poslovnice as p on p.kodPoslovnice=z.proda

        WHERE z.proda = :proda AND z.vrsDo = :vrsDo AND z.proIn = :proIn
	AND z.zapis = :zapis AND z.broDo = :broDo AND z.verzi = :verzi
        GROUP BY PDV";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->execute();
    $dok_po_stopi = $statement->fetchAll();
    $statement->closeCursor();
    return $dok_po_stopi;
}    

function get_ukupno_po_dokumentima($proda, $vrsDo, $DVOod, $DVOdo, $refProd, $kasa, $nacinPlacanja, $nezavrseni) {
    global $db;
    if ($nezavrseni)
        $sqlNezavrseni = " And z.verzi='NZV'";
    else
        $sqlNezavrseni = " And z.verzi<>'NZV'";

    $query = "
            select 
            z.proda,  
            z.vrsDo,
            z.broDo,
            z.verzi,
          
            sum(kolicina) as kolicina, 
            if(:vrsDo='4',sum(round(-kolicina*s.nabavnaCijena,2)),
              sum(round(kolicina*s.cijena,2))) as osnovica, 
            if(:vrsDo='4',0,
              sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'pdv'),2)))
             as PDVIznos, 
            if(:vrsDo='4',0, 
              sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabat'),2))) as rabat, 
            if(:vrsDo='4',sum(round(-kolicina*s.nabavnaCijena,2)),
              sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2))) as ukupno,
            if(:vrsDo='4',sum(round(-kolicina*s.nabavnaCijena,2)), (z.novac - z.povrat )) as novac,
            z.iznosTransRacun,
            if(:vrsDo='4',0,
              sum( if(r.robaUsluga='U', round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'pdv'),2),0))) as PDVIznosUsl, 
           if(:vrsDo='4',0,   
            sum( if(r.robaUsluga='U', round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabat'),2),0))) as rabatUsl,
           if(:vrsDo='4',0,   
            sum( if(r.robaUsluga='U', round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0))) as ukupnoUsl,
            z.rucniParagonac
            from dok_stavke as s
            left outer join dok_zag as z 
            on z.proda=s.proda and z.vrsDo=s.`vrsDo` and z.`proIn`=s.`proIn` 
            and z.zapis=s.zapis and z.`broDo`=s.`broDo` and z.verzi=s.verzi
            left outer join  poslovnice as p on p.kodPoslovnice=z.proda
            left outer join maticna_robe as r on  r.kodRobe=s.kodRobe

            where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
            and ( z.vrsDo=:vrsDo or trim(:vrsDo)='')
            and z.DVO between :DVOOd and :DVODo
            and (z.refProd=:refProd or trim(:refProd)='')
            and (z.kasa=:kasa or trim(:kasa)='')
            and (trim(:nacinPlacanja)='' or (:nacinPlacanja='N' and iznosKartice=0) or (:nacinPlacanja='K' and iznosKartice<>0))
            and (zastitniKod is not null or :vrsDo='4' or :vrsDo=8)
            $sqlNezavrseni

            group by
            z.proda,  
            z.vrsDo,
            z.broDo,
            z.verzi,
            z.novac,
            z.povrat
            ";
    $DVO_o = new DateTime($DVOod);
    $DVO_o2 = new DateTime($DVOdo);

    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':refProd', $refProd);
    $statement->bindValue(':kasa', $kasa);
    $statement->bindValue(':nacinPlacanja', $nacinPlacanja);
    $statement->execute();
    $dokumenti = $statement->fetchAll();
    $statement->closeCursor();
    return $dokumenti;
}

function get_ukupno_po_vkc($proda, $vrsDo, $DVOod, $DVOdo, $refProd, $kasa, $nacinPlacanja) {
    global $db;
    $query = "
        select
        z.vrstaKartice, 
        nazivKarticeCeka,
        sum(z.iznosKartice) as iznosKartice 
        from 
        ( 
            select 
            if(z.vrstaKartice like 'VI%E KARTICA', k.`vrstaRateKartice`, z. vrstaKartice) as vrstaKartice,
            if(z.vrstaKartice like 'VI%E KARTICA', k.`iznosRateKartice`, z. iznosKartice) as iznosKartice
            from dok_zag as z
            left outer join rate_kartice as k 
            on k.proda=z.proda and k.vrsDo=z.`vrsDo` and k.`proIn`=z.`proIn` 
            and k.zapis=z.zapis and k.`broDo`=z.`broDo` and k.verzi=z.verzi
            where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
            and ( z.vrsDo=:vsrDo or trim(:vsrDo)='')
            and z.DVO between :DVOOd and :DVODo
            and (z.refProd=:refProd or trim(:refProd)='')
            and (z.kasa=:kasa or :kasa=0)
            and (trim(:nacinPlacanja)='' or (:nacinPlacanja='N' and iznosKartice=0) or (:nacinPlacanja='K' and iznosKartice<>0))
            and z.iznosKartice<>0
            and z.verzi<>'NZV'
        ) as z
        left outer join v_k_c on v_k_c.vrsKart=z.vrstaKartice 
        group by
        z.vrstaKartice,
        nazivKarticeCeka
            ";
    $DVO_o = new DateTime($DVOod);
    $DVO_o2 = new DateTime($DVOdo);

    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vsrDo', $vrsDo);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':refProd', $refProd);
    $statement->bindValue(':kasa', $kasa);
    $statement->bindValue(':nacinPlacanja', $nacinPlacanja);
    $statement->execute();
    $dokumenti = $statement->fetchAll();
    $statement->closeCursor();
    return $dokumenti;
}

function get_ukupno_po_stopi($proda, $vrsDo, $DVOod, $DVOdo, $refProd, $kasa, $nacinPlacanja, $vrstaRobe = '', $samoFiskalizirani = 'Ne') {
    global $db;
    $query = "
            SELECT z.proda, PDV, sum(kolicina) as kolicina, sum(s.cijena) as cijena, 
            sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2)) as zaplatit, 
            sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'pdv'),2)) as PDVIznos, 
            sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'osnovica'),2)) as osnovica, 
            sum(round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabat'),2)) as rabat
            from dok_stavke as s
            left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
                and z.broDo=s.broDo and z.proIn=s.proIn and z.zapis=s.zapis and z.verzi=s.verzi
            left outer join  poslovnice as p on p.kodPoslovnice=z.proda    
            left outer join maticna_robe as r on  r.kodRobe=s.kodRobe
            left outer join vrste_dokumenata as v on  v.vrsDo=z.vrsDo


            where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
            and ( z.vrsDo=:vrsDo or trim(:vrsDo)='')
            and z.DVO between :DVOOd and :DVODo
            and (z.refProd=:refProd or trim(:refProd)='')
            and (z.kasa=:kasa or :kasa=0)
            and (trim(:nacinPlacanja)='' or (:nacinPlacanja='N' and iznosKartice=0) or (:nacinPlacanja='K' and iznosKartice<>0))
            and (:vrstaRobe='' or r.robaUsluga=:vrstaRobe)
            and (zastitniKod is not null or :vrsDo='4' or :samoFiskalizirani<>'Da')
            and (v.fiskalizacija='Da' or :samoFiskalizirani<>'Da')
            and z.verzi<>'NZV'
            
            group by
            z.proda,
            PDV
            ";
    $DVO_o = new DateTime($DVOod);
    $DVO_o2 = new DateTime($DVOdo);

    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':refProd', $refProd);
    $statement->bindValue(':kasa', $kasa);
    $statement->bindValue(':nacinPlacanja', $nacinPlacanja);
    $statement->bindValue(':vrstaRobe', $vrstaRobe);
    $statement->bindValue(':samoFiskalizirani', $samoFiskalizirani);
    $statement->execute();
    $dokumenti = $statement->fetchAll();
    $statement->closeCursor();
    return $dokumenti;
}

function get_dokumente_za_fiskalizciju($proda, $vrsDo, $DVOod, $DVOdo, $refProd, $kasa, $nacinPlacanja) {
    global $db;
    $query = "
            select 
            z.proda,  
            z.vrsDo,
            z.broDo

            from dok_stavke as s
            left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
                and z.broDo=s.broDo and z.proIn=s.proIn and z.zapis=s.zapis and z.verzi=s.verzi
            left outer join vrste_dokumenata as v on  v.vrsDo=z.vrsDo
            where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
            and ( z.vrsDo=:vsrDo or trim(:vsrDo)='')

            and z.DVO between :DVOOd and :DVODo
            and (z.refProd=:refProd or trim(:refProd)='')
            and (z.kasa=:kasa or trim(:kasa)='')
            and (trim(:nacinPlacanja)='' or (:nacinPlacanja='N' and iznosKartice=0) or (:nacinPlacanja='K' and iznosKartice<>0))
            and (zastitniKod is not null or z.vrsDo='8') 
            and (trim(JIR)='' or JIR is null)
            and v.fiskalizacija='Da'
            and z.verzi<>'NZV'
            
            group by
            z.proda,  
            z.vrsDo,
            z.broDo
            ";
    $DVO_o = new DateTime($DVOod);
    $pocetak = new DateTime('2013-04-01 00:00:00');
    //var_dump($DVO_o<$pocetak);
    if ($DVO_o < $pocetak)
        $DVO_o = $pocetak;
    $DVO_o2 = new DateTime($DVOdo);

    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vsrDo', $vrsDo);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':refProd', $refProd);
    $statement->bindValue(':kasa', $kasa);
    $statement->bindValue(':nacinPlacanja', $nacinPlacanja);
    $statement->execute();
    $dokumenti = $statement->fetchAll();
    $statement->closeCursor();
    return $dokumenti;
}

/*
function rekonstrukcija_stanja($proda,$DVOdo) {
   global $db;
   $dodano_stavki = 0;
   $DVOod = '01.04.2013';
   $DVO_o = new DateTime($DVOod);
   $DVOod = $DVO_o->format("Y-m-d H:i:s");
    $DVO_o2 = new DateTime($DVOdo);
    $DVOdo = $DVO_o2->format("Y-m-d H:i:s");
 //echo 'DVOod=' . $DVOod . ' dvoDO=' . $DVOdo;
    $vrsDo = '1 ';
    $query = 'SELECT proda, vrsDo, proIn, zapis, broDo, verzi, DVO, kodPartnera  
        FROM dok_zag WHERE (proda = :proda AND vrsDo = :vrsDo
    AND DVO >= :DVOod    AND DVO <= :DVOdo)';
    
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':DVOod', $DVOod);
    $statement->bindValue(':DVOdo', $DVOdo);
    $statement->execute();
    $dok_zags = $statement->fetchAll();
    $statement->closeCursor();
 //   return $dok_zags;
// echo 'U obradi su dokumenti:';  
 foreach ($dok_zags as $dok_zag) {
    $proda = $dok_zag['proda'];
    $vrsDo = $dok_zag['vrsDo'];
    $proIn = $dok_zag['proIn'];
    $zapis = $dok_zag['zapis'];
    $broDo = $dok_zag['broDo'];
    $verzi = $dok_zag['verzi'];
    $DVO = $dok_zag['DVO'];
    $kodPartneraPu = $dok_zag['kodPartnera'];
    echo ' ' . $proda . $vrsDo . $proIn . $zapis . $broDo . $verzi;
    $query = 'SELECT *
    FROM dok_stavke WHERE  proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
    AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi ';
    try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':verzi', $verzi);
        $statement->execute();
        $stavke = $statement->fetchAll();
        $statement->closeCursor();
     // return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    
    foreach ($stavke as $stavka) {
           $kodRobe = $stavka['kodRobe'];
           $vrstaProdaje = $stavka['vrstaProdaje'];
	   $cijena = $stavka['cijena'];
	   $kolicina = $stavka['kolicina'];
           $rabatPopust = $stavka['rabatPopust']; 
	   $absRabatPopust = $stavka['absRabatPopust'];
	   $nabavnaCijenaPu = $stavka['nabavnaCijena']; 
           $marzaPu = $stavka['marza'];	
           $absMarzaPu = $stavka['absMarza'];
	   $zavisniTroskoviPu = $stavka['zavisniTroskovi'];
	   $absZavisniTroskoviPu = $stavka['absZavTr'];
        
    $rowCount =  azuriranje_stanja($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$DVO,$kodPartneraPu,$kodRobe,$vrstaProdaje,$cijena,$kolicina,$rabatPopust,$absRabatPopust,
    $nabavnaCijenaPu,$marzaPu,$absMarzaPu,$zavisniTroskoviPu,$absZavisniTroskoviPu);     
    if ($rowCount == 1) $dodano_stavki ++;
    
   }
 }
  return $dodano_stavki;
}
*/

function rekonstrukcija_stanja($proda,$DVOdo,$privremeniDokumenti) {
    global $db;
    $DVO_o2 = new DateTime($DVOdo);
    $DVOdo_okr = $DVO_o2->format("Y-m-d H:i:s");

    $query = "
        insert into stanja
         (proda, stanja.`kodRobe`, `vrstaProdaje`, stanja.cijena, stanje, `datumOtvaranja`, `tkoJeIzmjenio` )
        select proda, s.kodrobe, `vrstaProdaje`, s.cijena , 0 as stanje, now(), 'rekonstrukcija'
        from dok_stavke as s
        left outer join vrste_dokumenata as v on v.`vrsDo`=s.`vrsDo`
        inner join poslovnice as p on p.`kodPoslovnice`=s.`proda`
        -- left outer join maticna_robe as m on m.kodrobe=s.`kodRobe`
        where (v.`tipDokumenta` ='R' and s.`DVO`>=p.`datumInventure`)
        -- and m.robaUsluga='R'
        and s.kodrobe not in
            (
                select st.`kodRobe`
                from stanja as st
                where st.proda=s.proda and st.`kodRobe`=s.`kodRobe` and st.`vrstaProdaje`=s.`vrstaProdaje` and st.cijena=s.cijena
            )
        and (s.proda=:proda or :proda='0')
        and s.DVO<=:DVODo
        group by proda, s.kodrobe, `vrstaProdaje`, s.cijena       
        ";
    
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':DVODo', $DVOdo_okr);
    $statement->execute();
    $statement->closeCursor();

    $query = "
        update stanja
        set stanje=0
        where proda=:proda or :proda='0'
        ";
    
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->execute();
    $statement->closeCursor();
    
   $query = "
update stanja as st
left outer join
(
select 
    st.proda, 
    st.kodrobe, 
    st.vrstaProdaje, 
    st.cijena, 
    ifnull(sum(ifnull(s.kolicina * v.`azurStanja`,0)),0) as stanje
from dok_stavke as s
left outer join vrste_dokumenata as v on v.`vrsDo`=s.`vrsDo`
join dok_zag as z 
  on z.proda=s.proda and z.vrsDo=s.`vrsDo` and z.`proIn`=s.`proIn` 
  and z.zapis=s.zapis and z.`broDo`=s.`broDo` and z.verzi=s.verzi
-- left outer join maticna_robe as m on m.kodrobe=s.`kodRobe`
inner join stanja as st
 on st.proda=s.proda and st.`kodRobe`=s.`kodRobe` and st.`vrstaProdaje`=s.`vrstaProdaje` and st.cijena=s.cijena
inner join poslovnice as p on s.proda=p.kodPoslovnice  
where v.`tipDokumenta` ='R'
-- and m.`robaUsluga`='R'
and s.`DVO`>=p.datumInventure
and (s.proda=:proda or :proda='0')
and (z.privremeniDokument<>'Da' or z.privremeniDokument is null or :privremeniDokumenti='Da')
and s.DVO<=:DVODo

group by st.proda, st.kodrobe, st.`vrstaProdaje`, st.cijena
)
 as s2 on s2.proda=st.proda and s2.`kodRobe`=st.`kodRobe` and s2.`vrstaProdaje`=st.`vrstaProdaje` and s2.cijena=st.cijena

set st.stanje= ifnull(s2.stanje,0) + ifnull(kolicinaInventure,0),
    st.datumIzmjene=now(),
    st.tkoJeIzmjenio='rekonstrukcija' 
        ";
    
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':DVODo', $DVOdo_okr);
    $statement->bindValue(':privremeniDokumenti', $privremeniDokumenti);
    $statement->execute();
    $brojSlogova=$statement->rowCount();
    $statement->closeCursor();
    return 'Obrađeno:'.$brojSlogova.' slogova.';
}    
function rekonsrukcija_vrsDoPu_vrsDoPi() {
    global $db;

    $query = "
/* ulazi */
UPDATE stanja as st
join
(  
SELECT s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, 
s.`rabatPopust`,s.`absRabatPopust`, s.marza,s.`absMarza`,s.`zavisniTroskovi`,s.`absZavTr`, s.`nabavnaCijena`, z.kodPartnera, z.`DVO`  
FROM dok_stavke as s
join
(
SELECT s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena,  
max(s.DVO) as datum 
FROM dok_stavke as s
JOIN vrste_dokumenata AS vd ON vd.`vrsDo`=s.`vrsDo`
WHERE vd.`azurStanja`=1
GROUP BY s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena
) as s2 on s2.proda=s.proda and s2.`kodRobe`=s.`kodRobe` and s2.cijena=s.cijena and s2.datum=s.DVO
JOIN vrste_dokumenata AS vd ON vd.`vrsDo`=s.`vrsDo`
join dok_zag as z 
  on z.proda=s.proda and z.vrsDo=s.`vrsDo` and z.`proIn`=s.`proIn` 
  and z.zapis=s.zapis and z.`broDo`=s.`broDo` and z.verzi=s.verzi

WHERE vd.`azurStanja`=1

)
as s on s.proda=st.proda and s.kodRobe=st.kodRobe and s.vrstaProdaje=st.`vrstaProdaje` and s.cijena=st.cijena 
set
    st.`vrsDoPu`=s.vrsDo,
    st.`proInPu`=s.proIn,
    st.`zapisPu`=s.zapis,
    st.`broDoPu`=s.broDo,
    st.`verziPu`=s.verzi,
    st.`datumPu`=s.DVO,
    st.`rabatPu`=s.rabatPopust,
    st.`absRabatPu`=s.`absRabatPopust`, 
    st.`marzaPu`=s.marza,
    st.`absMarzaPu`=s.`absMarza`,
    st.zavisniTroskoviPu=s.zavisniTroskovi,
    st. absZavisniTroskoviPu=s.absZavTr, 
    st.nabavnaCijenaPu=s.`nabavnaCijena`, 
    st.kodPartneraPu=s.kodPartnera
        ";
    
    $statement = $db->prepare($query);
    $statement->execute();
    $brojSlogova=$statement->rowCount();
    $statement->closeCursor();

    
   $query = "
/* izlazi */
UPDATE stanja as st
join
(  
SELECT s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena, s.vrsDo, s.proIn, s.zapis, s.broDo, s.verzi, 
s.`rabatPopust`,s.`absRabatPopust`, s.marza,s.`absMarza`,s.`zavisniTroskovi`,s.`absZavTr`, s.`nabavnaCijena`, z.kodPartnera, z.`DVO`  
FROM dok_stavke as s
join
(
SELECT s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena,  
max(s.DVO) as datum 
FROM dok_stavke as s
JOIN vrste_dokumenata AS vd ON vd.`vrsDo`=s.`vrsDo`
WHERE vd.`azurStanja`=-1
GROUP BY s.proda, s.kodRobe, s.`vrstaProdaje`, s.cijena
) as s2 on s2.proda=s.proda and s2.`kodRobe`=s.`kodRobe` and s2.cijena=s.cijena and s2.datum=s.DVO
JOIN vrste_dokumenata AS vd ON vd.`vrsDo`=s.`vrsDo`
join dok_zag as z 
  on z.proda=s.proda and z.vrsDo=s.`vrsDo` and z.`proIn`=s.`proIn` 
  and z.zapis=s.zapis and z.`broDo`=s.`broDo` and z.verzi=s.verzi

WHERE vd.`azurStanja`=-1

)
as s on s.proda=st.proda and s.kodRobe=st.kodRobe and s.vrstaProdaje=st.`vrstaProdaje` and s.cijena=st.cijena 
set
    st.`vrsDoPi`=s.vrsDo,
    st.`proInPi`=s.proIn,
    st.zapisPi=s.zapis,
    st.`broDoPu`=s.broDo,
    st.`verziPi`=s.verzi,
    st.`datumPi`=s.DVO,
    st.`rabatPopustPi`=s.rabatPopust,
    st.`absRabatPopustPi`=s.`absRabatPopust`
        ";
    
    $statement = $db->prepare($query);
    $statement->execute();
    $brojSlogova=$statement->rowCount();
    $statement->closeCursor();
    return 'Obrađeno:'.$brojSlogova.' slogova.';
}    
    
function osnovicaPoStopi($pdvStavka)
{
    if($pdvStavka['rabat']!=0)
        $osnovica = $pdvStavka['osnovica'] - $pdvStavka['rabat']/(1+$pdvStavka['PDV']/100);
    else
        $osnovica = $pdvStavka['osnovica'];
    return $osnovica;
}

// makar 5.4.2013

function get_knjigu_popisa($proda,$vrsDo,$verzi,$DVOod,$DVOdo,$kodPartnera,$donosDaNe,$privremeniDokumenti='Ne') {
    global $db, $zapis;
    ini_set('max_execution_time', 300);
    $query = "
select 
kodPoslovnice as proda, datumInventure as DVO, 0 as vrsDo, 'INVENTURA' as nazivDokumenta, 0 as broDo, ' ' as nazivPartnera,
'' as zapis,
'' as proIn,
'' as verzi,
vrstaPoslovnice,
if(vrstaPoslovnice=1,iznosInvSaPDV,`iznosInvBezPDV`) as zaduzenje,
0 as razduzenje, 0 as rabat, 0 as ukupnoUsl
from poslovnice
where (kodPoslovnice=:proda or trim(:proda)='' or trim(:proda)='0') and kodPoslovnice<>'0'
and :donosDaNe='D'

union all 

select 
z.proda,
z.DVO,  
z.vrsDo,
trim(concat(vd.nazivDokumenta,' ',z.zapis,' ',z.proIn)) as nazivDokumenta,
z.broDo,
pp.nazivPartnera,
z.zapis,
z.proIn,
z.verzi,
p.vrstaPoslovnice as vrstaPoslovnice,
if(z.vrsdo='6' or (z.vrsDo='5' or z.vrsDo='PR' or z.vrsDo='7') and int5.kodPoslovnice is not null ,-1,1 )
*round(sum(if((z.vrsDo='5' or z.vrsDo='PR' or z.vrsDo='7')  and int5.kodPoslovnice is null, 0,-- ako su dokumenti razdužemja u zaduženje stavlja 0
if(p.vrstaPoslovnice=1,
    if(z.vrsDo=1 or z.zapis='K1',
        -- bez rabata
        round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,if(trim(s.zapis)='' and trim(s.vrsDo)<>'1',s.PDV,s.ukalkuliraniPDV),0,0,0,0,'zaplatit'),2),
    -- else za : z.vrsDo=1 or z.zapis='K1'
        round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,if(trim(s.zapis)='',s.PDV,s.ukalkuliraniPDV),
           rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2)
    ),
    -- else za: p.vrstaPoslovnice=1
    round(kolicina*s.cijena,4)
)
)),2) as zaduzenje, 

round(sum(if((z.vrsDo='5' or z.vrsDo='PR' or z.vrsDo='7')  and int5.kodPoslovnice is null ,
 if(p.vrstaPoslovnice=1, 
    round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,if(trim(s.zapis)='' and s.PDV<>0,s.PDV,s.ukalkuliraniPDV),rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2), 
    round(kolicina*s.cijena,4)),
 0)),2) as razduzenje, 
-- popust se računa samo na maloprodaji uključujući sve zapisnike osim 'K1'
sum(if(((z.vrsDo='5' or z.vrsDo='PR') or (z.vrsdo='3' and trim(z.zapis)<>'K1')) and p.vrstaPoslovnice=1,
    if(r.robaUsluga='U',0,round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabat'),2))
       ,0)) as popust,
/*
-- usluge s uključenim popustom
sum( if(r.robaUsluga='U', round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,if(p.vrstaPoslovnice=0,0,PDV),
        if(z.vrsDo=1, 0, rabatPopust),
        if(z.vrsDo=1, 0,absRabatPopust),
        if(z.vrsDo=1, 0,rabatPopustNaKol),
        if(z.vrsDo=1, 0,absRabatPopustNaKol),'zaplatit'),2),0)) as ukupnoUsl
*/        
-- usluge bez umanjnog popusta
sum( if(r.robaUsluga='U', round( s.cijena*kolicina*(if(p.vrstaPoslovnice=0,1,1+PDV/100)),2),0)) as ukupnoUsl

from dok_stavke as s
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.proIn=s.proIn and z.zapis=s.zapis and z.verzi=s.verzi
left outer join vrste_dokumenata as vd on vd.vrsDo=z.vrsDo
left outer join poslovnice as  p on p.kodPoslovnice=z.proda
left outer join partner as pp on pp.kodPartnera=z.kodPartnera
left outer join maticna_robe as r on  r.kodRobe=s.kodRobe
-- dali je  Interna dostavnica - kupac je jedna od poslovnica
left outer join poslovnice as  int5 on int5.kodPoslovnice=z.kodPartnera
where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and( z.vrsDo in ('1','2','3','4','5','6','7','PR') and (trim(:vrsDo)='' or z.vrsDo=:vrsDo))
and (z.zapis=:zapis or :zapis='')
and (z.verzi=:verzi or trim(:verzi)='')
and (z.kodPartnera=:kodPartnera or :kodPartnera='')
and z.DVO between :DVOOd and :DVODo
and (z.DVO>p.datumInventure or p.datumInventure is null or :donosDaNe='N')
and (:privremeniDokumenti='' or (:privremeniDokumenti='bez' and ifnull(z.privremeniDokument,'')<>'Da') 
    or (:privremeniDokumenti='p' and ifnull(z.privremeniDokument,'')='Da'))


group by
z.proda,
z.zapis,
z.proIn,
z.broDo,
z.verzi,
z.DVO,
vd.nazivDokumenta,
z.vrsDo,
z.broDo,
pp.nazivPartnera,
p.vrstaPoslovnice
 
union all


select 
z.proda,
max(z.DVO) as DVO,  
'8' as vrsDo,
'REKAPITUAR' as nazivDokumenta,
date(z.DVO) as broDo,
'Utržak' as nazivPartnera,
'' as zapis,
'' as proIn,
'' as verzi,

'1' as vrstaPoslovnice,
0 as zaduzenje,
sum(round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2))
as razduzenje, 
sum(if(r.robaUsluga='U',0,round(racunajPDV(vrstaPoslovnice,s.cijena,kolicina,PDV,rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'rabat'),2))) as popust,
/*
-- uslge s rabatom
sum( if(r.robaUsluga='U', round(racunajPDV(p.vrstaPoslovnice,s.cijena,kolicina,PDV,
         rabatPopust,absRabatPopust,rabatPopustNaKol,absRabatPopustNaKol,'zaplatit'),2),0)) as ukupnoUsl
*/
-- usluge bez uključenog rabata
sum( if(r.robaUsluga='U', round( s.cijena*kolicina*(if(p.vrstaPoslovnice=0,1,1+PDV/100)),2),0)) as ukupnoUsl
from dok_stavke as s
left outer join dok_zag as z on z.proda=s.proda and z.vrsDo=s.vrsDo 
    and z.broDo=s.broDo and z.proIn=s.proIn and z.zapis=s.zapis and z.verzi=s.verzi
left outer join vrste_dokumenata as vd on vd.vrsDo=z.vrsDo
left outer join poslovnice as  p on p.kodPoslovnice=z.proda
left outer join maticna_robe as r on  r.kodRobe=s.kodRobe

where (z.proda=:proda or trim(:proda)='' or trim(:proda)='0')
and (z.vrsDo='8' and (trim(:vrsDo)='' or :vrsDo=8))
and :zapis=''
and (z.verzi=:verzi or trim(:verzi)='')
and (z.kodPartnera=:kodPartnera or :kodPartnera='')
and z.DVO between :DVOOd and :DVODo
and (z.DVO>p.datumInventure or p.datumInventure is null or :donosDaNe='N')
and (:privremeniDokumenti='' or (:privremeniDokumenti='bez' and ifnull(z.privremeniDokument,'')<>'Da') 
    or (:privremeniDokumenti='p' and ifnull(z.privremeniDokument,'')='Da'))

group by
date(z.DVO)

order by
proda,
DVO,
nazivDokumenta,
vrsDo,
broDo

";
    $poslovnica=  get_poslovnica($proda);
    if(strlen($poslovnica['datumInventure'])>1 && $donosDaNe=='D')
        $DVO_o = new DateTime($poslovnica['datumInventure']);
    else
        $DVO_o = new DateTime($DVOod);
    $DVO_o2 = new DateTime($DVOdo);

    $statement = $db->prepare($query);
    // /*
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':DVOOd', $DVO_o->format("Y-m-d H:i:s"));
    $statement->bindValue(':DVODo', $DVO_o2->format("Y-m-d H:i:s"));
    $statement->bindValue(':donosDaNe', $donosDaNe);
    $statement->bindValue(':privremeniDokumenti', $privremeniDokumenti);
     
     // */
    $statement->execute();
    $knjiga= $statement->fetchAll();
    $statement->closeCursor();
    return $knjiga;
}

function rasterFile($firmaR,$vrstaRas,$brojProd,$brojRac,$datumValuta,$dobKup,$status,$vrstaR,$zaliha,$rabati,$iznosDobKup,
        $ukalTr,$rc,$brojRacD,$porez,$ukalPorez,$datumDVO,
        $knjigovodstvenoKnjizenje='',$brojTemeljnice=0,$vrstaPoslovnice='0',$vrsDo='',$proIn='',$zapis='',$broDo=0,$verzi='',$vrstaPartnera='0',
        $iznosUstranojValuti=0,$stranaValuta='',$carineITakse=0,$zakljucak='',$EVporez=0,
        $gk_pdv=array(),$samoUsluga=0,$PDVsamoUsluga=0) {
//$ukalTr,$rc,$brojRacD,$porez,$ukalPorez,$datumDVO,$iznosUstranojValuti=0,$stranaValuta='',$carineITakse=0,$zakljucak='',$email='',$komentar='',$EVporez=0) {   
/* knjizenje u gk_stavke a nakon toga se kreira datoteka za stare programe za Panex-conzalting i MG knjigovodstvo) */
      
    
 if ($knjigovodstvenoKnjizenje=='MGsaldaKontiNovo' || $knjigovodstvenoKnjizenje=='MGgkSkNovo' || $knjigovodstvenoKnjizenje=='MGgkNovo') {
 // MG knjigovodstvo MySQL    
 // knjiženje samo salda-konti 1200, 2200, ....(zajedničko za oba slučaja   
    if ($knjigovodstvenoKnjizenje=='MGsaldaKontiNovo' && (trim($vrsDo)=='6' || trim($vrsDo)=='2' || trim($vrsDo)=='8' || trim($vrsDo)=='7' || trim($vrsDo)=='3')) {
        echo 'Na Salda konte se ne mogu knjižiti interne fakture,paragonci,izdatnice i zapisnici, PROGRAM SE PREKIDA ';
        exit;
    } 
 /*čitanje odgovarajućeg kontnog-modula (veleprodaja-maloprodaja) i odabir konta za kontiranje) */
   $kontniModul = '20'; 
   if (trim($vrsDo)=='5' && $vrstaPoslovnice =='0') $kontniModul = '20';
   if (trim($vrsDo)=='5' && $vrstaPoslovnice =='1') $kontniModul = '201'; 
   if (trim($vrsDo)=='5U') $kontniModul = '24';    
   if ( (trim($vrsDo)=='3' && ($zapis =='NC' || $zapis =='KN' || $zapis =='PC' || $zapis =='SC')) && $vrstaPoslovnice =='0' ) $kontniModul = '85';
   if ( (trim($vrsDo)=='3' && ($zapis =='NC' || $zapis =='KN' || $zapis =='PC' || $zapis =='SC')) && $vrstaPoslovnice =='1' ) $kontniModul = '851';
   if (trim($vrsDo)=='8') $kontniModul = '35';  if ($vrstaPoslovnice =='3' && trim($vrsDo)=='8') $kontniModul = '24';
   if ( trim($vrsDo)=='K' && $vrstaPoslovnice =='0' && ($vrstaPartnera=='0' || $vrstaPartnera=='1')) $kontniModul = '10';
   if ( trim($vrsDo)=='K' && $vrstaPoslovnice =='1' && ($vrstaPartnera=='0' || $vrstaPartnera=='1')) $kontniModul = '101';
   if ( trim($vrsDo)=='K' && $vrstaPoslovnice =='0' && $vrstaPartnera=='3' ) $kontniModul = '12'; 
   if ( trim($vrsDo)=='K' && $vrstaPoslovnice =='1' && $vrstaPartnera=='3' ) $kontniModul = '121';
   if ( trim($vrsDo)=='K' && $vrstaPoslovnice =='0' && $vrstaPartnera=='7' ) $kontniModul = '13'; 
   if ( trim($vrsDo)=='K' && $vrstaPoslovnice =='1' && $vrstaPartnera=='7' ) $kontniModul = '131';
   
   if ( (trim($vrsDo)=='6' || trim($vrsDo)=='2') && $vrstaPoslovnice =='0' ) $kontniModul = '650'; 
   if ( (trim($vrsDo)=='6' || trim($vrsDo)=='2') && $vrstaPoslovnice =='1' ) $kontniModul = '651'; 

   $gledaRate = $kontniModul=='20' || $kontniModul=='201' || $kontniModul=='24';
   
   if(!function_exists('add_gk_stavku')) {
        include_once 'knjigovodstvo/model/gk_db.php';
        include_once 'knjigovodstvo/model/konta_db.php';
   }
   global $db;
   $query = 'select * from kontni_moduli where kontniModul = :kontniModul';
   $statement = $db->prepare($query);
   $statement->bindValue(':kontniModul', $kontniModul);
   $statement->execute();
   $stavkeModula = $statement->fetchAll();
   $statement->closeCursor();
   
    foreach ($stavkeModula as $sM) {    
 //financijski trocifreni konti iz kontnih modula ne moraju biti prijavljeni u kontnom planu  660 662 710
 // ali ima npr 66202 66216 66218
      $kontoD = trim($sM['kontoDugovni']); $vrstaKontaD = ''; $ideUobraduD = 'Ne';
      if ($vrstaPoslovnice =='3' && trim($vrsDo)=='8' && trim($kontoD)=='1200') $kontoD = '102';
      $kontoD_A = get_konto($kontoD);      
      if (!empty($kontoD_A)) $vrstaKontaD = $kontoD_A['vrstaKonta'];
      if (empty($kontoD_A) && strlen($kontoD) > 2) $vrstaKontaD = 'F'; /* trocifreni fin.konto ne mora postojati u kontima */
      if ( $vrstaKontaD=='S' && ($knjigovodstvenoKnjizenje=='MGsaldaKontiNovo' || $knjigovodstvenoKnjizenje=='MGgkSkNovo') ) $ideUobraduD = 'Da';
      if ( $vrstaKontaD=='F' && ($knjigovodstvenoKnjizenje=='MGgkNovo' || $knjigovodstvenoKnjizenje=='MGgkSkNovo') ) $ideUobraduD = 'Da';
      
      $kontoP = trim($sM['kontoPotrazni']); $vrstaKontaP = ''; $ideUobraduP = 'Ne';
      $kontoP_A = get_konto($kontoP);
      if (!empty($kontoP_A)) $vrstaKontaP = $kontoP_A['vrstaKonta'];
      if (empty($kontoP_A) && strlen($kontoP) > 2) $vrstaKontaP = 'F';
      if ( $vrstaKontaP=='S' && ($knjigovodstvenoKnjizenje=='MGsaldaKontiNovo' || $knjigovodstvenoKnjizenje=='MGgkSkNovo') ) $ideUobraduP = 'Da';
      if ( $vrstaKontaP=='F' && ($knjigovodstvenoKnjizenje=='MGgkNovo' || $knjigovodstvenoKnjizenje=='MGgkSkNovo') ) $ideUobraduP = 'Da';
      
      if ($ideUobraduD == 'Ne' && $ideUobraduP == 'Ne' ) continue;
      
 // duplo kniženje dokumenta se ne dozvoljava niti za salda konte niti financijsko(ako se zabunom pokušaju knjižiti isti dokumenti)
      $proda=$brojProd; 
      $slog=array();
      $broDoGk=0; $vrsDoGk='';
      pretvoriBrojRobnoGk($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$broDoGk,$vrsDoGk);
     
      $slog['broDo']=$broDoGk; $slog['vrsDo']=$vrsDoGk;
      $slog['brojTemeljnice']=$brojTemeljnice; $slog['kodPartnera']=$dobKup; $slog['pozivNaBroj']=''; $slog['brojIzvoda']=0;
      $slog['DVO']=substr($datumDVO,0,11) . '00:00:00'; $slog['valuta']=substr($datumValuta,0,11) . '00:00:00'; $slog['brojDobRacuna']=$brojRacD; $slog['vrstaRacuna']=$vrstaR;       
  //    echo 'slogDVO=' . $slog['DVO'] . 'slogVALUTA=' . $slog['valuta'];
      $slog['PDVstatus']=$status; $slog['opisKnjizenja']='';
      
      // velika greška
      //$kontniModuliUvoz = ('12' || '13' || '121' || '131');
      //if (($kontniModul = $kontniModuliUvoz) && trim($slog['kodPartnera']) != '') 
      //
      // korigirano
      $kontniModuliUvoz = ($kontniModul=='12' || $kontniModul=='13' || $kontniModul=='121' || $kontniModul=='131');
      if (($kontniModuliUvoz && trim($slog['kodPartnera']) != '') || ((trim($vrsDo)=='5' || $vrsDo=='5U') && $iznosUstranojValuti!=0)) 
           $slog['opisKnjizenja'] =  number_format($iznosUstranojValuti,2,',','') . ', ' . $stranaValuta . ', ' . $zakljucak;      
      if (trim($slog['kodPartnera'] != '' )) $slog['gk_pdv']=$gk_pdv; else $slog['gk_pdv']= array();
      $stoSeKnjizi = $sM['stoSeKnjizi'];
      $iznosK = $iznosDobKup;
      if ($stoSeKnjizi==1 || $stoSeKnjizi==2) $iznosK = $zaliha; // zaliha bez poreza za veleprodaje inače je zaliha s porezom(ukalkuliranim) za maloprodaje
      if ( $stoSeKnjizi==2 && $vrstaPoslovnice == '1' ) $iznosK = $zaliha - $ukalPorez; 
      if ($vrstaPoslovnice =='3' && trim($vrsDo)=='8' && $stoSeKnjizi==1) $iznosK = $zaliha - $porez;
      if ($stoSeKnjizi==3) $iznosK = $rabati;        
      if ($stoSeKnjizi==5) $iznosK = $porez;        // PDV na izlazima samo roba
      if ($stoSeKnjizi==6) $iznosK = $zaliha;
      if ($stoSeKnjizi==7) $iznosK = $iznosDobKup;  
      if ($stoSeKnjizi==8) $iznosK = $rc;
      if ($stoSeKnjizi==10) $iznosK = $ukalPorez;
      if ($stoSeKnjizi==12) $iznosK = $ukalTr;
      if ($stoSeKnjizi==18) $iznosK = $samoUsluga;  // trošak dostave, prijevoza
      if ($stoSeKnjizi==19) $iznosK = $PDVsamoUsluga;
      if ($stoSeKnjizi==20) $iznosK = $porez; // pretporez na kalkulaciji
      if ($stoSeKnjizi==22) $iznosK = $samousluga; // na paragoncima usluga koja nije prijevoz
      if ($stoSeKnjizi==24) $iznosK = $carineITakse;
      if ($stoSeKnjizi==25) $iznosK = $EVporez;
      
 //     echo 'slogpdvstatus=' . $slog['PDVstatus'];
      
      /*
      if ($ideUobraduD == 'Da' && $iznosK !=0)  {
          if ($vrstaKontaD == 'F') $slog['kodPartnera'] = NULL;
          $slog['konto'] = $kontoD;
          if( $slog['konto'] == '767' and $slog['PDVstatus'] == 'C' ) $slog['konto'] = '762'; if( $slog['konto'] == '767' and $slog['PDVstatus'] == 'I' ) $slog['konto'] = '760';
          if ($vrstaKontaD == 'F') $slog['konto'] .= trim(substr($proda,2,3)); 
          if ( $slog['konto']=='1200' and $slog['PDVstatus'] == 'C' ) $slog['konto'] = '1210';
          if ( $slog['konto']=='1200' and $slog['PDVstatus'] == 'I' ) $slog['konto'] = '1211';
          if ($slog['konto']=='1200' && $vrstaPartnera == '1') $slog['konto'] = '1201';
          $slog['iznosDug']=$iznosK * $sM['predznakDugovni'];
          $slog['iznosPot']=0;         
          if ($vrstaKontaD == 'F')
               $imaDupli = getGkDupliDokumentF($slog);
           else 
               $imaDupli = getGkDupliDokument($slog);                    
          if ( !empty($imaDupli) ) {              
             echo 'Već je prije proknjižen dokument na temeljnicu:' . $imaDupli['brojTemeljnice'] . ' Konto:'. $imaDupli['konto'] . 
             ' Vrsta dokumenta:' . $imaDupli['vrsDo'] . ' Broj dokumenta:' . $imaDupli['broDo'] . ' Iznos dugovni:' . $imaDupli['iznosDug'] . '</br>';                              
          } else {   
            $maxBrojStavke = get_gk_max_brojStavke($brojTemeljnice);
            $slog['brojStavke'] = $maxBrojStavke + 1;
            add_gk_stavku($slog);
          }
      }    
      
      if ($ideUobraduP == 'Da' && $iznosK !=0)  {
          if ($vrstaKontaP == 'F') $slog['kodPartnera'] = NULL;        
          $slog['konto'] = $kontoP;  
          if( $slog['konto'] == '767' and $slog['PDVstatus'] == 'C' ) $slog['konto'] = '762'; if( $slog['konto'] == '767' and $slog['PDVstatus'] == 'I' ) $slog['konto'] = '760';
          if ($vrstaKontaP == 'F') $slog['konto'] .= trim(substr($proda,2,3));
          if ( $slog['konto']=='1200' and $slog['PDVstatus'] == 'C' ) $slog['konto'] = '1210';
          if ( $slog['konto']=='1200' and $slog['PDVstatus'] == 'I' ) $slog['konto'] = '1211';
          if ($slog['konto']=='1200' && $vrstaPartnera == '1') $slog['konto'] = '1201';
          $slog['iznosPot']=$iznosK * $sM['predznakPotrazni'];
          $slog['iznosDug']=0;
          if ($vrstaKontaP == 'F')
               $imaDupli = getGkDupliDokumentF($slog); // za financijska konta gleda i iznose 
           else 
               $imaDupli = getGkDupliDokument($slog);  // za salda konto konta po kontu vrsDo i broDo           
          if ( !empty($imaDupli) ) {  
              echo 'Već je prije proknjižen dokument na temeljnicu:' . $imaDupli['brojTemeljnice'] . ' Konto:'. $imaDupli['konto'] . 
             ' Vrsta dokumenta:' . $imaDupli['vrsDo'] . ' Broj dokumenta:' . $imaDupli['broDo'] . ' Iznos potražni:' . $imaDupli['iznosPot']. '</br>'; 
          } else {   
            $maxBrojStavke = get_gk_max_brojStavke($brojTemeljnice);
            $slog['brojStavke'] = $maxBrojStavke + 1;
            add_gk_stavku($slog);
          }
      }    
     */
      
        if($iznosK!=0) {
              if($ideUobraduD=='Da')  {
                 if ($vrstaKontaD == 'S' && trim($vrsDo)=='5') {
                    $rate = get_rate_kartice($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
                }
                else
                    $rate = false;
                 knjiziRasterUGk($brojTemeljnice, $slog, $proda, $vrstaPartnera, $kontoD, $vrstaKontaD, $iznosDug=$iznosK*$sM['predznakDugovni'], $iznosPot=0, $rate);
              }
              if($ideUobraduP=='Da')  {
                 if ($vrstaKontaP == 'S'  && trim($vrsDo)=='5') {
                    $rate = get_rate_kartice($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
                }
                else
                    $rate = false;
                  knjiziRasterUGk($brojTemeljnice, $slog, $proda, $vrstaPartnera, $kontoP, $vrstaKontaP, $iznosDug=0, $iznosPot=$iznosK*$sM['predznakPotrazni'],$rate);
              }       
        }
      
    }   /* za foreach */
      
 return;
 }   

 //nastavak kreiranja daoteke za stare programe
    $brojProd = str_pad(substr($brojProd,2),6);
    $brojRac = str_pad(trim($brojRac),14);
    if (!empty($datumValuta)) {
       $datum_o = new DateTime($datumValuta);
       $datumValuta = $datum_o->format("dmY");
    } else $datumValuta='        '; 
    $dobKup = str_pad(rtrim($dobKup),6);
    if (trim($status) == '')  $status = '3';
    $file = fopen('rasterFile.txt', 'ab');
    $dio1 = $firmaR.$vrstaRas.$brojProd.$brojRac.$datumValuta.$dobKup.$status.$vrstaR;
    fwrite($file, $dio1);
    $zaliha = f_rasterFile($zaliha);
    $rabati = f_rasterFile($rabati);
    $iznosDobKup = f_rasterFile($iznosDobKup);
    $ukalTr = f_rasterFile($ukalTr);
    $rc = f_rasterFile($rc);
    $porezpk = 0;
    $porezpk = f_rasterFile($porezpk);
    $zaokrp = 0;
    $zaokrp = f_rasterFile($zaokrp);
 //   $brojRacD = str_pad(rtrim($brojRacD),20);
    $brojRacD = str_pad(substr(trim($brojRacD),0,20),20);
    $iznosi1=$zaliha.$rabati.$iznosDobKup.$ukalTr.$rc.$porezpk.$zaokrp.$brojRacD;
    fwrite($file, $iznosi1);
    
    for ($i = 1; $i <= 10; $i++) {
       $izPor = '000000000000'; 
       if ($i == 1) $izPor = f_rasterFile($porez);
       if ($i == 10) $izPor = f_rasterFile($ukalPorez);
       fwrite($file, $izPor); 
    } 
    
    $datum_o = new DateTime($datumDVO);
    $datumDVO = $datum_o->format("dmY");
    $dioKraj = '0000'.$vrstaRas.' '.$datumDVO;    
  //  if ($firmaR == '23' || $firmaR == '70')  {
      if ($knjigovodstvenoKnjizenje == 'MGknjigovodstvo') {
        //za Panex-AGM datoteka iz koje se knjiži na vlastito knjigovodstvo a za chaky oboje moguće
        //prošireni slog
       fwrite($file, $dioKraj);
       $iznosUstranojValuti = f_rasterFile($iznosUstranojValuti);
       $carineITakse = f_rasterFile($carineITakse);
       $stranaValuta = str_pad(substr(trim($stranaValuta),0,3),3);
       $zakljucak = str_pad(substr(trim($zakljucak),0,20),20);
       $EVporez = f_rasterFile($EVporez);
       $stranaKalk = $iznosUstranojValuti.$stranaValuta.$carineITakse.$zakljucak.$EVporez. "\n"; 
       fwrite($file, $stranaKalk);
    } else {
        //Panex Dinamic i CHAKY  knjigovodstvo na tuđem programu
       fwrite($file, $dioKraj . "\r\n");
       fwrite($file, "\r\n");
    }
    fclose($file);
    
}

function knjiziRasterUGk($brojTemeljnice,$slog,$proda,$vrstaPartnera,$konto,$vrstaKonta,$iznosDug,$iznosPot,$rate) {
    if ($vrstaKonta == 'F') $slog['kodPartnera'] = NULL;
    $slog['konto'] = $konto;
    if( $slog['konto'] == '767' and $slog['PDVstatus'] == 'C' ) $slog['konto'] = '762'; 
    if( $slog['konto'] == '767' and $slog['PDVstatus'] == 'I' ) $slog['konto'] = '760';
    if ($vrstaKonta == 'F') $slog['konto'] .= trim(substr($proda,2,3)); 
    if ( $slog['konto']=='1200' and $slog['PDVstatus'] == 'C' ) $slog['konto'] = '1210';
    if ( $slog['konto']=='1200' and $slog['PDVstatus'] == 'I' ) $slog['konto'] = '1211';
    if ($slog['konto']=='1200' && $vrstaPartnera == '1') $slog['konto'] = '1201';
    $slog['iznosDug']=$iznosDug;
    $slog['iznosPot']=$iznosPot;         
    if ($vrstaKonta == 'S' && !empty($rate)) {
        $pomBrodo=$slog['broDo'];
        foreach ($rate as $rata) {
            $slog['broDo']=$pomBrodo.'/'.$rata['brojStavke'];
            $imaDupli = getGkDupliDokument($slog);                    
            if (!empty($imaDupli)) {
                echo 'Već je prije proknjižen dokument na temeljnicu:' . $imaDupli['brojTemeljnice'] . ' Konto:' . $imaDupli['konto'] .
                ' Vrsta dokumenta:' . $imaDupli['vrsDo'] . ' Broj dokumenta:' . $imaDupli['broDo'] . ' Iznos dugovni:' . $imaDupli['iznosDug'] . '</br>';
                return;
            }
            $slog['valuta']=$rata['valuta'];
            if($iznosDug==0) 
                $slog['iznosPot']=$rata['iznosRateKartice'];
            else
                $slog['iznosDug']=$rata['iznosRateKartice'];
            $maxBrojStavke = get_gk_max_brojStavke($brojTemeljnice);
            $slog['brojStavke'] = $maxBrojStavke + 1;
            add_gk_stavku($slog);            
        }
        return;
    }


    if ($vrstaKonta == 'F')
       $imaDupli = getGkDupliDokumentF($slog);
    else 
       $imaDupli = getGkDupliDokument($slog);                    
    if ( !empty($imaDupli) ) {              
     echo 'Već je prije proknjižen dokument na temeljnicu:' . $imaDupli['brojTemeljnice'] . ' Konto:'. $imaDupli['konto'] . 
     ' Vrsta dokumenta:' . $imaDupli['vrsDo'] . ' Broj dokumenta:' . $imaDupli['broDo'] . ' Iznos dugovni:' . $imaDupli['iznosDug'] . '</br>';                              
    } else {   
    $maxBrojStavke = get_gk_max_brojStavke($brojTemeljnice);
    $slog['brojStavke'] = $maxBrojStavke + 1;
    add_gk_stavku($slog);
    }
    
}

function  f_rasterFile($iznos)  {
   if ($iznos < 0) {
      $iznos = str_pad(number_format($iznos, 2, '', ''), 12, '0', STR_PAD_LEFT);
      $zadnjaZnamenka = substr($iznos,11,1); $z = $zadnjaZnamenka;
      $iznos11 = substr($iznos,0,11);
      if ($z == 0) $iznos = $iznos11 . 'p';
      if ($z == 1) $iznos = $iznos11 . 'q';
      if ($z == 2) $iznos = $iznos11 . 'r';
      if ($z == 3) $iznos = $iznos11 . 's';
      if ($z == 4) $iznos = $iznos11 . 't';
      if ($z == 5) $iznos = $iznos11 . 'u';
      if ($z == 6) $iznos = $iznos11 . 'v';
      if ($z == 7) $iznos = $iznos11 . 'w';
      if ($z == 8) $iznos = $iznos11 . 'x';
      if ($z == 9) $iznos = $iznos11 . 'y';
      $iznos2 = str_replace('-', '0', $iznos);
      $iznos = $iznos2; 
   } else {    
      $iznos = str_pad(number_format($iznos, 2, '', ''), 12, '0', STR_PAD_LEFT);
   }
   return $iznos;
}

function add_dok_zag_zapisnik($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi,$kodPartnera,$DVO, $kasa)  {
    global $db;
    $email_user = $_SESSION['admin']['email'];
    kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi);
    $query = 
    'INSERT INTO dok_zag 
     (proda,vrsDo,proIn,zapis,broDo,verzi,kodPartnera,DVO,valuta,kasa,refProd,datumOtvaranja,tkoJeIzmjenio,zavrsen)
     VALUES 
    (:proda,:vrsDo,:proIn,:zapis,:broDo,:verzi,:kodPartnera,:DVO,:valuta,:kasa,:refProd,NOW(),:email_user,"Da")';
    try {
        $datum_o = new DateTime($DVO);
        $DVO = $datum_o->format("Y-m-d H:i:s");    
        
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->bindValue(':proIn', $proIn);
	$statement->bindValue(':zapis', $zapis);
	$statement->bindValue(':broDo', $broDo);
	$statement->bindValue(':verzi', $verzi);
	$statement->bindValue(':kodPartnera', trim($kodPartnera));
	$statement->bindValue(':DVO', $DVO);
	$statement->bindValue(':valuta', $DVO);
	$statement->bindValue(':kasa', $kasa);
        $statement->bindValue(':refProd', $_SESSION['admin']['OIB']);

        $statement->bindValue(':email_user', $email_user);      
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
      } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
  return $rowCount;
}

function add_dok_stavke_zapisnik($proda, $vrsDo, $proIn, $zapis, $broDo, 
    $verzi,$DVO,$brojStavke,$kodRobe,$vrstaProdaje,$cijena,$kolicina,$ukalkuliraniPDV,$oznakaCjenika=NULL) {
    global $db;
    
    $email_user = $_SESSION['admin']['email'];
    kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi);
    $query = '
    INSERT INTO dok_stavke
    (proda,vrsDo,proIn,zapis,broDo,verzi,brojStavke,kodRobe,vrstaProdaje,
    cijena,cijenaZaIntFak,kolicina,rabatPopust,rabatPopustNaKol,ukalkuliraniPDV,DVO,oznakaCjenika,PDV,nabavnaCijena,marza,zavisniTroskovi,datumOtvaranja,tkoJeIzmjenio)
    VALUES
    (:proda,:vrsDo,:proIn,:zapis,:broDo,:verzi,:brojStavke,:kodRobe,:vrstaProdaje,
    :cijena,0,:kolicina,0,0,:ukalkuliraniPDV,:DVO,:oznakaCjenika,0,0,0,0,
    NOW(),:email_user)';
    $datum_o = new DateTime($DVO);
    $DVO = $datum_o->format("Y-m-d H:i:s");
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':brojStavke', $brojStavke);
    $statement->bindValue(':kodRobe', $kodRobe);
    $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
    $statement->bindValue(':cijena', $cijena);
    $statement->bindValue(':kolicina', $kolicina);
    $statement->bindValue(':ukalkuliraniPDV', $ukalkuliraniPDV);
    $statement->bindValue(':oznakaCjenika', $oznakaCjenika);

    $statement->bindValue(':DVO', $DVO);
    $statement->bindValue(':email_user', $email_user);
    $statement->execute();
    $rowCount = $statement->rowCount();
    $statement->closeCursor();
    return $rowCount;
}

function zabranjeno_po_poslovnici($opSaDok, $proda, $vrsDo, $DVO, $stavka=null, $vezniDokument=null)
{
    $poslovnica= get_poslovnica($proda);
    if($opSaDok=='Brisanje' && $poslovnica['brisanjeDokumenata']!='D')
        return 'Brisanje dokumenata u odabranoj poslovnici nije dozvoljeno!';
    if($opSaDok=='Unos' || $opSaDok=='Izmjena' || $opSaDok=='Brisanje' || $opSaDok=='Kopiranje') {
        // negatiivna stanja
        include_once 'model/vrste_dokumenata_db.php';
        $vrstaDokumenta=  get_vrsta_dokumenta($vrsDo);
        $tekstNegativnaStanja = ($poslovnica['negativnaStanja']=='N') ? 'Negativna stanja na skladištu nisu dozvoljena! ' : 'Želite li dozvoliti negativno stanje? ';
        if($opSaDok=='Brisanje' && $stavka===null) {
            //if($poslovnica['negativnaStanja']=='N' && $vrstaDokumenta['azurStanja']!=0)  {
            if($poslovnica['negativnaStanja']!='D' && $vrstaDokumenta['azurStanja']!=0 && !isset($_POST['dozvoliNegZalihe']))  {
                $proda = $proda;
                $vrsDo = $vrsDo;
                $proIn = $_SESSION['dok_zag']['proIn'];
                $zapis = $_SESSION['dok_zag']['zapis']; 
                $broDo = $_SESSION['dok_zag']['broDo'];
                $verzi = $_SESSION['dok_zag']['verzi'];
                $cart=get_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
                foreach ($cart as $s) {
                    $artikl=get_product_maticna_robe($s['kodRobe']);
                    if($artikl['robaUsluga'] =='U') 
                       continue;
                    
                    $roba=stanje_po_kodu_robe_1p($proda, $s['kodRobe'], $s['vrstaProdaje']);
                    $novoStanje=$roba['suma_po_kodu_robe'] - $s['kolicina']*$vrstaDokumenta['azurStanja'] ;
                    if($novoStanje<0)
                        return $tekstNegativnaStanja.'Za robu:'.$s['kodRobe'].' stanje je:'.$roba['suma_po_kodu_robe'].'. Novo stanje bi bilo:'.$novoStanje.'!';

                }
            }    
        }
        else if(isset($stavka) && trim($stavka['kodRobe']) != '#') {
            $artikl=get_product_maticna_robe($stavka['kodRobe']);
            if(isset($artikl['robaUsluga'])) { 
                if($artikl['robaUsluga']!='U') { 
                    //if($poslovnica['negativnaStanja']=='N' && $vrstaDokumenta['azurStanja']!=0 && is_array($stavka))  {
                    if($poslovnica['negativnaStanja']!='D' && $vrstaDokumenta['azurStanja']!=0 && is_array($stavka) && !isset($_POST['dozvoliNegZalihe']))  {
                        $roba=stanje_po_kodu_robe_1p($proda, $stavka['kodRobe'], $stavka['vrstaProdaje']);
                        if($opSaDok=='Brisanje')
                                $kolicina=-$stavka['kolicinaNaStavki'];
                        else
                            $kolicina=$stavka['kolicinaNaStavki'];
                        if($opSaDok=='Brisanje')
                            // $novoStanje=$roba['suma_po_kodu_robe'] + ($kolicina + kolicina_po_dokumentu_cart($stavka['kodRobe'], $stavka['vrstaProdaje']))*$vrstaDokumenta['azurStanja'] ;
                            $novoStanje=$roba['suma_po_kodu_robe'] - $stavka['kolicinaNaStavki']*$vrstaDokumenta['azurStanja'] ;
                        else
                            $novoStanje=$roba['suma_po_kodu_robe'] + ($kolicina
                                    +kolicina_po_dokumentu_cart($stavka['kodRobe'], $stavka['vrstaProdaje'])   
                                    -kolicina_po_dokumentu_u_bazi($stavka['kodRobe'], $stavka['vrstaProdaje']))*$vrstaDokumenta['azurStanja'] ;
                        if($novoStanje<0)
                                return $tekstNegativnaStanja.'Za robu:'.$stavka['kodRobe'].' stanje je:'.$roba['suma_po_kodu_robe'].'. Novo stanje bi bilo:'.$novoStanje.'!';

                    }
                }
            }    
        }    


        $DVO_d= new DateTime($DVO);
        if(trim($vrsDo)=="8" && is_array($stavka) && ($opSaDok=='Unos' || $opSaDok=='Kopanje')) {           
            if($stavka['kolicina']<0) {
                $artikl=get_product_maticna_robe($stavka['kodRobe']);
                if($poslovnica['daniStornoParagonci']==0 || $artikl['robaUsluga'] =='U')
                   ;
                else {
                    if(trim($stavka['vezniDokument'])=='') {
                        return "Vezni dokument je prazan. Potrebno je unijeti broj dokumenta koji se stornira!";
                    }
                    $vezniDokument= get_dok_zag($proda, $vrsDo, '', '', $stavka['vezniDokument'], '');
                    if(empty($vezniDokument))
                        return "Unesen je nepostojeći vezni dokument. Dokument broj ".$stavka['vezniDokument']." ne postoji!";
                    $DVO_d= new DateTime($vezniDokument["DVO"]);
                }
            }
        }
                    
        $danas= new DateTime();
        //$DVO_d= new DateTime($DVO);
        //$brojDana=$danas->diff($DVO_d)->days;
        $brojDana=brojDana($DVO_d, $danas);
        
        
        if($opSaDok=='Izmjena') {
            $slog_dok_zag=get_dok_zag($proda, $vrsDo, $_SESSION['dok_zag']['proIn'], $_SESSION['dok_zag']['zapis'], 
                                         $_SESSION['dok_zag']['broDo'], $_SESSION['dok_zag']['verzi']);
            $DVO_b= new DateTime($slog_dok_zag['DVO']);
            //$brojDanaUBazi=$danas->diff($DVO_b)->days;
            $brojDanaUBazi=brojDana($DVO_b, $danas);
        }
        else 
            $brojDanaUBazi=0;
       
       
        
        if($brojDana<1 && $brojDanaUBazi<1 && trim($vrsDo)!="8")
            return false;
        
        switch (trim($vrsDo)) {
        case '1':
            if($poslovnica['daniUnazadPrimke']>0 && ($poslovnica['daniUnazadPrimke']<$brojDana || $poslovnica['daniUnazadPrimke']<$brojDanaUBazi))
                return 'Knjiženje primke u nazad '.($brojDana>$brojDanaUBazi?$brojDana:$brojDanaUBazi).' dana nije dozvoljeno. Maksimalni broj dana za knjiženje primki je:'.$poslovnica['daniUnazadPrimke'].'!';
            break;
        case '5':
            if($poslovnica['daniUnazadDostavnice']>0 && ($poslovnica['daniUnazadDostavnice']<$brojDana || $poslovnica['daniUnazadDostavnice']<$brojDanaUBazi))
                return 'Knjiženje dostavnice u nazad '.($brojDana>$brojDanaUBazi?$brojDana:$brojDanaUBazi).' dana nije dozvoljeno. Maksimalni broj dana za knjiženje dostavnica je:'.$poslovnica['daniUnazadDostavnice'].'!';
            break;
        case '8':
            if(is_array($stavka) && $poslovnica['daniStornoParagonci']>0) {
                $artikl=get_product_maticna_robe($stavka['kodRobe']);
                if($stavka['kolicina']<0 && $artikl['robaUsluga'] == 'R') {                                      
                    if($poslovnica['daniStornoParagonci']>0 && ($poslovnica['daniStornoParagonci']<$brojDana || $poslovnica['daniStornoParagonci']<$brojDanaUBazi))
                        return 'Knjiženje storno računa u nazad '.$brojDana>$brojDanaUBazi?$brojDana:$brojDanaUBazi.' dana nije dozvoljeno. Maksimalni broj dana za knjiženje storno računa je:'.$poslovnica['daniStornoParagonci'].'!';
                    global $db;
                    $query = '
                        select broDo, kolicina
                        from dok_stavke as s
                        where proda=:proda 
                            and vrsDo=:vrsDo 
                            and proIn=:proIn 
                            and zapis=:zapis 
                            and broDo=:vezniDokument
                            and kodRobe=:kodRobe
                            and vrstaProdaje=:vrstaProdaje  
                    ';
                    $statement = $db->prepare($query);
                    $statement->bindValue(':proda', $proda);
                    $statement->bindValue(':vrsDo', $vrsDo);
                    $statement->bindValue(':proIn', '');
                    $statement->bindValue(':zapis', '');
                    $statement->bindValue(':vezniDokument', $stavka['vezniDokument']);
                    //$statement->bindValue(':verzi', '');
                    $statement->bindValue(':kodRobe', $stavka['kodRobe']);
                    $statement->bindValue(':vrstaProdaje', $stavka['vrstaProdaje']);
                    $statement->execute();
                    $veznaStavka = $statement->fetch();
                    $statement->closeCursor();
                    if(!is_array($veznaStavka))
                        return "U dokumentu broj ".$stavka['vezniDokument']." ne postoji roba: ".$stavka['kodRobe']."!";
                    if($opSaDok=='Unos' || $opSaDok=='Kopanje') {
                    $query = '
                        select ifnull(sum(kolicina),0) as stornirano
                        from dok_stavke as s
                        where proda=:proda 
                            and vrsDo=:vrsDo 
                            and proIn=:proIn 
                            and zapis=:zapis 
                            and vezniDokument=:vezniDokument
                            and kodRobe=:kodRobe
                            and vrstaProdaje=:vrstaProdaje                        
                    ';
                    $statement = $db->prepare($query);
                    $statement->bindValue(':proda', $proda);
                    $statement->bindValue(':vrsDo', $vrsDo);
                    $statement->bindValue(':proIn', '');
                    $statement->bindValue(':zapis', '');
                    $statement->bindValue(':vezniDokument', $stavka['vezniDokument']);
                    //$statement->bindValue(':verzi', '');
                    $statement->bindValue(':kodRobe', $stavka['kodRobe']);
                    $statement->bindValue(':vrstaProdaje', $stavka['vrstaProdaje']);
                    $statement->execute();
                    $dosadasnjiStorno = $statement->fetch();
                    $statement->closeCursor();
                    
                    $raspolozivo=$veznaStavka['kolicina'] + $dosadasnjiStorno['stornirano'];
                    if($raspolozivo<abs($stavka['kolicina']))
                        return "Raspoloživa količina: ".$raspolozivo." je manja od storno količine: ".$stavka['kolicina']."!";
                }
                }
                
            }
            break;

        default:            
          if ($_SESSION['admin']['prioritet'] != 9) {  
            if($poslovnica['daniUnazadOstaliDok']>0 && ($poslovnica['daniUnazadOstaliDok']<$brojDana || $poslovnica['daniUnazadOstaliDok']<$brojDanaUBazi)) {
                if($brojDana<$brojDanaUBazi)
                    $brojDana = $brojDanaUBazi;
                return 'Knjiženje dokumenta u nazad '.$brojDana.' dana nije dozvoljeno. Maksimalni broj dana za knjiženje ostali dokumenata je:'.$poslovnica['daniUnazadOstaliDok'].'!';
                //return 'Knjiženje dokumenta u nazad '.$brojDana>$brojDanaUBazi?$brojDana:$brojDanaUBazi.' dana nije dozvoljeno. Maksimalni broj dana za knjiženje ostali dokumenata je:'.$poslovnica['daniUnazadOstaliDok'].'!';
            }
            break;
          } else { 
            $godinaTekuca = $danas->format("Y");
            $godinaDVO = $DVO_d->format("Y");  
            if ($godinaTekuca != $godinaDVO)
               return 'Pogrešna godina, datum dokumenta(DVO) mora biti u tekućoj godini !';
            break;
          } 
        }
        
            }
    return false;
}        

function kolicina_po_dokumentu_cart($kodRobe, $vrstaProdaje) {
    $kolicina=0;
    $rbr=0;
    if(isset($_POST['action']))
        if($_POST['action']=='izmjena')
            $rbr=1;
    foreach ($_SESSION['cart'] as $stavka) {
        //ako mijenjamo postoječu stavku, ne zbraja količinu od te stavke
       if(isset($_REQUEST['brojStavke']))
            if($rbr==$_REQUEST['brojStavke']) {
                ++$rbr;
                continue;
            }
            
        if($stavka['kodRobe']==$kodRobe && $stavka['vrstaProdaje']==$vrstaProdaje)
            $kolicina+=$stavka['kolicina'];
        ++$rbr;
    }
    
    //ako mijenjamo postoječu stavku, ne zbraja količinu od te stavke
    //if($_REQUEST['action']=='izmjena')
    //    $kolicina-=$_REQUEST['kolicina'];
    
    return $kolicina;
}

function kolicina_po_dokumentu_u_bazi($kodRobe, $vrstaProdaje) {
    global $db;
    if(!isset($_SESSION['dok_zag']['broDo']) && !isset($_SESSION['dok_zag']['brojDokumenta']))
        return 0;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis'];
    if(isset($_SESSION['dok_zag']['broDo']))
      $broDo = $_SESSION['dok_zag']['broDo'];
    else
      $broDo = $_SESSION['dok_zag']['brojDokumenta'];
    $verzi = $_SESSION['dok_zag']['verzi'];
    
    $query = " 
        SELECT  IFNULL(SUM(kolicina),0) as kolicina
        FROM dok_stavke
        WHERE proda=:proda 
          AND vrsDo=:vrsDo 
          AND proIn=:proIn 
          AND zapis=:zapis 
          AND broDo=:broDo 
          AND verzi=:verzi 
          AND kodRobe=:kodRobe
          AND vrstaProdaje=:vrstaProdaje
          ";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':kodRobe', $kodRobe);
    $statement->bindValue(':vrstaProdaje', $vrstaProdaje);   
    $statement->execute();
    $stavka = $statement->fetch();
    $statement->closeCursor();
    return $stavka['kolicina'];

}    
/*
 * POZOR!! 
 * f-ja round ima grešku, rijetku ali grešku.
 * npr.: round(141.075, 2) daje 141,07, round(4.725, 2) daje 4,72
 * To se vidi na paragoncu:
 * proda=2316, broDo=1663 DVO=21.08.2013 13:27:07
 * ukoliko bi se umjesto round pozvala f-ja mround ona bi korigirala tu grešku
 * Za sada sam ja f-ju racunajPDV slozio da računa s istom greškom
 * MAKAR, 19.1.20014.
 */
function mround($number, $precision=0) {
    //return(round($number, $precision));
    
    $precision = ($precision == 0 ? 1 : $precision);   
    $pow = pow(10, $precision);
   
    $ceil = ceil($number * $pow)/$pow;
    $floor = floor($number * $pow)/$pow;
   
    $pow = pow(10, $precision+1);
   
    $diffCeil     = $pow*($ceil-$number);
    $diffFloor     = $pow*($number-$floor)+($number < 0 ? -1 : 1);
   
    if($diffCeil >= $diffFloor) return $floor;
    else return $ceil;
}
function izdatniceNaOtkupniBlok($proda, $brojOtkupnogBloka) {
    global $db;    
    /* broj otkupnog bloka  OB23 */
    $query = "SELECT s.broDo, s.kodRobe, s.kolicina, s.cijena, nazivRobe, m.jedinicaMjere, s.poreznaGrupa, robaUsluga FROM dok_stavke as s
        INNER JOIN maticna_robe as m ON s.kodRobe = m.kodRobe
        INNER JOIN dok_zag as z ON s.proda = z.proda and s.vrsDo = z.vrsDo and s.proIn = z.proIn and s.zapis = z.zapis
                   and s.broDo = z.broDo and s.verzi = z.verzi
        WHERE s.proda = :proda AND s.vrsDo = '7'
	AND z.brojNarudzbe = :brojOtkupnogBloka
        order by robaUsluga";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':brojOtkupnogBloka', $brojOtkupnogBloka); 
    $statement->execute();
    $stavkeZaOtkupniBlok = $statement->fetchAll();
    $statement->closeCursor();
    return $stavkeZaOtkupniBlok;
}
function EVdostavnice($proda,$DVOod,$DVOdo,$DVO='',$valuta='',$broDo=0,$polazniBrojDostavnice='') {
//ako se program izvodi poslje zadnjeg datuma u mjesecu, DVO se popuni kao zadnji datum u prošlom mjesecu
//broDo je defaultno 0 pa program u add_dok_zag.. traži sljedeći slobodni broj,
// ali ako imaju preskoćene brojeve(raspon brojeva rupa) onda se može popuniti kao početni broj iz rupe parametar
    if ($polazniBrojDostavnice=='') $polazniBrojDostavnice=0;
    global $db;
    $now = new DateTime;
    if ($DVO == '') $DVO = $DVOdo; $D_o = new DateTime($DVO); $DVO = $D_o->format("Y-m-d") . $now->format(" H:i:s"); $D_o = new DateTime($DVO);
    $interval = new DateInterval('P15D'); $D_o->add($interval);  $valuta = $D_o->format("Y-m-d H:i:s"); 
   // if ($valuta =='') $D_o = $D_o + 15; else $D_o = new DateTime($valuta);   $valuta = $D_o->format("Y-m-d H:i:s");     
    
    $D_o = new DateTime($DVOod); $DVOod = $D_o->format("Y-m-d H:i:s");
    $D_o = new DateTime($DVOdo); $DVOdo = $D_o->format("Y-m-d H:i:s"); 
    
    $query = "SELECT s.broDo,kodRobe,vrstaProdaje,cijena,kolicina,rabatPopust,absRabatPopust,rabatPopustNaKol,
        poreznaGrupa,PDV,ukalkuliraniPDV,povratnaNaknada,oznakaCjenika,kodPartnera,z.DVO  FROM dok_stavke as s        
        INNER JOIN dok_zag as z ON s.proda = z.proda and s.vrsDo = z.vrsDo and s.proIn = z.proIn and s.zapis = z.zapis
                   and s.broDo = z.broDo and s.verzi = z.verzi
        WHERE s.proda = :proda AND s.vrsDo = '5' AND s.verzi = 'EV'
        AND (z.DVO >= :DVOod AND z.DVO <= :DVOdo)	
        ORDER BY trim(kodPartnera), kodRobe, vrstaProdaje, cijena, rabatPopust";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':DVOod', $DVOod); 
    $statement->bindValue(':DVOdo', $DVOdo);
    $statement->execute();
    $stavkeZaEVdostavnice = $statement->fetchAll();
    $statement->closeCursor();
 if (!empty($stavkeZaEVdostavnice))  {    
//  generiranje i upisivanje računa po partnerima za svakog partnera po jedan račun(upis u dok_stavke i dok_zag)
//  prema "ključu za stavku" " kodRobe, vrstaProdaje, cijena, rabatPopust 
    $kodPartnera_ ='Pocetni'; $kodRobe_ =''; $vrstaProdaje_=''; $cijena_=''; $rabatPopust_=''; $sumaKolicina = 0; $brojStavke = 0; $komentar = '';
    $vrsDo = '5';  $proIn = '     '; $zapis = '  '; $verzi = '   '; $kasa = 1;
    echo 'Formirane fakture po kupcima:' . '</br>';
    $broDo = $polazniBrojDostavnice;
  //  echo 'brodo=' . $broDo. '</br>';
    
    foreach ($stavkeZaEVdostavnice as $EV) { 
  //    echo 'brodo=nakon foreacha' . $broDo. '</br>'; 
      if ($kodPartnera_ == 'Pocetni') {
        $kodPartnera_ = trim($EV['kodPartnera']); $kodRobe_ = $EV['kodRobe']; $vrstaProdaje_ = $EV['vrstaProdaje']; 
        $cijena_ = $EV['cijena']; $rabatPopust_ = $EV['rabatPopust']; $sumaKolicina = $EV['kolicina'];
        $absRabatPopust_ = $EV['absRabatPopust']; $rabatPopustNaKol_ = $EV['rabatPopustNaKol']; $poreznaGrupa_ = $EV['poreznaGrupa'];
        $PDV_ = $EV['PDV']; $ukalkuliraniPDV_ = $EV['ukalkuliraniPDV']; $povratnaNaknada_ = $EV['povratnaNaknada']; $oznakaCjenika_ = $EV['oznakaCjenika']; 
        continue;
      }
      if ( trim($kodPartnera_) == trim($EV['kodPartnera']) && $kodRobe_ == $EV['kodRobe'] && $vrstaProdaje_ == $EV['vrstaProdaje'] && 
          $cijena_ == $EV['cijena'] && $rabatPopust_ == $EV['rabatPopust']) { 
          $sumaKolicina += $EV['kolicina'];
          continue;
      }      
// upis stavke u dok_stavke(dok se promjeni "kljuc" za stavku ili partner)
// ako je broj stavke 1 odabire se zadnji slobodni broj i upisuje se u dok_zag  
    
      $brojStavke = $brojStavke +1;
      if ($brojStavke == 1) {
// utvrđivanje prvog slobodnog broja (ako je broDo=0) i upis u dok_zag 
     //   $broDo = 0;
      //    $broDo = $polazniBrojDostavnice;
          add_dok_zag_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi, $kodPartnera_, $DVO,$valuta,$kasa,$DVOod,$DVOdo);             
      }            
// upis u dok_stavke
      add_dok_stavke_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$brojStavke,
         $kodRobe_,$vrstaProdaje_,$cijena_, $sumaKolicina, $rabatPopust_,$absRabatPopust_,$rabatPopustNaKol_,
         $poreznaGrupa_,$PDV_,$ukalkuliraniPDV_,$povratnaNaknada_, $DVO ,$oznakaCjenika_);      
//
      if (trim($EV['kodPartnera']) != trim($kodPartnera_)) {$brojStavke = 0; $broDo = $broDo +1;};
          
      $kodPartnera_ = trim($EV['kodPartnera']); $kodRobe_ = $EV['kodRobe']; $vrstaProdaje_ = $EV['vrstaProdaje']; 
        $cijena_ = $EV['cijena']; $rabatPopust_ = $EV['rabatPopust']; $sumaKolicina = $EV['kolicina'];
        $absRabatPopust_ = $EV['absRabatPopust']; $rabatPopustNaKol_ = $EV['rabatPopustNaKol']; $poreznaGrupa_ = $EV['poreznaGrupa'];
        $PDV_ = $EV['PDV']; $ukalkuliraniPDV_ = $EV['ukalkuliraniPDV']; $povratnaNaknada_ = $EV['povratnaNaknada']; $oznakaCjenika_ = $EV['oznakaCjenika'];       
    }  
    //end foreacha za upis dokumenata po partneru    
   
// upisivanje stavke u dok_stavke (i eventualno u dok_zag ako zadnji partner ima samo jednu stavku) za ZADNJI STAVKU iz foreacha
    $brojStavke = $brojStavke + 1;
    if ($brojStavke == 1) {
// utvrđivanje prvog slobodnog broja(ako je broDo=0) i upis u dok_zag 
     //  $broDo = 0; 
     //  $broDo = $polazniBrojDostavnice;
       add_dok_zag_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi, $kodPartnera_, $DVO,$valuta,$kasa,$DVOod,$DVOdo);             
    }            
// upis u dok_stavke
     add_dok_stavke_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$brojStavke,
         $kodRobe_,$vrstaProdaje_,$cijena_, $sumaKolicina, $rabatPopust_,$absRabatPopust_,$rabatPopustNaKol_,
         $poreznaGrupa_,$PDV_,$ukalkuliraniPDV_,$povratnaNaknada_, $DVO ,$oznakaCjenika_);
//-------------------------------------------------------------------------------------------------------------------------------------------
    
      
//    upisivanje storno dostavnice EV(kreira se jedna dostavnica za sve stavke, a šifra partnera je prodavaonica) 
    $query = "SELECT s.broDo,kodRobe,vrstaProdaje,cijena,kolicina,rabatPopust,absRabatPopust,rabatPopustNaKol,
        poreznaGrupa,PDV,ukalkuliraniPDV,povratnaNaknada,oznakaCjenika,kodPartnera,z.DVO  FROM dok_stavke as s        
        INNER JOIN dok_zag as z ON s.proda = z.proda and s.vrsDo = z.vrsDo and s.proIn = z.proIn and s.zapis = z.zapis
                   and s.broDo = z.broDo and s.verzi = z.verzi
        WHERE s.proda = :proda AND s.vrsDo = '5' AND s.verzi = 'EV'
        AND (z.DVO >= :DVOod AND z.DVO <= :DVOdo)	
        ORDER BY kodRobe, vrstaProdaje, cijena, rabatPopust";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':DVOod', $DVOod); 
    $statement->bindValue(':DVOdo', $DVOdo);
    $statement->execute();
    $stavkeZaEVdostavnice = $statement->fetchAll();
    $statement->closeCursor(); 
//  
    $vrstaProdaje_=''; $cijena_=''; $rabatPopust_=''; $sumaKolicina = 0; $brojStavke = 0; $komentar = '';
    $vrsDo = '5 '; $proIn = '     '; $zapis = '  '; $kasa = 1;
    $kodRobe_ = 'Pocetni'; $verzi = 'EV'; 
    echo '</br>' . '</br>' . 'Formirana storno dostavnica EV koja stornira sve EV dostavnice iz odabranog razdoblja:' . '</br>';
    foreach ($stavkeZaEVdostavnice as $EV) {
        if ($kodRobe_ == 'Pocetni') {
        $kodRobe_ = $EV['kodRobe']; $vrstaProdaje_ = $EV['vrstaProdaje']; 
        $cijena_ = $EV['cijena']; $rabatPopust_ = $EV['rabatPopust']; $sumaKolicina = $EV['kolicina'] * -1;
        $absRabatPopust_ = $EV['absRabatPopust']; $rabatPopustNaKol_ = $EV['rabatPopustNaKol']; $poreznaGrupa_ = $EV['poreznaGrupa'];
        $PDV_ = $EV['PDV']; $ukalkuliraniPDV_ = $EV['ukalkuliraniPDV']; $povratnaNaknada_ = $EV['povratnaNaknada']; $oznakaCjenika_ = $EV['oznakaCjenika']; 
        continue;
      }
      if ($kodRobe_ == $EV['kodRobe'] && $vrstaProdaje_ == $EV['vrstaProdaje'] && 
          $cijena_ == $EV['cijena'] && $rabatPopust_ == $EV['rabatPopust']) { 
          $sumaKolicina -= $EV['kolicina'];
          continue;
      }
      
// upis stavke u dok_stavke(dok se promjeni "kljuc" za stavku )
// ako je broj stavke 1 odabire se zadnji slobodni broj i upisuje se u dok_zag  
 
      $brojStavke = $brojStavke +1;
      if ($brojStavke == 1) {
// utvrđivanje prvog slobodnog broja (ako je broDo=0) i upis u dok_zag 
          $broDo = 0;
//         $broDo = $polazniBrojDostavnice;
          $kodPartnera_ = $proda; $valuta = $DVO;
          add_dok_zag_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi, $kodPartnera_, $DVO,$valuta,$kasa,$DVOod,$DVOdo);             
      }            
// upis u dok_stavke
      add_dok_stavke_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$brojStavke,
         $kodRobe_,$vrstaProdaje_,$cijena_, $sumaKolicina, $rabatPopust_,$absRabatPopust_,$rabatPopustNaKol_,
         $poreznaGrupa_,$PDV_,$ukalkuliraniPDV_,$povratnaNaknada_, $DVO ,$oznakaCjenika_);

  //    if ($EV['kodPartnera'] != $kodPartnera_) {$brojStavke = 0; $broDo +1;};
          
        $kodRobe_ = $EV['kodRobe']; $vrstaProdaje_ = $EV['vrstaProdaje']; 
        $cijena_ = $EV['cijena']; $rabatPopust_ = $EV['rabatPopust']; $sumaKolicina = $EV['kolicina'] * -1;
        $absRabatPopust_ = $EV['absRabatPopust']; $rabatPopustNaKol_ = $EV['rabatPopustNaKol']; $poreznaGrupa_ = $EV['poreznaGrupa'];
        $PDV_ = $EV['PDV']; $ukalkuliraniPDV_ = $EV['ukalkuliraniPDV']; $povratnaNaknada_ = $EV['povratnaNaknada']; $oznakaCjenika_ = $EV['oznakaCjenika'];       
          
    } //kraj foreacha za storno dostavnicu EV
    
    // upisivanje stavke u dok_stavke (i eventualno u dok_zag (ako u dok_stavke postoji samo jedna stavka) za ZADNJI STAVKU iz foreacha
    $brojStavke = $brojStavke + 1;
    if ($brojStavke == 1) {
// utvrđivanje prvog slobodnog broja(ako je broDo=0) i upis u dok_zag 
       $broDo = 0; 
 //      $broDo = $polazniBrojDostavnice;
       $kodPartnera_ = $proda; $valuta = $DVO;
       add_dok_zag_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi, $kodPartnera_, $DVO,$valuta,$kasa,$DVOod,$DVOdo);             
    }            
// upis u dok_stavke
     add_dok_stavke_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$brojStavke,
         $kodRobe_,$vrstaProdaje_,$cijena_, $sumaKolicina, $rabatPopust_,$absRabatPopust_,$rabatPopustNaKol_,
         $poreznaGrupa_,$PDV_,$ukalkuliraniPDV_,$povratnaNaknada_, $DVO ,$oznakaCjenika_);
    
} else {    
//ako je prazan  $stavkeZaEVdostavnice
    echo 'Po navedenom odabiru(prodavaona i datumski interval) nije nađena niti jedna EV dostavnica!';
}
}

function add_dok_zag_EVdostavnice($proda,$vrsDo,$proIn,$zapis,&$broDo,$verzi, $kodPartnera, $DVO,$valuta,$kasa,$DVOod,$DVOdo)  {
// $DVO i $valuta $DVOod,$DVOdo su već pripremljeni u  Y-m-d H:i:s  formatu 
//broDo vraća vrijednost by reference jer to treba za add_dok_stavke_EVdostavnice koja se poziva nakon ad_dok..    
    global $db;    
    $zadnjiBroj = 0;   
 //   echo 'broDo u add_sok_zag...' . $broDo;
    if ($broDo == 0) {      
       $query = "SELECT MAX(broDo) as zadnjiBroj FROM dok_zag
           WHERE proda = :proda AND vrsDo = '5' AND TRIM(verzi) = TRIM(:verzi) AND TRIM(zapis) = ''";
      try {
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
        $statement->bindValue(':verzi', $verzi);
        $statement->execute();
        $zadnjiBroj = $statement->fetch();                
        $statement->closeCursor();
        if (empty($zadnjiBroj)) $zadnjiBroj = 0; else $zadnjiBroj = $zadnjiBroj[0];      
        $broDo = $zadnjiBroj + 1;
      } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
      }  
    }  
    if ($broDo == 0) {
        display_error("Broj dokumenta iz dok_zag odabran je 0(u funkciji add_dok_zag_EVdostavnice) ! program se PREKIDA!");
        exit("Programska greška !");
    }    
        
    $email_user = $_SESSION['admin']['email'];
    $refProd = $_SESSION['admin']['OIB'];
//kreiranje u komentaru popisa uključenih EV dostavnica
    if ($kodPartnera != $proda) $komentar = 'Roba je isporučena po dostavnicama:'; 
        else                    $komentar = 'Storno po dostavnicama:';
               
    
    $query = "SELECT broDo FROM dok_zag 
        WHERE proda = :proda AND vrsDo = '5' AND verzi = 'EV'
        AND (DVO >= :DVOod AND DVO <= :DVOdo)
        AND (kodPartnera = :kodPartnera OR :kodPartnera = proda)
        ORDER BY broDo";
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':DVOod', $DVOod); 
    $statement->bindValue(':DVOdo', $DVOdo);
    $statement->bindValue(':kodPartnera', $kodPartnera);
    $statement->execute();
    $EVdostavnice = $statement->fetchAll();
    $statement->closeCursor();        
    foreach ($EVdostavnice as $EK) {
        $komentar .= $proda . '-' . $EK['broDo'] . 'EV, ';
    }
    kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi);    
    $query = 
    "INSERT INTO dok_zag 
     (proda,vrsDo,proIn,zapis,broDo,verzi,kodPartnera,DVO,valuta,kasa,komentar,datumOtvaranja,tkoJeKreirao,refProd,zavrsen)
     VALUES 
    (:proda,:vrsDo,:proIn,:zapis,:broDo,:verzi,:kodPartnera,:DVO,:valuta,:kasa,:komentar,NOW(),:email_user,:refProd,'Da')";
    try {       
        $statement = $db->prepare($query);
	$statement->bindValue(':proda', $proda);
	$statement->bindValue(':vrsDo', $vrsDo);
	$statement->bindValue(':proIn', $proIn);
	$statement->bindValue(':zapis', $zapis);
	$statement->bindValue(':broDo', $broDo);
	$statement->bindValue(':verzi', $verzi);
	$statement->bindValue(':kodPartnera', $kodPartnera);
	$statement->bindValue(':DVO', $DVO);
	$statement->bindValue(':valuta', $valuta);
	$statement->bindValue(':kasa', $kasa);
        $statement->bindValue(':komentar', $komentar);
        $statement->bindValue(':email_user', $email_user);    
        $statement->bindValue(':refProd', $refProd);
        $statement->execute();
        $rowCount = $statement->rowCount();
        $statement->closeCursor();
        echo $proda . '-' . $broDo . $verzi . ',&nbsp;'; 
      } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
  return $rowCount;
}

function add_dok_stavke_EVdostavnice($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi,$brojStavke,
         $kodRobe,$vrstaProdaje,$cijena,$kolicina,$rabatPopust,$absRabatPopust,$rabatPopustNaKol,
         $poreznaGrupa,$PDV,$ukalkuliraniPDV,$povratnaNaknada,$DVO,$oznakaCjenika=NULL) {
    global $db;
    if (trim($rabatPopust) == '') $rabatPopust = 0;
    if (trim($rabatPopustNaKol) == '') $rabatPopustNaKol = 0;
    if (trim($kolicina) == '') $kolicina = 0;
    $email_user = $_SESSION['admin']['email'];
    kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,$zapis,$broDo,$verzi);
    $query = "
    INSERT INTO dok_stavke
    (proda,vrsDo,proIn,zapis,broDo,verzi,brojStavke,kodRobe,vrstaProdaje,
    cijena,kolicina,rabatPopust,absRabatPopust,rabatPopustNaKol,poreznaGrupa,PDV,ukalkuliraniPDV,povratnaNaknada,DVO,oznakaCjenika,datumOtvaranja,tkoJeIzmjenio)
    VALUES
    (:proda,:vrsDo,:proIn,:zapis,:broDo,:verzi,:brojStavke,:kodRobe,:vrstaProdaje,
    :cijena,:kolicina,:rabatPopust,:absRabatPopust,:rabatPopustNaKol,:poreznaGrupa,:PDV,:ukalkuliraniPDV,:povratnaNaknada,:DVO,:oznakaCjenika,NOW(),:email_user)";   
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);
    $statement->bindValue(':proIn', $proIn);
    $statement->bindValue(':zapis', $zapis);
    $statement->bindValue(':broDo', $broDo);
    $statement->bindValue(':verzi', $verzi);
    $statement->bindValue(':brojStavke', $brojStavke);
    $statement->bindValue(':kodRobe', $kodRobe);
    $statement->bindValue(':vrstaProdaje', $vrstaProdaje);
    $statement->bindValue(':cijena', $cijena);
    $statement->bindValue(':kolicina', $kolicina);
    $statement->bindValue(':rabatPopust', $rabatPopust);
     $statement->bindValue(':absRabatPopust', $absRabatPopust);
    $statement->bindValue(':rabatPopustNaKol', $rabatPopustNaKol);
    $statement->bindValue(':poreznaGrupa', $poreznaGrupa);   
    $statement->bindValue(':PDV', $PDV);
    $statement->bindValue(':ukalkuliraniPDV', $ukalkuliraniPDV);
    $statement->bindValue(':povratnaNaknada', $povratnaNaknada);
    $statement->bindValue(':DVO', $DVO);
    $statement->bindValue(':oznakaCjenika', $oznakaCjenika);
    $statement->bindValue(':email_user', $email_user);
    $statement->execute();
    $rowCount = $statement->rowCount();
    $statement->closeCursor();
    return $rowCount;
}

function imaNezavrsenDokument($proda,$vrsDo,$oib='')  {
  global $db;
    if ($_SERVER['HTTP_HOST'] === 'www.panex-agm.com' || $_SERVER['HTTP_HOST'] === 'panex-agm.com' ) {    
       $admDbname = 'panex_robno_mur.administrators'; 
    } else {      
       $admDbname = 'murskiga_robno_mur.administrators'; 
    }
  $query = "
      SELECT z.*,a.punkt 
      FROM dok_zag as z
      INNER JOIN $admDbname as a ON a.email=z.`tkoJeIzmjenio`
      WHERE (proda=:proda OR trim(:proda)='')
      AND vrsDo=:vrsDo 
      AND refProd=:oib
      AND zavrsen='Ne'
      AND (a.punkt=:punkt OR trim(:punkt)='')
      ORDER BY DVO
      ";
    if(trim($oib)=='')    
        $oib = $_SESSION['admin']['OIB'];
    $statement = $db->prepare($query);
    $statement->bindValue(':proda', $proda);
    $statement->bindValue(':vrsDo', $vrsDo);	
    $statement->bindValue(':oib', $oib);
    $statement->bindValue(':punkt', $_SESSION['admin']['punkt']);
    $statement->execute();
    $dok_zagNezavrseni = $statement->fetchAll();
    $statement->closeCursor();
    return $dok_zagNezavrseni;    
}   

function dokumentZavrsen() {
    if(trim($_SESSION['dok_zag']['vrsDo'])=='NS' && $_SESSION['dok_zag']['zavrsen']=='Da') {
        global $proda, $vrsDo, $proIn, $zapis, $broDo, $verzi;
        if($_SESSION['admin']['prioritet']==9) return;
        $cart=bez_0_kolicina($_SESSION['cart']);
        if(count($cart)<1) 
            return false;
        if(isset($_POST['kreiraPredracun']))
            $noviVrsDo='PR';
        else
            $noviVrsDo='5';
        // kreira završenu naruđbu s verzijom 'R' ili 'DR'
        if(nerealizirane_kolicine($_SESSION['cart']))
            kopiraj_dokument($_SESSION['dok_zag'], $_SESSION['cart'], $proda, 'N', '', '', $broDo,'DR', false, '');
        else
            kopiraj_dokument($_SESSION['dok_zag'], $_SESSION['cart'], $proda, 'N', '', '', $broDo, 'R', false, '');
        // briše 'NS' dokument
        delete_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi); 
        delete_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);

        // briše naruđbu bez verzije
        //delete_dok_stavke($proda, 'N', $proIn, $zapis, $broDo, ''); 
        //delete_dok_zag($proda, 'N', $proIn, $zapis, $broDo, '');
        
        // kreira dostavnicu
        $datum_o= new DateTime();
        $_SESSION['dok_zag']['DVO']=$_SESSION['dok_zag']['datumRacuna']=$datum_o->format("d.m.Y H:i:s");
        $interval = new DateInterval('P15D');
        $datum_o->add($interval);   
        $_SESSION['dok_zag']['valuta']=$datum_o->format("d.m.Y H:i:s");
        
        $_SESSION['cart']=$cart;
        kopiraj_dokument($_SESSION['dok_zag'], $_SESSION['cart'], $proda, $noviVrsDo, '', '', 0, '', true, 'briše');
        $vrsDo = $_SESSION['dok_zag']['vrsDo'];
        $broDo = $_SESSION['dok_zag']['brojDokumenta'] = $_SESSION['dok_zag']['broDo'];
        $verzi = $_SESSION['dok_zag']['verzi'] = '';
        return true;
    }
    
    global $db;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi']; 
    $email_user = $_SESSION['admin']['email'];
    if ($broDo === 0) {
        echo 'Broj dokumenta === 0 !! dokumentZavrsen IZBACUJE PROGRAM!!!';
        exit;
    }            
    
    $query = "
            update dok_zag
                set zavrsen = 'Da', 
                    komentar=:komentar,
                    datumIzmjene = NOW(), 
                    tkoJeIzmjenio = :email_user
                WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	        AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
            ";
    try {   
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);              
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);    
        $statement->bindValue(':verzi', $verzi);  
        $statement->bindValue(':komentar', $_SESSION['dok_zag']['komentar']);  
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();   
        $statement->closeCursor();
    } catch (PDOException $e) {            
         $error_message = 'Greška kod update dok_zag sa zavrsen!. <br>'.$e->getMessage();
         display_db_error($error_message);
    }
    if($_SESSION['admin']['prioritet']==9 && trim($_SESSION['dok_zag']['vrsDo'])=='N') {
   //  if(trim($_SESSION['dok_zag']['vrsDo'])=='N') {     16.06.2020
        global $proda, $vrsDo, $proIn, $zapis, $broDo, $verzi;
        if ($_SESSION['admin']['prioritet']==9) {
            $datum_o= new DateTime();
            $_SESSION['dok_zag']['DVO']=$_SESSION['dok_zag']['datumRacuna']=$datum_o->format("d.m.Y H:i:s");
            if(!isset($dok_zag['DVOY-m-d H:i:s']))   
                $_SESSION['DVOY-m-d H:i:s']=$datum_o->format("d.m.Y H:i:s");
        }
        $_SESSION['dok_zag']['zavrsen']='Da';
        kopiraj_dokument($_SESSION['dok_zag'], $_SESSION['cart'], $proda, 'NS', '', '', $broDo, 'B2B',false, 'kreira');
        // /*
        delete_rate_kartice($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi); 
        delete_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi); 
        delete_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
         // */
        $vrsDo = $_SESSION['dok_zag']['vrsDo'];
        $broDo = $_SESSION['dok_zag']['brojDokumenta'] = $_SESSION['dok_zag']['broDo'];
        $verzi = $_SESSION['dok_zag']['verzi'] = 'B2B';
        //return true;
    }
    return true;
}

// Parametri $dok_zag i &$dok_stavke se prenose s '&' - po adresi, kako bi sve promjene bile zapamčene u $_SESSION['dok_zag'] i $_SESSION['cart']
// funkcija se može pozvati: 
//  - kopiraj_dokument($_SESSION['dok_zak'], $_SESSION['cart'],...) - kopira se dokument koji je u sesiji,
//  - može se pročitati dokument iz baze:
//      dok_zag=get_dok_zag(...);
//      dok_stavke=get_dok_svstavke(...):
//      kopiraj_dokument(&$dok_zag, &$dok_stavke,...);
function kopiraj_dokument(&$dok_zag, &$dok_stavke, $prodaNovo, $vrsDoNovo, $proInNovo, $zapisNovo, $broDoNovo, $verziNovo, $kreiraVezu=false, $zeljeneKolicine='', $partnerNovo='') {
    global $db;
    //$db->beginTransaction();
    $vrsDoStaro=trim($dok_zag['vrsDo']);
    if($partnerNovo!='') 
        $dok_zag['kodPartnera']=$partnerNovo;
    if(isset($_SESSION['odabranaPoslovnica']))
        $_SESSION['odabranaPoslovnica']=$prodaNovo;
    if(trim($broDoNovo)=='' || (int)$broDoNovo==0) {
        $zadnji_broj = zadnji_broj($prodaNovo, $vrsDoNovo, $zapisNovo,$verziNovo);
        $broDoNovo=$zadnji_broj[0] + 1;
    }
    if($kreiraVezu) {
        global $db;
        $query = "  
            update dok_zag
            set prodaVezni=:prodaVezni,
                vrsDoVezni=:vrsDoVezni,
                proInVezni=:proInVezni,
                zapisVezni=:zapisVezni,
                broDoVezni=:broDoVezni,
                verziVezni=:verziVezni,
                datumIzmjene=NOW(), tkoJeIzmjenio=:email_user
            WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
            AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
            ";
        try {   
            $statement = $db->prepare($query);
            $statement->bindValue(':proda', $dok_zag['proda']);
            $statement->bindValue(':vrsDo', $dok_zag['vrsDo']);
            $statement->bindValue(':proIn', $dok_zag['proIn']);              
            $statement->bindValue(':zapis', $dok_zag['zapis']);
            $statement->bindValue(':broDo', $dok_zag['broDo']);
            $statement->bindValue(':verzi', $dok_zag['verzi']);  
            $statement->bindValue(':prodaVezni', $prodaNovo);
            $statement->bindValue(':vrsDoVezni', $vrsDoNovo);
            $statement->bindValue(':proInVezni', $proInNovo);              
            $statement->bindValue(':zapisVezni', $zapisNovo);
            $statement->bindValue(':broDoVezni', $broDoNovo);    
            $statement->bindValue(':verziVezni', $verziNovo);  
            $statement->bindValue(':email_user', $_SESSION['admin']['email']);
            $statement->execute();   
            $statement->closeCursor();
        } catch (PDOException $e) {            
             $error_message = 'Greška kod update dok_zag sa veznim dokumentom!. <br>'.$e->getMessage();
             display_db_error($error_message);
        }
        $dok_zag['prodaVezni']=$dok_zag['proda'];
        $dok_zag['vrsDoVezni']=$dok_zag['vrsDo'];
        $dok_zag['proInVezni']=$dok_zag['proIn'];
        $dok_zag['zapisVezni']=$dok_zag['zapis'];
        $dok_zag['broDoVezni']=$dok_zag['broDo'];
        $dok_zag['verziVezni']=$dok_zag['verzi'];
    }
    $dok_zag['proda']=$prodaNovo;
    $dok_zag['vrsDo']=$vrsDoNovo;
    $dok_zag['proIn']=$proInNovo;
    $dok_zag['zapis']=$zapisNovo; 
    $dok_zag['verzi']=$verziNovo; 
    $dok_zag['broDo']=$dok_zag['brojDokumenta']=$broDoNovo;

    if(!isset($dok_zag['kodPartneraPu'])) $dok_zag['kodPartneraPu']='';
    if(isset($_SESSION['odabranaPoslovnica']))    
        $dok_zag['odabranaPoslovnica']=$prodaNovo;
    add_dok_zag($dok_zag);
  
    if (!isset($dok_zag['DVOY-m-d H:i:s']))  {  
        $DVO =$dok_zag['DVO'];   
    }  else {
        $DVO = $dok_zag['DVOY-m-d H:i:s']; 
    }  

    // stavke
    require_once('model/vrste_dokumenata_db.php');
    $slogVrsDo=get_vrsta_dokumenta($vrsDoNovo);
    $brojStavke=0;
    for($i=0; $i<count($dok_stavke); $i++) {
        if($zeljeneKolicine=='briše') { 
            $dok_stavke[$i]['zeljenaKolicina']=0;
        }    
        else {
            if($zeljeneKolicine=='kreira') {
                $dok_stavke[$i]['zeljenaKolicina']=$dok_stavke[$i]['kolicina'];
               if($slogVrsDo['azurStanja']==-1 && $dok_stavke[$i]['kolicina']>0) {
    /*                 $zaliha=stanje_po_kodu_robe_1p($prodaNovo, $dok_stavke[$i]['kodRobe'], $dok_stavke[$i]['vrstaProdaje']);
                    if(!is_array($zaliha)) { 
                        $dok_stavke[$i]['kolicina']=0;
                    }    
                    else if($zaliha['suma_po_kodu_robe']<$dok_stavke[$i]['kolicina']) {
                        $dok_stavke[$i]['kolicina']=$zaliha['suma_po_kodu_robe']>0?$zaliha['suma_po_kodu_robe']:0;                                             
                    }   */ 
            // provjera da li je stanje dovoljno za odabranu količinu , važeće stanje se umanjuje za minimalnu zalihu ako je ima
                    $stanje = stanje_po_kodu_robe_sve_ili_neke_p($prodaNovo, $dok_stavke[$i]['kodRobe'], $dok_stavke[$i]['vrstaProdaje']);   
                    if(!is_array($stanje)) { 
                        $dok_stavke[$i]['kolicina']=0;
                    } else {   
                        if ($stanje['minZaliha'] === NULL)  { // minimalna zaliha
                          $vazeceStanje = $stanje['sumaPoKoduRobe'];
                        } else {
                          $vazeceStanje = $stanje['sumaPoKoduRobe'] - $stanje['minZaliha'];
                        }  
                        if($vazeceStanje < $dok_stavke[$i]['kolicina']) {
                           $dok_stavke[$i]['kolicina']=$vazeceStanje>0?$vazeceStanje:0;  
                        }                        
                    }                   
               }   
            }    
        }
        
        if(trim($vrsDoStaro)=='1' && trim($vrsDoNovo)!='1') {
            // kopiramo primku u neku drugu vrstu dokumenta
            $dok_stavke[$i]['marza'] = $dok_stavke[$i]['zavisniTroskovi'] = $dok_stavke[$i]['nabavnaCijena'] = 0;
        }
        else if(trim($vrsDoNovo)=='1' && $vrsDoStaro!='1') {
            // kopiramo neku drugu vrstu dokumenta u primku
            $dok_stavke[$i]['nabavnaCijena'] = $dok_stavke[$i]['cijena'];
        }
        
        if (trim($vrsDoNovo) == '6' && $vrsDoStaro != '6') {
            // kopiramo neku drugu vrstu dokumena u internu fakturu
            $dok_stavke[$i]['rabatPopust'] = $dok_stavke[$i]['rabatPopustNaKol'] = 0;
            $dok_stavke[$i]['absRabatPopust'] = $dok_stavke[$i]['absRabatPopustNaKol'] = '';
            
            $slogRobe = get_product_maticna_robe($dok_stavke[$i]['kodRobe']);
            if(isset($slogRobe['cijena'])) {
     //            $dok_stavke[$i]['cijena'] = $slogRobe['cijena'];   maknuto 11.02.2021
                if($dok_stavke[$i]['PDV']==0) {
                    $slogPDV = get_porez($slogRobe['poreznaGrupa']);
                    $dok_stavke[$i]['poreznaGrupa'] = $slogPDV['poreznaGrupa'];
                    $dok_stavke[$i]['PDV'] = $slogPDV['PDV'];
                    unset($slogPDV);
                }
                unset($slogRobe);
            }   
            
        }
        
        if(!isset($dok_stavke[$i]['ulaznaInterna'])) $dok_stavke[$i]['ulaznaInterna']='';
        add_dok_stavke($prodaNovo,$vrsDoNovo,$proInNovo,$zapisNovo,$dok_zag['broDo'],$verziNovo,++$brojStavke, 
                $dok_stavke[$i]['kodRobe'], $dok_stavke[$i]['vrstaProdaje'], $dok_stavke[$i]['cijena'], 
                $dok_stavke[$i]['cijenaZaIntFak'], $dok_stavke[$i]['kolicina'], $dok_stavke[$i]['rabatPopust'], $dok_stavke[$i]['absRabatPopust'], 
                $dok_stavke[$i]['rabatPopustNaKol'], $dok_stavke[$i]['absRabatPopustNaKol'], $dok_stavke[$i]['poreznaGrupa'], 
                $dok_stavke[$i]['PDV'], $dok_stavke[$i]['ukalkuliraniPDV'], $dok_stavke[$i]['povratnaNaknada'], $dok_stavke[$i]['nabavnaCijena'], 
                $dok_stavke[$i]['marza'], $dok_stavke[$i]['absMarza'], $dok_stavke[$i]['zavisniTroskovi'], $dok_stavke[$i]['absZavTr'], 
                $dok_stavke[$i]['tekst'], $dok_stavke[$i]['vezniDokument'], $dok_stavke[$i]['oznakaCjenika'],
                $dok_stavke[$i]['ulaznaInterna'],$dok_stavke[$i]['jedinicaMjere'],$dok_stavke[$i]['zeljenaKolicina'], $DVO);
        /*
        if($slogVrsDo['azurStanja']!=0)    
            azuriranje_stanja($prodaNovo,$vrsDoNovo,$proInNovo,$zapisNovo,$dok_zag['broDo'],$verziNovo,$dok_zag['DVO'],$dok_zag['kodPartneraPu'],
                              $dok_stavke[$i]['kodRobe'],$dok_stavke[$i]['vrstaProdaje'],$dok_stavke[$i]['cijena'],$dok_stavke[$i]['kolicina'],
                              $dok_stavke[$i]['rabatPopust'],$dok_stavke[$i]['absRabatPopust'],$dok_stavke[$i]['nabavnaCijena'],
                              $dok_stavke[$i]['marza'],$dok_stavke[$i]['absMarza'],$dok_stavke[$i]['zavisniTroskovi'],$dok_stavke[$i]['absZavTr']);   
        */
        if (trim($vrsDoNovo) == '6') {
            $vrsDoNovoInt = '2 ';
            $proInNovoInt = $prodaNovo;
            $kodPartneraPu = $proInNovo;
            $prodaNovoInt = $dok_zag['kodPartnera'];

            add_dok_stavke($prodaNovoInt,$vrsDoNovoInt,$proInNovoInt,$zapisNovo,$dok_zag['broDo'],$verziNovo,$brojStavke, 
                    $dok_stavke[$i]['kodRobe'], $dok_stavke[$i]['vrstaProdaje'], $dok_stavke[$i]['cijena'], 
                    $dok_stavke[$i]['cijenaZaIntFak'], $dok_stavke[$i]['kolicina'], $dok_stavke[$i]['rabatPopust'], $dok_stavke[$i]['absRabatPopust'], 
                    $dok_stavke[$i]['rabatPopustNaKol'], $dok_stavke[$i]['absRabatPopustNaKol'], $dok_stavke[$i]['poreznaGrupa'], 
                    $dok_stavke[$i]['PDV'], $dok_stavke[$i]['ukalkuliraniPDV'], $dok_stavke[$i]['povratnaNaknada'], $dok_stavke[$i]['nabavnaCijena'], 
                    $dok_stavke[$i]['marza'], $dok_stavke[$i]['absMarza'], $dok_stavke[$i]['zavisniTroskovi'], $dok_stavke[$i]['absZavTr'], 
                    $dok_stavke[$i]['tekst'], $dok_stavke[$i]['vezniDokument'], $dok_stavke[$i]['oznakaCjenika'],
                    $dok_stavke[$i]['ulaznaInterna'],$dok_stavke[$i]['jedinicaMjere'],$dok_stavke[$i]['zeljenaKolicina'], $DVO);
            /*
            // if($slogVrsDo['azurStanja']!=0)    
            azuriranje_stanja($prodaNovoInt,$vrsDoNovoInt,$proInNovoInt,$zapisNovo,$dok_zag['broDo'],$verziNovo,$dok_zag['DVO'],$kodPartneraPu,
                              $dok_stavke[$i]['kodRobe'],$dok_stavke[$i]['vrstaProdaje'],$dok_stavke[$i]['cijena'],$dok_stavke[$i]['kolicina'],
                              $dok_stavke[$i]['rabatPopust'],$dok_stavke[$i]['absRabatPopust'],$dok_stavke[$i]['nabavnaCijena'],
                              $dok_stavke[$i]['marza'],$dok_stavke[$i]['absMarza'],$dok_stavke[$i]['zavisniTroskovi'],$dok_stavke[$i]['absZavTr']);   
            */
        }   
        
    }
    //$db->commit();
    return $dok_zag['broDo'];
}

function kreiraj_K2_verzija_1($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    $dok_zag = get_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
    $dok_stavke = get_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi);
    
    for($i=0; $i<count($dok_stavke); $i++) {
        $dok_stavke[$i]['kolicina']*= -1;
        if($dok_stavke[$i]['vrstaProdaje']=='2') {
            $dok_stavke[$i]['vrstaProdaje']='0';
        }    
        else {
            $dok_stavke[$i]['vrstaProdaje']='2';
        }
    }
    kopiraj_dokument($dok_zag, $dok_stavke, $proda, $vrsDo, $proIn, $zapis, $broDo, "1");
} 

function vrati_dok_u_nezavrsene($proda, $vrsDo, $proIn, $zapis, $broDo, $verzi) {
    global $db;
    $email_user = $_SESSION['admin']['email'];

    $query = "
            update dok_zag
                set zavrsen = 'Ne', 
                    datumIzmjene = NOW(), 
                    tkoJeIzmjenio = :email_user
                WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	        AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
            ";
    try {   
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);              
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);    
        $statement->bindValue(':verzi', $verzi);  
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();   
        $statement->closeCursor();
    } catch (PDOException $e) {            
         $error_message = 'Greška kod update dok_zag je nezavrsen!. <br>'.$e->getMessage();
         display_db_error($error_message);
    }
    if (trim($vrsDo) == '3' && trim($zapis) == 'K2') {
        delete_dok_stavke($proda, $vrsDo, $proIn, $zapis, $broDo, '1');
        delete_dok_zag($proda, $vrsDo, $proIn, $zapis, $broDo, '1');
    }
    $_SESSION['dok_zag']['zavrsen']='Ne';

}

    

function update_dok_zag_komentar() {
    global $db;
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $proIn = $_SESSION['dok_zag']['proIn'];
    $zapis = $_SESSION['dok_zag']['zapis']; 
    $broDo = $_SESSION['dok_zag']['broDo'];
    $verzi = $_SESSION['dok_zag']['verzi']; 
    $email_user = $_SESSION['admin']['email'];
    
    $query = "
            update dok_zag
                set  
                    komentar=:komentar,
                    datumIzmjene = NOW(), 
                    tkoJeIzmjenio = :email_user
                WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	        AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
            ";
    try {   
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);
        $statement->bindValue(':proIn', $proIn);              
        $statement->bindValue(':zapis', $zapis);
        $statement->bindValue(':broDo', $broDo);    
        $statement->bindValue(':verzi', $verzi);  
        $statement->bindValue(':komentar', $_SESSION['dok_zag']['komentar']);  
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();   
        $statement->closeCursor();
        if(isset($_REQUEST['rbPredloska_komentar'])) 
            unset($_REQUEST['rbPredloska_komentar']);
    } catch (PDOException $e) {            
         $error_message = 'Greška kod update dok_zag komentar!. <br>'.$e->getMessage();
         display_db_error($error_message);
    }
}

function update_dok_zag_zakljucanog() {
    global $db;
    
    $query = "
            update dok_zag
                set  
                    brojNarudzbe=:brojNarudzbe,
                    datumIzmjene = NOW(), 
                    tkoJeIzmjenio = :email_user
                WHERE proda = :proda AND vrsDo = :vrsDo AND proIn = :proIn
	        AND zapis = :zapis AND broDo = :broDo AND verzi = :verzi
            ";
    try {   
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $_SESSION['odabranaPoslovnica']);
        $statement->bindValue(':vrsDo', $_SESSION['dok_zag']['vrsDo']);
        $statement->bindValue(':proIn', $_SESSION['dok_zag']['proIn']);              
        $statement->bindValue(':zapis', $_SESSION['dok_zag']['zapis']);
        $statement->bindValue(':broDo', $_SESSION['dok_zag']['broDo']);    
        $statement->bindValue(':verzi', $_SESSION['dok_zag']['verzi']);  
        $statement->bindValue(':brojNarudzbe', $_SESSION['dok_zag']['brojNarudzbe']);  
        $statement->bindValue(':email_user', $_SESSION['admin']['email']);
        $statement->execute();   
        $statement->closeCursor();
    } catch (PDOException $e) {            
         $error_message = 'Greška kod update dok_zag zaključanog dokumenta!. <br>'.$e->getMessage();
         display_db_error($error_message);
    }
}

function postoje_zeljene_kolicine($dok_stavke) {
    foreach ($dok_stavke as $stavka) {
        if(isset($stavka['zeljenaKolicina']))
            if($stavka['zeljenaKolicina']!=0)
                return true;
    }
    return false;
}

function nerealizirane_kolicine($dok_stavke) {
    foreach ($dok_stavke as $stavka) {
        if(isset($stavka['zeljenaKolicina']))
            if($stavka['zeljenaKolicina']>$stavka['kolicina'])
                return true;
    }
    return false;
}
function bez_0_kolicina($dok_stavke) {
    $cart=array();
    foreach ($dok_stavke as $stavka) {
       if((float)$stavka['kolicina']!=0)
          $cart[]=$stavka;
    }
    return $cart;
}

function kontrolaKljucaPrijeInsert($proda,$vrsDo,$proIn,&$zapis,$broDo,$verzi) {
    $kljuc=$proda . ' ' . $vrsDo . ' ' . $proIn . ' ' . $zapis . ' ' . $broDo . $verzi;
   //samo vrsDo 3(zapisnik mora imati popunjeno polje zapis ostali ne smiju   
    if (trim($vrsDo)=='3' && trim($zapis)=='') {
        $error_message = 'GREŠKA PREKID! Kod vrste dokumenta zapisnik(3) pokušava se upisati nespecificirana vrsta zapisnika(prazno) '
                . '</br>Provjeriti kopiranje Ostali dokumenti u zapisnik! Obavezno obavjestiti programera! Dokument:' . $kljuc;
        display_error($error_message);
    }     
    if ( trim($vrsDo)=='5' && $_SESSION['admin']['prioritet']=='9' ) {
        error_log('Pokusaj upisa dostavnice za b2b korisnika' .$_SESSION['odabranaBaza']);
        $call_stack=  var_export(debug_backtrace(), TRUE);
        error_log($call_stack);
        $error_message = 'GREŠKA PREKID! Kod vrste dokumenta OTPREMNICA-DOSTAVNICA(5) pokušava se upisati dokument kod B2B korisnika '
                . '</br>Obavezno obavjestiti programera  na tel. 098627062 radi ispravka greške! Dokument:' . $kljuc;
        display_error($error_message);
    }     
    if (trim($vrsDo)!='3' && trim($zapis)!='') {    
        $zapis = '';
        echo 'GREŠKA upozorenje! Kod vrste dokumenta koji nije zapisnik, pokušala se upisati vrsta zapisnika ' . $zapis                 
                . '</br> Polje zapis mora biti prazno. Programski je izvršeno pražnjenje polja zapis'
                . '  program dalje nastavlja s radom ali je potrebno obavjestiti programera. Dokument:' . $kljuc;
     //   sleep(10);           
    }   
    if (trim($broDo)=='' || $broDo == 0) {
        $error_message = 'GREŠKA PREKID! Pokušava se upisati dokument s brojem 0 ili prazno'
                . '</br> Obavezno obavjestiti programera! Dokument:' . $kljuc;
        display_error($error_message);
    }  
    if (trim($vrsDo)!='2' && trim($proIn)!='') {
        $error_message = 'GREŠKA PREKID! Kod vrste dokumenta koji nije ulazna interna faktura(2), pokušava se upisati oznaka' 
            . '</br> interne prodavaone(proIn)' . $proIn . ' za vrsDo ' . $vrsDo . ' Obavezno obavjestiti programera! Dokument:' . $kljuc;               
        display_error($error_message);
    }     
    if (trim($vrsDo)=='2' && trim($proIn)=='') {
        $error_message = 'GREŠKA PREKID! Kod ulazne interne fakture(2), pokušava se upisati bez popunjene prodavaone izlaza (proIn) (prazno je)' 
            . '</br> OPASNO! Izlazna interna faktura je proknjižena a ulazna NE!. Dokument:' . $kljuc;               
        display_error($error_message);
    }    
    return;
}
function kontrolaFiskalizacije($poFiskalizaciji,$JIR,$zastitniKod,$user,$proda,$vrsDo,$duzeOd) {
 //   echo 'proda='. $proda. 'vrsDo='.$vrsDo;
    
            global $db;  
    $JIRlike='%'.trim($JIR).'%'; $zastitniKodLike='%'.trim($zastitniKod).'%'; $userLike='%'.trim($user).'%';
 //   echo 'jirLIKE='. $JIRlike;
    $query = "
             SELECT proda as Poslovnica, vrsDo as VrsDok, proIn, zapis, broDo as BrojDok, verzi, DVO as DatumRacuna,
             datumIvrijemeJIR as DatumJIR, zastitniKod, JIR, tkoJeIzmjenio as KreatorDokumenta
	     FROM dok_zag
	     WHERE (             
               (:poFiskalizaciji = 'djeFisk' and (zastitniKod is not NULL and JIR is NULL) )
             or (:poFiskalizaciji = 'potFisk' and (zastitniKod is not NULL and JIR is not NULL) )
             or (:poFiskalizaciji = 'nakFisk' and (zastitniKod is not NULL and JIR is not NULL) )
             or (:poFiskalizaciji = 'neFisk' and zastitniKod is NULL)   
             )
             AND (:JIRlike ='%%' or trim(JIR) LIKE :JIRlike) 
             AND (:zastitniKodLike = '%%' or trim(zastitniKod) LIKE :zastitniKodLike)
             AND (:userLike ='%%' or trim(tkoJeIzmjenio) LIKE :userLike)
             AND (:proda ='' or trim(proda) = :proda)
             AND (:vrsDo ='' or trim(vrsDo) = :vrsDo)
            order by proda, vrsDo, DVO
             ";
   try {
        $statement = $db->prepare($query);
        $statement->bindValue(':poFiskalizaciji', $poFiskalizaciji);
        $statement->bindValue(':JIRlike', $JIRlike);
        $statement->bindValue(':zastitniKodLike', $zastitniKodLike);
        $statement->bindValue(':userLike', $userLike);
        $statement->bindValue(':proda', trim($proda));
        $statement->bindValue(':vrsDo', trim($vrsDo));
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        if ($poFiskalizaciji != 'nakFisk')
           return $result;
    } catch (PDOException $e) {
        $error_message = $e->getMessage();
        display_db_error($error_message);
    }
    //$duzeOdInterval = new DateInterval("PT".$duzeOd."H");
    //ostaje nakFisk
    $res2=array();
    foreach($result as $stavka ) {  
       
        $datetime1 = new DateTime($stavka['DatumJIR']);        
        $datetime2 = new DateTime($stavka['DatumRacuna']);
        $diff = $datetime1->diff($datetime2);
        if($diff->y == 0 && $diff->m == 0 && $diff->d == 0 && $diff->h == 0 && $diff->i < 10) continue;
        if($duzeOd>0) {
            // brojsati ne mora biti precizno izračunano. ako je duže od mjesec dana, sigurno je duže od unesenih sati
            $brojSekundi = (((($diff->y*12 + $diff->m)*30 + $diff->d)*24 + $diff->h)*60 + $diff->i)*60 + $diff->s;
            if($brojSekundi<=$duzeOd*3600) continue;
        }
        $razlika = $diff->m.' mjeseci, '.$diff->d.' dana, '.$diff->h.' sati, '.$diff->i.' minuta ';
        $stavka['razlika']=$razlika;
        $res2[]=$stavka;
                                  
    }
 return $res2;   
 }
 
 function korekcija_po_stopama(&$poStopama, $zaNaplatu) {
    $n=count($poStopama);
    $sumaPoStopama=0;
    for ($i = 0;$i < $n ;$i++) {
        $sumaPoStopama+=$poStopama[$i]['osnovica'] + $poStopama[$i]['PDVIznos'];
        if($i+1<$n || $zaNaplatu==(string)$sumaPoStopama)
            ;
        else {
            $razlika=(float)$zaNaplatu-$sumaPoStopama;
            $poStopama[$i]['osnovica'] += $razlika;
        }
    }
    
}

function update_za_verzi_NZV()  {    
     
/* sve vrste dokumenata koji SE FISKALIZIRAJU gdje je ------ knjizenjeStavkeOdmah == 'Da'  ----------  
 * pod verzi NZV je PRIVREMENO knjižen takav dokument(ovo se odnosi na paragonce a na ostale ovisno dali je broj dokumenta popunjen)
 *  da se sprijeći npr. da paragonac broj 30 ima DVO 15.03.2020 09:25:15 a paragonac broj 31 15.03.2020 09:10:00(veći broj treba imati veči datum) 
 * ako npr. kasira istovremeno više prodavača u ISTOJ prodavaoni i npr. jedan prodavač je prvi započeo knjižiti puno stavki,
 * a drugi počeo knjižiti kasnije, a ima samo jednu stavku pa brže završi
 * DAKLE, U TRENUTKU ZAVRŠAVANJA paragonca(ili drugog fisk. dokumenta kod kojeg nije popunjen broj dokumenta) odabire se KONAČNI BROJ DOKUMENTA
 * I KONAČNI DVO a verzi se postavlja na ' ' i takav konačni dokument ide na fiskalizaciju
 * 
 * kod prodvaonica gdje radi samo jedan prodavač privremeni broj broDo je uglavnom jednak konačnom broDo(ali ako u tom slučaju prodavač ima više accounta(a OIB je isti)
 * pa isti prodavač istovremeno radi sa više accounta moguća je gornja situacija)
 * Npr. dođe stranka koja će kupovati puno stavki, pa zatim druga stranka koja će kupiti samo jednu stavku, prodavač otvori drugi account i rješi drugu stranku,
 * pa nakon toga prvu
 * */   
      global $db;  
 /*   $stariBroj = $_SESSION['dok_zag']['broDo'];
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $zapis = '';
    $proIn = '';
        
            $zadnji_broj = zadnji_broj($_SESSION['odabranaPoslovnica'], $_SESSION['dok_zag']['vrsDo'], $_SESSION['dok_zag']['zapis'],$verzi='');
	 // konačni broj na koji će se knižiti dokument, verzi = ''   
           if (!isset($zadnji_broj[0])) {
             $broDo = 1; 
           } else {
             $broDo = $zadnji_broj[0] + 1; 
             // ovaj broj će se koristiti uvijek za paragonce, a za ostale dokumente ako nije popunjen broj dokumenta 
           }
    // konačni DVO  
           $datum_o = new DateTime;
           $DVO = $datum_o->format("Y-m-d H:i:s");
         
         $email_user = $_SESSION['admin']['email'];
           
           $query = "update dok_zag 
                    set broDo = :broDo,
                        DVO = :DVO,
                        datumRacuna = :DVO,
                        verzi = '',
                        novac = :novac,
                        vrstaKartice = :vrstaKartice,
                        iznosKartice = :iznosKartice,
                        iznosTransRacun = :iznosTransRacun,
                        brojRata = :brojRata,
                        povrat = :povrat,
                        tkoJeIzmjenio=:email_user
                   where proda = :proda and vrsDo = :vrsDo and trim(proIn) = '' and trim(zapis) = '' and broDo = :stariBroj and verzi = 'NZV' ";           
        try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);      
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':stariBroj', $stariBroj);
        $statement->bindValue(':DVO', $DVO);
        $statement->bindValue(':novac', $_SESSION['dok_zag']['novac']);
        $statement->bindValue(':vrstaKartice', $_SESSION['dok_zag']['vrstaKartice']);
        $statement->bindValue(':iznosKartice', $_SESSION['dok_zag']['iznosKartice']);
        $statement->bindValue(':iznosTransRacun', $_SESSION['dok_zag']['iznosTransRacun']);
        $statement->bindValue(':brojRata', $_SESSION['dok_zag']['brojRata']);
        $statement->bindValue(':povrat', $_SESSION['dok_zag']['povrat']);        
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška u update_za_verzi_NZV  prilikom update dok_zag! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }
 */
        
    update_dok_zag_placanja_zaFiskalDokument($proda,$vrsDo,$broDo,$stariBroj,$DVO,$email_user);  // 21.07.2021 ovo zamjena za gornji komentar  
    //  function update_dok_zag_placanja_zaFiskalDokument(&$proda...    ) je sa & pa se gornji parametri vide kao global nakon izvedbe funkcije?
    
            
    $query = "update dok_stavke 
                    set broDo = :broDo,
                        DVO = :DVO,
                        verzi = '',
                        tkoJeIzmjenio=:email_user
                   where proda = :proda and vrsDo = :vrsDo and trim(proIn) = '' and trim(zapis) = '' and broDo =  :stariBroj and verzi = 'NZV'";           
        try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);   
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':stariBroj', $stariBroj);
        $statement->bindValue(':DVO', $DVO);    
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška u update_za_verzi_NZV  prilikom update dok_stavke! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }
    
/*    require_once('../dokumenti/unosiIKontrole.php');
     echo 'Dolazim prd update_rate_kartice!';
     echo 'stariBroj =' . $stariBroj . 'proda=' . $proda;
     $query = "select * from rate_kartice where broDo = :stariBroj and proda = :proda";
     $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);       
        $statement->bindValue(':stariBroj', $stariBroj);       
        $statement->execute();
        $result = $statement->fetchAll();
        $statement->closeCursor();
        prikaziUTablici($result, 'Kartice ',400);
  */      
    
     $query = "update rate_kartice 
                    set broDo = :broDo,              
                        verzi = '',
                        datumOtvaranja = :DVO,
                        tkoJeIzmjenio=:email_user
                   where proda = :proda and vrsDo = :vrsDo and trim(proIn) = '' and trim(zapis) = '' and broDo =  :stariBroj and verzi = 'NZV' ";           
        try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);   
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':stariBroj', $stariBroj);
        $statement->bindValue(':DVO', $DVO);    
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška u update_za_verzi_NZV  prilikom update rate_kartice! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }
    
    $_SESSION['dok_zag']['broDo'] = $broDo;
    $_SESSION['dok_zag']['brojDokumenta'] = $broDo;
//    $_SESSION['dok_zag']['DVO'] = $DVO;    
    $_SESSION['dok_zag']['verzi'] = '';   
// s ovim podacima se ide na fiskalizaciju    
    
}
function update_dok_zag_placanja_zaFiskalDokument(&$proda,&$vrsDo,&$broDo,&$stariBroj,&$DVO,&$email_user) {
       global $db;  
    $stariBroj = $_SESSION['dok_zag']['broDo'];
    $proda = $_SESSION['odabranaPoslovnica'];
    $vrsDo = $_SESSION['dok_zag']['vrsDo'];
    $zapis = '';
    $proIn = '';
    if ($_SESSION['dok_zag']['verzi'] == 'NZV') {
         $zadnji_broj = zadnji_broj($_SESSION['odabranaPoslovnica'], $_SESSION['dok_zag']['vrsDo'], $_SESSION['dok_zag']['zapis'],$verzi='');
	 // konačni broj na koji će se knjižiti dokument, verzi = ''   za NZV dokument
           if (!isset($zadnji_broj[0])) {
             $broDo = 1; 
           } else {
             $broDo = $zadnji_broj[0] + 1; 
             // ovaj broj će se koristiti uvijek za paragonce, a za ostale dokumente ako nije popunjen broj dokumenta 
           }
    } else {
        $broDo = $stariBroj;   // za dostavnice koje se fiskaliziraju sa verzi = ''
    }       
    // konačni DVO  
           $datum_o = new DateTime;
           $DVO = $datum_o->format("Y-m-d H:i:s");
         
         $email_user = $_SESSION['admin']['email'];
           
           $query = "update dok_zag 
                    set broDo = :broDo,
                        DVO = :DVO,
                        datumRacuna = :DVO,
                        verzi = '',
                        novac = :novac,
                        vrstaKartice = :vrstaKartice,
                        iznosKartice = :iznosKartice,
                        iznosTransRacun = :iznosTransRacun,
                        brojRata = :brojRata,
                        povrat = :povrat,
                        rucniParagonac = :rucniParagonac,
                        tkoJeIzmjenio=:email_user
                  where proda = :proda and vrsDo = :vrsDo and trim(proIn) = '' and trim(zapis) = '' and broDo = :stariBroj and verzi = :verzi";       
      /* :verzi je NZV za regularno odabrane fiskalizirane dok, a prazno za npr. dostavnice, predračune... kod kojih se prvo nezavršeno proknjižilo kao nefiskalizirano, a onda naknadno odabarano Obveza fiskalizacije = 'Da'     */   
        try {
        $statement = $db->prepare($query);
        $statement->bindValue(':proda', $proda);
        $statement->bindValue(':vrsDo', $vrsDo);      
        $statement->bindValue(':broDo', $broDo);
        $statement->bindValue(':stariBroj', $stariBroj);
             $statement->bindValue(':verzi', $_SESSION['dok_zag']['verzi']);
        $statement->bindValue(':DVO', $DVO);
   
        $statement->bindValue(':novac', ($_SESSION['dok_zag']['novac'] + $_SESSION['dok_zag']['kuneUeurima']) );
        $statement->bindValue(':vrstaKartice', $_SESSION['dok_zag']['vrstaKartice']);
        $statement->bindValue(':iznosKartice', $_SESSION['dok_zag']['iznosKartice']);
        $statement->bindValue(':iznosTransRacun', $_SESSION['dok_zag']['iznosTransRacun']);
        $statement->bindValue(':brojRata', $_SESSION['dok_zag']['brojRata']);
        $statement->bindValue(':povrat', $_SESSION['dok_zag']['povrat']);   
        if ($_SESSION['dok_zag']['povratKune'] == 0 || trim($_SESSION['dok_zag']['povratKune']) == '') {
           $statement->bindValue(':rucniParagonac', $_SESSION['dok_zag']['kune']); 
 //          echo 'sesion dokzakgkune' . $_SESSION['dok_zag']['kune']; 
        } else {
           $statement->bindValue(':rucniParagonac', ( $_SESSION['dok_zag']['kune'] . '_'  . $_SESSION['dok_zag']['povratKune']) );  
        }   
        $statement->bindValue(':email_user', $email_user);
        $statement->execute();
        $statement->closeCursor();
    } catch (PDOException $e) {
        $error_message = 'Pogreška u update_dok_zag_placanja_zaFiskalDokument  prilikom update dok_zag! <br>'.$e->getMessage().'<br>'.$query;
        display_db_error($error_message);
    }
    
}
?>